import React from 'react'
import { Map, fromJS, Set } from 'immutable'
import { action as MetaAction, AppLoader } from 'edf-meta-engine'
import { FormDecorator, LoadingMask, Button, Input, Icon, Upload, Tabs, Radio, Select } from 'edf-component'
import extend from './extend'
import config from './config'
import { areaList } from './city'
import renderColumns from './utils/renderColumns'
import changeToOption from './utils/changeToOption'
import { fetch, number, history } from 'edf-utils'
import { message } from 'antd';
import { debug } from 'util';
import moment from 'moment'

const Option = Select.Option
class action {
    constructor(option) {
        this.metaAction = option.metaAction
        this.extendAction = option.extendAction
        this.config = config.current
        this.webapi = this.config.webapi
        //this.beforeLoad = option.voucherAction.excelbeforeUpload
    }
    onInit = async ({ component, injections }) => {
        /* ********
        菜单名	    财报转换申报
        使用场景：	1、财税助手集成报表转换功能
                   2、北京、大连等国税局集成报表转换功能 （导入第三方财务软件生成的财务报表，并生成税局统一格式的财务报表。生成成功后，跳转到电局填表页）
                   3、产品中报税功能 财务三大报表集成报表转换
        拼接规则
        参数说明
        参数	           参数名称	     类型	必填	描述	范例
        gdslxDm	        国地税类型代码	 String	必填	区分上报的是国税还是地税，国税：1，地税：2
        kjzdzzDm（作废）	   会计制度准则代码	 String	必填	第一阶段暂支持企业会计准则、小企业会计准则两类 企业会计准则=》2000020001，小企业会计准则 =》 2000020002
        zlbsxlDm	   资料报送小类代码	 String	必填	企业会计准则对应的小类目前只支持一般企业//企业 =》 "ZL1001001" ， 小企业 =》  "ZL1001003"
        bbbsqDm	       报表报送期代码	 String	必填	01：年报；03：季报；04：月报
        sssqQ	       所属时期起	     String	必填	例	2018-03-01
        sssqZ	       所属时期止	     String	必填	例	2018-03-31
        nsrsbh	       纳税人识别号	     String	必填  北京的第2,3位是11
        nsrmc	       纳税人名称	     String	必填
        zgswskfjDm	   主管税务所科分局代码	String	必填	纳税人主管税务所科分局代码
        djxh           登记序号               10111101000060491228
        *******/
        this.extendAction.gridAction.onInit({ component, injections })
        this.component = component
        this.injections = injections
        injections.reduce('init')
        let addEventListener = this.component.props.addEventListener
        if (addEventListener) {
            addEventListener('onTabFocus', :: this.onTabFocus)
        }
        let params, res, reduceArr = [], paramExternalData = this.component.props.param //this.getUrlData()
        //申报列表过来
        if (this.component.props.financeParam) {
            params = this.component.props.financeParam
            await this.initData(params.sourceType, params)
        }

        /**
         * (局方版)财报转换申报10001002
           (企业版)财报转换申报10001006
           (福建集成版)财报转换申报10002001
         */
        if (this.component.props.appKey) {
            this.initData(this.component.props.appKey, null, paramExternalData)
        }

        // if (this.component.props.sourceType) {
        //     this.initData(this.component.props.sourceType, null, paramExternalData)
        // }

        // //通过url访问
        // // sourceType约定： 字段说明 表示来源，如果url里面没有此属性，走oauthAuthentication验证，否则走本地
        // // 1. 无值（未传该参数）：认为是北京国税产品跳转过来的，调用oauthAuthentication接口
        // // 2. B01：同1
        // // 3. A01：通过拼接url方式访问，测试人员使用该方式，调用getOrgAndToken接口
        // // 4. A02：通过产品内菜单访问，演示报表转换功能使用，在发现企业信息没有设置纳税人识别号时会抛提示，调用getOrg接口
        // if (!paramExternalData.sourceType || (paramExternalData.sourceType && paramExternalData.sourceType == 'B01')) {
        //     res = await this.webapi.tranreport.oauthAuthentication(afferentParamsData)
        // } else if (paramExternalData.sourceType == 'A01') {
        //     //sourceType=A01 通过拼接url方式访问，测试人员使用该方式，调用getOrgAndToken接口
        //     if (!paramExternalData.nsrsbh || paramExternalData.nsrsbh == "undefined") {
        //         message.warning('纳税人识别号为空', 5);
        //         return
        //     }
        //     res = await this.webapi.tranreport.getOrgAndToken(paramExternalData)
        // }
        // if (res) {
        //     reduceArr.push({
        //         path: 'data.orgDto',
        //         value: res.orgDto
        //     })
        //     reduceArr.push({
        //         path: 'data.paramExternalDto',
        //         value: res.paramExternalDto
        //     })
        //     reduceArr.push({
        //         path: 'data.tokenData',
        //         value: res.token
        //     })
        //     reduceArr.push({
        //         path: 'data.other.allVisible',
        //         value: true
        //     })
        //     paramExternalData = res.paramExternalDto
        //     this.injections.reduce('updateArr', reduceArr)
        //     this.load(paramExternalData)
        // }
    }

    //页面加载
    load = async (paramExternalData) => {
        let reduceArr = [], rptTitleList = this.metaAction.gf('data.source.rptTitleList')
        this.injections.reduce('load', paramExternalData, rptTitleList.toJS())
        let showRptStates = this.setShowRptStates(paramExternalData.zgswskfjDm, paramExternalData.bbbsqDm)
        if (showRptStates) {
            reduceArr = [
                ...reduceArr,
                {
                    path: 'data.other.balancesheetStatus',
                    value: showRptStates.balancesheetStatus
                }, {
                    path: 'data.other.profitstatementStatus',
                    value: showRptStates.profitstatementStatus
                }, {
                    path: 'data.other.cashflowstatementStatus',
                    value: showRptStates.cashflowstatementStatus
                }
            ]
            this.injections.reduce('updateArr', reduceArr)
        }
        this.isExistHistoryReportData(paramExternalData)
        // setTimeout(() => {
        //     this.onResize()
        // }, 20)
    }

    //渲染radio
    renderOption = (value) => {
        let taxTimeTypes = this.metaAction.gf('data.enumListForm.taxTimeTypes').toJS()
        return taxTimeTypes.map(item => {
            return (
                <Radio
                    checked={item.value == value}
                    onClick={() => this.fieldChange('data.form.taxTimeType', item.value)}
                    value={item.value}
                >
                    {item.label}
                </Radio>
            )
        })
    }

    onTabFocus = (params) => {
        //申报列表过来
        if (this.component.props.financeParam) {
            params = this.component.props.financeParam
            this.initData(params.sourceType, params)
        }
        //税务助手、国税局过来
        if (this.component.props.appKey) {
            const paramExternalData = this.component.props.param//this.getUrlData()
            this.initData(this.component.props.appKey, null, paramExternalData)
        }
    }
    //作废
    getUrlData = () => {
        //以下处理url跳转过来问题
        let urlData, urlSearch, urltest = 'http://127.0.0.1:8001/#/edfx-app-root/ttk-access-app-tranreport?zlbsxlDm=ZL1001003&bbbsqDm=01&sssqQ=2018-01-01&sssqZ=2018-12-31&nsrsbh=91199106726456657C&nsrmc=%E8%8D%80%E5%BD%A7%E9%A2%84%E7%BD%AE%E5%8C%97%E4%BA%AC%E5%9C%B0%E5%8C%BA%E4%BC%81%E4%B8%9A%E5%B9%B4%E6%8A%A5&zgswskfjDm=11102270000&djxh=10111101000060491334&sourceType=A02'
        urlSearch = (location && location.search.indexOf('?') >= 0) ? location.search : ((location && location.hash.indexOf('?') >= 0) ? location.hash : "?")
        //产品走此分支
        if (urlSearch.indexOf('&') < 0) {
            urlSearch = urltest
        }
        urlData = this.urlParse(decodeURI(urlSearch))
        if (typeof urlData['tmp_code'] != "undefined") {
            urlData['code'] = urlData['tmp_code']
        }
        //三种情况
        //第一种，从云财税进来，有token。不需要调接口，直接向下走
        //第二种，从国税进来，没有code，调用A接口，返回新的带有code的地址，重定向
        //第三种，重定向完毕，有code，调用B接口，获取token 和其他信息，向下走
        // if (location.href.indexOf('erp.jchl.com') >= 0
        //     || location.href.indexOf('erpdemo.jchl.com') >= 0
        //     || location.href.indexOf('erp-dzsj.jchl.com') >= 0
        //     || location.href.indexOf('erpdemo-dzsj.jchl.com') >= 0)
        return urlData
    }
    initData = async (appKey, params, paramExternalDto) => {

        // (局方版)财报转换申报10001002
        // (企业版)财报转换申报10001006
        // (福建集成版)财报转换申报10002001
        let res, response, reduceArr = []
        if (appKey) {
            if (appKey == '10001002') {  //北京局方
                //sourceType=A02 通过产品内菜单访问，演示报表转换功能使用，在发现企业信息没有设置纳税人识别号时会抛提示，调用getOrg接口
                let reduceArr = [{
                    path: 'data.step.step0Visible',
                    value: false
                }, {
                    path: 'data.step.step1Visible',
                    value: true
                }, {
                    path: 'data.step.step2Visible',
                    value: false
                }, {
                    path: 'data.step.iconVisible',
                    value: false
                }, {
                    path: 'data.other.componyVisible', //财税助手-对应得按钮
                    value: false
                }, {
                    path: 'data.other.taxVisible', //局端对应得按钮
                    value: true
                }, {
                    path: 'data.other.taxapplyVisible',//申报功能对应得按钮 
                    value: false
                }, {
                    path: 'data.other.taxapplyTipsVisible',
                    value: true
                }, {
                    path: 'data.other.isProjectAdjust',
                    value: true
                }]
                this.injections.reduce('updateArr', reduceArr)
                res = await this.webapi.tranreport.getOrg(paramExternalDto)
                if (res) {
                    reduceArr.push({
                        path: 'data.orgDto',
                        value: res.orgDto
                    })
                    reduceArr.push({
                        path: 'data.paramExternalDto',
                        value: res.paramExternalDto
                    })
                    reduceArr.push({
                        path: 'data.other.allVisible',
                        value: true
                    })
                    paramExternalDto = res.paramExternalDto
                    this.injections.reduce('updateArr', reduceArr)
                }
                this.load(paramExternalDto)
            } else if (appKey == '10002001') {//(福建集成版)财报转换                 
                let reduceArr = [{
                    path: 'data.step.step0Visible',
                    value: false
                }, {
                    path: 'data.step.step1Visible',
                    value: true
                }, {
                    path: 'data.step.step2Visible',
                    value: false
                }, {
                    path: 'data.step.iconVisible',
                    value: false
                }, {
                    path: 'data.other.componyVisible', //财税助手-对应得按钮
                    value: false
                }, {
                    path: 'data.other.taxVisible', //局端对应得按钮
                    value: true
                }, {
                    path: 'data.other.taxapplyVisible',//申报功能对应得按钮 
                    value: false
                }, {
                    path: 'data.other.taxapplyTipsVisible',
                    value: true
                }, {
                    path: 'data.other.isProjectAdjust',
                    value: true
                }]

                this.injections.reduce('updateArr', reduceArr)
                const resZlBsXlDm = await this.webapi.tranreport.queryAccountingStandards()
                let resData = resZlBsXlDm.find(element => element.zlbsxlDm == paramExternalDto.zlbsxlDm)
                paramExternalDto.accountingStandards = resData && resData.accountingStandardsId
                paramExternalDto.accountingStandardsId = resData && resData.accountingStandardsId
                reduceArr.push({
                    path: 'data.paramExternalDto',
                    value: paramExternalDto
                })
                reduceArr.push({
                    path: 'data.other.allVisible',
                    value: true
                })
                this.injections.reduce('updateArr', reduceArr)
                this.load(paramExternalDto)
            } else if (appKey == '10001006') {//企业版
                //财税助手集成 appKey="10001006"
                // "entryType": "1000090001" 财税云
                // "entryType": "1000090002" 财税助手                
                const entryType = this.component.props.entryType
                //初始化企业版基础信息
                let reduceArr = [{
                    path: 'data.step.step0Visible',
                    value: true
                }, {
                    path: 'data.step.step1Visible',
                    value: false
                }, {
                    path: 'data.step.step2Visible',
                    value: false
                }, {
                    path: 'data.step.iconVisible',
                    value: true
                }, {
                    path: 'data.other.componyVisible', //财税助手-对应得按钮
                    value: true
                }, {
                    path: 'data.other.taxVisible', //局端对应得按钮
                    value: false
                }, {
                    path: 'data.other.taxapplyVisible',//申报功能对应得按钮
                    value: false
                }, {
                    path: 'data.other.allVisible',
                    value: true
                }, {
                    path: 'data.other.taxapplyTipsVisible',
                    value: true
                }, {
                    path: 'data.other.isProjectAdjust',
                    value: true
                }]

                this.injections.reduce('updateArr', reduceArr)
                //this.injections.reduce('setLoading', 'data.other.step0loading', true)
                const taxTimeTypes = this.metaAction.gf('data.taxTimeType').toJS()//await this.webapi.tranreport.findByEnumCode({ "enumCode": "taxTimeType" })
                const accountingStandardEnums = this.metaAction.gf('data.accountStandardsForSB').toJS()//await this.webapi.tranreport.getAccountStandardsForSB({ "enumCode": "accountingStandards" })
                let querys = [], serverDate, date, curFormData, taxTimes = []
                if (entryType == '1000090002') { //财税助手
                    querys = this.metaAction.gf('data.localForm').toJS()//await this.webapi.tranreport.queryLocal()
                    curFormData = querys && querys[0]
                    serverDate = await this.webapi.tranreport.getSystemDate()
                    curFormData.systemDate = serverDate
                    date = moment(new Date(serverDate))
                } else {
                    querys = await this.webapi.tranreport.queryServer()
                    curFormData = querys && querys[0]
                    serverDate = curFormData.systemDate ? new Date(curFormData.systemDate) : new Date()
                    date = moment(serverDate)
                }
                this.injections.reduce('initForm', curFormData)
                taxTimeTypes.forEach(element => {
                    taxTimes.push({ value: element.id, label: element.name })
                })

                //按照城市区号进行排序
                let sortCity = fromJS(changeToOption(areaList, 'n', 'cityNo')).sortBy((val, index, obj) => {
                    return val.get('key')
                }, (a, b) => {
                    if (a < b) { return -1 }
                    if (a > b) { return 1 }
                    if (a === b) { return 0 }
                })

                let { arraryYear, arraySeason } = this.getEnumYearsAndSeason()
                this.injections.reduce('enumDetails', { taxTimeTypes: taxTimes, accountingStandardEnums, areaCode: sortCity, taxYears: arraryYear, taxSeasons: arraySeason })
                this.setVisibleDate(curFormData.taxTimeType)
                this.getDefaultDate(date.year(), date.month())
                //this.injections.reduce('setLoading', 'data.other.step0loading', false)
            } else if (appKey == 'A04') {//申报  
                const appraisalId = params.id
                response = await this.webapi.tranreport.querySelectReport({ appraisalId })
                if (response && !response.haveSelected) {//是否有选择的报表
                    let mutilSelect = await this.showRptSelectData(response && response.reportList, appraisalId)
                    if (!mutilSelect) {
                        return
                    }
                }
                //解决切换页签后，如果数据变更，不重新请求数据
                let editStatus = this.metaAction.gf('data.other.editStatus')
                if (editStatus) {
                    return
                }
                let reduceArr = [{
                    path: 'data.step.step0Visible',
                    value: false
                }, {
                    path: 'data.step.step1Visible',
                    value: false
                }, {
                    path: 'data.step.step2Visible',
                    value: true
                }, {
                    path: 'data.step.iconVisible',
                    value: false
                }, {
                    path: 'data.other.componyVisible', //财税助手-对应得按钮
                    value: false
                }, {
                    path: 'data.other.taxVisible', //局端对应得按钮
                    value: false
                }, {
                    path: 'data.other.taxapplyVisible',//申报功能对应得按钮
                    value: true
                }, {
                    path: 'data.other.allVisible',
                    value: true
                }, {
                    path: 'data.other.taxapplyTipsVisible',
                    value: false
                }]
                this.injections.reduce('updateArr', reduceArr)
                let bbbsqDm,
                    month = this.getDiffMonth(params.startPeriod, params.endPeriod),
                    cityNo = params.cityNo ? params.cityNo : '1100',
                    writable = params.writable//true：可编辑 false：不可编辑

                let paramExternalDto = {
                    // gdslxDm: '1',	        //国地税类型代码
                    // kjzdzzDm: '',
                    // zlbsxlDm: 'ZL1001003',	   //资料报送小类代码	 String	必填	企业会计准则对应的小类目前只支持一般企业//企业 =》 "ZL1001001" ， 小企业 =》  "ZL1001003"
                    // bbbsqDm: '03',      //报表报送期代码	 String	必填	01：年报；03：季报；04：月报
                    sssqQ: params.startPeriod,
                    sssqZ: params.endPeriod,
                    startPeriod: params.startPeriod,
                    endPeriod: params.endPeriod,
                    nsrsbh: params.nsrsbh,	       //纳税人识别号	     String	必填  北京的第2, 3位是11
                    nsrmc: params.nsrmc,       //纳税人名称
                    zgswskfjDm: params.zgswskfjDm,//cityNo.padStart('5', '0'),//'11102270000'//主管税务所科分局代码
                    //djxh: '10111101000060491228',           //登记序号
                    accountingStandardsId: params.accountingStandardsId,
                    tmpRvState: params.tmpRvState, //申报状态
                    taxProjectName: params.taxProjectName //申报项目
                }
                const rptTitleList = this.metaAction.gf('data.source.rptTitleList')
                this.injections.reduce('load', paramExternalDto, rptTitleList.toJS())
                if (month < 3) {
                    bbbsqDm = '04' //月报
                } else if (month >= 3 && month < 12) {
                    bbbsqDm = '03' //季报
                } else if (month == 12) {
                    bbbsqDm = '01' //年报
                }
                if (bbbsqDm == '01') {
                    //上传附注只有年报才显示
                    reduceArr.push({
                        path: 'data.other.yearVisible',
                        value: true
                    })
                }
                let showRptStates = this.setShowRptStates(params.zgswskfjDm, bbbsqDm)
                if (showRptStates) {
                    reduceArr = [
                        {
                            path: 'data.other.balancesheetStatus',
                            value: showRptStates.balancesheetStatus
                        }, {
                            path: 'data.other.profitstatementStatus',
                            value: showRptStates.profitstatementStatus
                        }, {
                            path: 'data.other.cashflowstatementStatus',
                            value: showRptStates.cashflowstatementStatus
                        }, {
                            path: 'data.other.appraisalId',
                            value: params.id
                        }, {
                            path: 'data.other.writable',
                            value: writable
                        }
                    ]
                }
                this.injections.reduce('updateArr', reduceArr)
                setTimeout(() => {
                    const tableHeight = this.getTableCurHeigh()
                    document.querySelector('.ttk-access-app-tranreport-step2content-content').style.height = `${tableHeight}px`
                }, 500)
                //初始化申报列表
                this.initTaxReport(paramExternalDto)
            }
        }
    }
    //初始化申报
    initTaxReport = async (paramExternalDto) => {
        LoadingMask.show()
        const res = await this.webapi.tranreport.getData(paramExternalDto)
        LoadingMask.hide()
        if (res) {
            //this.injections.reduce('setLoading', 'data.other.loading', false)
            let currentRptName = this.metaAction.gf('data.other.rpttype')

            //报表转换--选择转换利润表，成功导入后前端的tab应该切换到利润表页签上。
            let reduceArr = [{
                path: 'data.other.rpttype',
                value: currentRptName
            }, {
                path: 'data.other.editStatus',
                value: false
            }, {
                path: 'data.other.loading',
                value: false
            }, {
                path: 'data.other.isProjectAdjust',
                value: res.isProjectAdjust ? false : true   //取反,true 会计自动一致,隐藏调整项目按钮
            }]
            this.injections.reduce('updateArr', reduceArr)
            //初始化第一个报表
            const rptTitle = this.metaAction.gf('data.rptTitle')
            this.injections.reduce('setSourceRpt', res, currentRptName, rptTitle && rptTitle.toJS()[currentRptName])
            let writable = true, params = this.component.props.financeParam
            if (params) {
                writable = params.writable
            }
            if (res.needMatching && writable) {
                this.nextResponseWarning(this.getMessages(this.metaAction.gf('data.btnState.nextState')))
            }
        }
    }
    getDiffMonth = (startTime, endTime) => {
        if (!startTime || !endTime) {
            this.metaAction.toast('success', '开始结束日期不能为空！')
            return
        }
        let startDate, endDate, differMonth = 0
        if (typeof startTime == 'string') {
            startDate = moment(new Date(startTime))
        }
        if (typeof endTime == 'string') {
            endDate = moment(new Date(endTime))
        }
        differMonth = parseInt(endDate.month() - startDate.month())
        return differMonth + 1
    }
    fieldChange = async (fieldPath, value) => {
        let cityNo, resJson = {}
        if (fieldPath == 'data.form.taxTimeType') {
            this.setVisibleDate(value)
        }
        if (fieldPath == 'data.form.vatTaxpayerNum') {
            /*当纳税人识别号15位时，根据前4位确定省市代码，根据代码确定“省市”信息，
                自动带入到“省市”中去，如果无法对应则不带入“省市”信息；当纳税人识别号18位时，
                根据第3 - 6位对应的省市代码，将对应的省市信息带入到“省市”中去，如果无法对应则不带入“省市”信息；
                纳税人识别号20位时，则不自动带入省市信息。

                （备注：
                15位纳税人识别号第一二位为省级代码、第三四位为市级代码, 第五六位为区县级代码. 
                18位的纳税人识别号取值规则：第一部分（第1位），为登记管理部门代码。
                第二部分（第2位），为企业等纳税人类别代码。第三部分（第3 - 8位），
                为登记管理机关行政区划码。第四部分（第9 - 17位），为主体标识码。
                第五部分（第18位），为校验码，由系统自动生成。
                20位纳税人为个体户，只能开普票）*/
            if (value.length == 15) {
                cityNo = this.getCurCityNo(value.substr(0, 4))
                this.metaAction.sf('data.form.areaCode', cityNo)
                resJson['data.error.vatTaxpayerNum'] = ''
                resJson['data.error.areaCode'] = ''
            } else if (value.length == 18) {
                cityNo = this.getCurCityNo(value.substr(2, 4))
                this.metaAction.sf('data.form.areaCode', cityNo)
                resJson['data.error.vatTaxpayerNum'] = ''
                resJson['data.error.areaCode'] = ''
            } else if (value.length == 20) {
                this.metaAction.sf('data.form.areaCode', cityNo)
            } else if (value && value.length < 2) {
                resJson['data.error.vatTaxpayerNum'] = ''
            }
            this.metaAction.sfs(resJson)
        }
        if (fieldPath == 'data.form.areaCode') {
            resJson['data.error.areaCode'] = ''
            this.metaAction.sfs(resJson)
        }
        if (fieldPath == 'data.form.accountingStandards') {
            resJson['data.error.accountingStandards'] = ''
            this.metaAction.sfs(resJson)
        }
        this.metaAction.sf(fieldPath, value)

    }
    /**
     * 根据年、月、季选项切换控件
     */
    setVisibleDate = (value) => {
        let reduceArr = []
        if (value == '2000070001') {//月
            reduceArr.push(
                {
                    path: 'data.other.seasonVisible',
                    value: false
                }, {
                    path: 'data.other.yearDateVisible',
                    value: false
                }, {
                    path: 'data.other.monthDateVisible',
                    value: true
                }
            )
        } else if (value == '2000070002') {//季度
            reduceArr.push(
                {
                    path: 'data.other.seasonVisible',
                    value: true
                }, {
                    path: 'data.other.yearDateVisible',
                    value: false
                }, {
                    path: 'data.other.monthDateVisible',
                    value: false
                }
            )
        } else {
            //年
            reduceArr.push(
                {
                    path: 'data.other.seasonVisible',
                    value: false
                }, {
                    path: 'data.other.yearDateVisible',
                    value: true
                }, {
                    path: 'data.other.monthDateVisible',
                    value: false
                }
            )
        }
        this.injections.reduce('updateArr', reduceArr)
    }
    /**
     * 获取当前日期值
     */
    getCurrentDate = (value, nowDate) => {
        let taxDate,
            reduceArr = [],
            month = nowDate.month() + 1,
            year = nowDate.year()
        if (value == '2000070001') {//月
            taxDate = {
                sssqQ: nowDate.startOf('month').format("YYYY-MM-DD"),
                sssqZ: nowDate.endOf('month').format("YYYY-MM-DD")
            }
            reduceArr.push(
                {
                    path: 'data.form.monthTaxTime',
                    value: `${year}-${month < 10 ? `0${month}` : `${month}`}`,
                }
            )
        } else if (value == '2000070002') {//季度
            let { season, sssqQ, sssqZ } = this.getSeason(year, month)
            //季
            taxDate = {
                sssqQ: sssqQ,
                sssqZ: sssqZ
            }
            reduceArr.push(
                {
                    path: 'data.form.year',
                    value: year
                }, {
                    path: 'data.form.season',
                    value: season
                }
            )
        } else {
            //年 2000070003
            taxDate = {
                sssqQ: `${year}-01-01`,
                sssqZ: `${year}-12-31`
            }
            reduceArr.push(
                {
                    path: 'data.form.yearTaxTime',
                    value: year
                }
            )
        }
        this.metaAction.sf('data.form.sssqQ', fromJS(taxDate.sssqQ))
        this.metaAction.sf('data.form.sssqZ', fromJS(taxDate.sssqZ))
        this.injections.reduce('updateArr', reduceArr)
    }
    /**
     * 获取日期默认值
     */
    getDefaultDate = (year, month) => {
        let tmpYear, preSeason,
            reduceArr = [],
            tempMonth = month + 1
        if (tempMonth < 4) {
            tmpYear = year - 1
            preSeason = 12
        } else if (tempMonth >= 4 && tempMonth < 7) {
            tmpYear = year
            preSeason = 3
        } else if (tempMonth >= 7 && tempMonth < 10) {
            tmpYear = year
            preSeason = 6
        } else {
            tmpYear = year
            preSeason = 9
        }
        reduceArr.push(
            {
                path: 'data.form.year',
                value: tmpYear
            }, {
                path: 'data.form.season',
                value: preSeason
            }, {
                path: 'data.form.monthTaxTime',
                value: `${year}-${month < 10 ? `0${month}` : `${month}`}`,
            }, {
                path: 'data.form.yearTaxTime',
                value: year - 1
            }
        )
        this.injections.reduce('updateArr', reduceArr)
    }
    /**
     * 获取季度得起始和结束日期间隔段
     */
    getSeason = (year, season) => {
        let sssqQ, sssqZ
        if (season == 3) {
            sssqQ = `${year}-01-01`
            sssqZ = `${year}-03-31`
        } else if (season == 6) {
            sssqQ = `${year}-04-01`
            sssqZ = `${year}-06-30`
        } else if (season == 9) {
            sssqQ = `${year}-07-01`
            sssqZ = `${year}-09-30`
        } else {
            sssqQ = `${year}-10-01`
            sssqZ = `${year}-12-31`
        }
        return { season, sssqQ, sssqZ }
    }
    /**
     * 获取基础信息年和季列表
     */
    getEnumYearsAndSeason = () => {
        let arraryYear = [],
            arraySeason = [],
            nowDate = moment(new Date()),
            minYear = nowDate.year() - 20
        for (let index = nowDate.year(); nowDate.year() - 20 <= index; index--) {
            arraryYear.push({
                id: index,
                name: `${index}年`
            })
        }
        arraySeason.push(
            { id: 3, name: '一季度' },
            { id: 6, name: '二季度' },
            { id: 9, name: '三季度' },
            { id: 12, name: '四季度' },
        )
        return { arraryYear, arraySeason }
    }

    //判断是否存在历史报表数据
    isExistHistoryReportData = async (paramExternalData) => {
        let reduceArr = [], res = await this.webapi.tranreport.getReportJson(paramExternalData)
        if (res) {
            if (!(res.body && (!res.body.zcfzbBody && !res.body.lrbBody && !res.body.xjllbBody))) {
                //报表转换--选择转换利润表，成功导入后前端的tab应该切换到利润表页签上。
                let currentRptName = this.metaAction.gf('data.other.rpttype')
                //初始化第一个报表
                const rptTitle = this.metaAction.gf('data.rptTitle')
                reduceArr.push({
                    path: 'data.other.editStatus',
                    value: false
                })
                this.injections.reduce('setSourceRpt', res, currentRptName, rptTitle && rptTitle.toJS()[currentRptName])
                reduceArr = [
                    ...reduceArr,
                    {
                        path: 'data.balancesheetData',
                        value: undefined
                    }, {
                        path: 'data.cashflowstatementData',
                        value: undefined
                    }, {
                        path: 'data.profitstatementData',
                        value: undefined
                    }, {
                        //如果下一步调用接口成功，将updateState 改为false。文件名清空。返回上一步重新选择文件
                        path: 'data.btnState.updateState',
                        value: false
                    }, {
                        path: 'data.btnState.nextState',
                        value: false
                    }
                ]
                this.injections.reduce('updateArr', reduceArr)
            }
        }
    }

    /**
     * 组件从界面上移除触发
     */
    componentWillUnmount = () => {
        if (window.removeEventListener) {
            window.removeEventListener('resize', this.onResize, false)
            document.body.removeEventListener('keydown', this.bodyKeydownEvent, false)
        } else if (window.detachEvent) {
            window.detachEvent('onresize', this.onResize)
            document.body.detachEvent('onkeydown', this.bodyKeydownEvent)
        } else {
            window.onresize = undefined
        }
    }
    /**
     * 在初始化render之后只执行一次
     */
    componentDidMount = () => {
        if (window.addEventListener) {
            window.addEventListener('resize', this.onResize, false)
            document.body.addEventListener('keydown', this.bodyKeydownEvent, false)
        } else if (window.attachEvent) {
            window.attachEvent('onresize', this.onResize)
            document.body.attachEvent('onkeydown', this.bodyKeydownEvent)
        } else {
            window.onresize = this.onResize
        }
    }
    //处理在IE9、IE8按BackSpace 回退页面的问题
    bodyKeydownEvent = (e) => {
        const projectadjustbody = document.getElementById('ttk-access-app-tranreport-projectadjust')
        const tranreportbody = document.getElementById('ttk-access-app-tranreport')
        const setInfo = document.getElementById('setInfo')

        //IE8不存在document.getElementsByClassName 属性
        const inputs = this.getElementsByClassName('ant-input mk-input-number ttk-access-app-tranreport-step2content-tableCellInput')
        //获取事件对象 兼容IE8
        var eve = e || window
        ////获取document 对象的引用 兼容IE8
        var objEle = eve.target || eve.srcElement
        if (!projectadjustbody && !setInfo) {
            if (tranreportbody && inputs) {
                if (inputs.length < 1 && eve) {
                    this.bodyhandleKeyDown({ event: eve })
                } else {
                    const index = $(inputs).index(objEle)
                    if ((inputs[index] != document.activeElement)) {
                        this.bodyhandleKeyDown({ event: eve })
                    }
                }
            }
        }
    }
    bodyhandleKeyDown = (e) => {
        //e.keyCode  8:Backspace
        if (e && e.event) {
            const keydown = e && e.event
            if (keydown.type !== 'keydown' || keydown.keyCode == 8) {
                //IE
                window.event.cancelBubble = true;//停止冒泡
                window.event.returnValue = false;//阻止事件的默认行为
                //chrome
                if (keydown.preventDefault) {
                    keydown.preventDefault()
                }
                if (keydown.stopPropagation) {
                    keydown.stopPropagation()
                }

            }
        }
    }
    /**
     * 获取dom节点值，兼容IE9一下浏览器
     */
    getElementsByClassName = (className) => {
        if (document.getElementsByClassName) {
            // 使用现有方法
            return document.getElementsByClassName(className);
        } else {
            // 循环遍历所有标签，返回带有相应类名的元素
            let results = [],
                elems = document.getElementsByTagName("input");
            for (var i = 0, len = elems.length; i < len; i++) {
                if (elems[i].className.indexOf(className) != -1) {
                    results[results.length] = elems[i];
                }
            }
            return results;
        }
    }
    /**
     * 计算table滚动条
     */
    onResize = (e) => {
        let keyRandomTab = Math.floor(Math.random() * 10000)
        this.keyRandomTab = keyRandomTab
        setTimeout(() => {
            if (keyRandomTab == this.keyRandomTab) {
                this.getTableScroll('ttk-access-app-tranreport-step2content-content', 'ant-table-thead', 1, 'ant-table-body', 'data.tableOption', e)
            }
        }, 200)
    }
    //获取当前表格的高度
    getTableCurHeigh = (num = 109) => {
        let curTableHeight
        const body = document.body.clientHeight
        const header = 148
        curTableHeight = body - header - num
        return curTableHeight
    }
    /**
     * 计算table滚动条
     */
    getTableScroll = (contaienr, head, num, target, path, e) => {
        try {
            const tableCon = document.getElementsByClassName(contaienr)[0]
            if (!tableCon) {
                if (e) {
                    return
                }
                setTimeout(() => {
                    this.getTableScroll(contaienr, head, num, target, path)
                }, 500)
                return
            }
            const header = tableCon.getElementsByClassName(head)[0]
            const body = tableCon.getElementsByClassName(target)[0].getElementsByTagName('table')[0]
            const pre = this.metaAction.gf(path).toJS()
            const y = tableCon.offsetHeight - header.offsetHeight - num
            const bodyHeight = body.offsetHeight
            if (bodyHeight > y && y != pre.y) {
                this.metaAction.sf(path, fromJS({ ...pre, y }))
            } else if (bodyHeight < y && pre.y != null) {
                this.metaAction.sf(path, fromJS({ ...pre, y: null }))
            } else {
                return false
            }
        } catch (err) {
            console.log(err)
        }
    }
    /**
     * 解析url
     */
    urlParse = (url) => {
        let arr = [], obj = {};
        if (url.indexOf('?') != -1) {
            const parseStr = url.split("?")[1];
            if (parseStr.indexOf("&") != -1) {
                arr = parseStr.split("&");
                for (let i = 0; i < arr.length; i++) {
                    obj[arr[i].split("=")[0]] = arr[i].split("=")[1];
                }
            } else {
                obj[parseStr.split("=")[0]] = parseStr.split("=")[1];
            }
        }
        return obj;
    }
    /**
   * 基础信息设置
   */
    taxSettingClick = async () => {
        //更新保存设置ts
        let querys, appKey = this.component.props && this.component.props.appKey
        if (!appKey) {
            querys = await this.webapi.tranreport.queryServer()
        }
        let reduceArr = [{
            path: 'data.step.step0Visible',
            value: true
        }, {
            path: 'data.step.step1Visible',
            value: false
        }, {
            path: 'data.step.step2Visible',
            value: false
        }, {
            path: 'data.form.ts',
            value: querys && querys[0].ts //更新保存设置ts
        }, {
            path: 'data.btnState.nextState',
            value: true
        }]
        this.injections.reduce('updateArr', reduceArr)
    }

    getAccessToken = () => {
        let token = fetch.getAccessToken()
        return { token }
    }

    //基础信息保存
    formSaveClick = async () => {
        let form = this.metaAction.gf('data.form').toJS()
        //const error = this.metaAction.gf('data.error').toJS()
        const checkInfo = await this.preSaveCheck(
            [{
                path: 'data.form.vatTaxpayerNum', value: form.vatTaxpayerNum
            }, {
                path: 'data.form.accountingStandards', value: form.accountingStandards
            }, {
                path: 'data.form.areaCode', value: form.areaCode
            }])
        if (checkInfo) {
            return
        }
        //处理日期
        let nowDate
        if (form.taxTimeType == '2000070001') {//月
            nowDate = new moment(new Date(form.monthTaxTime))
        } else if (form.taxTimeType == '2000070002') {//季
            nowDate = new moment(new Date(form.year + `-${form.season < 10 ? `0${form.season}` : form.season}`))
        } else {
            nowDate = new moment(new Date(form.yearTaxTime + '-12'))
        }
        this.getCurrentDate(form.taxTimeType, nowDate)
        //this.injections.reduce('setLoading', 'data.other.step0loading', true)
        let response,
            areaCode = form.areaCode.length < 4 ? form.areaCode.padEnd('4', '0') : form.areaCode,
            registerNum,
            appKey = this.component.props && this.component.props.appKey,
            resZlBsXlDm = await this.webapi.tranreport.queryAccountingStandards()
        // 1000090001 菜单
        // 1000090002 url
        const entryType = this.component.props.entryType
        if (appKey && entryType=='1000090002') {
            //appKey: "10001006"
            form.name = "<空>"
            form.vatTaxpayer = "2000010002"
            const date = new moment(new Date(form.systemDate))
            form.enabledMonth = `${date.month() + 1 < 10 ? `0${date.month() + 1}` : date.month() + 1}`
            form.enabledYear = date.year()
            form.appKey = appKey
            form.registerNum = (areaCode || '1100').padStart('5', '0')
            LoadingMask.show()
            response = await this.webapi.tranreport.accessLogin({ ...form })
            LoadingMask.hide()
            sessionStorage['_accessToken'] = response && response.token
        } else {
            LoadingMask.show()
            response = await this.webapi.tranreport.updateEDFOrgInfo(form)
            LoadingMask.hide()
        }
        if (response) {
            const sssqQ = this.metaAction.gf('data.form.sssqQ')
            const sssqZ = this.metaAction.gf('data.form.sssqZ')
            //this.injections.reduce('setLoading', 'data.other.step0loading', false)
            let zlbsxlDmData = resZlBsXlDm.find(element => element.accountingStandardsId == form.accountingStandards)
            let paramExternalDto = {
                gdslxDm: '1',	        //国地税类型代码
                kjzdzzDm: form.accountingStandards,
                zlbsxlDm: zlbsxlDmData.zlbsxlDm,	   //资料报送小类代码	 String	必填	企业会计准则对应的小类目前只支持一般企业//企业 =》 "ZL1001001" ， 小企业 =》  "ZL1001003"
                bbbsqDm: form.taxTimeType == '2000070001' ? '04' : form.taxTimeType == '2000070002' ? '03' : '01',	       //报表报送期代码	 String	必填	01：年报；03：季报；04：月报
                sssqQ: sssqQ,	       //所属时期起	     String	必填	例	2018-03 - 01
                sssqZ: sssqZ,	       //所属时期止	     String	必填	例	2018 - 03 - 31
                nsrsbh: form.vatTaxpayerNum,//纳税人识别号	     String	必填  北京的第2, 3位是11
                nsrmc: form.name,           //纳税人名称
                zgswskfjDm: (areaCode || '1100').padStart('5', '0'),//'11102270000',	   //主管税务所科分局代码
                //djxh: '10111101000060491228',   //登记序号
                cityNo: (areaCode || '1100').padStart('5', '0'),
                accountingStandards: form.accountingStandards
            }
            paramExternalDto.zlbsxlDm = zlbsxlDmData.zlbsxlDm
            const rptTitleList = this.metaAction.gf('data.source.rptTitleList')
            this.injections.reduce('load', paramExternalDto, rptTitleList.toJS())
            let showRptStates = this.setShowRptStates(paramExternalDto.cityNo, paramExternalDto.bbbsqDm)
            const reduceArr = [{
                path: 'data.other.balancesheetStatus',
                value: showRptStates.balancesheetStatus
            }, {
                path: 'data.other.profitstatementStatus',
                value: showRptStates.profitstatementStatus
            }, {
                path: 'data.other.cashflowstatementStatus',
                value: showRptStates.cashflowstatementStatus
            }, {
                path: 'data.step.step0Visible',
                value: false
            }, {
                path: 'data.step.step1Visible',
                value: true
            }, {
                path: 'data.step.step2Visible',
                value: false
            }
            ]
            this.injections.reduce('updateArr', reduceArr)
            //判断是否存在历史数据
            this.isExistHistoryReportData(paramExternalDto)
        }
    }

    //保存校验
    preSaveCheck = async (fieldPathAndValues) => {
        let checkResults = [], resJson = {}, hasError = false
        if (!fieldPathAndValues) {
            return
        }
        for (let o of fieldPathAndValues) {
            let r = { ...o }
            if (o.path == 'data.form.vatTaxpayerNum') {
                Object.assign(r, await this.vatTaxpayerNumCheck(o.value))
            } else if (o.path == 'data.form.accountingStandards') {
                Object.assign(r, await this.accountingStandardsCheck(o.value))
            } else if (o.path == 'data.form.areaCode') {
                Object.assign(r, await this.areaCodeCheck(o.value))
            }
            checkResults.push(r)
        }
        checkResults.forEach(o => {
            resJson[o.errorPath] = o.message
            if (o.message) {
                hasError = true
            }

        })
        this.metaAction.sfs(resJson)
        return hasError
    }

    //1、校验纳税人识别号
    vatTaxpayerNumCheck = async (vatTaxpayerNum) => {
        var message
        if (!vatTaxpayerNum)
            message = '请输入纳税人识别号'
        else if (vatTaxpayerNum.length <= 14)
            message = "位数错误,请输入15、18、20位数字或字母"
        else if (vatTaxpayerNum.length > 14 && vatTaxpayerNum.length !== 15 && vatTaxpayerNum.length !== 18 && vatTaxpayerNum.length !== 20)
            message = "位数错误,请输入15、18、20位数字或字母"
        else if (vatTaxpayerNum.length > 20)
            message = "不能超过20位数字或字母"
        return { errorPath: 'data.error.vatTaxpayerNum', message }
    }
    //2、校验会计制度准则
    accountingStandardsCheck = async (accountingStandards) => {
        var message
        if (!accountingStandards)
            message = '会计制度准则'
        return { errorPath: 'data.error.accountingStandards', message }
    }
    //3、校验城市
    areaCodeCheck = async (areaCode) => {
        var message
        if (!areaCode)
            message = '请选择地区'
        return { errorPath: 'data.error.areaCode', message }
    }

    /**
     * 转为局端格式
     */
    selectLocalRptClick = async () => {
        //updateState 为false 代表没上传文件，不可以下一步
        if (!this.metaAction.gf('data.btnState.updateState')) {
            message.warning('请至少选择一个财务报表', 5);
            return
        }
        LoadingMask.show()
        let res = await this.webapi.tranreport.importDataSource(this.getParams('importDataSource'))
        LoadingMask.hide()
        if (res) {
            let reduceArr = []
            //报表转换--选择转换利润表，成功导入后前端的tab应该切换到利润表页签上。
            let isMutilSelct = 0, currentRptName,
                balancesheetData = 'balanceSheetRpt',//this.metaAction.gf('data.balancesheetData'),
                cashflowstatementData = this.metaAction.gf('data.cashflowstatementData'),
                profitstatementData = this.metaAction.gf('data.profitstatementData')
            if (balancesheetData) {
                isMutilSelct++
                currentRptName = 'balanceSheetRpt'
                _hmt && _hmt.push(['_trackEvent', '财务', '报表转换', '选择文件是“资产负债表”转为局端格式'])
            }
            if (profitstatementData) {
                isMutilSelct++
                currentRptName = 'profitStatementRpt'
                _hmt && _hmt.push(['_trackEvent', '财务', '报表转换', '选择文件是“利润表”转为局端格式'])
            }
            if (cashflowstatementData) {
                isMutilSelct++
                currentRptName = 'cashflowStatementRpt'
                _hmt && _hmt.push(['_trackEvent', '财务', '报表转换', '选择文件是“现金流量表”转为局端格式'])
            }

            if (isMutilSelct > 1) {
                if (balancesheetData) {
                    currentRptName = 'balanceSheetRpt'
                } else {
                    currentRptName = 'profitStatementRpt'
                }
            }
            reduceArr.push({
                path: 'data.other.rpttype',
                value: currentRptName
            })
            //初始化第一个报表
            const rptTitle = this.metaAction.gf('data.rptTitle')
            reduceArr.push({
                path: 'data.other.editStatus',
                value: false
            })
            this.injections.reduce('setSourceRpt', res, currentRptName, rptTitle && rptTitle.toJS()[currentRptName])
            reduceArr = [
                ...reduceArr,
                {
                    //如果下一步调用接口成功，将updateState 改为false。文件名清空。返回上一步重新选择文件
                    path: 'data.btnState.updateState',
                    value: false
                }, {
                    path: 'data.btnState.nextState',
                    value: false
                }, {
                    path: 'data.balancesheetData',
                    value: undefined
                }, {
                    path: 'data.cashflowstatementData',
                    value: undefined
                }, {
                    path: 'data.profitstatementData',
                    value: undefined
                }, {
                    path: 'data.step.step2Visible',
                    value: true
                }, {
                    path: 'data.step.step1Visible',
                    value: false
                }
            ]
            let writable = true, params = this.component.props.financeParam
            if (params) {
                writable = params.writable
            }
            if (res.needMatching && writable) {
                this.nextResponseWarning(this.getMessages(this.metaAction.gf('data.btnState.nextState')))
            } else {
                // this.metaAction.toast('success', '转为局端格式成功')
                message.success('转为局端格式成功', 5)
            }
            this.injections.reduce('updateArr', reduceArr)
        }
        LoadingMask.hide()
        setTimeout(() => {
            let tableHeight
            if (this.component.props.entryType == '1000090003'  //福建财税助手集成
                || this.component.props.entryType == '1000090002') { //财税助手独立版（有设置页面）
                tableHeight = this.getTableCurHeigh(11)
            } else {
                tableHeight = this.getTableCurHeigh()
            }
            document.querySelector('.ttk-access-app-tranreport-step2content-content').style.height = `${tableHeight}px`
        }, 100)
    }

    //点击转换的报表
    nextClick = () => {
        let reduceArr = [{
            path: 'data.step.step2Visible',
            value: true
        }, {
            path: 'data.step.step1Visible',
            value: false
        }]
        this.injections.reduce('updateArr', reduceArr)
        setTimeout(() => {
            let tableHeight
            if (this.component.props.entryType == '1000090003'  //福建财税助手集成
                || this.component.props.entryType == '1000090002') { //财税助手独立版（有设置页面）
                tableHeight = this.getTableCurHeigh(11)
            } else {
                tableHeight = this.getTableCurHeigh()
            }
            document.querySelector('.ttk-access-app-tranreport-step2content-content').style.height = `${tableHeight}px`
        }, 100)

    }

    //获取参数
    getParams = (type) => {
        let params = {},
            afferentParamsData = this.metaAction.gf('data.afferentParamsData')
        if (type == 'init') {
            params = {
                name: afferentParamsData.get('nsrmc'),
                accountingStandards: afferentParamsData.get('kjzdzzDm'),//kjzdzzDm
                enabledYear: '2017',
                enabledMonth: '03',
                vatTaxpayer: afferentParamsData.get('zlbsxlDm'),//zlbsxlDm
                vatTaxpayerNum: afferentParamsData.get('nsrsbh'),//nsrsbh
                registeredProvincial: afferentParamsData.get('nsrsbh').substr(1, 2) + '0000',//nsrsbh
                registeredCity: afferentParamsData.get('nsrsbh').substr(1, 4) + '00',
                registeredCounty: afferentParamsData.get('nsrsbh').substr(1, 4) + '00'//现在地区代码是在纳税人识别号中截取的。由于纳税人识别号中好像没有精确到县，所以先默认后面是00。1—2位为省、市代码，3—6位为地区代码，7—8位为经济性质代码
            }
            return params
        } else if (type == 'importDataSource') {
            params.analysisInputParams = []
            params.calcBalanceSheet = !!this.metaAction.gf('data.balancesheetData')
            params.calcProfitStatement = !!this.metaAction.gf('data.profitstatementData')
            params.calcCashFlowStatement = !!this.metaAction.gf('data.cashflowstatementData')
            this.metaAction.gf('data.balancesheetData')
            //获取从上游url传递过来的值
            if (afferentParamsData) {
                params.externalParam = this.metaAction.gf('data.afferentParamsData').toJS()
            }
            params.analysisInputParams = this.setRptList(params.analysisInputParams, 'balancesheet', afferentParamsData.get('nsrsbh'))
            params.analysisInputParams = this.setRptList(params.analysisInputParams, 'profitstatement', afferentParamsData.get('nsrsbh'))
            params.analysisInputParams = this.setRptList(params.analysisInputParams, 'cashflowstatement', afferentParamsData.get('nsrsbh'))
            return params
        }
    }

    //参数中添加报表信息
    setRptList = (params, name, nsrsbh) => {
        if (this.metaAction.gf(`data.${name}Data`)) {
            params.push({
                fieldId: this.metaAction.gf(`data.${name}Data.id`),
                fieldName: name,
                flag: (name == 'balancesheet' ? 1 : (name == 'profitstatement' ? 2 : 3)),
                nsrsbh: nsrsbh
            })
        }
        return params
    }

    //获取城市编号
    getCurCityNo = (fourCityNo) => {
        let topFourNo,//前四位
            topTwoNo,//前二位
            cityNo,
            resData
        topFourNo = fourCityNo.substr(0, 4)
        topTwoNo = fourCityNo.substr(0, 2)
        if (topFourNo == '2102'
            || topFourNo == '3302'
            || topFourNo == '3502'
            || topFourNo == '3702'
            || topFourNo == '4403') {
            cityNo = topFourNo
        } else {
            resData = areaList.find(function (element) {
                return element.cityNo == topTwoNo
            })
            cityNo = resData ? resData.cityNo : ''
        }
        return cityNo
    }

    //通过纳税人识别号判断是显示状态
    setShowRptStates = (zgswskfjDm, bbbsqDm) => {
        //1、	根据企业所属税务主管机关是否要求报送现金流量表，决定是否显示现金流量表的选项（北京地区企业会计准则、小企业会计准则，年报才需要现金流量表，季报月报不需要现金流量表，其他地区在收集中）。
        // 2、	现金流量表、资产负债表和利润表至少有一个不为空。（北京不需要现金流量表）
        if (!zgswskfjDm) return
        let fourfjDm,//四位
            twofjDm//两位
        fourfjDm = zgswskfjDm.substr(1, 4)//四位
        twofjDm = zgswskfjDm.substr(1, 2)//两位
        if (fourfjDm == '2102'
            || fourfjDm == '3302'
            || fourfjDm == '3502'
            || fourfjDm == '3702'
            || fourfjDm == '4403') {
            // 3、	地区判断规则
            // 取主管税务机关的第2位、第3位、第4位、第5位数字；
            // 如果截取的数字与以下编码相等，则为经济特区，它们税务报表有别于本省其他地区：
            // 编码	地区
            // 2102	大连
            // 3302	宁波
            // 3502	厦门
            // 3702	青岛
            // 4403	深圳
            return {
                balancesheetStatus: true,
                profitstatementStatus: true,
                cashflowstatementStatus: true
            }
        } else {
            if (twofjDm == '11' && bbbsqDm != '01') {//如果地区的前两位是11就认为是北京
                return {
                    balancesheetStatus: true,
                    profitstatementStatus: true,
                    cashflowstatementStatus: false
                }
            } else {
                return {
                    balancesheetStatus: true,
                    profitstatementStatus: true,
                    cashflowstatementStatus: true
                }
            }
        }
    }

    // 渲染选择文件
    renderUpload = (key) => {
        const file = this.metaAction.gf('data.uploadFile')
        const accountingStandards = this.metaAction.gf('data.afferentParamsData.accountingStandards') || this.metaAction.gf('data.afferentParamsData.accountingStandardsId')
        let token = fetch.getAccessToken()
        const props = {
            action: location.protocol + '//' + location.host + '/v1/reportconverter/upload?flag=' + (key == 'balancesheet' ? 1 : (key == 'profitstatement' ? 2 : 3)) + '&accountingStandards=' + accountingStandards + '&token=' + token,
            showUploadList: false,
            accept: '.xls, .xlsx'
        }
        let originalName
        if (key == 'balancesheet') {
            originalName = this.metaAction.gf('data.balancesheetData') ? this.metaAction.gf('data.balancesheetData.originalName') : ''
        } else if (key == 'profitstatement') {
            originalName = this.metaAction.gf('data.profitstatementData') ? this.metaAction.gf('data.profitstatementData.originalName') : ''
        } else if (key == 'cashflowstatement') {
            originalName = this.metaAction.gf('data.cashflowstatementData') ? this.metaAction.gf('data.cashflowstatementData.originalName') : ''
        }
        return (
            <div style={{ display: 'flex' }}>
                <div style={{ color: originalName ? '#535252' : '#c3c3c3', display: 'inline-block', marginLeft: '8px', whiteSpace: 'nowrap', border: '1px solid #d9d9d9', width: '330px', height: '35px', margintop: '2px', 'background': '#fff' }} title={originalName}
                    className='update-balancesheet-item-content-input'>
                    <span className="update-balancesheet-item-content-input-text">{originalName ? originalName : '请上传采集好的数据文件'}</span>
                    {originalName ? <Icon type='cuowutishi' fontFamily='edficon' className='update-shanchu-icon' onClick={this.delUpdate(key)} ></Icon> : ''}
                </div>
                <Upload onChange={this.handleOnChange(key)} {...props} beforeUpload={this.excelbeforeUpload}
                    style={{ display: 'inline-block', width: '100px', height: '35px', marginLeft: '10px', margintop: '2px', 'lineHeight': '38px' }}>
                    <Button style={{ height: '35px', 'borderRadius': '0px', 'lineHeight': '38px', 'textAlign': 'center', display: 'inline-block', width: '100%', 'cursor': 'pointer' }}>{originalName ? `重选文件` : `选择文件`}</Button>
                </Upload>
            </div>
        )
    }

    excelbeforeUpload = (file) => {
        let isWin = (navigator.platform == "Win32") || (navigator.platform == "Windows") || (navigator.platform == "MacIntel" && navigator.userAgent.toLowerCase().indexOf('chrome') < 0)
        if (!isWin) return
        let type = file.type ? file.type : 'application/vnd.ms-excel'
        if (!(type == 'application/vnd.ms-excel'
            || type == 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet')) {
            this.metaAction.toast('error', '仅支持上传Excel格式的文件')
            return false
        }
        return this.beforeUpload(file)
    }

    beforeUpload = (file, filetype) => {
        const isLt10M = file.size / 1024 / 1024 < 10;
        if (file.size && !isLt10M) {
            this.metaAction.toast('warning', '文件过大，请上传小于10MB的附件')
            return false
        }
    }

    //删除上传文件
    delUpdate = (key) => {
        return async () => {
            let res = this.webapi.tranreport.deleteDataSource([{
                fieldId: this.metaAction.gf(`data.${key}Data.id`),
                fieldName: key
            }])
            if (res) {
                let reduceArr = []
                if (key == "balancesheet") {
                    reduceArr.push({
                        path: 'data.balancesheetData',
                        value: undefined
                    })
                    // this.metaAction.sf('data.balancesheetData', undefined)
                } else if (key == "profitstatement") {
                    reduceArr.push({
                        path: 'data.profitstatementData',
                        value: undefined
                    })
                    // this.metaAction.sf('data.profitstatementData', undefined)
                } else if (key == "cashflowstatement") {
                    reduceArr.push({
                        path: 'data.cashflowstatementData',
                        value: undefined
                    })
                    // this.metaAction.sf('data.cashflowstatementData', undefined)
                }
                if (!this.metaAction.gf('data.balancesheetData') &&
                    !this.metaAction.gf('data.profitstatementData') &&
                    !this.metaAction.gf('data.cashflowstatementData')) {
                    reduceArr.push({
                        path: 'data.btnState.updateState',
                        value: false
                    })

                }
                // this.metaAction.toast('success', '文件删除成功')
                this.injections.reduce('updateArr', reduceArr)
                message.success('文件删除成功', 5)
            }
        }
    }

    // 上传文件
    handleOnChange = (key) => {
        return (info) => {
            // if (!info.file.status) {
            //     // this.metaAction.toast('error', '仅支持上传Excel格式的文件')
            //     message.warning('仅支持上传Excel格式的文件',5);
            //     return
            // }
            LoadingMask.show()
            if (info.file.status == 'done') {
                LoadingMask.hide()
                if (info.file.response.result && info.file.response.value) {
                    // this.metaAction.toast('success', '文件上传成功')
                    message.success('文件上传成功', 5)
                    this.injections.reduce('uploadFile', info.file.response.value, key)
                } else {
                    this.uploadResponseWarning([info.file.response.error.message])
                }
            } else if (info.file.status === 'error') {
                LoadingMask.hide()
                // this.metaAction.toast('warning', '文件上传失败')
                message.warning('文件上传失败', 5);
            }
        }
    }

    //获取 上传界面的提示文本
    getUpdatePrompt = () => {
        let zlbsxlDm = this.metaAction.gf('data.afferentParamsData.zlbsxlDm')
        return <div>
            <p>注：目前支持会计准则（适用于一般企业/商业银行/证券公司/保险公司/担保企业）、小企业会计准则、事业单位会计制度。</p>
            {
                zlbsxlDm == 'ZL1001001' ?
                    <p>请上传从财务软件导出的Excel格式的财务报表，可只上传一个报表。请确保本期金额是本年累计金额，上期金额是去年同期累计金额。</p> :
                    (zlbsxlDm == 'ZL1001003' ?
                        <p>请上传从财务软件导出的Excel格式的财务报表，可只上传一个报表。请确保上年金额是去年全年累计金额。</p> :
                        <p>请上传从财务软件导出的Excel格式的财务报表，可只上传一个报表。并确保报表数据与申报所属期一致。</p>
                    )
            }
        </div>
    }


    //提示内容
    getDisplayErrorMSg = (errorMsg, headerRow, footerRow) => {
        //footerRow
        return <div style={{ display: 'inline-table' }}>
            {headerRow ? <div style={{ 'fontSize': '14px', color: '#2F2F2F', marginBottom: '13px', 'lineHeight': '18px' }}>{headerRow}<br /></div> : ''}
            {errorMsg.map((item, index) => {
                return <div style={{ 'fontSize': '12px', color: '#484848' }}>{item}<br /></div>
            })}
            {false ? <div style={{ 'fontSize': '12px', color: '#484848', marginTop: '13px' }}>
                立即<a style={{ display: 'inline-block', 'paddingLeft': '2px' }} className='care-adjustproject-link' href="javascript:;" onClick={this.handleAdjustClick} >调整项目</a>
            </div> : ''}
        </div>
    }

    /**
     * 调整项目处理事件
     */
    handleAdjustClick = () => {
        let btnDom = document.querySelector('.ant-confirm-btns .ant-btn-primary')
        if (btnDom) {
            btnDom.click()
        }

        let that = this
        window.setTimeout(function () {
            that.projectAdjustClick(true)
        }, 100)
    }

    getMessages = (type) => {   //提示文本
        let arr = []
        if (type) {//初次导入，如果存在未完全匹配（即名称完全相同）的行与列的时候
            arr.push('原表与局端报表有不一致的项目，请调整项目对应关系。调整后，以后征期可直接导入啦')
        } else {//后续导入报表，如果出现新的未匹配项目
            arr.push('报表格式发生了变化，变化的部分与局端报表项目不匹配，请调整项目对应关系。')
        }
        return arr
    }

    handleWarningClick = async () => {//调用提示框的方法
        let rpt = await this.nextResponseWarning(this.getMessages(1))
        if (rpt) {
        }
    }

    //返回提示框
    responseWarning = async (messages, headerRow, footerRow, messageType = 'warning', type = '', modalwidth) => {
        let rpt = await this.metaAction.modal(messageType, {
            content: type == '' ? this.getDisplayErrorMSg(messages, headerRow, footerRow) : this.formatMessage(messages),
            okText: '确定',
            width: modalwidth,
            className: 'tranreport-prompt-modal'
        })
        if (rpt) {
        }
    }
    //点击转为局端格式提示框
    nextResponseWarning = async (messages) => {
        let rpt = await this.responseWarning(messages, undefined, true)
        return rpt
    }
    //上传文件提示框
    uploadResponseWarning = async (messages) => {
        let rpt = await this.responseWarning(messages, '导入问题：')
        return rpt
    }
    //生成提示框
    generateResponseWarning = async (messages) => {
        let rpt = await this.responseWarning(messages, '生成问题：')
        return rpt
    }
    //申报生成提示框
    generateTaxReportWarning = async (messages, type, messageType) => {
        let rpt = await this.responseWarning(messages, '', '', messageType, type, 700)
        return rpt
    }
    /**
     * 表格样式
     */
    assetOrProjectStyle = (record) => {
        // return record.summary == '本月合计' || record.summary == '本年累计' ? 'total_data_weight' : ''
        // return ''

    }

    /**
     * 渲染cell金额框
     */
    renderCellTextBox = (columnName, coltitle, v, rowIndex) => {
        let list = this.metaAction.gf('data.source.dataList'),
            currformula = list.get(rowIndex).get('sum' + this.indexTitleCase(columnName)),
            text = list && (list.get(rowIndex).get(columnName) != "0.00") ? list.get(rowIndex).get(columnName) : '',
            editable = list.get(rowIndex).get(columnName) == '' ? false : (list.get(rowIndex).get('isSumRow') && currformula) ? false : true,
            precision = 2,
            customAttribute = this.metaAction.gf('data.other.customAttribute'), //为了只有操作另一个input时才去render input
            maxValue = 99999999999999.99,
            minValue = -99999999999999.99

        return (
            <EditableCell
                editable={editable}
                value={number.toFixedLocal(text, precision)}
                onBlur={(value) => this.handleBlur(rowIndex, columnName, value, coltitle, maxValue)}
                onEnter={(e) => this.handleEnter(e, rowIndex, columnName, coltitle, maxValue)}
                // onkeydown={(e) => this.handleKeyDown(e, rowIndex, columnName)}
                toFixedLocal={() => number.toFixedLocal(text, precision)}
                precision={precision}
                customAttribute={customAttribute}
            />
        )
    }
    /**
     * input金额框失去焦点时处理的事件
     */
    handleBlur = (rowIndex, columnName, value, coltitle, maxValue) => {
        let list = this.metaAction.gf('data.source.dataList'),
            oldValue = list.get(rowIndex).get(columnName),
            newValue = number.transferData(value, 2),
            colMaxValue = '99,999,999,999,999.99'
        if (newValue && newValue.indexOf && newValue.indexOf(',') > -1) {
            //对于修改格式化好的数字 避免isNaN为true
            newValue = newValue.replace(/,/g, '')
        }
        if (newValue > maxValue) {
            if (oldValue == ' ') {
                newValue = '0.00'
            } else {
                newValue = ' '
            }
            list = list.update(rowIndex, item => {
                item = item.set(columnName, newValue)
                return item
            })
            this.metaAction.sf('data.source.dataList', list)
            // this.metaAction.toast('warning', `${coltitle}不能大于${colMaxValue},请调整`)
            message.warning(`${coltitle}不能大于${colMaxValue},请调整`, 5);
            return
        }
        if (newValue < -maxValue) {
            if (oldValue == ' ') {
                newValue = '0.00'
            } else {
                newValue = ' '
            }
            list = list.update(rowIndex, item => {
                item = item.set(columnName, newValue)
                return item
            })
            this.metaAction.sf('data.source.dataList', list)
            // this.metaAction.toast('warning', `${coltitle}不能小于-${colMaxValue},请调整`)
            message.warning(`${coltitle}不能小于-${colMaxValue},请调整`, 5);
            return
        }
        if (isNaN(newValue)) {
            // this.metaAction.toast('warning', '请输入数字')
            message.warning('请输入数字', 5);
            return
        }
        let reduceArr = []
        if (oldValue != newValue) {
            //编辑状态
            reduceArr.push({
                path: 'data.other.editStatus',
                value: true
            })
            // this.metaAction.sf('data.other.editStatus', true)
        }
        //先把当前值保存进去
        list = list.update(rowIndex, item => item.set(columnName, number.format(newValue, 2)))
        reduceArr.push({
            path: 'data.source.dataList',
            value: list
        })
        // this.metaAction.sf('data.source.dataList', list)
        const customAttribute = Math.random()
        reduceArr.push({
            path: 'data.other.customAttribute',
            value: customAttribute
        })
        this.injections.reduce('updateArr', reduceArr)
        //递归计算合计行的值
        this.calculateTotalData(rowIndex, columnName)
    }
    /**
     * 按enter键切换金额控件
     */
    handleEnter = (e, rowIndex, columnName, coltitle, maxValue) => {
        if (e.keyCode == 13 || e.key == 'Enter' || e.keyCode == 108) {
            const inputs = this.getElementsByClassName('ant-input mk-input-number ttk-access-app-tranreport-step2content-tableCellInput')
            const index = $(inputs).index(e.target)
            let newValue = e.target.value,
                colMaxValue = '99,999,999,999,999.99'
            if (newValue && newValue > maxValue) {
                // this.metaAction.toast('warning', `${coltitle}不能大于${colMaxValue},请调整`)
                message.warning(`${coltitle}不能大于${colMaxValue},请调整`, 5);
                return
            }
            if (newValue && newValue < -maxValue) {
                // this.metaAction.toast('warning', `${coltitle}不能小于-${colMaxValue}，请调整`)
                message.warning(`${coltitle}不能小于-${colMaxValue}，请调整`, 5);
                return
            }
            if (newValue && newValue.indexOf(',') > -1) {
                newValue = newValue.replace(/,/g, '')
            }
            if (isNaN(newValue)) {
                // this.metaAction.toast('warning', '请输入数字')
                message.warning('请输入数字', 5);
                return
            }
            inputs[index + 1].focus()
        }
    }
    /**
        * 计算合计行的值
        */
    calculateTotalData = (rowIndex, columnName) => {
        let totalValue,
            currformula,
            allFormulaList = this.metaAction.gf('data.source.allFormulaList'),
            //currentValue = list.get(rowIndex).get(columnName),
            isMutilColFormula = this.metaAction.gf('data.source.isMutilColFormula'),
            currFormulaList = [],
            parentFormulas = []

        /* 表达式计算说明*
         *"col2_17+col2_18+col2_19+col2_20+col2_21+col2_22+col2_23+col2_24+col2_25+col2_26+col2_27+col2_28+col2_29+col2_30+col2_31+col2_32+col2_33"
         *  colFormula : "{0}>0?{1}:{2}" sumListData:["col1:2", "col1:2+col1:3", "col1:4"] totalCol:"col4_15"
         * colFormula :"col1_2+col1_3+col1_4+col1_5+col1_6+col1_7+col1_8+col1_9+col1_10+col1_11+col1_12+col1_13+col1_14"totalCol:"col1_15"
         * //isSumCol:true,sumCol0:'1+2-3+4+6'，sumCol3:'1+2-3+4+6'，sumCol1:'1+2-3+4+6'，sumCol1:'1+2-3+4+6'
         *1、判断当前列是否存在需要合计的行 isSumCol:true 表示需要合计
         *2、根据columnName 解析当前行对应的表达式 例如：columnName='col1',当前行对应的表达式(col1:'1+2-3+4+5') col1:表示列名，后面的值表示：合计行通过以上行的索引值计算
         *3、计算结果更新到合计行,如果当前修改的是合计行，则忽略当前行的计算
         */



        /**
        * 测试数据开始
        */
        // for (let _rowIndex = 0; _rowIndex < allFormulaList.size; _rowIndex++) {
        //     let rowData = allFormulaList.get(_rowIndex).toJS()
        //     console.log(`${rowData.totalCol}${rowData.colFormula}`)
        // }

        /**
       * 测试数据结束
       */
        if (allFormulaList) {
            let colFormulaName = `${columnName}_${rowIndex + 1}`
            currFormulaList = this.getCurrFormulaList(allFormulaList, columnName)
            //计算当且列
            this.findColNextTotalValue(colFormulaName, fromJS(currFormulaList), columnName, parentFormulas)
            //存在跨列计算表达式
            if (isMutilColFormula) {
                //跨列
                let allColumns = this.metaAction.gf('data.source.allColumns') ? this.metaAction.gf('data.source.allColumns').toJS() : []
                for (let index = 0; index < parentFormulas.length; index++) {
                    const element = parentFormulas[index]
                    for (let _rowIndex = 0; _rowIndex < allColumns.length; _rowIndex++) {
                        let col = allColumns[_rowIndex]
                        if (col != columnName) {
                            currFormulaList = this.getCurrFormulaList(allFormulaList, col)
                            let parFormulas = []
                            //计算当且列
                            this.findColNextTotalValue(element, fromJS(currFormulaList), columnName, parFormulas)
                        }
                    }
                }
            }
        }

        // totalValue = this.splitFormula(list, columnName, currformula.split(':') && currformula.split(':')[1])
        //需求参照->企业会计准则（一般行业）财务报表格式变更
        //特殊处理 企业会计总则 校验但不自动计算：净利润=持续经营净利润+终止经营净利润 更新（一）持续经营净利润（净亏损以“-”号填列）
        let accountingStandards = this.metaAction.gf('data.afferentParamsData.accountingStandards') || this.metaAction.gf('data.afferentParamsData.accountingStandardsId'),
            curRptType = this.metaAction.gf('data.other.rpttype'),
            list = this.metaAction.gf('data.source.dataList')
        if (accountingStandards == '2000020001' && curRptType == 'profitStatementRpt') {//企业会计总则并且是利润表
            for (let index = 0; index < parentFormulas.length; index++) {
                const element = parentFormulas[index]
                if (element == 'col1_18' || element == 'col2_18') {
                    let _rowIndex = element.split('_')[1],
                        currentValue = list.get(_rowIndex - 1).get(columnName)
                    list = list.update(_rowIndex, item => item.set(columnName, currentValue))
                    list = list.update(19, item => item.set(columnName, '0.00'))
                    this.metaAction.sf('data.source.dataList', list)
                    break
                }
            }
        }
    }

    //递归查找当前列下一个合计行值
    findColNextTotalValue = (formulaName, currFormulaList, columnName, parentFormulas) => {
        // let totalValue, formulas = []
        // for (let i = 0; i < currFormulaList.length; i++) {
        //     let strs = totalGridRow[i].value.replace(/\+/g, ',').replace(/\-/g, ',')
        //     let minusstrs = strs.split(',')
        //     //处理减法
        //     for (let j = 0; j < minusstrs.length; j++) {
        //         if (minusstrs[j] == rowIndex) {
        //             formulas.push(totalGridRow[i])
        //         }
        //     }
        // }
        // let list = this.metaAction.gf('data.source.dataList')
        // if (formulas && formulas.length < 1) {
        //     return
        // }

        // for (let i = 0; i < formulas.length; i++) {
        //     totalValue = this.splitFormula(list, columnName, formulas[i].value)
        //     //更新合计值
        //     list = list.update(formulas[i].key - 1, item => item.set(columnName, totalValue))
        //     this.metaAction.sf('data.source.dataList', list)
        //     this.findNextTotalValue(formulas[i].key, totalGridRow, columnName)
        // }

        let totalValue, list = this.metaAction.gf('data.source.dataList')
        parentFormulas.push(formulaName)
        for (let _rowIndex = 0; _rowIndex < currFormulaList.size; _rowIndex++) {
            let rowData = currFormulaList.get(_rowIndex),
                colFormula = rowData.get('colFormula'),
                totalCol = rowData.get('totalCol')
            // "sumCol4": "{0}>0?{1}:{2}",
            //     "sumListCol4": ["col4:2", "col4:2+col4:3", "col4:4"],
            if (!colFormula.includes(formulaName) && !colFormula.includes('?')) {
                continue
            }
            //1、判断当前是否包含编辑列,优先查找当前编辑列 2、带条件判断
            let col = totalCol && totalCol.split('_'),
                key = col[0],
                value = col[1]

            if (colFormula.includes('?')) {
                let sumListData = rowData.get('sumListData'),
                    isExist = false
                for (let index = 0; index < sumListData.size; index++) {
                    const element = sumListData.get(index)
                    let keyFormula = element.replace(/:/g, '_')
                    totalValue = this.splitFormula(list, columnName, keyFormula)
                    colFormula = colFormula.replace(`{${index}}`, totalValue)
                    if (keyFormula.includes(formulaName)) {
                        isExist = true
                    }
                }
                if (!isExist) {
                    continue
                }
                let condtionResult = eval(colFormula)
                //更新合计值
                list = list.update(value - 1, item => item.set(key, condtionResult))
            } else {

                if (!this.isFullReplace(colFormula, formulaName)) {
                    //没有完全匹配续找
                    continue
                }
                totalValue = this.splitFormula(list, columnName, colFormula)
                //更新合计值
                list = list.update(value - 1, item => item.set(key, totalValue))
            }
            this.metaAction.sf('data.source.dataList', list)

            let nextFormulaList = currFormulaList.delete(_rowIndex)
            return this.findColNextTotalValue(totalCol, nextFormulaList, columnName, parentFormulas)
        }
    }

    //当前值是否完全匹配
    isFullReplace = (colFormula, colName) => {
        let res,
            strCols = colFormula.replace(/\+/g, ',').replace(/\-/g, ',')
        let minusstrs = strCols.split(',')
        res = minusstrs.find(function (element) {
            return element == colName
        })
        return res
    }

    //获取当且列表达式
    getCurrFormulaList = (allFormulaList, columnName) => {
        let currFormulaList = []
        for (let _rowIndex = 0; _rowIndex < allFormulaList.size; _rowIndex++) {
            let rowData = allFormulaList.get(_rowIndex)
            if (rowData.get('totalCol').startsWith(`${columnName}_`)) {
                currFormulaList.push(rowData.toJS())
            }
        }
        return currFormulaList
    }

    //转换列头第一个字母为大写
    indexTitleCase = (str) => {
        return str.toLowerCase().replace(/( |^)[a-z]/g, (L) => L.toUpperCase());
    }
    /**
      * 拆分表达式，做加减运算
      */
    splitFormula = (list, columnName, formula) => {
        // 行索引col1:2+3+4+5+6+7+8+9+10+11+12
        let result = 0,
            newTextArr = [],
            tmpTextArr,
            plusStrs = formula.split('+')
        for (let i = 0; i < plusStrs.length; i++) {
            //处理加法
            if (plusStrs[i].indexOf('-') < 0) {
                let strs = plusStrs[i].split('_'),
                    colName = strs[0],
                    colIndex = strs[1]
                let plus = number.transferData(list.get(colIndex - 1).get(colName))
                if (i == 0) {
                    newTextArr.push(plus)
                } else {
                    if (plus < 0) {
                        newTextArr.push('-')
                        newTextArr.push(Math.abs(plus))
                    } else {
                        newTextArr.push('+')
                        newTextArr.push(plus)
                    }
                }
            } else {
                let minusStrs = plusStrs[i].split('-')
                //处理减法
                for (let j = 0; j < minusStrs.length; j++) {
                    let strs = minusStrs[j].split('_'),
                        colName = strs[0],
                        colIndex = strs[1]
                    let minus = number.transferData(list.get(colIndex - 1).get(colName))
                    if (j == 0) {
                        if (minus < 0) {
                            newTextArr.push('-')
                            newTextArr.push(Math.abs(minus))
                        } else {
                            newTextArr.push('+')
                            newTextArr.push(minus)
                        }

                    } else {
                        if (minus < 0) {
                            newTextArr.push('+')
                            newTextArr.push(Math.abs(minus))
                        } else {
                            newTextArr.push('-')
                            newTextArr.push(minus)
                        }
                    }
                }
            }
        }
        tmpTextArr = newTextArr.join('')
        try {
            result = eval(tmpTextArr)
        } catch (exception) {
            console.log(exception)
        }
        return number.format(result, 2)
    }
    /**
     * 报表类型切换（作废）
     */
    rptTypeChange = (path, value) => {
        const rptTitle = this.metaAction.gf('data.rptTitle').toJS(),
            params = this.preSaveData()
        if (params) {
            this.injections.reduce('setSourceRpt', params, value, rptTitle[value])
        }
        this.metaAction.sf(path, value)
        //计算滚动条
        setTimeout(() => {
            this.onResize()
        }, 20)
    }
    //tab 页签切换
    tabChange = (path, value) => {
        const rptTitle = this.metaAction.gf('data.rptTitle').toJS(),
            params = this.preSaveData()
        if (params) {
            this.injections.reduce('setSourceRpt', params, value, rptTitle[value])
        }
        this.metaAction.sf(path, value)
    }
    /**
     * 选择表单
     */
    selectRptClick = async () => {
        let appraisalId = this.metaAction.gf('data.other.appraisalId')  //清册ID
        const response = await this.webapi.tranreport.querySelectReport({ appraisalId })
        const res = await this.showRptSelectData(response && response.reportList, appraisalId)
        if (res) {
            //生成
            let params = await this.preSaveData(),
                editStatus = this.metaAction.gf('data.other.editStatus'),
                afferentParamsData = this.metaAction.gf('data.afferentParamsData') && this.metaAction.gf('data.afferentParamsData').toJS()

            afferentParamsData['accountingStandardsId'] = afferentParamsData.accountingStandards || afferentParamsData.accountingStandardsId
            //状态变化，保存报表数据
            if (editStatus) {
                params.paramDto = afferentParamsData
                LoadingMask.show()
                let saveRes = await this.webapi.tranreport.saveReport(params)
                LoadingMask.hide()
                if (saveRes) {
                    this.metaAction.sf('data.other.editStatus', false)
                }
            }
            //初始化申报列表
            this.initTaxReport(afferentParamsData)
        }
    }
    //申报-保存
    saveRptClick = async () => {
        //生成
        let params = await this.preSaveData(),
            editStatus = this.metaAction.gf('data.other.editStatus'),
            afferentParamsData = this.metaAction.gf('data.afferentParamsData') && this.metaAction.gf('data.afferentParamsData').toJS()
        if (!editStatus) {
            message.warning('数据没有修改,不允许保存！', 5)
            return
        }
        afferentParamsData['accountingStandardsId'] = afferentParamsData.accountingStandards || afferentParamsData.accountingStandardsId
        //状态变化，保存报表数据
        if (editStatus) {
            params.paramDto = afferentParamsData
            LoadingMask.show()
            let res = await this.webapi.tranreport.saveReport(params)
            LoadingMask.hide()
            if (res) {
                message.success('数据保存成功。', 5)
                this.metaAction.sf('data.other.editStatus', false)
            }
        }
    }
    //弹出表单选择界面
    showRptSelectData = async (option, appraisalId) => {
        const ret = await this.metaAction.modal('show', {
            title: '表单选择',
            okText: '保存',
            width: 700,
            style: { top: 40 },
            bodyStyle: { padding: '8px', height: 300 },
            children: this.metaAction.loadApp('ttk-access-app-tranreport-rptselect', {
                store: this.component.props.store,
                initData: {
                    option,
                    appraisalId
                }

            })
        })
        return ret
    }
    //重新取数
    reQueryRptClick = async () => {
        let paramExternalDto = this.metaAction.gf('data.afferentParamsData') && this.metaAction.gf('data.afferentParamsData').toJS()
        //this.injections.reduce('setLoading', 'data.other.loading', true)
        LoadingMask.show()
        paramExternalDto.reCalc = true //重新取数
        const res = await this.webapi.tranreport.getData(paramExternalDto)
        LoadingMask.hide()
        if (res) {
            //报表转换切换到对应得页签上。
            const currentRptName = this.metaAction.gf('data.other.rpttype')

            //this.injections.reduce('setLoading', 'data.other.loading', false)
            //初始化第一个报表
            const rptTitle = this.metaAction.gf('data.rptTitle')
            this.injections.reduce('setSourceRpt', res, currentRptName, rptTitle && rptTitle.toJS()[currentRptName])
            //虽然准则制度不一样，但已过申报期，进财务报表查看。 
            let writable = true, params = this.component.props.financeParam
            if (params) {
                writable = params.writable
            }
            if (res.needMatching && writable) {
                this.nextResponseWarning(this.getMessages(this.metaAction.gf('data.btnState.nextState')))
            }
            message.success('重新取数成功。', 5)
        }
    }
    //更多
    moreActionOpeate = (e) => {
        this[e.key] && this[e.key]()
    }
    /**
     * 下载pdf
     */
    downRptPdfClick = async () => {
        let params = this.metaAction.gf('data.afferentParamsData') && this.metaAction.gf('data.afferentParamsData').toJS()
        params.reportCode = "balanceSheet" //todo 暂时支持下载一张pdf
        const res = await this.webapi.tranreport.downloadPdf(params)
        if (res) {
            message.success('下载pdf成功', 5)
            return
        }

    }
    /**
     * 上传附件
     */
    uploadAttachClick = async () => {
        const ret = await this.metaAction.modal('show', {
            title: '上传附注',
            width: 791,
            okText: '保存',
            children: this.metaAction.loadApp('ttk-access-app-tranreport-import', {
                store: this.component.props.store,
                sourceType: 'tranreport',
                id: '123'
            }),
        })
    }
    //申报
    taxDeclareRptClick = async () => {
        let params = await this.preSaveData(),
            editStatus = this.metaAction.gf('data.other.editStatus'),
            afferentParamsData = this.metaAction.gf('data.afferentParamsData') && this.metaAction.gf('data.afferentParamsData').toJS()
        afferentParamsData['accountingStandardsId'] = afferentParamsData.accountingStandards || afferentParamsData.accountingStandardsId
        params.isReturnValue = true
        afferentParamsData['editStatus'] = editStatus || false
        params.paramDto = afferentParamsData
        //this.webapi.tranreport.glReportDeclare(params)
        //this.webapi.tranreport.glReportDeclareWithCheck(params)        
        let resMessage
        LoadingMask.show()
        let response = await this.webapi.tranreport.glReportDeclareWithSaveAndCheck(params)
        LoadingMask.hide()
        if (response.result == false && response.error != undefined) {
            resMessage = `尊敬的${afferentParamsData.nsrmc}（${afferentParamsData.nsrsbh}）：<br>    您的属期为[${afferentParamsData.sssqQ}]至[${afferentParamsData.sssqZ}]的[${afferentParamsData.taxProjectName}]<br>已申报失败。<br>失败原因：${response.error.message}`
            //message.error(this.formatMessage(response.error.message), 5)
            this.generateTaxReportWarning(resMessage, 'tax', 'error')
        } else {
            resMessage = `尊敬的${afferentParamsData.nsrmc}（${afferentParamsData.nsrsbh}）：<br>    您的属期为[${afferentParamsData.sssqQ}]至[${afferentParamsData.sssqZ}]的[${afferentParamsData.taxProjectName}]<br>已申报成功。`
            this.generateTaxReportWarning(resMessage, 'tax', 'success')
        }


    }

    formatMessage = (message) => {
        message = message.split('<br>')
        return (
            <div style={{ textAlign: 'left', "white-space": 'pre', "margin-top": '-8px' }}>
                {
                    message.map((o, i) => {
                        return (
                            <div>{o}</div>
                        )
                    })
                }
            </div>
        )
    }

    /**
     * 重传Excel
     */
    reSelectRptClick = async () => {
        const editStatus = this.metaAction.gf('data.other.editStatus')
        if (editStatus) {
            //保存报表
            const params = await this.preSaveData(),
                afferentParamsData = this.metaAction.gf('data.afferentParamsData') && this.metaAction.gf('data.afferentParamsData').toJS()
            afferentParamsData['accountingStandardsId'] = this.metaAction.gf('data.paramExternalDto') && this.metaAction.gf('data.paramExternalDto').toJS().accountingStandardsId

            params.paramDto = afferentParamsData
            let res = await this.webapi.tranreport.saveReport(params)
            if (res) {
                this.metaAction.sf('data.other.editStatus', false)
            }
        }
        const rptTitle = this.metaAction.gf('data.rptTitle').toJS(),
            rpttype = this.metaAction.gf('data.other.rpttype')
        //添加埋点
        _hmt && _hmt.push(['_trackEvent', '财务', '报表转换', `选择文件是${rptTitle[rpttype]}重传Excel`])
        //重新选择报表
        this.injections.reduce('updateArr', [{
            path: 'data.step.step1Visible',
            value: true
        }, {
            path: 'data.step.step2Visible',
            value: false
        }])
    }

    // 将报表导出为Excel
    downloadRptClick = async () => {
        //生成
        let params = await this.preSaveData(),
            editStatus = this.metaAction.gf('data.other.editStatus'),
            afferentParamsData = this.metaAction.gf('data.afferentParamsData') && this.metaAction.gf('data.afferentParamsData').toJS()
        //状态变化，保存报表数据
        if (editStatus) {
            params.paramDto = afferentParamsData
            let res = await this.webapi.tranreport.saveReport(params)
            if (res) {
                this.metaAction.sf('data.other.editStatus', false)
            }
        }
        const checkParams = { startPeriod: afferentParamsData.sssqQ, endPeriod: afferentParamsData.sssqZ, accountingStandardsId: afferentParamsData.accountingStandards || afferentParamsData.accountingStandardsId, ...afferentParamsData }

        //校验报表
        if (checkParams) {
            let check = await this.webapi.tranreport.checkReport(checkParams)
            if (check && !check.checkPass) {
                let res1 = await this.metaAction.modal('warning', {
                    content: this.getDisplayGenerateErrorMSg(check),
                    wrapClassName: 'tranreport-generate-modal-bg',
                    className: 'tranreport-generate-modal',
                    okText: '返回修改'
                })
                return
            } else if (check && ((check.msgList && check.msgList.length)
                || (check.xjllbList && check.xjllbList.length)
                || (check.lrbList && check.lrbList.length)
                || (check.zcfzbList && check.zcfzbList.length))) {
                let confirmUpReport2 = await this.metaAction.modal('confirm', {
                    content: this.getDisplayGenerateErrorMSg(check),
                    wrapClassName: 'tranreport-generate-modal-bg',
                    className: 'tranreport-generate-modal tranreport-generate-modal-confirm',
                    cancelText: '返回修改',
                    okText: '继续下载'
                })
                if (confirmUpReport2) {
                    await this.webapi.tranreport.downloadRpt(checkParams)
                }
                return
            }
            await this.webapi.tranreport.downloadRpt(checkParams)
        }

    }

    /**
     * 调整项目
     */
    projectAdjustClick = async (fromPromp) => {
        //调用调整项目前判断是否需要保存，需要的就先保存
        let editStatus = this.metaAction.gf('data.other.editStatus'),
            params,
            afferentParamsData = this.metaAction.gf('data.afferentParamsData') && this.metaAction.gf('data.afferentParamsData').toJS()
        afferentParamsData['accountingStandardsId'] = afferentParamsData.accountingStandards || afferentParamsData.accountingStandardsId
        //状态变化，保存报表数据
        if (editStatus) {
            params = await this.preSaveData()

            params.paramDto = afferentParamsData
            let res = await this.webapi.tranreport.saveReport(params)
            if (res) {
                this.metaAction.sf('data.other.editStatus', false)
            }
        }
        //调整项目
        let reportCode = this.metaAction.gf('data.other.rpttype')
        const res = await this.metaAction.modal('show', {
            title: '调整项目',
            // width: 789,
            width: 1009,
            bodyStyle: { height: 385 },
            okText: "重新转换",
            wrapClassName: 'tranreport-projectadjust-modal',
            children: this.metaAction.loadApp('ttk-access-app-tranreport-projectadjust', {//app-transform-rpt//app-cashflowstatement-distribution
                store: this.component.props.store,
                initData: {
                    tabStatus: {
                        balancesheetStatus: this.metaAction.gf('data.other.balancesheetStatus'),
                        profitstatementStatus: this.metaAction.gf('data.other.profitstatementStatus'),
                        cashflowstatementStatus: this.metaAction.gf('data.other.cashflowstatementStatus')
                    },
                    params: {
                        "nsrsbh": this.metaAction.gf('data.afferentParamsData.nsrsbh'),//	--纳税人识别号
                        "startPeriod": this.metaAction.gf('data.afferentParamsData.sssqQ'),//	--申报起始日期
                        "endPeriod": this.metaAction.gf('data.afferentParamsData.sssqZ'),//	--申报终止日期
                        "accountingStandardsId": this.metaAction.gf('data.afferentParamsData.accountingStandards') || this.metaAction.gf('data.afferentParamsData.accountingStandardsId'),	//
                        "zgswskfjDm": this.metaAction.gf('data.afferentParamsData.zgswskfjDm'),	//
                        "nsrmc": this.metaAction.gf('data.afferentParamsData.nsrmc'),	//
                    },
                    "fromPromp": (typeof fromPromp != 'object'),
                    'reportCode': reportCode.toLocaleLowerCase().substr(0, reportCode.length - 3),
                    rptTitle: this.metaAction.gf('data.rptTitle')
                }
            }),
        })
        if (res) {
            const rptTitle = this.metaAction.gf('data.rptTitle').toJS()
            this.injections.reduce('setSourceRpt', res, reportCode, rptTitle[reportCode])
            // this.metaAction.toast('success', '重新转换成功。')
            message.success('重新转换成功。', 5)
            //添加埋点
            _hmt && _hmt.push(['_trackEvent', '财务', '报表转换', `选择文件是${rptTitle[reportCode]}调整项目`])

        }
    }

    /**
          * 生成
          */
    generateClick = async () => {
        const entryType = this.component.props.entryType
        //生成
        let params = await this.preSaveData(),
            editStatus = this.metaAction.gf('data.other.editStatus'),
            afferentParamsData = this.metaAction.gf('data.afferentParamsData') && this.metaAction.gf('data.afferentParamsData').toJS()

        afferentParamsData['accountingStandardsId'] = this.metaAction.gf('data.paramExternalDto').toJS().accountingStandardsId
        //状态变化，保存报表数据
        if (editStatus) {
            params.paramDto = afferentParamsData
            let res = await this.webapi.tranreport.saveReport(params)
            if (res) {
                this.metaAction.sf('data.other.editStatus', false)
            }
        }

        const checkParams = { startPeriod: afferentParamsData.sssqQ, endPeriod: afferentParamsData.sssqZ, accountingStandardsId: afferentParamsData.accountingStandardsId, ...afferentParamsData }
        //校验报表
        if (checkParams) {
            let check = await this.webapi.tranreport.checkReport(checkParams)
            if (check && !check.checkPass) {
                let res1 = await this.metaAction.modal('warning', {
                    content: this.getDisplayGenerateErrorMSg(check),
                    wrapClassName: 'tranreport-generate-modal-bg',
                    className: 'tranreport-generate-modal',
                    okText: '返回修改'
                })
                return
            } else if (check && ((check.msgList && check.msgList.length) || (check.xjllbList && check.xjllbList.length) || (check.lrbList && check.lrbList.length) || (check.zcfzbList && check.zcfzbList.length))) {
                let confirmUpReport2 = await this.metaAction.modal('confirm', {
                    content: this.getDisplayGenerateErrorMSg(check),
                    wrapClassName: 'tranreport-generate-modal-bg',
                    className: 'tranreport-generate-modal tranreport-generate-modal-confirm',
                    cancelText: '返回修改',
                    okText: '继续生成'
                })
                const rptTitle2 = this.metaAction.gf('data.rptTitle').toJS(),
                    rpttype2 = this.metaAction.gf('data.other.rpttype')
                //添加埋点
                _hmt && _hmt.push(['_trackEvent', '财务', '报表转换', `选择文件是${rptTitle2[rpttype2]}进行生成`])
                //跳转url
                if (confirmUpReport2) {
                    if (afferentParamsData && afferentParamsData.appKey == '10002001') {
                        if (entryType == '1000090001') {//福建财税集成版 菜单入口
                            message.success('生成成功', 5)
                        }
                        if (entryType == '1000090003') {//福建财税集成版 url
                            const fjres = await this.webapi.tranreport.uploadXml(afferentParamsData)
                            if (fjres) {
                                const appParams = '{"appid": "CWBB", "appName": "CwbbzhJg", "appParam":{"code": "0", "msg": "' + fjres + '"}}'
                                window.external.InvokeService("OmniContainer", "NotifyCwbbzh", appParams)
                            }
                        }
                    } else {
                        const rediretBJUrl = await this.webapi.tranreport.getTaxReportUrl(afferentParamsData)
                        if (rediretBJUrl) {
                            //history.redirect(rediretUrl2)
                            message.success('生成成功', 5)
                        }
                    }
                }
                return
            }
        }
        let confirmUpReport = await this.metaAction.modal('confirm', {
            content: this.getDisplayErrorMSg(['确定生成税务格式的财务报表，并进入到申报页面？']),
            className: 'tranreport-sc-modal'
        })
        const rptTitle = this.metaAction.gf('data.rptTitle').toJS(),
            rpttype = this.metaAction.gf('data.other.rpttype')
        //添加埋点
        _hmt && _hmt.push(['_trackEvent', '财务', '报表转换', `选择文件是${rptTitle[rpttype]}进行生成`])
        //跳转url
        if (confirmUpReport) {
            if (afferentParamsData && afferentParamsData.appKey == '10002001') {
                if (entryType == '1000090001') {//福建财税集成版 菜单入口
                    message.success('生成成功', 5)
                }
                if (entryType == '1000090003') {
                    const fjres = await this.webapi.tranreport.uploadXml(afferentParamsData)
                    if (fjres) {
                        const appParams = '{"appid": "CWBB", "appName": "CwbbzhJg", "appParam":{"code": "0", "msg": "' + fjres + '"}}'
                        window.external.InvokeService("OmniContainer", "NotifyCwbbzh", appParams)
                    }
                }
            } else {
                const rediretBJUrl = await this.webapi.tranreport.getTaxReportUrl(afferentParamsData)
                if (rediretBJUrl) {
                    //history.redirect(rediretUrl2)
                    message.success('生成成功', 5)
                }
            }
        }
    }

    /**
     * 准备保存数据
     */
    preSaveData = () => {
        let targetData,
            target = this.metaAction.gf('data.targetList'),
            source = this.metaAction.gf('data.source.dataList'),
            oldTypeValue = this.metaAction.gf('data.other.rpttype')
        if (target && source) {
            targetData = target.toJS()
            const sourceData = this.getSaveList(source.toJS())
            if (oldTypeValue == 'balanceSheetRpt') {
                targetData.body.zcfzbBody = sourceData
            } else if (oldTypeValue == 'profitStatementRpt') {
                targetData.body.lrbBody = sourceData
            } else if (oldTypeValue == 'cashflowStatementRpt') {
                targetData.body.xjllbBody = sourceData
            }
        }
        return targetData ? targetData : target && target.toJS()
    }

    getSaveList(list) {
        list = list.map(item => {
            for (let name in item) {
                if (item[name] == ' ') {
                    item[name] = '0.00'
                }
            }
            return item
        })
        return list
    }
    /**
     * 表格列处理
     */
    tableColumns = () => {
        //会计总则
        let accountingStandards = this.metaAction.gf('data.accountingStandards'),
            rpttype = this.metaAction.gf('data.other.rpttype'),
            headerList = this.metaAction.gf('data.source.headerList')
        let res = renderColumns(headerList && headerList.toJS(), rpttype, accountingStandards, this.renderCellTextBox, this.assetOrProjectStyle)
        return res
    }

    getDisplayGenerateErrorMSg = (check) => {
        return <div style={{ display: 'block' }}>
            <div className='tranreport-generate-modal-header'>校验问题</div>
            {(check.zcfzbList && check.zcfzbList.length) ? <div className='tranreport-generate-modal-content'>
                <div className='tranreport-generate-modal-content-title'>
                    资产负债表
                </div>
                {this.getItems(check.zcfzbList)}
            </div> : ''}
            {(check.lrbList && check.lrbList.length) ? <div className='tranreport-generate-modal-content'>
                <div className='tranreport-generate-modal-content-title'>
                    利润表
                </div>
                {this.getItems(check.lrbList)}
            </div> : ''}
            {(check.xjllbList && check.xjllbList.length) ? <div className='tranreport-generate-modal-content'>
                <div className='tranreport-generate-modal-content-title'>
                    现金流量表
                </div>
                {this.getItems(check.xjllbList)}
            </div> : ''}
            {(check.msgList && check.msgList.length) ? <div className='tranreport-generate-modal-content'>
                <div className='tranreport-generate-modal-content-title'>
                    表间勾稽关系
                </div>
                {this.getItems(check.msgList)}
            </div> : ''}

        </div>
    }

    getItems(list) {
        let arr = []
        list.map((item, index) => {
            arr.push(
                <div className='tranreport-generate-modal-content-item'>{(index + 1) + '.' + item}</div>
            )
        })
        return arr
    }

    renderSelectOption = (data, key, name) => {
        if (!data) {
            return []
        }
        let arr = []
        data.forEach((item) => {
            if (item) {
                arr.push(<Option key={item[key]} value={item[key]}>{item[name]}</Option>)
            }
        })
        return arr
    }
}

export default function creator(option) {
    const metaAction = new MetaAction(option),
        extendAction = extend.actionCreator({ ...option, metaAction }),
        voucherAction = FormDecorator.actionCreator({ ...option, metaAction }),
        o = new action({ ...option, metaAction, extendAction, voucherAction }),
        ret = { ...metaAction, ...extendAction.gridAction, ...voucherAction, ...o }
    metaAction.config({ metaHandlers: ret })
    return ret
}
const EditableCell = ({ editable, value, onBlur, onEnter, onkeydown, toFixedLocal, precision, customAttribute }) => {

    return (
        <div style={{ textAlign: 'right' }}>
            {editable
                ? <Input.Number
                    // key={Math.random()}
                    style={{ margin: '-5px 0' }}
                    customAttribute={customAttribute}
                    className='ttk-access-app-tranreport-step2content-tableCellInput'
                    id='ttk-access-app-tranreport-step2content-tableCellInput'
                    onPressEnter={(e) => onEnter(e)}
                    // onKeyDown={(e) =>{onkeydown(e)} }
                    value={value ? toFixedLocal(value, precision) : ''}
                    onBlur={(value) => onBlur(value)}
                    regex='^(-?[0-9]+)(?:\.[0-9]{1,2})?$' />
                : <div id='ttk-access-app-tranreport-step2content-tableCellInput' className='ttk-access-app-tranreport-step2content-tableCellInput' title={value}>{value ? toFixedLocal(value, precision) : ''}</div>
            }
        </div>
    )
}
