import { Map, List, fromJS } from 'immutable'
import { reducer as MetaReducer } from 'edf-meta-engine'
import { getInitState } from './data'

class reducer {
    constructor(option) {
        this.metaReducer = option.metaReducer
    }

    init = (state) => {
        return this.metaReducer.init(state, getInitState())
    }

    load = (state, res) => {
        if(res.reportEnclosures){
            state = this.metaReducer.sf(state, 'data.reportEnclosures', fromJS(res.reportEnclosures))
        }
        if(res.nodeEnclosures){
            state = this.metaReducer.sf(state, 'data.nodeEnclosures', fromJS(res.nodeEnclosures))
        }
        return state
    }
    
    //上传附件
	upload = (state, value, type) => {
        let list = this.metaReducer.gf(state, 'data.reportEnclosures').toJS()
        if(type!='left') list = this.metaReducer.gf(state, 'data.nodeEnclosures').toJS()
        
        list.push({fileId: value.id, file: value})
        if(type!='left') {
            state = this.metaReducer.sf(state, 'data.nodeEnclosures', fromJS(list))
        }else{
            state = this.metaReducer.sf(state, 'data.reportEnclosures', fromJS(list))
        }
		return state
    }
    
    //删除附件
    deleteUploadFile = (state, option, type) => {
        let list = this.metaReducer.gf(state, 'data.reportEnclosures').toJS(), index
        if(type!='left') list = this.metaReducer.gf(state, 'data.nodeEnclosures').toJS()
        list.map((item, num)=>{
            if(option.fileId == item.fileId) index = num
        })
        if(index!==undefined) list.splice(index, 1);  
        if(type!='left') {
            state = this.metaReducer.sf(state, 'data.nodeEnclosures', fromJS(list))
        }else{
            state = this.metaReducer.sf(state, 'data.reportEnclosures', fromJS(list))
        }
        return state
    }
}

export default function creator(option) {
    const metaReducer = new MetaReducer(option),
        o = new reducer({ ...option, metaReducer })

    return { ...metaReducer, ...o }
}