import moment from 'moment'

export function getMeta() {
    return {
        name: 'root',
        component: '::div',
        className: 'ttk-access-app-tranreport-projectadjust',
        id: 'ttk-access-app-tranreport-projectadjust',
        children: {
            name: 'mail',
            component: '::div',
            tip: '数据处理中...',
            spinning: '{{data.other.loading}}',
            children: [{
                name: 'tabs',
                component: '::div',
                className: 'ttk-access-app-tranreport-projectadjust-tabs',
                children: [{
                    name: 'ButtonList',
                    className: 'ttk-access-app-tranreport-projectadjust-tabs-group',
                    component: 'Radio.Group',
                    value: '{{data.form.activeTab}}',
                    onChange: `{{function(v){$rptTypeChange('data.form.activeTab',v.target.value)}}}`,
                    children: [{
                        name: 'balanceSheetRpt',
                        value: 'balancesheet',
                        component: 'Radio.Button',
                        key: 'balancesheet',
                        _visible: '{{data.other.balancesheetStatus}}',
                        children: '{{data.rptTitle.balanceSheetRpt}}'
                    }, {
                        name: 'profitStatementRpt',
                        value: 'profitstatement',
                        component: 'Radio.Button',
                        _visible: '{{data.other.profitstatementStatus}}',
                        key: 'profitstatement',
                        children: '{{data.rptTitle.profitStatementRpt}}'
                    }, {
                        name: 'cashflowStatementRpt',
                        value: 'cashflowstatement',
                        key: 'cashflowstatement',
                        component: 'Radio.Button',
                        _visible: '{{data.other.cashflowstatementStatus}}',
                        children: '{{data.rptTitle.cashflowStatementRpt}}'
                    }]
                }]
            }, {
                name: 'content',
                component: '::div',
                className: 'ttk-access-app-tranreport-projectadjust-content',
                children: [{
                    name: 'top-rpt',
                    component: '::div',
                    className: 'app-transform-left-rpttb',
                    children: [{
                        name: 'topTitle',
                        component: '::div',
                        className: 'app-transform-top-title',
                        children: [{
                            name: 'change',
                            component: '::div',
                            children: '列:',
                            style: {
                                'fontSize': '12px', 'font-weight': 'bold', 'margin-top': '5px'
                            }
                        }, {
                            pagination: false,
                            className: 'app-transform-top-body',
                            name: 'colreport',
                            component: 'Table',
                            pagination: false,
                            // scroll: '{{ data.colums <= 1000 ? ( (data.form.activeTab =="balancesheet" ?data.balancesheetColList.length : (data.form.activeTab == "profitstatement"? data.profitstatementColList.length: data.cashflowstatementColList.length)) <= 7 ? {x:0,y:0}:{x:0,y:245}) : ((data.form.activeTab =="balancesheet" ?data.balancesheetColList.length : (data.form.activeTab == "profitstatement"? data.profitstatementColList.length: data.cashflowstatementColList.length)) <= 7 ? {x:(data.colums+50), y:0} : {x:(data.colums+50), y:245})}}',
                            allowColResize: false,
                            enableSequenceColumn: true,
                            bordered: true,
                            dataSource: '{{ data.form.activeTab =="balancesheet" ?data.balancesheetColList : (data.form.activeTab == "profitstatement"? data.profitstatementColList: data.cashflowstatementColList) }}',
                            noCalculate: true,
                            columns: [{
                                title: '原表所在列',
                                dataIndex: 'sourceName',
                                key: 'sourceName',
                                width: '120px',
                                render: "{{ function(text, record, index){return $renderCell('sourceName', index, text, 'Col')} }}"
                            }, {
                                title: '局端报表所在列',
                                dataIndex: 'targetame',
                                key: 'targetame',
                                width: '120px',
                                render: "{{function(text, record, index){return $renderCell('targetame', index, text, 'Col')} }}"
                            }, {
                                // title: '忽略',
                                title: "{{$getLastTitle('忽略一列后，整列的数据都不会导入', '.app-transform-top-body')}}",
                                dataIndex: 'ignore',
                                key: 'ignore',
                                width: '70px',
                                render: "{{function(text, record, index){return $renderCell('ignore', index, text, 'Col')} }}"
                            }]
                        }]
                    }]
                }, {
                    name: 'bottom-rpt',
                    component: '::div',
                    className: 'app-transform-right-rpttb',
                    children: [{
                        name: 'bottomTitle',
                        component: '::div',
                        className: 'app-transform-bottom-title',
                        children: [{
                            name: 'change',
                            component: '::div',
                            children: '{{$getTableTitle()}}',
                            style: {
                                'fontSize': '12px', 'font-weight': 'bold', 'margin-top': '5px'
                            }
                        }, {
                            pagination: false,
                            className: 'app-transform-bottom-body',
                            id: 'app-transform-bottom-body',
                            name: 'rowreport',
                            component: 'Table',
                            pagination: false,
                            // scroll: '{{ data.colums <= 1000 ? ((data.form.activeTab =="balancesheet" ?data.balancesheetRowList.length : (data.form.activeTab == "profitstatement"? data.profitstatementRowList.length: data.cashflowstatementRowList.length)) <= 7 ? {x:0,y:0}:{x:0,y:245}) : ((data.form.activeTab =="balancesheet" ?data.balancesheetRowList.length : (data.form.activeTab == "profitstatement"? data.profitstatementRowList.length: data.cashflowstatementRowList.length)) <= 7 ? {x:(data.colums+50), y:0} : {x:(data.colums+50), y:245})}}',
                            allowColResize: false,
                            enableSequenceColumn: true,
                            bordered: true,
                            dataSource: '{{ data.form.activeTab =="balancesheet" ?data.balancesheetRowList : (data.form.activeTab == "profitstatement"? data.profitstatementRowList: data.cashflowstatementRowList) }}',
                            noCalculate: true,
                            // loading: '{{data.other.isLoading}}',
                            columns: [{
                                title: '原表所在行',
                                dataIndex: 'sourceName',
                                key: 'sourceName',
                                width: '296px',
                                render: "{{ function(text, record, index){return $renderCell('sourceName', index, text, 'Row')} }}"
                            }, {
                                title: '局端报表所在行',
                                dataIndex: 'targetame',
                                key: 'targetame',
                                width: '205px',
                                render: "{{function(text, record, index){return $renderCell('targetame', index, text, 'Row'  )} }}"
                            }, {
                                // title: '忽略',
                                title: "{{$getLastTitle('忽略一行后，这行的数据不会导入', '.app-transform-bottom-body')}}",
                                dataIndex: 'ignore',
                                key: 'ignore',
                                width: '70px',
                                render: "{{function(text, record, index){return $renderCell('ignore', index, text, 'Row')} }}"
                            }]
                        }]
                    }]
                }]
            }]
        }
    }
}

export function getInitState() {
    return {
        data: {
            editState: false,
            balancesheetUpdate: false,//upload
            cashflowstatementUpdate: false,//upload
            profitstatementUpdate: false,//upload
            updateState: false,
            balancesheetColList: EMPTYROWARR,
            balancesheetRowList: EMPTYROWARR,
            profitstatementColList: EMPTYROWARR,
            profitstatementRowList: EMPTYROWARR,
            cashflowstatementColList: EMPTYROWARR,
            cashflowstatementRowList: EMPTYROWARR,
            balancesheetColDataSource: [],
            balancesheetRowDataSource: [],
            cashflowstatementColDataSource: [],
            cashflowstatementRowDataSource: [],
            profitstatementColDataSource: [],
            profitstatementRowDataSource: [],
            form: {
                deprMonth: '',
                quantity: 1,
                activeTab: 'balancesheet',
                buyDate: moment().format('YYYY-MM-DD'),
                changeDate: moment().format('YYYY-MM-DD'),
                isHasInit: false,
                salvageRate: 5,
            },
            systemDate: '',
            other: {
                care: '注：下方列表只显示不一致的项目。',
                balancesheetDisabled: false,//页签是否可选
                cashflowstatementDisabled: false,//true,
                profitstatementDisabled: false,
                balancesheetStatus: true,//upload
                profitstatementStatus: true,//upload
                cashflowstatementStatus: true, //upload
                balancesheetEditStatus: false,//是否已编辑
                profitstatementEditStatus: false,//是否已编辑
                cashflowstatementEditStatus: false,//是否已编辑
                error: {},
                assetProperty: [{
                    id: 1,
                    name: '资产负债表'
                }, {
                    id: 2,
                    name: '利润表'
                }, {
                    id: 3,
                    name: '现金流量表'
                }],
                ok: true,
                loading: false,
                rptTitle: {
                    balanceSheetRpt: '资产负债表',
                    profitStatementRpt: '利润表',
                    cashflowStatementRpt: '现金流量表'
                }
            }
        }
    }
}

const EMPTYROWARR = [{
    empty: true
}, {
    empty: true
}, {
    empty: true
}, {
    empty: true
}, {
    empty: true
}, {
    empty: true
}, {
    empty: true
}]


