import { Map, List, fromJS } from 'immutable'
import { reducer as MetaReducer } from 'edf-meta-engine'
import config from './config'
import moment from 'moment'
import { getInitState } from './data'
import utils from 'edf-utils'
class reducer {
	constructor(option) {
		this.metaReducer = option.metaReducer
	}

	init = (state, option) => {
		let initData = getInitState()
		initData.data.params = option.initData.params
		initData.data.other.balancesheetStatus = option.initData.tabStatus.balancesheetStatus
		initData.data.other.profitstatementStatus = option.initData.tabStatus.profitstatementStatus
		initData.data.other.cashflowstatementStatus = option.initData.tabStatus.cashflowstatementStatus
		initData.data.other.fromPromp = option.initData.fromPromp
		initData.data.form.activeTab = option.initData.reportCode
		initData.data.rptTitle = option.initData.rptTitle
		return this.metaReducer.init(state, initData)
	}

	load = (state, res, reportCode) => {
		let data = {}
		res.map(item => {
			let curReportCode = item.reportCode ? item.reportCode.toLocaleLowerCase() : ''			
			data = this.setTableData(data, item.needMatchHead ? item.headList : [], curReportCode, 'Col')
			data = this.setTableData(data, item.needMatchDetail ? item.detailList : [], curReportCode, 'Row')
			data[`data.${curReportCode}ColState`] = item.needMatchHead
			data[`data.${curReportCode}RowState`] = item.needMatchHead
			data[`data.${curReportCode}ColDataSource`] = fromJS(item.baseHeadList)
			data[`data.${curReportCode}RowDataSource`] = fromJS(item.baseDetailList)		
		})
		data[`data.form.activeTab`] = reportCode		
		state = this.metaReducer.sfs(state, data)
		return state
	}

	setTableData(data, listData, rptType, type) {//将要编辑的行列表数据赋值
		let list = this.getList(listData)		
		data[`data.${rptType}${type}ListLength`] = fromJS(list.length)
		if (list.length < EMPTYROWARR.length) {
			list = list.concat(EMPTYROWARR.slice(list.length))
		}		
		data[`data.${rptType}${type}List`] = fromJS(list)		
		return data		
	}

	getList = (list) => {
		
		let haveNew = false
		list = list.map(item => {
			if (!item.targetame && !item.ignore) {
				item.new = true
				haveNew = true
			}
			return item
		})
		if (haveNew) {			
			document.querySelector('.tranreport-projectadjust-modal .ant-modal-footer .ant-btn-primary').disabled = false
		}
		return list
	}
}
export default function creator(option) {
	const metaReducer = new MetaReducer(option),
		o = new reducer({ ...option, metaReducer })
	return { ...metaReducer, ...o }
}
const EMPTYROWARR = [{
	empty: true
}, {
	empty: true
}, {
	empty: true
}, {
	empty: true
}, {
	empty: true
}, {
	empty: true
}, {
	empty: true
}]
