import { Map, fromJS } from 'immutable'
import { reducer as MetaReducer } from 'edf-meta-engine'
import config from './config'
import { getInitState, getLastMonth, REPORT_TYPE_TAX, REPORT_TYPE_FINANCE } from './data'
import moment from 'moment'
import { fetch, number, history } from 'edf-utils'

class reducer {
    constructor(option) {
        this.metaReducer = option.metaReducer
        this.config = config.current
    }
    init = (state, option) => {
        const initState = getInitState()
        state = this.metaReducer.init(state, initState)       
        return state
    }
    load = (state, response) => {        
        state = this.metaReducer.sf(state, 'data.list', fromJS(response && response.option))
        state = this.metaReducer.sf(state, 'data.appraisalId', fromJS(response && response.appraisalId))
        return state
    }
    //设置loading加载
    setLoading = (state, value) => {
        return this.metaReducer.sf(state, 'data.other.loading', value)
    }
    checkboxChange = (state, option) => {
        state = this.metaReducer.sf(state, 'data.tableCheckbox', fromJS(option))
        return state
    }    

    update = (state, { path, value }) => {
        return this.metaReducer.sf(state, path, fromJS(value))
    }
}
export default function creator(option) {
    const metaReducer = new MetaReducer(option),
        o = new reducer({ ...option, metaReducer })
    return { ...metaReducer, ...o }
}
