/**
 * webapi.js 封装app所需的所有web请求
 * 供app测试使用，app加入网站后webpai应该由网站通过config,提供给每个app
 */

import { fetch } from 'edf-utils'
import { resolve } from 'path';
export default {
	tranreport: {
		//1、获取申报所属期的接口：参数为 { "enumCode": "taxTimeType" }
		//2、获取会计准则的下拉列表接口 参数为： {"enumCode":"accountingStandards"}
		//findByEnumCode: (option) => fetch.post('/v1/edf/enumDetail/findByEnumCode', option)
		//进入设置界面后，获取关于当前企业信息的接口：/edf/org/query 没有参数
		queryServer: (option) => fetch.post('/v1/edf/org/queryAll', {}),
		//getAccountStandardsForSB: (option) => fetch.post('/v1/edf/enumDetail/getAccountStandardsForSB', {}),
		//进入设置界面后，点击保存时调用的接口：/edf/org/updateEDFOrgInfo
		updateEDFOrgInfo: (option) => fetch.post('/v1/edf/org/updateEDFOrgInfo', option),
		//保存设置，创建企业
		// getOrgDtoForReportConvert: (option) => fetch.post('v1/edf/orgreportconvert/getOrgDtoForReportConvert', option),
		accessLogin: (option) => fetch.post('/v1/edf/orgreportconvert/accessLogin', option),
		oauthAuthenticationAIO: (option) => fetch.post('/v1/reportconverter/oauthAuthenticationAIO', option),//国税进入第一步没有code接口
		getOauthUrl: (option) => fetch.post('/v1/reportconverter/getOauthUrl', option),//国税进入第一步没有code接口
		oauthAuthentication: (option) => fetch.post('/v1/reportconverter/oauthAuthentication', option),//国税进入第一步有code接口
		getOrgAndToken: (option) => fetch.post('/v1/reportconverter/getOrgAndToken', option),//测试
		getOrg: (option) => fetch.post('/v1/reportconverter/getOrg', option),//获取当前org
		getReportJson: (option) => fetch.post('/v1/reportconverter/getReportJson', option),//初始化
		//转为局端格式调用接口
		importDataSource: (option) => fetch.post('/v1/reportconverter/importDataSource', option),
		//将报表导出为Excel
		downloadRpt: (option) => fetch.formPost('/v1/reportconverter/export', option),
		//保存报表
		saveReport: (option) => fetch.post('/v1/reportconverter/saveReport', option),
		/*
		接口说明:报表生成校验
        参数：{
                   "nsrsbh": "123456789012345", --纳税人识别号
                   "startPeriod": "2017-12-01", --申报起始日期
                   "endPeriod": "2017-12-31", --申报终止日期
                   "accountingStandardsId": 2000020001  --会计准则ID(企业会计准则: 2000020001 小企业会计准则: 2000020002)
               }
        返回: {
                   "checkPass": false,
                       "msgList": ["资产负债表不平衡"]
               }
		*/
		checkReport: (option) => fetch.post('/v1/reportconverter/checkReport', option),
		//删除上传文件
		deleteDataSource: (option) => fetch.post('/v1/reportconverter/deleteDataSource', option),
		/*
		接口说明：拼接跳转电局报表页url接口
		参数：
		{
			"nsrsbh":"11111",  -- 纳税人识别号
			"gdslxDm":"11111",  -- 国地税类型代码（必需）
			"kjzdzzDm":"11111",  -- 会计制度准则代码
			"zlbsxlDm":"11111",  -- 资料报送小类代码
			"bbbsqDm":"01",  -- 报表报送期代码
			"sssqQ":"2018-03-01",  -- 报送所属期起（必需）
			"sssqZ":"2018-03-31",  -- 报送所属期止（必需）
			"nsrmc":"xxxx",  -- 纳税人名称
			"zgswskfjDm":"xxxx",  -- 主管税务所科分局代码（必需）
		}
		返回值：
		{
			"result":true,
			"value":"http://....."
		}
		*/
		getTaxReportUrl: (option) => fetch.post('/v1/reportconverter/getTaxReportUrl', option),
		
		/**
		 * 福建ECS集成版调用的接口
		 */
		uploadXml: (option) => fetch.post('/v1/reportconverter/uploadXml', option),
		
		// 转为局端格式调用接口
		// importDataSource: (option) => {
		// 	//保存报表
		// 	return ({ "result": true, "value": { "needMatching": false, "header": { "zcfzbHeader": [{ "fieldName": "col0", "title": "资产", "fieldType": "str" }, { "fieldName": "col1", "title": "期末余额", "fieldType": "num" }, { "fieldName": "col2", "title": "年初余额", "fieldType": "num" }, { "fieldName": "col3", "title": "负债及所有者权益 (或股东权益)", "fieldType": "str" }, { "fieldName": "col4", "title": "期末余额", "fieldType": "num" }, { "fieldName": "col5", "title": "年初余额", "fieldType": "num" }], "lrbHeader": [{ "fieldName": "col0", "title": "项目", "fieldType": "str" }, { "fieldName": "col1", "title": "本期金额", "fieldType": "num" }, { "fieldName": "col2", "title": "上期金额", "fieldType": "num" }], "xjllbHeader": [{ "fieldName": "col0", "title": "项目", "fieldType": "str" }, { "fieldName": "col1", "title": "本期金额", "fieldType": "num" }, { "fieldName": "col2", "title": "上期金额", "fieldType": "num" }] }, "body": { "zcfzbBody": [{ "col0": "流动资产：", "col1": "", "col2": "", "col3": "流动负债：", "col4": "", "col5": "", "isSumRow": false }, { "col0": "    货币资金", "col1": "-884.00", "col2": "0.00", "col3": "    短期借款", "col4": "-21.00", "col5": "-21.00", "isSumRow": false }, { "col0": "    以公允价值计量且其变动计入当期损益的金融资产", "col1": "-100.00", "col2": "-984.00", "col3": "    以公允价值计量且其变动计入当期损益的金融负债", "col4": "-20.00", "col5": "-20.00", "isSumRow": false }, { "col0": "    应收票据", "col1": "12.00", "col2": "12.00", "col3": "    应付票据", "col4": "129.00", "col5": "129.00", "isSumRow": false }, { "col0": "    应收账款", "col1": "23.00", "col2": "23.00", "col3": "    应付账款", "col4": "138.00", "col5": "138.00", "isSumRow": false }, { "col0": "    预付款项", "col1": "13.00", "col2": "13.00", "col3": "    预收款项", "col4": "0.00", "col5": "0.00", "isSumRow": false }, { "col0": "    应收利息", "col1": "14.00", "col2": "14.00", "col3": "    应付职工薪酬", "col4": "-24.00", "col5": "-24.00", "isSumRow": false }, { "col0": "    应收股利", "col1": "15.00", "col2": "15.00", "col3": "    应交税费", "col4": "-26.00", "col5": "-26.00", "isSumRow": false }, { "col0": "    其他应收款", "col1": "16.00", "col2": "16.00", "col3": "    应付利息", "col4": "-25.00", "col5": "-25.00", "isSumRow": false }, { "col0": "    存货", "col1": "-230.00", "col2": "-230.00", "col3": "    应付股利", "col4": "-27.00", "col5": "-27.00", "isSumRow": false }, { "col0": "    一年内到期的非流动资产", "col1": "0.00", "col2": "0.00", "col3": "    其他应付款", "col4": "-28.00", "col5": "-28.00", "isSumRow": false }, { "col0": "    其他流动资产", "col1": "-130.00", "col2": "-130.00", "col3": "    一年内到期的非流动负债", "col4": "0.00", "col5": "0.00", "isSumRow": false }, { "col0": "        流动资产合计", "col1": "-1,251.00", "col2": "-1,251.00", "col3": "    其他流动负债", "col4": "310.00", "col5": "310.00", "isSumRow": true, "sumCol1": "col1:2+3+4+5+6+7+8+9+10+11+12", "sumCol2": "col2:2+3+4+5+6+7+8+9+10+11+12" }, { "col0": "非流动资产：", "col1": "", "col2": "", "col3": "        流动负债合计", "col4": "406.00", "col5": "406.00", "isSumRow": true, "sumCol4": "col4:2+3+4+5+6+7+8+9+10+11+12+13", "sumCol5": "col5:2+3+4+5+6+7+8+9+10+11+12+13" }, { "col0": "    可供出售金融资产", "col1": "17.00", "col2": "17.00", "col3": "非流动负债：", "col4": "", "col5": "", "isSumRow": false }, { "col0": "    持有至到期投资", "col1": "34.00", "col2": "34.00", "col3": "    长期借款", "col4": "151.00", "col5": "151.00", "isSumRow": false }, { "col0": "    长期应收款", "col1": "39.00", "col2": "39.00", "col3": "    应付债券", "col4": "0.00", "col5": "0.00", "isSumRow": false }, { "col0": "    长期股权投资", "col1": "33.00", "col2": "33.00", "col3": "    长期应付款", "col4": "-58.00", "col5": "-58.00", "isSumRow": false }, { "col0": "    投资性房地产", "col1": "13.00", "col2": "13.00", "col3": "    专项应付款", "col4": "-31.00", "col5": "-31.00", "isSumRow": false }, { "col0": "    固定资产", "col1": "0.00", "col2": "0.00", "col3": "    预计负债", "col4": "-32.00", "col5": "-32.00", "isSumRow": false }, { "col0": "    在建工程", "col1": "14.00", "col2": "14.00", "col3": "    递延收益", "col4": "0.00", "col5": "0.00", "isSumRow": false }, { "col0": "    工程物资", "col1": "15.00", "col2": "15.00", "col3": "    递延所得税负债", "col4": "-33.00", "col5": "-33.00", "isSumRow": false }, { "col0": "    固定资产清理", "col1": "16.00", "col2": "16.00", "col3": "    其他非流动负债", "col4": "-34.00", "col5": "-34.00", "isSumRow": false }, { "col0": "    生产性生物资产", "col1": "0.00", "col2": "0.00", "col3": "      非流动负债合计", "col4": "-37.00", "col5": "-37.00", "isSumRow": true, "sumCol4": "col4:16+17+18+19+20+21+22+23", "sumCol5": "col5:16+17+18+19+20+21+22+23" }, { "col0": "    油气资产", "col1": "0.00", "col2": "0.00", "col3": "          负债合计", "col4": "369.00", "col5": "369.00", "isSumRow": true, "sumCol4": "col4:14+24", "sumCol5": "col5:14+24" }, { "col0": "    无形资产", "col1": "0.00", "col2": "0.00", "col3": "所有者权益（或股东权 益）：", "col4": "", "col5": "", "isSumRow": false }, { "col0": "    开发支出", "col1": "17.00", "col2": "17.00", "col3": "    实收资本（或股本）", "col4": "-151.00", "col5": "-151.00", "isSumRow": false }, { "col0": "    商誉", "col1": "18.00", "col2": "18.00", "col3": "    资本公积", "col4": "-36.00", "col5": "-36.00", "isSumRow": false }, { "col0": "    长期待摊费用", "col1": "19.00", "col2": "19.00", "col3": "    减：库存股", "col4": "37.00", "col5": "37.00", "isSumRow": false }, { "col0": "    递延所得税资产", "col1": "20.00", "col2": "20.00", "col3": "    其他综合收益", "col4": "0.00", "col5": "0.00", "isSumRow": false }, { "col0": "    其他非流动资产", "col1": "0.00", "col2": "0.00", "col3": "    盈余公积", "col4": "-38.00", "col5": "-1,178.00", "isSumRow": false }, { "col0": "        非流动资产合计", "col1": "255.00", "col2": "255.00", "col3": "    未分配利润", "col4": "-1,140.00", "col5": "0.00", "isSumRow": true, "sumCol1": "col1:15+16+17+18+19+20+21+22+23+24+25+26+27+28+29+30+31", "sumCol2": "col2:15+16+17+18+19+20+21+22+23+24+25+26+27+28+29+30+31" }, { "col0": "", "col1": "", "col2": "", "col3": "所有者权益（或股东权益）合计", "col4": "-1,402.00", "col5": "-1,402.00", "isSumRow": true, "sumCol4": "col4:27+28-29+30+31+32", "sumCol5": "col5:27+28-29+30+31+32" }, { "col0": "          资产合计", "col1": "-996.00", "col2": "-996.00", "col3": "负债和所有者权益（或股东权益）总计", "col4": "-1,033.00", "col5": "-1,033.00", "isSumRow": true, "sumCol1": "col1:13+32", "sumCol2": "col2:13+32", "sumCol4": "col4:25+33", "sumCol5": "col5:25+33" }], "lrbBody": [{ "col0": "一、营业收入", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "    减：营业成本", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "        税金及附加", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "        销售费用", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "        管理费用", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "        财务费用", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "        资产减值损失", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "    加：公允价值变动收益（损失以“-”号填列）", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "        投资收益（损失以“-”号填列）", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "        其中：对联营企业和合营企业的投资收益", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "二、营业利润（亏损以“-”号填列）", "col1": "0.00", "col2": "0.00", "isSumRow": true, "sumCol1": "col1:1-2-3-4-5-6-7+8+9", "sumCol2": "col2:1-2-3-4-5-6-7+8+9" }, { "col0": "    加：营业外收入", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "        其中:非流动资产处置利得", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "    减：营业外支出", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "        其中：非流动资产处置损失", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "三、利润总额（亏损总额以“-”号填列）", "col1": "0.00", "col2": "0.00", "isSumRow": true, "sumCol1": "col1:11+12-14", "sumCol2": "col2:11+12-14" }, { "col0": "    减：所得税费用", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "四、净利润（净亏损以“-”号填列）", "col1": "0.00", "col2": "0.00", "isSumRow": true, "sumCol1": "col1:16-17", "sumCol2": "col2:16-17" }, { "col0": "五、其他综合收益的税后净额", "col1": "0.00", "col2": "0.00", "isSumRow": true, "sumCol1": "col1:20+23", "sumCol2": "col2:20+23" }, { "col0": "（一）以后不能重分类进损益的其他综合收益", "col1": "0.00", "col2": "0.00", "isSumRow": true, "sumCol1": "col1:21+22", "sumCol2": "col2:21+22" }, { "col0": "1.重新计量设定收益计划净负债或净资产的变动", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "2.权益法下在被投资单位不能重分类进损益的其他综合收益中享有的份额", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "（二）以后将重分类进损益的其他综合收益", "col1": "0.00", "col2": "0.00", "isSumRow": true, "sumCol1": "col1:24+25+26+27+28", "sumCol2": "col2:24+25+26+27+28" }, { "col0": "1.权益法下在被投资单位以后将重分类进损益的其他综合收益中享有的份额", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "2.可供出售金融资产公允价值变动损益", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "3.将有至到期投资重分类可供出售金融资产损益", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "4.现金流经套期损益的有效部分", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "5.外币财务报表折算差额", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "六、综合收益总额", "col1": "0.00", "col2": "0.00", "isSumRow": true, "sumCol1": "col1:18+19", "sumCol2": "col2:18+19" }, { "col0": "七、每股收益：", "col1": "", "col2": "", "isSumRow": false }, { "col0": "    （一）基本每股收益", "col1": "0.00", "col2": "0.00", "isSumRow": false }, { "col0": "    （二）稀释每股收益", "col1": "0.00", "col2": "0.00", "isSumRow": false }] }, "memo": { "zcfzbMemo": { "nsrsbh": "11111111111111111111", "nsrmc": "纳税人名称", "fromDate": "2018-04-01", "toDate": "2018-04-30", "reportShortName": "会企01表", "reportDate": "2018-05-06", "accountingStandardDescribe": "（适用执行企业会计准则的一般企业）" }, "lrbMemo": { "nsrsbh": "11111111111111111111", "nsrmc": "纳税人名称", "fromDate": "2018-04-01", "toDate": "2018-04-30", "reportShortName": "会企02表", "reportDate": "2018-05-06", "accountingStandardDescribe": "（适用执行企业会计准则的一般企业）" }, "xjllbMemo": { "nsrsbh": "11111111111111111111", "nsrmc": "纳税人名称", "fromDate": "2018-04-01", "toDate": "2018-04-30", "reportShortName": "会企03表", "reportDate": "2018-05-06", "accountingStandardDescribe": "（适用执行企业会计准则的一般企业）" } } } })
		// }
		// getData: (option) => fetch.post('/v1/reportconverter/getData', option),
		getData: (option) => fetch.post('/v1/gl/convert/router/getData', option),
		/**
		 * 财务报表申报状态
		 * {
				"sssqQ": "2018-01-01", --申报所属期起
				"sssqZ": "2018-03-31", --申报所属期止
				"tmpRvState": 1         -- 申报状态：0未申报，1已申报
		 }
		 */
		tmpSetGlReportDeclareState: (option) => fetch.post('/v1/reportconverter/tmpSetGlReportDeclareState', option),

		/**
		 * 财务报表申报接口
		 * 	{
			"sssqQ":"2018-01-01",
			"sssqZ":"2018-12-31"
			}
		 */
		glReportDeclare: (option) => fetch.post('/v1/tax/sb/declare/glReportDeclare', option),
		glReportDeclareWithCheck: (option) => fetch.post('/v1/tax/sb/declare/glReportDeclareWithCheck', option),
		glReportDeclareWithSaveAndCheck: (option) => fetch.post('/v1/tax/sb/declare/glReportDeclareWithSaveAndCheck', option),

		/**
		 * 下载Pdf
		 */
		downloadPdf: (option) => fetch.formPost('/v1/reportconverter/downloadPdf', option),

		/**
		 * 批量查找会计总则和保送小类代码
		 */
		batchQueryAccountingStandards: (option) => fetch.post('/v1/tax/sb/kjzz/query', option),


		/**
		 * 1、根据会计制度总则id获取报送小类代码{ "enumDetailId": 2000020001 }
		 * 2、根据报送小类代码获取会计制度总则id{ "zlbsxlDm": "ZL1001001" }
		 */
		// queryAccountingStandards: (option) => {
		// 	//fetch.post('/v1/tax/sb/kjzz/queryFirst', option)
		// 	let arrays = [{
		// 		"enumDetailId": 2000020001,
		// 		"zlbsxlDm": "ZL1001001"
		// 	},
		// 	{
		// 		"enumDetailId": 2000020002,
		// 		"zlbsxlDm": "ZL1001003"
		// 	},
		// 	{
		// 		"enumDetailId": 2000020003,
		// 		"zlbsxlDm": "ZL1001018"
		// 	},
		// 	{
		// 		"enumDetailId": 2000020005,
		// 		"zlbsxlDm": "ZL1001019"
		// 	},
		// 	{
		// 		"enumDetailId": 2000020004,
		// 		"zlbsxlDm": "ZL1001020"
		// 	},
		// 	{
		// 		"enumDetailId": 2000020006,
		// 		"zlbsxlDm": "ZL1001022"
		// 	},
		// 	{
		// 		"enumDetailId": 2000020007,
		// 		"zlbsxlDm": "ZL1001024"
		// 	}]
		// 	let res
		// 	arrays.forEach(element => {
		// 		if (element.enumDetailId == option.enumDetailId) {
		// 			res = element
		// 			return
		// 		}
		// 	})
		// 	return res
		// },
		//获取会计总则id和
		queryAccountingStandards: () => fetch.post('/v1/reportconverter/getKjzzDict', {}),
		//财务报表选表界面查询接口 入参：{"projectId":"2"--申报项目ID}
		querySelectReport: (option) =>fetch.post('/v1/tax/sb/appraisal/queryReport', option),
		// querySelectReport: (option) => {			
		// 	return ({
		// 		"haveSelected": true,
		// 		"reportList": [
		// 			{
		// 				"id": 1,
		// 				"rowNo": 1,
		// 				"projectId": 4,
		// 				"projectReportId": 4,
		// 				"projectReportName": "资产负债表",
		// 				"canDel": true,
		// 				"selected": true
		// 			},
		// 			{
		// 				"id": 2,
		// 				"rowNo": 2,
		// 				"projectId": 4,
		// 				"projectReportId": 5,
		// 				"projectReportName": "利润表",
		// 				"canDel": true,
		// 				"selected": false
		// 			},
		// 			{
		// 				"id": 3,
		// 				"rowNo": 3,
		// 				"projectId": 6,
		// 				"projectReportId": 6,
		// 				"projectReportName": "现金流量表",
		// 				"canDel": true,
		// 				"selected": false
		// 			}
		// 		]
		// 	})
		// },
		/**
		 * 获取服务器的当前时间
		 */
		getSystemDate: () => fetch.post('/v1/edf/org/getSystemDate', {}),
	}
}
