export function getMeta() {
	return {
		name: 'root',
		component: 'Layout',
		className: 'app-asset-record',
		children: [{
			name: 'header',
			className: 'app-asset-record-header',
			component: '::div',
			children: '{{"历史记录:" + data.note}}',
			title: '{{data.note}}'
		},{
			name: 'content',
			className: 'app-asset-record-content',
			component: '::div',
			children: [{
				name: 'dataGrid',
				component: 'DataGrid',
				headerHeight: 37,
				loading: '{{data.other.loading}}',
				isColumnResizing: true,
				rowHeight: 35,
				enableSequence: true,
				ellipsis: true,
				rowsCount: "{{$getListRowsCount()}}",
				columns: [{
					name: 'createTime',
					component: 'DataGrid.Column',
					columnKey: 'createTime',
					width: 100,
					header: {
						name: 'header',
						component: 'DataGrid.Cell',
						children: '时间'
					},
					cell: {
						name: 'cell',
						component: "DataGrid.Cell",
						value: "{{data.list[_rowIndex].createTime}}",
						_power: '({rowIndex})=>rowIndex',
					}
				}, {
					name: 'changeTypeName',
					component: 'DataGrid.Column',
					columnKey: 'changeTypeName',
					width: 80,
					flexGrow: 1,
					header: {
						name: 'header',
						component: 'DataGrid.Cell',
						children: '行为'
					},
					cell: {
						name: 'cell',
						component: "DataGrid.Cell",
						className: 'mk-datagrid-cellContent-left',
						value: "{{data.list[_rowIndex].changeTypeName}}",
						_power: '({rowIndex})=>rowIndex',
						tip: true,
					}
				}, {
					name: 'creatorName',
					component: 'DataGrid.Column',
					columnKey: 'creatorName',
					width: 100,
					flexGrow: 1,
					isResizable: true,
					header: {
						name: 'header',
						component: 'DataGrid.Cell',
						children: '操作员'
					},
					cell: {
						name: 'cell',
						component: "DataGrid.Cell",
						className: 'mk-datagrid-cellContent-left',
						value: "{{data.list[_rowIndex].creatorName}}",
						_power: '({rowIndex})=>rowIndex',
						tip: true,
					}
				}, {
					name: 'note',
					component: 'DataGrid.Column',
					columnKey: 'note',
					width: 240,
					flexGrow: 1,
					header: {
						name: 'header',
						component: 'DataGrid.Cell',
						children: '说明'
					},
					cell: {
						name: 'cell',
						component: "DataGrid.Cell",
						className: 'mk-datagrid-cellContent-left',
						value: "{{data.list[_rowIndex].note}}",
						_power: '({rowIndex})=>rowIndex',
						tip: true,
					}
				}]
			}]
		}]
	}
}

export function getInitState() {
	return {
		data: {
			list: [],
			note: '',
			other: {
				loading: false
			}
		}
	}
}



