export function getMeta() {
	return {
		name: 'root',
		component: '::div',
		className: 'edfx-app-org',
		children: [{
			name: 'main',
			component: 'Tabs',
			className: 'edfx-app-org-main',
			animated: false,
			forceRender: false,
			activeKey: '{{data.other.activeTabKey}}',
			onChange: '{{$handleTabChange}}',
			children: [{
				name: 'tab1',
				component: 'Tabs.TabPane',
				tab: '基本信息',
				forceRender: false,
				key: '1',
				children: [{
					name: 'save',
					component: '::div',
					className: 'save',
					_visible: '{{data.other.activeTabKey == 1}}',
					children: {
						name: 'button',
						onClick: '{{$saveBasicInfo}}',
						component: 'Button',
						type: 'primary',
						children: '保存'
					}
				}, {
					name: 'content',
					component: '::div',
					className: 'edfx-app-org-main-content edfx-app-org-main-content-basicInfo',
					_visible: '{{data.other.activeTabKey == 1}}',
					children: [{
						name: 'basic',
						component: '::div',
						children:[{
							name: 'title',
							className: 'blockTitle',
							component: '::div',
							children: [{
								name: 'name',
								component: '::span',
								children: '基本信息'
							}, {
								name: 'line',
								component: '::div',
								className: 'assistLine'
							}]
						}, {
							name: 'block',
							component: '::div',
							children: [{
								name: 'line1',
								component: '::div',
								className: 'itemLine',
								children: [{
									name: 'orgName',
									component: 'Form.Item',
									colon: false,
									label: '企业名称',
									validateStatus: "{{data.error.name?'error':'success'}}",
									help: '{{data.error.name}}',
									required: true,
									children: {
										name: 'input',
										component: 'Input',
										value: '{{data.basic.name}}',
										timeout: true,
										onChange: "{{function(e){$fieldChange('data.basic.name',e.target.value)}}}",
										onBlur: "{{function(e){$fieldChange('data.basic.name',e.target.value, 'blur')}}}",
									}
								}, {
									name: 'accountingStandards',
									component: 'Form.Item',
									colon: false,
									label: '会计准则',
									required: true,
									children: {
										name: 'popover',
										component: 'Popover',
										overlayClassName: '{{data.other.canModify ? "vatTaxpayerPopover vatTaxpayerPopoverHide" : "vatTaxpayerPopover"}}',
										getPopupContainer: '{{function(){return document.querySelector(".edfx-app-org-main-content-basicInfo")}}}',
										trigger: 'hover',
										placement: 'bottomLeft',
										content: {
											name: 'content',
											component: '::span',
											children: '当前企业已存在业务数据、财务数据或已读取企业信息，修改会计准则需【重新初始化】才能操作'
										},
										children: {
											name: 'select',
											component: '::div',
											style: { position: 'relative' },
											children: [{
												name: 'select',
												component: 'Select',
												disabled: '{{!data.other.canModify}}',
												getPopupContainer: '{{function(){return document.querySelector(".edfx-app-org-main-content-basicInfo")}}}',
												showSearch: false,
												value: '{{data.basic.accountingStandards}}',
												onChange: "{{function(e){$setField('data.basic.accountingStandards',e)}}}",
												children: {
													name: 'option',
													component: 'Select.Option',
													value: '{{data.enumData.basic.accountingStandards[_rowIndex].id}}',
													children: '{{data.enumData.basic.accountingStandards[_rowIndex].name}}',
													_power: 'for in data.enumData.basic.accountingStandards',
												}
											}, {
												name: 'shadow',
												component: '::div',
												_visible: '{{!data.other.canModify}}',
												className: 'shadow'
											}]
										}
									}
								}]
							}, {
								name: 'line2',
								component: '::div',
								className: 'itemLine',
								children: [{
									name: 'enableDate',
									component: 'Form.Item',
									colon: false,
									label: '启用期间',
									validateStatus: "{{data.error.enableDate?'error':'success'}}",
									help: '{{data.error.enableDate}}',
									required: true,
									children: {
										name: 'input',
										component: 'DatePicker.MonthPicker',
										getCalendarContainer: '{{function(){return document.querySelector(".edfx-app-org-main-content-basicInfo")}}}',
										value: "{{$stringToMoment((data.basic.enableDate),'YYYY-MM')}}",
										onChange: "{{function(v) {$fieldChange('data.basic.enableDate', $momentToString(v,'YYYY-MM'))}}}",
									}
								}, {
									name: 'name',
									component: 'Form.Item',
									style: {visibility:'hidden'},
									label: '*',
								}]
							}]
						}]
					}, {
						name: 'tax',
						component: '::div',
						children:[{
							name: 'title',
							className: 'blockTitle',
							component: '::div',
							children: [{
								name: 'name',
								component: '::span',
								children: '税务信息'
							}, {
								name: 'line',
								component: '::div',
								className: 'assistLine'
							}]
						}, {
							name: 'block',
							component: '::div',
							children: [{
								name: 'line1',
								component: '::div',
								className: 'itemLine',
								children: [{
									name: 'vatTaxpayer',
									component: 'Form.Item',
									colon: false,
									label: '纳税人性质',
									required: true,
									children: {
										name: 'popover',
										component: 'Popover',
										overlayClassName: '{{data.other.canModify ? "accountingStandardsPopover accountingStandardsPopoverHide" : "accountingStandardsPopover"}}',
										getPopupContainer: '{{function(){return document.querySelector(".edfx-app-org-main-content-basicInfo")}}}',
										trigger: 'hover',
										placement: 'bottomLeft',
										content: {
											name: 'content',
											component: '::span',
											children: '当前企业已存在业务数据、财务数据或已读取企业信息，修改纳税人性质需【重新初始化】才能操作'
										},
										children: {
											name: 'select',
											component: '::div',
											style: { position: 'relative' },
											children: [{
												name: 'select',
												component: 'Select',
												disabled: '{{!data.other.canModify}}',
												getPopupContainer: '{{function(){return document.querySelector(".edfx-app-org-main-content-basicInfo")}}}',
												showSearch: false,
												value: '{{data.basic.vatTaxpayer}}',
												onChange: "{{function(e){$setField('data.basic.vatTaxpayer',e)}}}",
												children: {
													name: 'option',
													component: 'Select.Option',
													value: '{{data.enumData.basic.vatTaxpayer[_rowIndex].id}}',
													children: '{{data.enumData.basic.vatTaxpayer[_rowIndex].name}}',
													_power: 'for in data.enumData.basic.vatTaxpayer',
												}
											}, {
												name: 'shadow',
												component: '::div',
												_visible: '{{!data.other.canModify}}',
												className: 'shadow'
											}]
										}
									}
								}, {
									name: 'vatTaxpayerNum',
									component: 'Form.Item',
									colon: false,
									label: '纳税人识别号',
									required: true,
									validateStatus: "{{data.error.vatTaxpayerNum?'error':'success'}}",
									help: '{{data.error.vatTaxpayerNum}}',
									children: {
										name: 'input',
										component: 'Input',
										timeout:true,
										value: '{{data.basic.vatTaxpayerNum}}',
										onChange: '{{function(e){$handleNsrsbhChange(e.target.value)}}}',
										onBlur: '{{function(e){$handleNsrsbhBlur(e.target.value)}}}'
									}
								}]
							}, {
								name: 'line2',
								component: '::div',
								className: 'itemLine',
								children: [{
									name: 'ss',
									component: 'Form.Item',
									colon: false,
									label: '省市',
									required: true,
									validateStatus: "{{data.error.ss?'error':'success'}}",
									help: '{{data.error.ss}}',
									children: {
										name: 'input',
										component: 'Select',
										getPopupContainer: '{{function(){return document.querySelector(".edfx-app-org-main-content-basicInfo")}}}',
										showSearch: false,
										value: '{{data.basic.ss}}',
										onChange: '{{function(e){$handleSelectChange("data.basic.ss", e)}}}',
										children: {
											name: 'option',
											component: 'Select.Option',
											value: '{{data.enumData.basic.SS[_rowIndex].id}}',
											children: '{{data.enumData.basic.SS[_rowIndex].name}}',
											_power: 'for in data.enumData.basic.SS',
										}
									}
								}, {
									name: 'agree',
									component: 'Form.Item',
									// _visible: '{{data.basic.vatTaxpayer == "2000010001" ? true : false}}',
									_visible: false,
									colon: false,
									className: 'jzjt',
									label: ' ',
									children:{
										name: 'checkbox',
										component: 'Checkbox',
										checked: '{{data.basic.isSignAndRetreat}}',
										onChange: "{{function(e){$setField('data.basic.isSignAndRetreat',e.target.checked)}}}",
										children: '即征即退'
									}
								}, {
									name: 'name',
									component: 'Form.Item',
									// _visible: '{{data.basic.vatTaxpayer == "2000010001" ? false : true}}',
									_visible: true,
									style: {visibility:'hidden'},
									label: '*',
								}]
							}]
						}]
					}, {
						name: 'login',
						component: '::div',
						children:[{
							name: 'title',
							className: 'blockTitle',
							component: '::div',
							children: [{
								name: 'name',
								component: '::span',
								children: '税局登录信息'
							}, {
								name: 'line',
								component: '::div',
								className: 'assistLine'
							}]
						}, {
							name: 'block',
							component: '::div',
							children: [{
								name: 'line1',
								component: '::div',
								className: 'itemLine',
								children: [{
									name: 'loginType',
									component: 'Form.Item',
									colon: false,
									label: '登录方式',
									children: {
										name: 'input',
										component: 'Select',
										getPopupContainer: '{{function(){return document.querySelector(".edfx-app-org-main-content-basicInfo")}}}',
										showSearch: false,
										value: '{{data.basic.dlfs}}',
										onChange: '{{function(e){$handleSelectChange("data.basic.dlfs", e)}}}',
										onFocus: '{{$onDlfsSelectChange}}',
										children: {
											name: 'option',
											component: 'Select.Option',
											value: '{{data.enumData.basic.DLFS[_rowIndex].id}}',
											children: '{{data.enumData.basic.DLFS[_rowIndex].name}}',
											_power: 'for in data.enumData.basic.DLFS',
										}
									}
								}, {
									name: 'name',
									component: 'Form.Item',
									style: {visibility:'hidden'},
									label: '*',
								}]
							}, {
								name: 'line2',
								component: '::div',
								className: 'itemLine',
								_visible: '{{data.basic.dlfs != 1}}',
								children: [{
									name: 'account',
									component: 'Form.Item',
									colon: false,
									label: '网报账号',
									children: {
										name: 'input',
										component: 'Input',
										value: '{{data.basic.wbzh}}',
										onChange: '{{function(e){$setField("data.basic.wbzh", e.target.value);$readOrgInfoBtnState()}}}',
									}
								}, {
									name: 'password',
									component: 'Form.Item',
									colon: false,
									label: '网报密码',
									children: {
										name: 'input',
										component: 'Input',
										type: 'password',
										value: '{{data.basic.wbmm}}',
										onChange: '{{function(e){$setField("data.basic.wbmm", e.target.value);$readOrgInfoBtnState()}}}',
									}
								}]
							}, {
								name: 'line3',
								component: '::div',
								_visible: '{{data.basic.dlfs == 1}}',
								className: 'caHandle',
								children: [{
									name: 'title',
									component: '::div',
									style: {marginBottom: '10px'},
									children: {
										name: 'item',
										component: '::span',
										className: 'CATitle',
										style: {overflow: 'hidden', display: 'inline-block', cursor: 'pointer'},
										onClick: '{{$changeCAStep}}',
										children: [{
											name: 'item',
											component: '::span',
											children: 'CA证书登录步骤'
										}, {
											name: 'icon',
											component: 'Icon',
											fontFamily: 'edficon',
											type: '{{data.other.CAStep ? "shang" : "xia"}}',
											style: {float: 'right'},
										}]
									}
								}, {
									name: 'step',
									component: '::div',
									_visible: '{{data.other.CAStep}}',
									children: [{
										name: 'step1',
										component: '::div',
										style: {marginBottom: '10px'},
										children: [{
											name: 'title',
											component: '::div',
											children: '1、下载安装CA证书读取工具',
											style: {marginBottom: '5px'},
											className: 'stepName',
										}, {
											name: 'btn',
											component: 'Button',
											style: {width: '90px'},
											onClick: '{{$downloadCACertifacate}}',
											children: '点击下载'
										}]
									}, {
										name: 'step2',
										component: '::div',
										style: {marginBottom: '10px'},
										children: [{
											name: 'title',
											component: '::div',
											children: "{{!data.other.hasReadCA ? '2、下载完成后，读取CA证书' : '2、CA证书已读取，可更换CA证书'}}",
											style: {marginBottom: '5px'},
											className: 'stepName',
										}, {
											name: 'btn',
											component: 'Button',
											style: {width: '90px'},
											onClick: '{{$openCATool}}',
											children: '读取CA证书'
										}]
									}, {
										name: 'step3',
										component: '::div',
										style: {marginBottom: '10px'},
										children: [{
											name: 'title',
											component: '::div',
											children: '3、完成第1、2步后，可读取企业信息',
											className: 'stepName',
										}]
									}]
								}, {
									name: 'changeCA',
									component: '::div',
									_visible: '{{data.other.hasReadCA}}',
									children: [{
										name: 'a',
										component: '::a',
										children: '更换CA证书'
									}, {
										name:'item',
										component: '::span',
										children: '（如果无法打开更换CA证书，请点击上方重新下载证书读取工具）'
									}]
								}]
							}, {
								name: 'line4',
								component: '::div',
								className: 'itemLine readOrgBtn',
								style: {textAlign: 'left', paddingTop: '10px'},
								children:[{
									name: 'readBtn',
									component: 'Button',
									onClick: '{{$readOrgInfo}}',
									disabled: '{{data.other.readOrgInfoBtn}}',
									style: {marginLeft: '168px', width: '90px'},
									type: 'primary',
									children: '读取企业信息'
								}, {
									name: 'remind',
									component: 'Popover',
									getPopupContainer: '{{function() {return document.querySelector(".readOrgBtn")}}}',
									placement: 'right',
									// content: '提示：正确读取企业信息以后，会自动将信息带入到“纳税信息”、“资格认定”、“税费种信息”页签',
									content: [
										{
											name: 'p',
											component: '::div',
											children: '1、读取企业信息后，才可以采集发票'
										},{
											name: 'p',
											component: '::div',
											children: '2、读取企业信息后，才可以税务申报'
										},{
											name: 'p',
											component: '::div',
											children: '3、正确读取企业信息以后，会自动将信息带入到“企业信息”、“资格认定”、“税费种信息”页签'
										}],
									children: {
										name: 'icon',
										component: 'Icon',
										fontFamily: 'edficon',
										type: 'bangzhutishi'
									}
								}]
							}]
						}]
					}, {
						name: 'loginBottom',
						component: '::div',
						children:[{
							name: 'title',
							className: 'blockTitle',
							component: '::div',
							children: [{
								name: 'name',
								component: '::span',
								style: {display: 'none'},
								children: '税局登录信息'
							}, {
								name: 'line',
								component: '::div',
								className: 'assistLine'
							}]
						}]
					}]
				}]
			}, {
				name: 'tab2',
				component: 'Tabs.TabPane',
				forceRender: false,
				tab: '企业信息',
				key: '2',
				children: [{
					name: 'save',
					component: '::div',
					className: 'save',
					_visible: '{{data.other.activeTabKey == 2}}',
					children: {
						name: 'button',
						component: 'Button',
						onClick: '{{$saveOrgInfo}}',
						type: 'primary',
						children: '保存'
					}
				}, {
					name: 'content',
					component: '::div',
					_visible: '{{data.other.activeTabKey == 2}}',
					className: 'edfx-app-org-main-content edfx-app-org-main-content-orgInfo',
					children: [{
						name: 'basic',
						component: '::div',
						children:[{
							name: 'title',
							className: 'blockTitle',
							component: '::div',
							onClick: '{{function() {$setField("data.other.title1", !data.other.title1)}}}',
							children: [{
								name: 'name',
								component: '::span',
								children: '纳税人基本信息'
							}, {
								name: 'line',
								component: '::div',
								className: 'assistLine'
							}, {
								name: 'arrow',
								component: '::div',
								className: 'blockTitle-arrow',
								children: {
									name: 'arrow',
									component: 'Icon',
									fontFamily: 'edficon',
									type: '{{data.other.title1 ? "shang" : "xia"}}'
								}
							}]
						}, {
							name: 'block',
							component: '::div',
							_visible: '{{data.other.title1}}',
							children: [{
								name: 'title',
								component: '::div',
								className: 'itemLine',
								children: [{
									name: 'enableDate',
									component: 'Form.Item',
									colon: false,
									label: '纳税人名称',
									validateStatus: "{{data.error.orgInfo.NSRMC?'error':'success'}}",
									help: '{{data.error.orgInfo.NSRMC}}',
									children: {
										name: 'input',
										component: 'Input',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.NSRMC}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.NSRMC', e.target.value, '纳税人名称')}}}",
									}
								}, {
									name: 'state',
									component: 'Form.Item',
									colon: false,
									label: '纳税人状态',
									children: {
										name: 'input',
										component: 'Select',
										disabled: '{{data.other.isShowOtherMsg}}',
										getPopupContainer: '{{function(){return document.querySelector(".edfx-app-org-main-content-orgInfo")}}}',
										showSearch: false,
										// value: '{{data.nsxxDto.NSRZT && Number(data.nsxxDto.NSRZT)}}',
										value: '{{data.nsxxDto.NSRZTDM}}',
										onChange: "{{function(e){$setField('data.nsxxDto.NSRZTDM',e)}}}",
										children: {
											name: 'option',
											component: 'Select.Option',
											key: '{{data.enumData.tax.NSRZT.enumDetails[_rowIndex].id}}',
											value: '{{data.enumData.tax.NSRZT.enumDetails[_rowIndex].code}}',
											children: '{{data.enumData.tax.NSRZT.enumDetails[_rowIndex].name}}',
											_power: 'for in data.enumData.tax.NSRZT.enumDetails',
										}
									}
								}]
							}, {
								name: 'line1',
								component: '::div',
								className: 'itemLine',
								children: [{
									name: 'industry',
									component: 'Form.Item',
									colon: false,
									label: '所属行业',
									children: {
										name: 'input',
										component: 'Select',
										disabled: '{{data.other.isShowOtherMsg}}',
										key: '{{data.other.key}}',
										getPopupContainer: '{{function(){return document.querySelector(".edfx-app-org-main-content-orgInfo")}}}',
										showSearch: false,
										value: '{{data.nsxxDto.SSHY}}',
										onChange: "{{function(e){$setField('data.nsxxDto.SSHY',e)}}}",
										children: '{{$getSelectOption()}}'
									}
								}, {
									name: 'registerNum',
									component: 'Form.Item',
									colon: false,
									label: '登记序号',
									validateStatus: "{{data.error.orgInfo.DJXH?'error':'success'}}",
									help: '{{data.error.orgInfo.DJXH}}',
									children: {
										name: 'input',
										component: 'Input',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.DJXH}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.DJXH', e.target.value, '登记序号')}}}",
									}
								}]
							}, {
								name: 'line2',
								component: '::div',
								className: 'itemLine',
								children: [{
									name: 'capital',
									component: 'Form.Item',
									colon: false,
									label: '注册资本',
									validateStatus: "{{data.error.orgInfo.ZCZB?'error':'success'}}",
									help: '{{data.error.orgInfo.ZCZB}}',
									children: {
										name: 'input',
										component: 'Input',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.ZCZB}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.ZCZB', e.target.value, '注册资本')}}}",
										onBlur: '{{function(e){$zczb(e.target.value)}}}'
									}
								}, {
									name: 'registerType',
									component: 'Form.Item',
									colon: false,
									label: '登记注册类型',
									children: {
										name: 'input',
										component: 'Select',
										disabled: '{{data.other.isShowOtherMsg}}',
										getPopupContainer: '{{function(){return document.querySelector(".edfx-app-org-main-content-orgInfo")}}}',
										showSearch: false,
										value: '{{data.nsxxDto.DJZCLX}}',
										onChange: "{{function(e){$setField('data.nsxxDto.DJZCLX',e)}}}",
										children: {
											name: 'option',
											component: 'Select.Option',
											key: '{{data.enumData.tax.DJZCLX.enumDetails[_rowIndex].id}}',
											value: '{{data.enumData.tax.DJZCLX.enumDetails[_rowIndex].code}}',
											children: '{{data.enumData.tax.DJZCLX.enumDetails[_rowIndex].name}}',
											_power: 'for in data.enumData.tax.DJZCLX.enumDetails',
										}
									}
								}]
							}, {
								name: 'line3',
								component: '::div',
								className: 'itemLine',
								children: [{
									name: 'zzsqylx',
									component: 'Form.Item',
									colon: false,
									label: '增值税企业类型',
									children: {
										name: 'input',
										component: 'Select',
										disabled: '{{data.other.isShowOtherMsg}}',
										getPopupContainer: '{{function(){return document.querySelector(".edfx-app-org-main-content-orgInfo")}}}',
										showSearch: false,
										value: '{{data.nsxxDto.ZZSQYLX}}',
										onChange: "{{function(e){$setField('data.nsxxDto.ZZSQYLX',e)}}}",
										children: {
											name: 'option',
											component: 'Select.Option',
											key: '{{data.enumData.tax.ZZSQYLX.enumDetails[_rowIndex].id}}',
											value: '{{data.enumData.tax.ZZSQYLX.enumDetails[_rowIndex].code}}',
											children: '{{data.enumData.tax.ZZSQYLX.enumDetails[_rowIndex].name}}',
											_power: 'for in data.enumData.tax.ZZSQYLX.enumDetails',
										}
									}
								}, {
									name: 'cyrs',
									component: 'Form.Item',
									colon: false,
									label: '从业人数',
									validateStatus: "{{data.error.orgInfo.CYRS?'error':'success'}}",
									help: '{{data.error.orgInfo.CYRS}}',
									children: {
										name: 'input',
										component: 'Input.Number',
										regex: '^([0-9]+)$',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.CYRS}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.CYRS', e, '从业人数')}}}",
									}
								}]
							}, {
								name: 'line4',
								component: '::div',
								className: 'itemLine',
								children: [{
									name: 'level',
									component: 'Form.Item',
									colon: false,
									label: '信用等级',
									children: {
										name: 'input',
										component: 'Select',
										getPopupContainer: '{{function(){return document.querySelector(".edfx-app-org-main-content-orgInfo")}}}',
										showSearch: false,
										value: '{{data.nsxxDto.XYDJ && Number(data.nsxxDto.XYDJ)}}',
										onChange: "{{function(e){$setField('data.nsxxDto.XYDJ',e)}}}",
										children: {
											name: 'option',
											component: 'Select.Option',
											key: '{{data.enumData.tax.XYDJ.enumDetails[_rowIndex].id}}',
											value: '{{data.enumData.tax.XYDJ.enumDetails[_rowIndex].id}}',
											children: '{{data.enumData.tax.XYDJ.enumDetails[_rowIndex].name}}',
											_power: 'for in data.enumData.tax.XYDJ.enumDetails',
										}
									}
								}, {
									name: 'level',
									component: 'Form.Item',
									colon: false,
									label: '纳税人电子档案',
									validateStatus: "{{data.error.orgInfo.NSRDZDA?'error':'success'}}",
									help: '{{data.error.orgInfo.NSRDZDA}}',
									children: {
										name: 'input',
										component: 'Input',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.NSRDZDA}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.NSRDZDA', e.target.value, '纳税人电子档案')}}}",
									}
								}]
							}, {
								name: 'more',
								component: '::div',
								className: 'itemLine',
								style: {borderTop: '1px dashed #d9d9d9'},
								children: [{
									name: 'more',
									component: '::span',
									onClick: '{{$hideInfo}}',
									className: 'more',
									children: ['更多', {
										name: 'icon',
										component: 'Icon',
										style: {marginLeft: '5px'},
										type: '{{data.other.detailInfo ? "up" : "down"}}'
									}]
								}]
							}, {
								name: 'line5',
								component: '::div',
								className: 'itemLine',
								_visible: '{{data.other.detailInfo}}',
								children: [{
									name: 'enableDate',
									component: 'Form.Item',
									colon: false,
									label: '银行账户',
									validateStatus: "{{data.error.orgInfo.YHZH?'error':'success'}}",
									help: '{{data.error.orgInfo.YHZH}}',
									children: {
										name: 'input',
										component: 'Input',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.YHZH}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.YHZH', e.target.value, '银行账户')}}}",
									}
								}, {
									name: 'registerNum',
									component: 'Form.Item',
									colon: false,
									label: '开户银行',
									validateStatus: "{{data.error.orgInfo.KHYH?'error':'success'}}",
									help: '{{data.error.orgInfo.KHYH}}',
									children: {
										name: 'input',
										component: 'Input',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.KHYH}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.KHYH', e.target.value, '开户银行')}}}",
									}
								}]
							}, {
								name: 'line6',
								component: '::div',
								className: 'itemLine',
								_visible: '{{data.other.detailInfo}}',
								children: [{
									name: 'level',
									component: 'Form.Item',
									colon: false,
									label: '开业日期',
									children: {
										name: 'input',
										disabled: '{{data.other.isShowOtherMsg}}',
										component: 'DatePicker',
										getCalendarContainer: '{{function(){return document.querySelector(".edfx-app-org-main-content-orgInfo")}}}',
										value: '{{$stringToMoment((data.nsxxDto.KYRQ), "YYYY-MM-DD")}}',
										onChange: "{{function(v) {$sf('data.nsxxDto.KYRQ', $momentToString(v,'YYYY-MM-DD'))}}}",
									}
								}, {
									name: 'registerNum',
									component: 'Form.Item',
									colon: false,
									label: '组织机构代码',
									validateStatus: "{{data.error.orgInfo.ZZJGDM?'error':'success'}}",
									help: '{{data.error.orgInfo.ZZJGDM}}',
									children: {
										name: 'input',
										component: 'Input',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.ZZJGDM}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.ZZJGDM', e.target.value, '组织机构代码')}}}",
									}
								}]
							}, {
								name: 'line7',
								component: '::div',
								className: 'itemLine',
								_visible: '{{data.other.detailInfo}}',
								children: [{
									name: 'level',
									component: 'Form.Item',
									colon: false,
									label: '总分机构标志',
									children: {
										name: 'input',
										component: 'Select',
										disabled: '{{data.other.isShowOtherMsg}}',
										getPopupContainer: '{{function(){return document.querySelector(".edfx-app-org-main-content-orgInfo")}}}',
										showSearch: false,
										value: '{{data.nsxxDto.ZFJGBZ}}',
										onChange: "{{function(e){$setField('data.nsxxDto.ZFJGBZ',e)}}}",
										children: {
											name: 'option',
											component: 'Select.Option',
											key: '{{data.enumData.tax.ZFJGLX.enumDetails[_rowIndex].id}}',
											value: '{{data.enumData.tax.ZFJGLX.enumDetails[_rowIndex].code}}',
											children: '{{data.enumData.tax.ZFJGLX.enumDetails[_rowIndex].name}}',
											_power: 'for in data.enumData.tax.ZFJGLX.enumDetails',
										}
									}
								}, {
									name: 'registerNum',
									component: 'Form.Item',
									colon: false,
									label: '代扣代缴标志',
									children: {
										name: 'input',
										component: 'Select',
										disabled: '{{data.other.isShowOtherMsg}}',
										getPopupContainer: '{{function(){return document.querySelector(".edfx-app-org-main-content-orgInfo")}}}',
										showSearch: false,
										value: '{{data.nsxxDto.DKDJBZ}}',
										onChange: "{{function(e){$setField('data.nsxxDto.DKDJBZ',e)}}}",
										children: {
											name: 'option',
											component: 'Select.Option',
											key: '{{data.enumData.tax.DKDJBZ.enumDetails[_rowIndex].id}}',
											value: '{{data.enumData.tax.DKDJBZ.enumDetails[_rowIndex].code}}',
											children: '{{data.enumData.tax.DKDJBZ.enumDetails[_rowIndex].name}}',
											_power: 'for in data.enumData.tax.DKDJBZ.enumDetails',
										}
									}
								}]
							}, {
								name: 'line9',
								component: '::div',
								className: 'itemLine textarea',
								_visible: '{{data.other.detailInfo}}',
								children: [{
									name: 'enableDate',
									component: 'Form.Item',
									colon: false,
									label: '经营范围',
									validateStatus: "{{data.error.orgInfo.JYFW?'error':'success'}}",
									help: '{{data.error.orgInfo.JYFW}}',
									children: {
										name: 'input',
										component: 'Input.TextArea',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.JYFW}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(200, 'data.error.orgInfo.JYFW', e.target.value, '经营范围')}}}",
									}
								}]
							}, {
								name: 'line10',
								component: '::div',
								className: 'itemLine textarea',
								_visible: '{{data.other.detailInfo}}',
								children: [{
									name: 'enableDate',
									component: 'Form.Item',
									colon: false,
									label: '生产经营地址',
									validateStatus: "{{data.error.orgInfo.SCJYDZ?'error':'success'}}",
									help: '{{data.error.orgInfo.SCJYDZ}}',
									children: {
										name: 'input',
										component: 'Input.TextArea',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.SCJYDZ}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(200, 'data.error.orgInfo.SCJYDZ', e.target.value, '生产经营地址')}}}",
									}
								}]
							}]
						}]
					}, {
						name: 'tax',
						component: '::div',
						children:[{
							name: 'title',
							className: 'blockTitle',
							component: '::div',
							onClick: '{{function() {$setField("data.other.title2", !data.other.title2)}}}',
							children: [{
								name: 'name',
								component: '::span',
								children: '税务机关信息'
							}, {
								name: 'line',
								component: '::div',
								className: 'assistLine'
							}, {
								name: 'arrow',
								component: '::div',
								className: 'blockTitle-arrow',
								children: {
									name: 'arrow',
									component: 'Icon',
									fontFamily: 'edficon',
									type: '{{data.other.title2 ? "shang" : "xia"}}'
								}
							}]
						}, {
							name: 'block',
							component: '::div',
							_visible: '{{data.other.title2}}',
							children: [{
								name: 'line1',
								component: '::div',
								className: 'itemLine',
								children: [{
									name: 'vatTaxpayer',
									component: 'Form.Item',
									colon: false,
									label: '主管税务局',
									validateStatus: "{{data.error.orgInfo.ZGSWJ?'error':'success'}}",
									help: '{{data.error.orgInfo.ZGSWJ}}',
									children: {
										name: 'input',
										component: 'Input',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.ZGSWJ}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.ZGSWJ', e.target.value, '主管税务局')}}}",
									}
								}, {
									name: 'vatTaxpayerNum',
									component: 'Form.Item',
									colon: false,
									label: '主管税务人员',
									validateStatus: "{{data.error.orgInfo.ZGSWRY?'error':'success'}}",
									help: '{{data.error.orgInfo.ZGSWRY}}',
									children: {
										name: 'input',
										component: 'Input',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.ZGSWRY}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.ZGSWRY', e.target.value, '主管税务人员')}}}",
									}
								}]
							}]
						}]
					}, {
						name: 'login',
						component: '::div',
						children:[{
							name: 'title',
							className: 'blockTitle',
							onClick: '{{function() {$setField("data.other.title3", !data.other.title3)}}}',
							component: '::div',
							children: [{
								name: 'name',
								component: '::span',
								children: '联系人信息'
							}, {
								name: 'line',
								component: '::div',
								className: 'assistLine'
							}, {
								name: 'arrow',
								component: '::div',
								className: 'blockTitle-arrow',
								children: {
									name: 'arrow',
									component: 'Icon',
									fontFamily: 'edficon',
									type: '{{data.other.title3 ? "shang" : "xia"}}'
								}
							}]
						}, {
							name: 'block',
							component: '::div',
							_visible: '{{data.other.title3}}',
							children: [{
								name: 'line1',
								component: '::div',
								className: 'itemLine',
								children: [{
									name: 'account',
									component: 'Form.Item',
									colon: false,
									label: '法定负责人',
									validateStatus: "{{data.error.orgInfo.FDFZR?'error':'success'}}",
									help: '{{data.error.orgInfo.FDFZR}}',
									children: {
										name: 'input',
										component: 'Input',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.FDFZR}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.FDFZR', e.target.value, '法定负责人')}}}",
									}
								}, {
									name: 'account',
									component: 'Form.Item',
									colon: false,
									label: '联系电话',
									validateStatus: "{{data.error.orgInfo.FDFZR_TEL?'error':'success'}}",
									help: '{{data.error.orgInfo.FDFZR_TEL}}',
									children: {
										name: 'input',
										component: 'Input',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.FDFZR_TEL}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.FDFZR_TEL', e.target.value, '联系电话')}}}",
									}
								}]
							}, {
								name: 'line2',
								component: '::div',
								className: 'itemLine',
								children: [{
									name: 'account',
									component: 'Form.Item',
									colon: false,
									label: '财务负责人',
									validateStatus: "{{data.error.orgInfo.CWFZR?'error':'success'}}",
									help: '{{data.error.orgInfo.CWFZR}}',
									children: {
										name: 'input',
										component: 'Input',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.CWFZR}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.CWFZR', e.target.value, '财务负责人')}}}",
									}
								}, {
									name: 'password',
									component: 'Form.Item',
									colon: false,
									label: '联系电话',
									validateStatus: "{{data.error.orgInfo.CWFZR_TEL?'error':'success'}}",
									help: '{{data.error.orgInfo.CWFZR_TEL}}',
									children: {
										name: 'input',
										component: 'Input',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.CWFZR_TEL}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.CWFZR_TEL', e.target.value, '联系电话')}}}",
									}
								}]
							}, {
								name: 'line3',
								component: '::div',
								className: 'itemLine',
								children:[{
									name: 'account',
									component: 'Form.Item',
									colon: false,
									label: '办税员',
									validateStatus: "{{data.error.orgInfo.BSY?'error':'success'}}",
									help: '{{data.error.orgInfo.BSY}}',
									children: {
										name: 'input',
										component: 'Input',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.BSY}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.BSY', e.target.value, '办税员')}}}",
									}
								}, {
									name: 'account',
									component: 'Form.Item',
									colon: false,
									label: '联系电话',
									validateStatus: "{{data.error.orgInfo.BSY_TEL?'error':'success'}}",
									help: '{{data.error.orgInfo.BSY_TEL}}',
									children: {
										name: 'input',
										component: 'Input',
										disabled: '{{data.other.isShowOtherMsg}}',
										value: '{{data.nsxxDto.BSY_TEL}}',
										timeout: true,
										onChange: "{{function(e){$checkNotRequire(50, 'data.error.orgInfo.BSY_TEL', e.target.value, '联系电话')}}}",
									}
								}]
							}]
						}]
					}]
				}]
			}, {
				name: 'tab3',
				component: 'Tabs.TabPane',
				forceRender: false,
				_visible: '{{data.other.isShowOtherMsg}}',
				tab: '资格认定',
				key: '3',
				children:[{
					name: 'bar',
					component: '::div',
					className: 'refreshBtn',
					children: [{
						name: 'refresh',
						component: 'Icon',
						fontFamily: 'edficon',
						onClick: '{{$readOrgInfo}}',
						type: 'shuaxin',
						style: {float: 'left', fontSize: '28px', lineHeight: '30px'}
					}, {
						name: 'explain',
						component: '::span',
						style: {lineHeight: '30px',color:'rgb(250, 149, 76)',fontSize: '12px', float: 'left'},
						children: '提示：刷新后将重新读取企业信息'
					}]
				}, {
					name: 'zgrdDiv',
					component: '::div',
					children:[{
						name: 'dataGrid',
						component: 'DataGrid',
						headerHeight: 36,
						rowHeight: 36,
						rowsCount: '{{data.zgrdDtos.length}}',
						isColumnResizing: true,
						ellipsis: true,
						columns:[{
							name: 'ZGRDLX',
							component: 'DataGrid.Column',
							columnKey: 'ZGRDLX',
							flexGrow: 1,
							width: 300,
							header: {
								name: 'header',
								component: 'DataGrid.Cell',
								children: '资格认定类型'
							},
							cell:{
								name: 'cell',
								component: 'DataGrid.TextCell',
								align: 'left',
								value: '{{$renderColValue(data.zgrdDtos[_rowIndex] && data.zgrdDtos[_rowIndex].ZGRDLX, data.enumData.tax.ZGRDLX.enumDetails)}}',
								_power: '({rowIndex}) => rowIndex',
							}
						},{
							name: 'YXQKSRQ',
							component: 'DataGrid.Column',
							columnKey: 'YXQKSRQ',
							flexGrow: 1,
							width: 80,
							header: {
								name: 'header',
								component: 'DataGrid.Cell',
								children: '有效期开始日期'
							},
							cell:{
								name: 'cell',
								component: 'DataGrid.TextCell',
								value:'{{$renderDate(data.zgrdDtos[_rowIndex] && data.zgrdDtos[_rowIndex].YXQKSRQ)}}',
								_power: '({rowIndex}) => rowIndex',
							}
						},{
							name: 'YXQJSRQ',
							component: 'DataGrid.Column',
							columnKey: 'YXQJSRQ',
							flexGrow: 1,
							width: 80,
							header: {
								name: 'header',
								component: 'DataGrid.Cell',
								children: '有效期结束日期'
							},
							cell:{
								name: 'cell',
								component: 'DataGrid.TextCell',
								value:'{{$renderDate(data.zgrdDtos[_rowIndex] && data.zgrdDtos[_rowIndex].YXQJSRQ)}}',
								_power: '({rowIndex}) => rowIndex',
							}
						},{
							name: 'SJZZRQ',
							component: 'DataGrid.Column',
							columnKey: 'SJZZRQ',
							flexGrow: 1,
							width: 80,
							header: {
								name: 'header',
								component: 'DataGrid.Cell',
								children: '实际中止日期'
							},
							cell:{
								name: 'cell',
								component: 'DataGrid.TextCell',
								value:'{{$renderDate(data.zgrdDtos[_rowIndex] && data.zgrdDtos[_rowIndex].SJZZRQ)}}',
								_power: '({rowIndex}) => rowIndex',
							}
						}]
					}]
				}]
			}, {
				name: 'tab4',
				component: 'Tabs.TabPane',
				forceRender: false,
				_visible: '{{data.other.isShowOtherMsg}}',
				tab: '税费种信息',
				key: '4',
				children:[{
					name: 'bar',
					component: '::div',
					className: 'refreshBtn',
					children: [{
						name: 'refresh',
						component: 'Icon',
						onClick: '{{$readOrgInfo}}',
						fontFamily: 'edficon',
						type: 'shuaxin',
						style: {float: 'left', fontSize: '28px', lineHeight: '30px'}
					}, {
						name: 'explain',
						component: '::span',
						style: {lineHeight: '30px',color:'rgb(250, 149, 76)',fontSize: '12px', float: 'left'},
						children: '提示：刷新后将重新读取企业信息'
					}]
				}, {
					name: 'taxDiv',
					component: '::div',
					children:[{
						name: 'details',
						component: 'DataGrid',
						headerHeight: 36,
						rowHeight: 36,
						rowsCount: '{{data.sfzxxDtos.length}}',
						isColumnResizing: true,
						ellipsis: true,
						columns:[{
							name: 'SBXM',
							component: 'DataGrid.Column',
							columnKey: 'SBXM',
							flexGrow: 1,
							width: 300,
							header: {
								name: 'header',
								component: 'DataGrid.Cell',
								children: '申报项目'
							},
							cell:{
								name: 'cell',
								align: 'left',
								component: 'DataGrid.TextCell',
								value: '{{$renderColValue(data.sfzxxDtos[_rowIndex] && data.sfzxxDtos[_rowIndex].SBXM, data.enumData.tax.SBXM.enumDetails)}}',
								_power: '({rowIndex}) => rowIndex',
							}
						},{
							name: 'SBPM',
							component: 'DataGrid.Column',
							columnKey: 'SBPM',
							flexGrow: 1,
							width: 300,
							header: {
								name: 'header',
								component: 'DataGrid.Cell',
								children: '申报品目'
							},
							cell:{
								name: 'cell',
								component: 'DataGrid.TextCell',
								align: "left",
								value: '{{$renderColValue(data.sfzxxDtos[_rowIndex] && data.sfzxxDtos[_rowIndex].SBPM, data.enumData.tax.SBPM.enumDetails)}}',
								_power: '({rowIndex}) => rowIndex',
							}
						},{
							name: 'SBZQ',
							component: 'DataGrid.Column',
							columnKey: 'SBZQ',
							flexGrow: 1,
							width: 30,
							header: {
								name: 'header',
								component: 'DataGrid.Cell',
								children: '申报周期'
							},
							cell:{
								name: 'cell',
								component: 'DataGrid.TextCell',
								value: '{{$renderColValue(data.sfzxxDtos[_rowIndex] && data.sfzxxDtos[_rowIndex].SBZQ, data.enumData.tax.SBZQ.enumDetails)}}',
								_power: '({rowIndex}) => rowIndex',
							}
						},{
							name: 'YXQQ',
							component: 'DataGrid.Column',
							columnKey: 'YXQQ',
							flexGrow: 1,
							width: 80,
							header: {
								name: 'header',
								component: 'DataGrid.Cell',
								children: '有效期起'
							},
							cell:{
								name: 'cell',
								component: 'DataGrid.TextCell',
								value:'{{$renderDate(data.sfzxxDtos[_rowIndex] && data.sfzxxDtos[_rowIndex].YXQQ)}}',
								_power: '({rowIndex}) => rowIndex',
							}
						},{
							name: 'YXQZ',
							component: 'DataGrid.Column',
							columnKey: 'YXQZ',
							flexGrow: 1,
							width: 80,
							header: {
								name: 'header',
								component: 'DataGrid.Cell',
								children: '有效期止'
							},
							cell:{
								name: 'cell',
								component: 'DataGrid.TextCell',
								value:'{{$renderDate(data.sfzxxDtos[_rowIndex] && data.sfzxxDtos[_rowIndex].YXQZ)}}',
								_power: '({rowIndex}) => rowIndex',
							}
						}]
					}]
				}]
			}]
		}, {
			name: 'reinit',
			component: '::div',
			className: 'reinit',
			onClick: '{{$reinit}}',
			children: [{
				name: 'icon',
				component: 'Icon',
				fontFamily: 'edficon',
				type: 'zhongxinchushihua'
			}, {
				name: 'explain',
				component: '::span',
				children: '重新初始化'
			}]
		}]
	}
}

export function getInitState() {
	return {
		data: {
			basic: {
				name: null,
				accountingStandards: null,
				enableDate: null,
				vatTaxpayer: null,
				vatTaxpayerNum: null,
				isSignAndRetreat: false,
				ss: null,
				dlfs: null,
				wbzh: null,
				wbmm: null,
			},
			nsxxDto: {
				SCJYDZ: null,
				ZGSWRY: null,
				BSY: null,
				ZCZB: null,
				BSY_TEL: null,
				CWFZR_TEL: null,
				NSRDZDA: null,
				FDFZR: null,
				FDFZR_TEL: null,
				DKDJBZ: null,
				ZGSWJ: null,
				ZZSQYLX: null,
				SSHY: null,
				YHZH: null,
				CWFZR: null,
				JYFW: null,
				NSRZTDM: null,
				DJXH: null,
				CYRS: null,
				DJZCLX: null,
				KYRQ: null,
				KHYH: null,
				XYDJ: null,
				ZZJGDM: null,
				ZFJGBZ: null
			},
			zgrdDtos:[],
			sfzxxDtos:[],
			enumData: {
				basic: {},
				tax: {}
			},
			initState: {
				enableDate: null,
				name: null,
				pwd: null
			},
			other: {
				canModify: true,
				CAStep: true,			//是否显示CA登录的详细信息
				hasReadCA: false,		//是否已读取过证书
				readOrgInfoBtn: true,	//读取按钮是否置灰
				key: '11',
				activeTabKey: '1',
				isShowOtherMsg: false,
				detailInfo: false,
				title1: true,
				title2: true,
				title3: true
			},
			error: {
				orgInfo:{}
			}
		}
	}
}
