import React from 'react'
import { action as MetaAction, AppLoader } from 'edf-meta-engine'
import {Icon} from 'edf-component'
import config from './config'
import {Tree} from 'edf-component'
import { FormDecorator } from 'edf-component'
import extend from './extend'

class action {
    constructor(option) {
        this.metaAction = option.metaAction
		this.extendAction = option.extendAction
		this.voucherAction = option.voucherAction
		this.config = config.current
		this.webapi = this.config.webapi
    }

    onInit = ({ component, injections }) => {
        this.extendAction.gridAction.onInit({ component, injections })
        this.component = component
        this.injections = injections
        if (this.component.props.setOkListener) {
            this.component.props.setOkListener(this.onOk)
        }
        injections.reduce('init')

        this.load()
    }

    load = async () => {
	    let response = {}
		let {influencetitArr,influenceArr,subject,accountCode, glAccountId} = this.component.props.initButtionValue
		let influenceList = []
		influenceArr = influenceArr.reverse()
		this.metaAction.sf('data.other.loading', true)
		influencetitArr.map((item,index)=>{
			if(influenceArr[index] != '-'){
				influenceList.push({
					influence: influencetitArr[index],
					influenceValue: influenceArr[index]
				})
			}
		})

		this.metaAction.sf('data.form.codeAndName', subject)
		// this.metaAction.sf('data.form.glAccountId', glAccountId)
		this.metaAction.sf('data.other.subjectCode', accountCode)
		
		response = await this.webapi.accountCard.getSubject()
		let res = {response,influenceList,subject,glAccountId}
        if(res){
            this.injections.reduce('load', res)
		}
        this.metaAction.sf('data.other.loading', false)
    }

	//修改科目select
	fieldChange = (path, value) => {	
		this.voucherAction.fieldChange(path, value, this.check)
	}
	filterOptionSubject = (input, option) => {
		if (option && option.props && option.props.children) {
			return option.props.children.toLowerCase().indexOf(input.toLowerCase()) >= 0
		}
		return true
	}
	selectSubject = (v)=>{
		v = Number(v)
		let subjectList = this.metaAction.gf('data.other.subjectList')
		if(subjectList){
			this.fieldChange('data.form.glAccountId', v)
			
			let subjectId = subjectList.toJS().filter(o => o.value == v)[0] 
			let subjectCode
			subjectList.toJS().map((item, index)=>{
				if(item.value == v) {
					subjectCode = item.code 
					this.metaAction.sf('data.other.subjectCode', subjectCode)
				}
			})
		}
	}
    
    //确定修改科目
	onOk =  () => {
        return this.saveSubject({})
    }
	
	saveSubject = async () => {
		let {templateUserId, templateAccountTypeId, accountCode,influence,influenceValue,ts} = this.component.props.initButtionValue
		let subjectCodes = this.metaAction.gf('data.other.subjectCode')
		if(accountCode == subjectCodes) return   
		
		const ret = await this.metaAction.modal('confirm', {
			title: '提示',
			content: '您手工改动了科目设置，将会影响到以后生成的相关凭证哦，请确认修改'
		})

		if(ret){
			let response 
			if(templateUserId){
				response = await this.webapi.accountCard.saveAccountType({
					id:templateUserId,
					templateAccountTypeId,
					influence,
					influenceValue,
					accountCode: subjectCodes,
					ts
				})
			}else{
				response = await this.webapi.accountCard.saveAccountType({
					id:templateUserId,
					templateAccountTypeId,
					influence,
					influenceValue,
					accountCode: subjectCodes,
				})
			}
			if (response && response.result == false) {
				this.metaAction.toast('error', response.error.message)
			} else {
				this.metaAction.toast('success', '修改成功')
				return response
			}
		}
	}	
}

export default function creator(option) {
    const metaAction = new MetaAction(option),
		extendAction = extend.actionCreator({ ...option, metaAction }),
		voucherAction = FormDecorator.actionCreator({ ...option, metaAction }),
		o = new action({ ...option, metaAction, extendAction,voucherAction }),
		ret = { ...metaAction, ...extendAction.gridAction,...voucherAction, ...o }
	
	metaAction.config({ metaHandlers: ret })
	
	return ret

}