import { Map, fromJS } from 'immutable'
import { reducer as MetaReducer } from 'edf-meta-engine'
import config from './config'
import { getInitState } from './data'

class reducer {
    constructor(option) {
        this.metaReducer = option.metaReducer
    }

    init = (state, option) => {
        let initState = getInitState()
        return this.metaReducer.init(state, initState)
    }
    load = (state, option) => {
        if(option && option.response) state = this.metaReducer.sf(state, 'data.other.subject', fromJS(option.response.subject))  
        if(option && option.response){
            let subjectList = option.response.glAccounts.filter((item)=> item.isEndNode == true && item.isEnable == true)
            let newSubject = []
            subjectList.map(item=>{
                newSubject.push({
                    value: item.id,
                    label: item.codeAndName,
                    code: item.code
                })
            })
            state = this.metaReducer.sf(state, 'data.other.subjectList', fromJS(newSubject))  
            state = this.metaReducer.sf(state, 'data.form.glAccountId', option.glAccountId)
        }  
        if(option && option.influenceList) state = this.metaReducer.sf(state, 'data.other.influenceList', fromJS(option.influenceList))  
        
        return state  
    }
}

export default function creator(option) {
    const metaReducer = new MetaReducer(option),
        o = new reducer({ ...option, metaReducer })

    return { ...metaReducer, ...o }
}