
export function getMeta() {
		return {
			name: 'root',
			component: 'Layout',
			className: 'edfx-business-subject-manage',
			children: [{
				name: 'left',
				className: 'edfx-business-subject-manage-left',
				component: 'Card',
				title: '科目设置管理',
				children:{
					name:'tree',
					component: 'Tree',
					className: 'edfx-deptPers-tree',
					onSelect: '{{$selectType}}',  
					onExpand: '{{$onExpand}}',
					expandedKeys: '{{data.other.expandedKeys}}',
					selectedKeys: '{{data.other.treeSelectedKey}}',
					children: '{{$renderTreeNodes(data.other.resTreeList)}}'
				}
			}, {
				name:'right',
				className: 'edfx-business-subject-manage-right',
				component: '::div',
				children: [
					{
						name: 'top',
						component: 'Form',
						className: 'edfx-business-subject-manage-top',
						children: [{
							name: 'renderSelect',
							component: '::div',
							children: '{{$renderSelect()}}',
						},{
								name: 'refreshBtn',
								component: 'Button',
								className: 'refresh',
								children: {
									name: 'userIcon',
									className: 'refresh-btn',
									component: 'Icon',
									fontFamily: 'edficon',
									type: 'shuaxin'
								},
								onClick: '{{$refreshBtn}}'
							}]
					},{
						name: 'content',
						className: 'edfx-business-subject-manage-content',
						component: 'Layout',
						onScroll: '{{$scrollTable}}',
						children: [{
							name: 'manageContent',
							component: 'Table',
							pagination: false,
							className: 'edfx-business-subject-manage-table',
							allowColResize: false,
							enableSequenceColumn: false,
							loading: '{{data.loading}}',
							bordered: true,
							scroll: '{{data.other.tableList.length > 0 ? data.tableOption : {} }}',
							dataSource: '{{data.other.tableList}}',
							noDelCheckbox: true,
							columns: '{{$tableColumns()}}'
						}]
					},{
						name: 'footer',
						className: 'edfx-business-subject-manage-footer',
						component: 'Layout',
						children: [{
							name: 'pagination',
							component: 'Pagination',
							showSizeChanger: true,
							pageSize: '{{data.page.pageSize}}',
							current: '{{data.page.current}}',
							total: '{{data.page.total}}',
							onChange: '{{$pageChanged}}',
							onShowSizeChange: '{{$pageChanged}}'
						}]
					}
				]
			}]
		}
}

export function getInitState() {
	return {
		data: {
			loading: true,
			tableOption: {
                x: 900,
                y: null
			},
			
			other: {
				tree: [],
				tableList: [],
				treeSelectedKey: [],
				expandedKeys: []
			},
			filter: {
				page: {pageSize: 50, currentPage: 1}
			},
			page: {
				current: 1,
				total: 1,
				pageSize: 50,
			},
		}
	}
}