import React from 'react'
import { action as MetaAction, AppLoader } from 'edf-meta-engine'
import config from './config'
import NumberInfo from '../../components/NumberInfo'
import CountDown from '../../components/CountDown'
import { Tooltip } from 'edf-component'

const targetTime = new Date().getTime() + 3900000;
const dealImg = require('../../img/dealImg.png')
class action {
    constructor(option) {
        this.metaAction = option.metaAction
        this.config = config.current
    }

    
    onInit = ({ component, injections }) => {
        this.component = component
        this.injections = injections
        injections.reduce('init')
    }

    renderContent = () => {
        return (
            <div className='ttk-edf-app-dashboard-deal'>
                <div className='ttk-edf-app-dashboard-deal-topdiv'>
                    <NumberInfo
                        subTitle="今日交易总额"
                        suffix="元"
                        total={addThousandsPosition(Number(124543233))}
                        style={{width:'25%'}}
                    />
                    <NumberInfo subTitle="销售目标完成率" total="92%" style={{width:'25%'}}/>
                    <NumberInfo subTitle="活动剩余时间" total={<CountDown target={targetTime} />} style={{width:'25%'}}/>
                    <NumberInfo
                        subTitle="每秒交易总额"
                        suffix="元"
                        total={addThousandsPosition(Number(234))}
                        style={{width:'25%'}}
                    />
                </div>
                <div className='ttk-edf-app-dashboard-deal-imgdiv'>
                    <Tooltip title="等待后期实现">
                        <img
                            src={dealImg}
                            alt="map"
                        />
                    </Tooltip>
                </div>
            </div>
        )

    }
}

export default function creator(option) {
    const metaAction = new MetaAction(option),
        o = new action({ ...option, metaAction }),
        ret = { ...metaAction, ...o }

    metaAction.config({ metaHandlers: ret })

    return ret
}

const addThousandsPosition = (input) => {
    if(isNaN(input)) return null
    let num
        num = input.toString()
    return num.replace(/(\d{1,3})(?=(\d{3})+(?:$|\.))/g, "$1,")
}

