import React from 'react'
import { action as MetaAction, AppLoader } from 'edf-meta-engine'
import config from './config'
import {Echarts} from 'edf-component'

class action {
    constructor(option) {
        this.metaAction = option.metaAction
        this.config = config.current
    }

    
    onInit = ({ component, injections }) => {
        this.component = component
        this.injections = injections
        injections.reduce('init')
    }

    renderContent = () => {
        const dataList = [
            [{value:100, name:`中式快餐${(100/400)*100}%`,itemStyle:{color: '#388E8E'}},
            {value:300, name:'',itemStyle:{color: '#ccc'}}],
            [{value:100, name:`西餐${(100/400)*100}%`,itemStyle:{color: '#B8860B'}},
            {value:300, name:'',itemStyle:{color: '#ccc'}}],
            [{value:200, name:`火锅${(200/1000)*100}%`,itemStyle:{color: '#A52A2A'}},
            {value:800, name:'',itemStyle:{color: '#ccc'}}]
        ]
        const data = dataList.map((item) => {
            const option = {
                animation:false,
                series: [
                    {
                        name:'',
                        type:'pie',
                        radius: ['50%', '70%'],
                        avoidLabelOverlap: false,
                        label: {
                            normal: {
                                show: true,
                                position: 'center'
                            }
                        },
                        labelLine: {
                            normal: {
                                show: false
                            }
                        },  
                        itemStyle: {
                            color: '#ccc'
                        },
                        detail: {formatter:'{value}%'},
                        data:item
                    }
                ]
            };
            return <Echarts option={option} className='ttk-edf-app-dashboard-scale'/>
        })

        return data
    }
}

export default function creator(option) {
    const metaAction = new MetaAction(option),
        o = new action({ ...option, metaAction }),
        ret = { ...metaAction, ...o }

    metaAction.config({ metaHandlers: ret })

    return ret
}

