import React from 'react'
import { action as MetaAction, AppLoader } from 'edf-meta-engine'
import config from './config'
import {Echarts} from 'edf-component'
class action {
    constructor(option) {
        this.metaAction = option.metaAction
        this.config = config.current
    }

    
    onInit = ({ component, injections }) => {
        this.component = component
        this.injections = injections
        injections.reduce('init')
    }

    renderContent = () => {
        const dataList = [
            {value:335, name:'上海市'},
            {value:310, name:'厦门市'},
            {value:234, name:'杭州市'},
            {value:135, name:'天津市'},
            {value:548, name:'北京市'},
            {value:230, name:'珠海市'},
            {value:120, name:'山南地区'},
            {value:226, name:'榆林市'},
            {value:256, name:'重庆市'},
            {value:345, name:'离岛'},
            {value:335, name:'海外'},
            {value:178, name:'新余市'},
            {value:253, name:'渭南市'},
            {value:325, name:'齐齐哈尔市'},
            {value:210, name:'玉林市'},
            {value:145, name:'南平市'},
            {value:347, name:'西安市'},
            {value:215, name:'海南藏族自治州'},
            {value:146, name:'高雄市'},
            {value:236, name:'酒泉市'},
            {value:286, name:'平顶山市'},
        ]
        const option = {
            tooltip : {
                trigger: 'item',
                formatter: "{b}"
            },
            series : [
                {
                    name: '',
                    type: 'pie',
                    radius : '55%',
                    center: ['50%', '60%'],
                    data:dataList,
                    itemStyle: {
                        emphasis: {
                            shadowBlur: 10,
                            shadowOffsetX: 0,
                            shadowColor: 'rgba(0, 0, 0, 0.5)'
                        }
                    }
                }
            ]
        };
        return <Echarts option={option} className='ttk-edf-app-dashboard-searchHot'/>
    }
   
}

export default function creator(option) {
    const metaAction = new MetaAction(option),
        o = new action({ ...option, metaAction }),
        ret = { ...metaAction, ...o }

    metaAction.config({ metaHandlers: ret })

    return ret
}

