import React from 'react'
import { action as MetaAction, AppLoader } from 'edf-meta-engine'
import config from './config'
import {Echarts} from 'edf-component'

class action {
    constructor(option) {
        this.metaAction = option.metaAction
        this.config = config.current
    }

    
    onInit = ({ component, injections }) => {
        this.component = component
        this.injections = injections
        injections.reduce('init')
    }

    renderContent = () => {
        const option = {
            series: [
                {
                    name: '',
                    type: 'gauge',
                    detail: {formatter:'{value}%',fontSize:'15px',offsetCenter:[0, '60%']},
                    data: [{value: 87, name: '跳出率'}],
                    axisTick:{
                        show:false
                    },
                    title: {
                        offsetCenter: [0, '82%']
                    },
                    axisLabel: {           // 坐标轴文本标签，详见axis.axisLabel
                        show: true,
                        formatter: function(v){
                            switch (v+''){
                                case '10': return '差';
                                case '30': return '中';
                                case '60': return '良';
                                case '90': return '优';
                                default: return '';
                            }
                        },
                        textStyle: {       // 其余属性默认使用全局文本样式，详见TEXTSTYLE
                            color: '#333'
                        }
                    },
                }
            ]
        };

        return <Echarts option={option} className='ttk-edf-app-dashboard-volume'/>
    }
}

export default function creator(option) {
    const metaAction = new MetaAction(option),
        o = new action({ ...option, metaAction }),
        ret = { ...metaAction, ...o }

    metaAction.config({ metaHandlers: ret })

    return ret
}

