
const classStr = 'ttk-edf-app-dashboard-workplace'
export function getMeta() {
	return {
		name: 'root',
		component: '::div',
		className: classStr,
		children: [{
			name: 'demo',
			component: '::div',
			className: `${classStr}-header`,
			children: [
				{
					name: `header-left`,
					className: `${classStr}-header-left`,
					component: '::div',
					children:[
						{
							name: 'article-logo',
							component: '::div',
							className: `${classStr}-header-left-logo`,
							children: {
								name: 'img',
								component: '::img',
								src: require('./images/ttk-logo.jpg')
							}
						},
						{
							name: 'article-detail',
							component: '::div',
							className: `${classStr}-header-left-detail`,
							children: [
								{
									name: 'detail-top',
									component: '::div',
									className: `${classStr}-header-left-detail-top`,
									children: {
										name: 'sign',
										component: '::span',
										children: '早安，小明，祝你开心每一天！'
									}
								},
								{
									name: 'detail-bottom',
									component: '::div',
									className: `${classStr}-header-left-detail-bottom`,
									children: {
										name: 'warn-message',
										component: '::span',
										children: '交互专家 | ttk－某某某事业群－某某平台部－某某技术部－UED'
									}
								}
							]
						}
					]
				},
				{
					name: `header-right`,
					className: `${classStr}-header-right`,
					component: '::div',
					children:[
						{
							name: 'right-item-1',
							component: '::div',
							className: `${classStr}-header-right-item`,
							children: [
								{
									name: 'project-count',
									component: '::span',
									children: '项目数'
								},
								{
									name: 'project-number',
									component: '::b',
									children: '56'
								}
							]
						},
						{
							name: 'right-item-2',
							component: '::div',
							className: `${classStr}-header-right-item`,
							children: [
								{
									name: 'project-count',
									component: '::span',
									children: '团队内排名'
								},
								{
									name: 'project-number',
									component: '::b',
									children: '8/24'
								}
							]
						},
						{
							name: 'right-item-3',
							component: '::div',
							className: `${classStr}-header-right-item`,
							children: [
								{
									name: 'project-count',
									component: '::span',
									children: '项目访问'
								},
								{
									name: 'project-number',
									component: '::b',
									children: '2,223'
								}
							]
						}
					]
				}
			]
		}, {
			name: 'main',
			component: '::div',
			className: `${classStr}-main`,
			children: [
				{
					name: 'main-left',
					component: '::div',
					className: `${classStr}-main-left`,
					children: [
						{
							name: 'project-list',
							component: 'Card',
							className: `${classStr}-main-project-list`,
							title: '进行中的项目',
							extra: {
								name: 'more',
								component: '::a',
								children: '全部项目'
							},
							className: `${classStr}-main-project`,
							children: `{{$renderCardItem(data.project)}}`
						},
						{
							name: 'project-list',
							component: 'Card',
							title: '动态',
							className: `${classStr}-main-active`,
							children: `{{$renderActiveItem(data.active)}}`
						}
					]
				},
				{
					name: 'main-right',
					component: '::div',
					className: `${classStr}-main-right`,
					children: [
						{
							name: 'quick-nav',
							component: 'Card',
							title: '快速开始/便捷导航',
							className: `${classStr}-main-right-quick-nav`,
							children: '{{$renderQuicknNav(data.quickNav)}}'
						},
						{
							name: 'xx-chart',
							component: 'Card',
							title: 'XX-指数',
							className: `${classStr}-main-right-xx-chart`,
							children: '{{$renderEcharts(data.chart)}}'
						},
						{
							name: 'team',
							component: 'Card',
							title: '团队',
							className: `${classStr}-main-right-team`,
							children: '{{$renderTeam(data.team)}}'
						}
					]
				}
			]
		}]
	}
}

export function getInitState() {
	return {
		data: {
			content: 'Hello TTK!!! Successful project initialization',
			version: 'v1.0.0',
			active: [],
			chart: [],
			project: [],
			quickNav: [],
			team: []
		}
	}
}