export function getMeta() {
	return {
		name: 'root',
		component: 'Layout',
		className: 'ttk-edf-app-list-account',
		children: [
			{
				name: 'root-content',
				component: 'Layout',
				className: 'ttk-edf-app-list-account-backgroundColor',
				children: [{
					name: 'header',
					component: '::div',
					className: 'ttk-edf-app-list-account-header',
					children: [{
						name: 'refresh',
						component: '::div',
						className: 'ttk-edf-app-list-account-header-left',
						children: [{
							name: 'refresh',
							component: 'Button',
							className: 'refresh',
							children: {
								name: 'userIcon',
								className: 'refresh-btn',
								component: 'Icon',
								fontFamily: 'edficon',
								type: 'shuaxin',
							},
							onClick: '{{$load}}'
						}]
					}, {
						name: 'btnGroup',
						component: 'Layout',
						className: 'ttk-edf-app-list-account-header-right',
						children: [{
							name: 'add',
							component: 'Button',
							children: '新增',
							type: 'primary',
							className: 'btn',
							onClick: '{{$addClick}}'
						}, {
							name: 'del',
							component: 'Button',
							children: '删除',
							className: 'btn',
							onClick: '{{$delClickBatch}}'
						}]
					}]
				},
					{
						name: 'content',
						component: 'Layout',
						className: 'ttk-edf-app-list-account-content',
						children: [{
							name: 'dataGrid',
							component: 'DataGrid',
							ellipsis: true,
							headerHeight: 37,
							isColumnResizing: false,
							rowHeight: 35,
							loading: '{{data.other.loading}}',
							className: '{{$heightCount()}}',
							//enableSequence: true,
							startSequence: '{{(data.pagination.currentPage-1)*data.pagination.pageSize + 1}}',
							rowsCount: "{{$getListRowsCount()}}",
							columns: [{
								name: 'select',
								component: 'DataGrid.Column',
								columnKey: 'operation',
								width: 60,
								header: {
									name: 'header',
									component: 'DataGrid.Cell',
									children: [{
										name: 'chexkbox',
										component: 'Checkbox',
										checked: '{{$isSelectAll("dataGrid")}}',
										onChange: '{{$selectAll("dataGrid")}}',
									}]
								},
								cell: {
									name: 'cell',
									component: 'DataGrid.Cell',
									tip: true,
									_power: '({rowIndex})=>rowIndex',
									children: [{
										name: 'select',
										component: 'Checkbox',
										checked: '{{data.list[_rowIndex].selected}}',
										onChange: "{{$selectRow(_rowIndex)}}"
									}]
								}
							}, {
								name: 'bankAccountTypeName',
								component: 'DataGrid.Column',
								columnKey: 'bankAccountTypeName',
								width: 120,
								flexGrow: 1,
								header: {
									name: 'header',
									component: 'DataGrid.Cell',
									children: '账户类型'
								},
								cell: {
									name: 'cell',
									component: "DataGrid.Cell",
									tip: true,
									className: 'mk-datagrid-cellContent-left',
									value: "{{data.list[_rowIndex].bankAccountTypeName}}",
									_power: '({rowIndex})=>rowIndex',
								}
							}, {
								name: 'code',
								component: 'DataGrid.Column',
								columnKey: 'code',
								width: 120,
								flexGrow: 1,
								header: {
									name: 'header',
									component: 'DataGrid.Cell',
									children: '账户编码'
								},
								cell: {
									name: 'cell',
									component: "DataGrid.Cell",
									tip: true,
									className: 'mk-datagrid-cellContent-left',
									value: "{{data.list[_rowIndex].code}}",
									_power: '({rowIndex})=>rowIndex',
								}
							}, {
								name: 'name',
								component: 'DataGrid.Column',
								columnKey: 'name',
								width: 120,
								flexGrow: 1,
								// isResizable: true,
								header: {
									name: 'header',
									component: 'DataGrid.Cell',
									children: '账户名称'
								},
								cell: {
									name: 'cell',
									component: 'DataGrid.Cell',
									className: 'mk-datagrid-cellContent-left',
									_power: '({rowIndex})=>rowIndex',
									children: [{
										name: 'name',
										component: '::a',
										title: '{{data.list[_rowIndex].name}}',
										children: '{{data.list[_rowIndex].name}}',
										onClick: '{{$modifyDetail(data.list[_rowIndex].id)}}'
									}]
								}
							}, {
								name: 'isDefault',
								component: 'DataGrid.Column',
								columnKey: 'isDefault',
								width: 120,
								header: {
									name: 'header',
									component: 'DataGrid.Cell',
									children: '默认账户'
								},
								cell: {
									name: 'cell',
									component: 'DataGrid.Cell',
									_power: '({rowIndex})=>rowIndex',
									children: [{
										name: 'isDefault',
										component: 'Icon',
										type: 'check',
										_visible: '{{data.list[_rowIndex].isDefault ? true : false}}',
										style: {
											fontSize: 22
										},
										title: '默认账户',
									}]
								}
							}, {
								name: 'beginningBalance',
								component: 'DataGrid.Column',
								columnKey: 'beginningBalance',
								width: 120,
								flexGrow: 1,
								header: {
									name: 'header',
									component: 'DataGrid.Cell',
									children: '期初余额'
								},
								cell: {
									name: 'cell',
									component: "DataGrid.Cell",
									tip: true,
									className: 'mk-datagrid-cellContent-right',
									value: "{{data.list[_rowIndex].beginningBalance}}",
									_power: '({rowIndex})=>rowIndex',
								}
							}, {
								name: 'operation',
								component: 'DataGrid.Column',
								columnKey: 'operation',
								width: 100,
								header: {
									name: 'header',
									component: 'DataGrid.Cell',
									children: '操作'
								},
								cell: {
									name: 'cell',
									component: 'DataGrid.Cell',
									_power: '({rowIndex})=>rowIndex',
									children: [{
										name: 'isEnable',
										component: 'Icon',
										fontFamily: 'edficon',
										type: '{{data.list[_rowIndex].isEnable ? "tingyong-" : "qiyong-"}}',
										disabled: '{{data.list[_rowIndex].bankAccountTypeId == 3000050001}}',
										style: {
											fontSize: 22,
											marginRight: '4px'
										},
										title: '{{data.list[_rowIndex].isEnable ? "已启用" : "已停用"}}',
										onClick: '{{function(){data.list[_rowIndex].bankAccountTypeId != 3000050001?$personStatusClick(data.list[_rowIndex], _rowIndex):""}}}'
									}, {
										name: 'update',
										component: 'Icon',
										fontFamily: 'edficon',
										type: 'bianji',
										style: {
											fontSize: 22
										},
										title: '编辑',
										onClick: '{{$modifyDetail(data.list[_rowIndex].id)}}'
									}, {
										name: 'remove',
										component: 'Icon',
										fontFamily: 'edficon',
										disabled: '{{data.list[_rowIndex].bankAccountTypeId == 3000050001}}',
										type: 'shanchu',
										style: {
											fontSize: 22
										},
										title: '删除',
										onClick: '{{function(){data.list[_rowIndex].bankAccountTypeId != 3000050001?$delClick(data.list[_rowIndex]):""}}}'
									}]
								}
							}]
						}]
					}]
			}
			, {
				name: 'footer',
				component: '::div',
				className: 'ttk-edf-app-list-account-footer',
				children: [{
					name: 'pagination',
					component: 'Pagination',
					showSizeChanger: true,
					pageSize: '{{data.pagination.pageSize}}',
					current: '{{data.pagination.current}}',
					total: '{{data.pagination.total}}',
					onChange: '{{$pageChanged}}',
					onShowSizeChange: '{{$pageChanged}}',
				}]
			}]
	}
}

export function getInitState() {
	return {
		data: {
			list: [],
			pagination: {
				current: 1,
				total: 0,
				pageSize: 50
			},
			columns: []
		}
	}
}
