/**
 * mock.js 提供应用截获ajax请求，为脱离后台测试使用
 * 模拟查询更改内存中mockData,并返回数据
 */

import {fetch} from 'edf-utils'

const mockData = fetch.mockData

function initMockData() {
	if (!mockData.account) {
		mockData.account = {
			id: 1,
			list: [{
				"bankAccountTypeId": 3000050001,
				"bankAccountTypeName": "现金",
				"bankName": "",
				"isDefault": true,
				"beginningBalance": 0,
				"id": 4,
				"code": "XJ",
				"name": "现金",
				"helpCode": "XJ",
				"isEnable": true,
				"ts": "2018-04-09 15:51:00.0"
			}, {
				"bankAccountTypeId": 3000050002,
				"bankAccountTypeName": "银行",
				"bankName": "银行",
				"isDefault": true,
				"beginningBalance": 0,
				"id": 1,
				"code": "YHJBH",
				"name": "银行基本户",
				"helpCode": "YHJBH",
				"isEnable": true,
				"ts": "2018-04-09 15:51:00.0"
			}]
		}
	}
}

initMockData()

fetch.mock('v1/ba/bankAccount/queryList', (option) => {
	initMockData()
	return {
		"result": true,
		"value": {
			"list": !!mockData.account && mockData.account.list ? mockData.account.list : [],
			"page": {
				"pageSize": option.page && option.page.pageSize ? option.page.pageSize : 50,
				"currentPage": 1,
				"totalPage": 1,
				"totalCount": 1
			}
		}
	}
})

fetch.mock('v1/ba/bankAccount/delete', (option) => {
	let account = mockData.account.list, v
	option.forEach((oData, i) => {
		account.forEach((data, index) => {
			if (option[i].id == data.id) {
				account.splice(index, 1)
			}
		})
	})
	return {
		"result": true,
		"value": {
			"list": [],
			"page": {
				"pageSize": option && option.page && option.page.pageSize ? option.page.pageSize : 50,
				"currentPage": 1,
				"totalPage": 1,
				"totalCount": 1
			}
		}
	}
})


fetch.mock('/v1/ba/bankAccount/update', (option) => {
	let account = mockData.account.list, v
	account.forEach((data, index) => {
		if (option.id == data.id) {
			v = index
		}
	})
	account[v] = option
	return {result: true, value: option}
})
