/**
 * mock.js 提供应用截获ajax请求，为脱离后台测试使用
 * 模拟查询更改内存中mockData,并返回数据
 */

import {fetch} from 'edf-utils'

const mockData = fetch.mockData

function initMockData() {
	if (!mockData.currency) {
		mockData.currency = {
			id: 1,
			list: [{
				"exchangeRate": 1,
				"isBaseCurrency": true,
				"id": 1,
				"code": "RMB",
				"name": "人民币",
				"helpCode": "RMB",
				"isEnable": true,
				"ts": "2018-04-09 15:51:00.0"
			}, {
				"exchangeRate": 6.7705,
				"isBaseCurrency": false,
				"id": 2,
				"code": "USD",
				"name": "美元",
				"helpCode": "MY",
				"isEnable": true,
				"ts": "2018-04-09 15:51:00.0"
			}, {
				"exchangeRate": 7.3707,
				"isBaseCurrency": false,
				"id": 3,
				"code": "EUR",
				"name": "欧元",
				"helpCode": "OY",
				"isEnable": true,
				"ts": "2018-04-09 15:51:00.0"
			}, {
				"exchangeRate": 0.065026,
				"isBaseCurrency": false,
				"id": 4,
				"code": "JPY",
				"name": "日元",
				"helpCode": "RY",
				"isEnable": true,
				"ts": "2018-04-09 15:51:00.0"
			}, {
				"exchangeRate": 8.2472,
				"isBaseCurrency": false,
				"id": 5,
				"code": "GBP",
				"name": "英镑",
				"helpCode": "YB",
				"isEnable": true,
				"ts": "2018-04-09 15:51:00.0"
			}, {
				"exchangeRate": 3.8089,
				"isBaseCurrency": false,
				"id": 6,
				"code": "DEM",
				"name": "德国马克",
				"helpCode": "DGMK",
				"isEnable": true,
				"ts": "2018-04-09 15:51:00.0"
			}, {
				"exchangeRate": 5.1803,
				"isBaseCurrency": false,
				"id": 7,
				"code": "AUD",
				"name": "澳大利亚元",
				"helpCode": "ADLYY",
				"isEnable": true,
				"ts": "2018-04-09 15:51:00.0"
			}, {
				"exchangeRate": 0.8729,
				"isBaseCurrency": false,
				"id": 8,
				"code": "HKD",
				"name": "港币",
				"helpCode": "GY",
				"isEnable": true,
				"ts": "2018-04-09 15:51:00.0"
			}]
		}
	}
}

initMockData()
fetch.mock('v1/ba/currency/queryList', (option) => {
	initMockData()
	return {
		"result": true,
		"value": {
			"list": mockData.currency.list,
			"page": {
				"pageSize": option.page && option.page.pageSize ? option.page.pageSize : 50,
				"currentPage": 1,
				"totalPage": 1,
				"totalCount": 1
			}
		}
	}
})

fetch.mock('v1/ba/currency/delete', (option) => {
	let currency = mockData.currency.list, v
	option.forEach((oData, i) => {
		currency.forEach((data, index) => {
			if (option[i].id == data.id) {
				currency.splice(index, 1)
			}
		})
	})
	return {
		"result": true,
		"value": {
			"list": [],
			"page": {
				"pageSize": option.page && option.page.pageSize ? option.page.pageSize : 50,
				"currentPage": 1,
				"totalPage": 1,
				"totalCount": 1
			}
		}
	}
})


fetch.mock('/v1/ba/currency/update', (option) => {
	let currency = mockData.currency.list, v
	currency.forEach((data, index) => {
		if (option.id == data.id) {
			v = index
		}
	})
	currency[v] = option
	return {result: true, value: option}
})
