/**
 * mock.js 提供应用截获ajax请求，为脱离后台测试使用
 * 模拟查询更改内存中mockData,并返回数据
 */

import {fetch} from 'edf-utils'

const mockData = fetch.mockData

function initMockData() {
	if (!mockData.department) {
		mockData.department = {
			id: 6,
			list: [{
					"grade": 1,
					"property": 3000010001,
					"propertyName": "其它（含管理）",
					"isEndNode": true,
					"id": 2,
					"code": "01",
					"name": "财务部",
					"helpCode": "CWB",
					"ts": "2018-04-09 15:51:00.0"
				}, {
					"grade": 1,
					"property": 3000010003,
					"propertyName": "销售相关",
					"isEndNode": true,
					"id": 3,
					"code": "02",
					"name": "销售部",
					"helpCode": "XSB",
					"ts": "2018-04-09 15:51:00.0"
				}, {
					"grade": 1,
					"property": 3000010004,
					"propertyName": "采购相关",
					"isEndNode": true,
					"id": 4,
					"code": "03",
					"name": "采购部",
					"helpCode": "CGB",
					"ts": "2018-04-09 15:51:00.0"
				}, {
					"grade": 1,
					"property": 3000010005,
					"propertyName": "研发相关",
					"isEndNode": true,
					"id": 5,
					"code": "04",
					"name": "研发部",
					"helpCode": "YFB",
					"ts": "2018-04-09 15:51:00.0"
				}]
		}
	}
	if (!mockData.person) {
		mockData.person = {
			id: 1,
			list: [{
				"gender": 3000020003,
				"mobile": "18088668832",
				"userId": 4359725242754048,
				"activeStatus": 3000030003,
				"maritalStatus": 3000100003,
				"employee": 3000110001,
				"isOrgCreator": true,
				"genderName": "保密",
				"employeeName": "雇员",
				"maritalstatusName": "保密",
				"id": 4361136089026560,
				"code": "001",
				"name": "18088668832",
				"helpCode": "18088668832",
				"isEnable": true,
				"ts": "2018-04-09 15:51:00.0",
				"roleDtoList": [{
					"userId": 4359725242754048,
					"roleId": 1,
					"orgId": 4361136053309440,
					"personId": 4361136089026560
				}]
			}]
		}
	}
}

initMockData()

fetch.mock('/v1/edf/role/query', (option) => {
	return {
		"result": true,
		"value": [
			{
				"id": 1,
				"code": "001",
				"name": "系统管理员",
				"memo": "拥有全部功能权限"
			}, {
				"id": 2,
				"code": "002",
				"name": "资产会计",
				"memo": "拥有资产操作【资产卡片】，查看【资产统计表】，【资产明细表】权限"
			}, {
				"id": 3,
				"code": "003",
				"name": "总账会计",
				"memo": "拥有操作凭证，查看财务报表，资金状况，经营状况的权限"
			}, {
				"id": 4,
				"code": "004",
				"name": "老板",
				"memo": "拥有查看资金状况，经营状况权限"
			}]
	}
})

fetch.mock('v1/ba/department/delete', (option) => {
	let department = mockData.department.list, v
	// option.forEach((oData, i) => {

		department.forEach((data, index) => {
			if (option.id == data.id) {
				department.splice(index, 1)
			}
		})
	// })
	return {
		"result": true,
		"value": {
		}
	}
})

fetch.mock('v1/ba/department/queryList', (option) => {
	return {
		"result": true,
		"value": {
			"list": mockData.department.list
		}
	}
})

fetch.mock('v1/ba/person/delete', (option) => {
	let person = mockData.person.list, v
	option.forEach((oData, i) => {
		person.forEach((data, index) => {
			if (option[i].id == data.id) {
				person.splice(index, 1)
			}
		})
	})
	return {
		"result": true,
		"value": {
		}
	}
})

fetch.mock('v1/ba/person/queryList', (option) => {
	let arr
	if(option.entity){
		arr = mockData.person.list.filter((data) => {return data.departmentId == option.entity.departmentId})
	}else {
		arr = mockData.person.list
	}
	return {
		"result": true,
		"value": {
			"list": arr,
			"page": {
				"pageSize": option && option.page && option.page.pageSize ? option.page.pageSize : 50,
				"currentPage": 1,
				"totalPage": 1,
				"totalCount": 1
			}
		}
	}
})

fetch.mock('v1/edf/sysOrgUser/getIsOrgCreator', (option) => {
	return {"result": true, "value": true}
})

