/**
 * mock.js 提供应用截获ajax请求，为脱离后台测试使用
 * 模拟查询更改内存中mockData,并返回数据
 */

import { fetch } from 'edf-utils'

const mockData = fetch.mockData

function initMockData() {
	if (!mockData.inventory) {
		mockData.inventory = {
			id: 1,
			list: []
		}
	}
}
initMockData()

fetch.mock('v1/ba/inventory/queryList', (option) => {
	initMockData()
	return {
		"result": true,
		"value": {
			"list": !!mockData.inventory && mockData.inventory.list ? mockData.inventory.list : [],
			"page": {
				"pageSize": option && option.page && option.page.pageSize ? option.page.pageSize : 50,
				"currentPage": 1,
				"totalPage": 1,
				"totalCount": 1
			}
		}
	}
})

fetch.mock('v1/ba/inventory/delete', (option) => {
	let inventory = mockData.inventory.list, v
	option.forEach((oData, i) => {
		inventory.forEach((data, index) => {
			if (option[i].id == data.id) {
				inventory.splice(index, 1)
			}
		})
	})
	return {
		"result": true,
		"value": {
			"list": [],
			"page": {
				"pageSize": option.page && option.page.pageSize ? option.page.pageSize : 50,
				"currentPage": 1,
				"totalPage": 1,
				"totalCount": 1
			}
		}
	}
})


fetch.mock('/v1/ba/inventory/update', (option) => {
	let inventory = mockData.inventory.list, v
	inventory.forEach((data, index) => {
		if (option.id == data.id) {
			v = index
		}
	})
	inventory[v] = option
	return {result: true, value: option}
})
