/**
 * mock.js 提供应用截获ajax请求，为脱离后台测试使用
 * 模拟查询更改内存中mockData,并返回数据
 */

import { fetch } from 'edf-utils'

const mockData = fetch.mockData

function initMockData() {
	if (!mockData.supplier) {
		mockData.supplier = {
			id: 1,
			list: []
		}
	}
}

initMockData()

fetch.mock('v1/ba/supplier/queryList', (option) => {
	initMockData()
	return {
		"result": true,
		"value": {
			"list": !!mockData.supplier && mockData.supplier.list ? mockData.supplier.list : [],
			"page": {
				"pageSize": option.page && option.page.pageSize ? option.page.pageSize : 50,
				"currentPage": 1,
				"totalPage": 1,
				"totalCount": 1
			}
		}
	}
})

fetch.mock('v1/ba/supplier/delete', (option) => {
	let supplier = mockData.supplier.list, v
	option.forEach((oData, i) => {
		supplier.forEach((data, index) => {
			if (option[i].id == data.id) {
				supplier.splice(index, 1)
			}
		})
	})
	return {
		"result": true,
		"value": {
			"list": [],
			"page": {
				"pageSize": option.page && option.page.pageSize ? option.page.pageSize : 50,
				"currentPage": 1,
				"totalPage": 1,
				"totalCount": 1
			}
		}
	}
})


fetch.mock('/v1/ba/supplier/update', (option) => {
	let supplier = mockData.supplier.list, v
	supplier.forEach((data, index) => {
		if (option.id == data.id) {
			v = index
		}
	})
	supplier[v] = option
	return {result: true, value: option}
})
