/**
 * mock.js 提供应用截获ajax请求，为脱离后台测试使用
 * 模拟查询更改内存中mockData,并返回数据
 */

import { fetch } from 'edf-utils'

const mockData = fetch.mockData

function initMockData() {
	if (!mockData.userdefinecard) {
		mockData.userdefinecard = {
			id: 1,
			list: [],
			listData: []
		}
	}
}

initMockData()

fetch.mock('v1/ba/userdefinearchive/queryList', (option) => {
	initMockData()
	return {
		"result": true,
		"value": {
			"list": !!mockData.userdefinecard && mockData.userdefinecard.list ? mockData.userdefinecard.list : [],
			"page": {
				"pageSize": option && option.page && option.page.pageSize ? option.page.pageSize : 50,
				"currentPage": 1,
				"totalPage": 1,
				"totalCount": 1
			}
		}
	}
})

fetch.mock('v1/ba/userdefinearchive/queryListData', (option) => {
	initMockData()
	let value = !!mockData.userdefinecard && mockData.userdefinecard.listData ? mockData.userdefinecard.listData.filter((data) => {return data.archiveId == option.entity.archiveId})[0].list : []
	return {
		"result": true,
		"value": {
			"list": value,
			"page": {
				"pageSize": option && option.page && option.page.pageSize ? option.page.pageSize : 50,
				"currentPage": 1,
				"totalPage": 1,
				"totalCount": 1
			}
		}
	}
})

fetch.mock('v1/ba/userdefinearchive/delete', (option) => {
	let list = mockData.userdefinecard.list, listData = mockData.userdefinecard.listData, dataLength = listData.filter((value) => {return value.archiveId == option.id})[0].list.length
	// option.forEach((oData, i) => {
	// 	userdefinecard.forEach((data, index) => {
	// 		if (option[i].id == data.id) {
	// 			userdefinecard.splice(index, 1)
	// 		}
	// 	})
	// })
	if(dataLength > 0){
		return {
			result: false,
			error: {message: "已存在明细数据，不能删除！"}
		}
	}
	// list.forEach((oData, i) => {
	list.forEach((data, index) => {
			if (option.id == data.id) {
				list.splice(index, 1)
			}
		})
	// })
	return {
		"result": true,
		"value": {
			"list": [],
			// "page": {
			// 	"pageSize": option.page && option.page.pageSize ? option.page.pageSize : 50,
			// 	"currentPage": 1,
			// 	"totalPage": 1,
			// 	"totalCount": 1
			// }
		}
	}
})

fetch.mock('/v1/ba/userdefinearchive/updateData', (option) => {
	let userdefinecard = mockData.userdefinecard.listData, value,retValue,idx
	userdefinecard.forEach((data) => {
		if (option.archiveId == data.archiveId) {
			value = data.list
		}
	})
	if(value){
		value.forEach((data, index) => {
			if (option.id == data.id) {
				idx = index
			}
		})
	}
	value[idx] = option
	return {result: true, value: option}
})

fetch.mock('v1/ba/userdefinearchive/deleteData', (option) => {
	let userdefinecard = mockData.userdefinecard.listData, v
	option.forEach((oData, i) => {
		userdefinecard.forEach((data, index) => {
			if (option[i].archiveId == data.archiveId) {
				// userdefinecard.splice(index, 1)
				data.list.forEach((sonData, dataIndex) => {
					if (option[i].id == sonData.id) {
						userdefinecard[index].list.splice(dataIndex, 1)
					}
				})
			}
		})
	})
	return {
		"result": true,
		"value": {
			"list": []
		}
	}
})

