/**
 * mock.js 提供应用截获ajax请求，为脱离后台测试使用
 * 模拟查询更改内存中mockData,并返回数据
 */

import { fetch } from 'edf-utils'

const mockData = fetch.mockData

function initTableList() {
    if (mockData.tableList && mockData.tableList.length > 0)
        return
    mockData.tableList = {
        "displayDate": "2018-03",
        "dtoList": [{
            "rowStatus": 0,
            "id": 4287170031244288,
            "docId": 4287170031178752,
            "docType": "记",
            "year": 2018,
            "period": 3,
            "docCode": "0001",
            "origAmountDrSum": 3,
            "origAmountCrSum": 3,
            "amountDrSum": 3,
            "amountCrSum": 3,
            "creatorId": 4265310795651072,
            "creator": "13333333333",
            "businessTypeId": 5000040001,
            "attachedNum": 0,
            "voucherState": 1000020001,
            "voucherStateName": "未审核",
            "ts": "2018-03-27 16:52:11.0",
            "accountId": 99001,
            "accountCode": "1001",
            "accountName": "苹果",
            "accountGradeName": "苹果",
            "accountCashTypeId": 5000020001,
            "accountIsIncidentalAcc": false,
            "direction": 0,
            "directionName": "借",
            "summary": "111",
            "currencyId": 1,
            "currencyCode": "RMB",
            "currencyName": "人民币",
            "isBaseCurrency": true,
            "exchangeRate": 1,
            "origAmountDr": 3,
            "amountDr": 3,
            "rowNo": 1,
            "isPeriodBegin": false,
            "docTypeAndCode": "记-0001",
            "amountSum": 3,
            "accountCodeName": "1001 苹果",
            "voucherDate": "2018-03-27",
            "createTime": "2018-03-27 14:20:28"
        }, {
            "rowStatus": 0,
            "id": 4287170032096256,
            "docId": 4287170031178752,
            "docType": "记",
            "year": 2018,
            "period": 3,
            "docCode": "0001",
            "origAmountDrSum": 3,
            "origAmountCrSum": 3,
            "amountDrSum": 3,
            "amountCrSum": 3,
            "creatorId": 4265310795651072,
            "creator": "13333333333",
            "businessTypeId": 5000040001,
            "attachedNum": 0,
            "voucherState": 1000020001,
            "voucherStateName": "未审核",
            "ts": "2018-03-27 16:52:11.0",
            "accountId": 99068,
            "accountCode": "100201",
            "accountName": "基本户",
            "accountGradeName": "荔枝",
            "accountCashTypeId": 5000020003,
            "accountIsIncidentalAcc": false,
            "direction": 0,
            "directionName": "借",
            "summary": "111",
            "currencyId": 1,
            "currencyCode": "RMB",
            "currencyName": "人民币",
            "isBaseCurrency": true,
            "exchangeRate": 1,
            "origAmountCr": 3,
            "amountCr": 3,
            "rowNo": 2,
            "isPeriodBegin": false,
            "docTypeAndCode": "记-0001",
            "amountSum": 3,
            "accountCodeName": "100201 荔枝",
            "voucherDate": "2018-03-27",
            "createTime": "2018-03-27 14:20:28"
        }, {
            "rowStatus": 0,
            "id": 4291796177147904,
            "docId": 4291796177082368,
            "docType": "记",
            "year": 2018,
            "period": 3,
            "docCode": "0002",
            "origAmountDrSum": 3,
            "origAmountCrSum": 3,
            "amountDrSum": 3,
            "amountCrSum": 3,
            "creatorId": 4265310795651072,
            "creator": "13333333333",
            "businessTypeId": 5000040001,
            "attachedNum": 0,
            "voucherState": 1000020001,
            "voucherStateName": "未审核",
            "ts": "2018-03-28 09:56:57.0",
            "accountId": 99003,
            "accountCode": "1012",
            "accountName": "梨",
            "accountGradeName": "梨",
            "accountCashTypeId": 5000020002,
            "accountIsIncidentalAcc": false,
            "direction": 0,
            "directionName": "借",
            "summary": "222",
            "currencyId": 1,
            "currencyCode": "RMB",
            "currencyName": "人民币",
            "isBaseCurrency": true,
            "exchangeRate": 1,
            "origAmountDr": 3,
            "amountDr": 3,
            "rowNo": 1,
            "isPeriodBegin": false,
            "docTypeAndCode": "记-0002",
            "amountSum": 3,
            "accountCodeName": "1012 梨",
            "voucherDate": "2018-03-27",
            "createTime": "2018-03-28 09:56:58"
        }, {
            "rowStatus": 0,
            "id": 4291796178655232,
            "docId": 4291796177082368,
            "docType": "记",
            "year": 2018,
            "period": 3,
            "docCode": "0002",
            "origAmountDrSum": 3,
            "origAmountCrSum": 3,
            "amountDrSum": 3,
            "amountCrSum": 3,
            "creatorId": 4265310795651072,
            "creator": "13333333333",
            "businessTypeId": 5000040001,
            "attachedNum": 0,
            "voucherState": 1000020001,
            "voucherStateName": "未审核",
            "ts": "2018-03-28 09:56:57.0",
            "accountId": 99093,
            "accountCode": "170103",
            "accountName": "商标权",
            "accountGradeName": "芒果",
            "accountCashTypeId": 5000020004,
            "accountIsIncidentalAcc": false,
            "direction": 0,
            "directionName": "借",
            "summary": "222",
            "currencyId": 1,
            "currencyCode": "RMB",
            "currencyName": "人民币",
            "isBaseCurrency": true,
            "exchangeRate": 1,
            "origAmountCr": 3,
            "amountCr": 3,
            "rowNo": 2,
            "isPeriodBegin": false,
            "docTypeAndCode": "记-0002",
            "amountSum": 3,
            "accountCodeName": "170103 芒果",
            "voucherDate": "2018-03-27",
            "createTime": "2018-03-28 09:56:58"
        }, {
            "rowStatus": 0,
            "id": 4291798065567744,
            "docId": 4291798065502208,
            "docType": "记",
            "year": 2018,
            "period": 3,
            "docCode": "0003",
            "origAmountDrSum": 4,
            "origAmountCrSum": 4,
            "amountDrSum": 4,
            "amountCrSum": 4,
            "creatorId": 4265310795651072,
            "creator": "13333333333",
            "businessTypeId": 5000040001,
            "attachedNum": 0,
            "voucherState": 1000020001,
            "voucherStateName": "未审核",
            "ts": "2018-03-28 09:57:26.0",
            "accountId": 99046,
            "accountCode": "3002",
            "accountName": "柚子",
            "accountGradeName": "柚子",
            "accountCashTypeId": 5000020004,
            "accountIsIncidentalAcc": false,
            "direction": 1,
            "directionName": "贷",
            "summary": "111",
            "currencyId": 1,
            "currencyCode": "RMB",
            "currencyName": "人民币",
            "isBaseCurrency": true,
            "exchangeRate": 1,
            "origAmountDr": 4,
            "amountDr": 4,
            "rowNo": 1,
            "isPeriodBegin": false,
            "docTypeAndCode": "记-0003",
            "amountSum": 4,
            "accountCodeName": "3002 柚子",
            "voucherDate": "2018-03-27",
            "createTime": "2018-03-28 09:57:27"
        }, {
            "rowStatus": 0,
            "id": 4291798066419712,
            "docId": 4291798065502208,
            "docType": "记",
            "year": 2018,
            "period": 3,
            "docCode": "0003",
            "origAmountDrSum": 4,
            "origAmountCrSum": 4,
            "amountDrSum": 4,
            "amountCrSum": 4,
            "creatorId": 4265310795651072,
            "creator": "13333333333",
            "businessTypeId": 5000040001,
            "attachedNum": 0,
            "voucherState": 1000020001,
            "voucherStateName": "未审核",
            "ts": "2018-03-28 09:57:26.0",
            "accountId": 99237,
            "accountCode": "505102",
            "accountName": "出租固定资产收入",
            "accountGradeName": "橙子",
            "accountCashTypeId": 5000020004,
            "accountIsIncidentalAcc": false,
            "direction": 1,
            "directionName": "贷",
            "summary": "111",
            "currencyId": 1,
            "currencyCode": "RMB",
            "currencyName": "人民币",
            "isBaseCurrency": true,
            "exchangeRate": 1,
            "origAmountCr": 4,
            "amountCr": 4,
            "rowNo": 2,
            "isPeriodBegin": false,
            "docTypeAndCode": "记-0003",
            "amountSum": 4,
            "accountCodeName": "505102 橙子",
            "voucherDate": "2018-03-27",
            "createTime": "2018-03-28 09:57:27"
        }, {
            "rowStatus": 0,
            "id": 4291799385790464,
            "docId": 4291799385724928,
            "docType": "记",
            "year": 2018,
            "period": 3,
            "docCode": "0004",
            "origAmountDrSum": 5,
            "origAmountCrSum": 5,
            "amountDrSum": 5,
            "amountCrSum": 5,
            "creatorId": 4265310795651072,
            "creator": "13333333333",
            "businessTypeId": 5000040001,
            "attachedNum": 0,
            "voucherState": 1000020001,
            "voucherStateName": "未审核",
            "ts": "2018-03-28 09:57:46.0",
            "accountId": 99161,
            "accountCode": "400103",
            "accountName": "黄桃",
            "accountGradeName": "黄桃",
            "accountCashTypeId": 5000020004,
            "accountIsIncidentalAcc": false,
            "direction": 0,
            "directionName": "借",
            "summary": "222",
            "currencyId": 1,
            "currencyCode": "RMB",
            "currencyName": "人民币",
            "isBaseCurrency": true,
            "exchangeRate": 1,
            "origAmountDr": 5,
            "amountDr": 5,
            "rowNo": 1,
            "isPeriodBegin": false,
            "docTypeAndCode": "记-0004",
            "amountSum": 5,
            "accountCodeName": "400103 黄桃",
            "voucherDate": "2018-03-27",
            "createTime": "2018-03-28 09:57:47"
        }, {
            "rowStatus": 0,
            "id": 4291799386642432,
            "docId": 4291799385724928,
            "docType": "记",
            "year": 2018,
            "period": 3,
            "docCode": "0004",
            "origAmountDrSum": 5,
            "origAmountCrSum": 5,
            "amountDrSum": 5,
            "amountCrSum": 5,
            "creatorId": 4265310795651072,
            "creator": "13333333333",
            "businessTypeId": 5000040001,
            "attachedNum": 0,
            "voucherState": 1000020001,
            "voucherStateName": "未审核",
            "ts": "2018-03-28 09:57:46.0",
            "accountId": 99107,
            "accountCode": "221101",
            "accountName": "西瓜",
            "accountGradeName": "西瓜",
            "accountCashTypeId": 5000020004,
            "accountIsIncidentalAcc": false,
            "direction": 1,
            "directionName": "贷",
            "summary": "222",
            "currencyId": 1,
            "currencyCode": "RMB",
            "currencyName": "人民币",
            "isBaseCurrency": true,
            "exchangeRate": 1,
            "origAmountCr": 5,
            "amountCr": 5,
            "rowNo": 2,
            "isPeriodBegin": false,
            "docTypeAndCode": "记-0004",
            "amountSum": 5,
            "accountCodeName": "221101 西瓜",
            "voucherDate": "2018-03-27",
            "createTime": "2018-03-28 09:57:47"
        }, {
            "rowStatus": 0,
            "id": 4291800556001280,
            "docId": 4291800555935744,
            "docType": "记",
            "year": 2018,
            "period": 3,
            "docCode": "0005",
            "origAmountDrSum": 4,
            "origAmountCrSum": 4,
            "amountDrSum": 4,
            "amountCrSum": 4,
            "creatorId": 4265310795651072,
            "creator": "13333333333",
            "businessTypeId": 5000040001,
            "attachedNum": 0,
            "voucherState": 1000020001,
            "voucherStateName": "未审核",
            "ts": "2018-03-28 09:58:04.0",
            "accountId": 99001,
            "accountCode": "1001",
            "accountName": "苹果",
            "accountGradeName": "苹果",
            "accountCashTypeId": 5000020001,
            "accountIsIncidentalAcc": false,
            "direction": 0,
            "directionName": "借",
            "summary": "222",
            "currencyId": 1,
            "currencyCode": "RMB",
            "currencyName": "人民币",
            "isBaseCurrency": true,
            "exchangeRate": 1,
            "origAmountDr": 4,
            "amountDr": 4,
            "rowNo": 1,
            "isPeriodBegin": false,
            "docTypeAndCode": "记-0005",
            "amountSum": 4,
            "accountCodeName": "1001 苹果",
            "voucherDate": "2018-03-27",
            "createTime": "2018-03-28 09:58:05"
        }, {
            "rowStatus": 0,
            "id": 4291800556787712,
            "docId": 4291800555935744,
            "docType": "记",
            "year": 2018,
            "period": 3,
            "docCode": "0005",
            "origAmountDrSum": 4,
            "origAmountCrSum": 4,
            "amountDrSum": 4,
            "amountCrSum": 4,
            "creatorId": 4265310795651072,
            "creator": "13333333333",
            "businessTypeId": 5000040001,
            "attachedNum": 0,
            "voucherState": 1000020001,
            "voucherStateName": "未审核",
            "ts": "2018-03-28 09:58:04.0",
            "accountId": 99020,
            "accountCode": "1501",
            "accountName": "草莓",
            "accountGradeName": "草莓",
            "accountCashTypeId": 5000020004,
            "accountIsIncidentalAcc": false,
            "direction": 0,
            "directionName": "借",
            "summary": "222",
            "currencyId": 1,
            "currencyCode": "RMB",
            "currencyName": "人民币",
            "isBaseCurrency": true,
            "exchangeRate": 1,
            "origAmountCr": 4,
            "amountCr": 4,
            "rowNo": 2,
            "isPeriodBegin": false,
            "docTypeAndCode": "记-0005",
            "amountSum": 4,
            "accountCodeName": "1501 草莓",
            "voucherDate": "2018-03-27",
            "createTime": "2018-03-28 09:58:05"
        }, {
            "rowStatus": 0,
            "id": 4291800581888000,
            "docId": 4291800581822464,
            "docType": "记",
            "year": 2018,
            "period": 3,
            "docCode": "0006",
            "origAmountDrSum": 0.8,
            "origAmountCrSum": 0.8,
            "amountDrSum": 0.8,
            "amountCrSum": 0.8,
            "creatorId": 1,
            "creator": "系统",
            "businessTypeId": 5000040014,
            "attachedNum": 0,
            "voucherState": 1000020001,
            "voucherStateName": "未审核",
            "ts": "2018-03-28 09:58:05.0",
            "accountId": 99067,
            "accountCode": "5801",
            "accountName": "猕猴桃",
            "accountGradeName": "猕猴桃",
            "accountCashTypeId": 5000020041,
            "accountIsIncidentalAcc": false,
            "direction": 0,
            "directionName": "借",
            "summary": "计提3月所得税",
            "currencyId": 1,
            "currencyCode": "RMB",
            "currencyName": "人民币",
            "isBaseCurrency": true,
            "exchangeRate": 1,
            "origAmountDr": 0.8,
            "amountDr": 0.8,
            "rowNo": 1,
            "isPeriodBegin": false,
            "docTypeAndCode": "记-0006",
            "amountSum": 0.8,
            "accountCodeName": "5801 猕猴桃",
            "voucherDate": "2018-03-31",
            "createTime": "2018-03-28 09:58:05"
        }, {
            "rowStatus": 0,
            "id": 4291800582150144,
            "docId": 4291800581822464,
            "docType": "记",
            "year": 2018,
            "period": 3,
            "docCode": "0006",
            "origAmountDrSum": 0.8,
            "origAmountCrSum": 0.8,
            "amountDrSum": 0.8,
            "amountCrSum": 0.8,
            "creatorId": 1,
            "creator": "系统",
            "businessTypeId": 5000040014,
            "attachedNum": 0,
            "voucherState": 1000020001,
            "voucherStateName": "未审核",
            "ts": "2018-03-28 09:58:05.0",
            "accountId": 99133,
            "accountCode": "222115",
            "accountName": "应交所得税",
            "accountGradeName": "火龙果",
            "accountCashTypeId": 5000020042,
            "accountIsIncidentalAcc": false,
            "direction": 1,
            "directionName": "贷",
            "summary": "计提3月所得税",
            "currencyId": 1,
            "currencyCode": "RMB",
            "currencyName": "人民币",
            "isBaseCurrency": true,
            "exchangeRate": 1,
            "origAmountCr": 0.8,
            "amountCr": 0.8,
            "rowNo": 2,
            "isPeriodBegin": false,
            "docTypeAndCode": "记-0006",
            "amountSum": 0.8,
            "accountCodeName": "222115 火龙果",
            "voucherDate": "2018-03-31",
            "createTime": "2018-03-28 09:58:05"
        }, {
            "rowStatus": 0,
            "id": 4291800584181761,
            "docId": 4291800584181760,
            "docType": "记",
            "year": 2018,
            "period": 3,
            "docCode": "0007",
            "origAmountDrSum": 4,
            "origAmountCrSum": 4,
            "amountDrSum": 4,
            "amountCrSum": 4,
            "creatorId": 1,
            "creator": "系统",
            "businessTypeId": 5000040004,
            "attachedNum": 0,
            "voucherState": 1000020001,
            "voucherStateName": "未审核",
            "ts": "2018-03-28 09:58:05.0",
            "accountId": 99237,
            "accountCode": "505102",
            "accountName": "出租固定资产收入",
            "accountGradeName": "橙子",
            "accountCashTypeId": 5000020004,
            "accountIsIncidentalAcc": false,
            "direction": 1,
            "directionName": "贷",
            "summary": "结转3月损益",
            "currencyId": 1,
            "currencyCode": "RMB",
            "currencyName": "人民币",
            "isBaseCurrency": true,
            "exchangeRate": 1,
            "origAmountDr": 4,
            "amountDr": 4,
            "rowNo": 1,
            "isPeriodBegin": false,
            "docTypeAndCode": "记-0007",
            "amountSum": 4,
            "accountCodeName": "505102 橙子",
            "voucherDate": "2018-03-31",
            "createTime": "2018-03-28 09:58:05"
        }, {
            "rowStatus": 0,
            "id": 4291800584706048,
            "docId": 4291800584181760,
            "docType": "记",
            "year": 2018,
            "period": 3,
            "docCode": "0007",
            "origAmountDrSum": 4,
            "origAmountCrSum": 4,
            "amountDrSum": 4,
            "amountCrSum": 4,
            "creatorId": 1,
            "creator": "系统",
            "businessTypeId": 5000040004,
            "attachedNum": 0,
            "voucherState": 1000020001,
            "voucherStateName": "未审核",
            "ts": "2018-03-28 09:58:05.0",
            "accountId": 99048,
            "accountCode": "3103",
            "accountName": "葡萄",
            "accountGradeName": "葡萄",
            "accountCashTypeId": 5000020005,
            "accountIsIncidentalAcc": false,
            "direction": 1,
            "directionName": "贷",
            "summary": "结转3月损益",
            "currencyId": 1,
            "currencyCode": "RMB",
            "currencyName": "人民币",
            "isBaseCurrency": true,
            "exchangeRate": 1,
            "origAmountCr": 3.2,
            "amountCr": 3.2,
            "rowNo": 2,
            "isPeriodBegin": false,
            "docTypeAndCode": "记-0007",
            "amountSum": 4,
            "accountCodeName": "3103 葡萄",
            "voucherDate": "2018-03-31",
            "createTime": "2018-03-28 09:58:05"
        }, {
            "rowStatus": 0,
            "id": 4291800585426944,
            "docId": 4291800584181760,
            "docType": "记",
            "year": 2018,
            "period": 3,
            "docCode": "0007",
            "origAmountDrSum": 4,
            "origAmountCrSum": 4,
            "amountDrSum": 4,
            "amountCrSum": 4,
            "creatorId": 1,
            "creator": "系统",
            "businessTypeId": 5000040004,
            "attachedNum": 0,
            "voucherState": 1000020001,
            "voucherStateName": "未审核",
            "ts": "2018-03-28 09:58:05.0",
            "accountId": 99067,
            "accountCode": "5801",
            "accountName": "猕猴桃",
            "accountGradeName": "猕猴桃",
            "accountCashTypeId": 5000020041,
            "accountIsIncidentalAcc": false,
            "direction": 0,
            "directionName": "借",
            "summary": "结转3月损益",
            "currencyId": 1,
            "currencyCode": "RMB",
            "currencyName": "人民币",
            "isBaseCurrency": true,
            "exchangeRate": 1,
            "origAmountCr": 0.8,
            "amountCr": 0.8,
            "rowNo": 3,
            "isPeriodBegin": false,
            "docTypeAndCode": "记-0007",
            "amountSum": 4,
            "accountCodeName": "5801 猕猴桃",
            "voucherDate": "2018-03-31",
            "createTime": "2018-03-28 09:58:05"
        }],
        "page": {
            "pageSize": 20,
            "currentPage": 1,
            "totalPage": 1,
            "totalCount": 2
        },
        "accountList": [{
            "accountTypeName": "资产",
            "cashTypeName": "现金",
            "codeAndName": "1001 苹果",
            "openingBankName": "",
            "id": 99001,
            "code": "1001",
            "name": "苹果",
            "gradeName": "苹果"
        }, {
            "accountTypeName": "资产",
            "cashTypeName": "银行存款",
            "codeAndName": "100201 荔枝",
            "id": 99068,
            "code": "100201",
            "name": "基本户",
            "gradeName": "荔枝"
        }, {　　　　　　
            "accountTypeName": "资产",
            "cashTypeName": "梨",
            "codeAndName": "1012 梨",
            "id": 99003,
            "code": "1012",
            "name": "梨",
            "gradeName": "梨"
        }, {
            "accountTypeName": "资产",
            "cashTypeName": "",
            "codeAndName": "1501 草莓",
            "id": 99020,
            "code": "1501",
            "name": "草莓",
            "gradeName": "草莓"
        }, {
            "accountTypeName": "资产",
            "cashTypeName": "",
            "codeAndName": "170103 芒果",
            "id": 99093,
            "code": "170103",
            "name": "商标权",
            "gradeName": "芒果"
        }, {
            "accountTypeName": "负债",
            "cashTypeName": "",
            "codeAndName": "221101 西瓜",
            "id": 99107,
            "code": "221101",
            "name": "职工工资",
            "gradeName": "西瓜"
        }, {
            "accountTypeName": "负债",
            "cashTypeName": "应交所得税",
            "codeAndName": "222115 火龙果",
            "id": 99133,
            "code": "222115",
            "name": "应交所得税",
            "gradeName": "火龙果"
        }, {
            "accountTypeName": "权益",
            "cashTypeName": "",
            "codeAndName": "3002 柚子",
            "id": 99046,
            "code": "3002",
            "name": "柚子",
            "gradeName": "柚子"
        }, {
            "accountTypeName": "权益",
            "cashTypeName": "葡萄",
            "codeAndName": "3103 葡萄",
            "id": 99048,
            "code": "3103",
            "name": "葡萄",
            "gradeName": "葡萄"
        }, {
            "accountTypeName": "成本",
            "cashTypeName": "",
            "codeAndName": "400103 黄桃",
            "id": 99161,
            "code": "400103",
            "name": "基本社会保险费",
            "gradeName": "黄桃"
        }, {
            "accountTypeName": "损益",
            "cashTypeName": "",
            "codeAndName": "505102 橙子",
            "id": 99237,
            "code": "505102",
            "name": "出租固定资产收入",
            "gradeName": "橙子"
        }, {
            "accountTypeName": "损益",
            "cashTypeName": "猕猴桃",
            "codeAndName": "5801 猕猴桃",
            "id": 99067,
            "code": "5801",
            "name": "猕猴桃",
            "gradeName": "猕猴桃"
        }],
        "voucherTypeList": [],
        "voucherStateList": [{
            "id": 1000020001,
            "name": "未审核",
            "code": "NotApprove",
            "enumId": 100002
        }, {
            "id": 1000020002,
            "name": "已审核",
            "code": "Approved",
            "enumId": 100002
        }],
        "columnDto": {
            "id": 500001,
            "code": "docList",
            "name": "凭证管理",
            "isDefault": true,
            "columnDetails": [{
                "id": 50000100001,
                "columnId": 500001,
                "fieldName": "voucherDate",
                "caption": "日期",
                "idFieldType": 1000040001,
                "width": 100,
                "idAlignType": 1000050001,
                "colIndex": 1,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": true,
                "isMustSelect": true,
                "isSystem": false,
                "isHeader": true,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040001,
                    "name": "字符",
                    "code": "string",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050001,
                    "name": "左对齐",
                    "code": "01",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100002,
                "columnId": 500001,
                "fieldName": "docTypeAndCode",
                "caption": "账单序号",
                "idFieldType": 1000040001,
                "width": 100,
                "idAlignType": 1000050001,
                "colIndex": 2,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": true,
                "isMustSelect": true,
                "isSystem": false,
                "isHeader": true,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040001,
                    "name": "字符",
                    "code": "string",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050001,
                    "name": "左对齐",
                    "code": "01",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100003,
                "columnId": 500001,
                "fieldName": "amountSum",
                "caption": "总金额",
                "idFieldType": 1000040002,
                "width": 100,
                "idAlignType": 1000050003,
                "colIndex": 3,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": false,
                "isMustSelect": false,
                "isSystem": false,
                "isHeader": true,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040002,
                    "name": "数值",
                    "code": "decimal",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050003,
                    "name": "右对齐",
                    "code": "03",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100004,
                "columnId": 500001,
                "fieldName": "summary",
                "caption": "摘要",
                "idFieldType": 1000040001,
                "width": 100,
                "idAlignType": 1000050001,
                "colIndex": 4,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": true,
                "isMustSelect": false,
                "isSystem": false,
                "isHeader": false,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040001,
                    "name": "字符",
                    "code": "string",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050001,
                    "name": "左对齐",
                    "code": "01",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100005,
                "columnId": 500001,
                "fieldName": "accountCodeName",
                "caption": "水果种类",
                "idFieldType": 1000040001,
                "width": 100,
                "idAlignType": 1000050001,
                "colIndex": 5,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": true,
                "isMustSelect": false,
                "isSystem": false,
                "isHeader": false,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040001,
                    "name": "字符",
                    "code": "string",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050001,
                    "name": "左对齐",
                    "code": "01",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100006,
                "columnId": 500001,
                "fieldName": "currencyAndExchangeRate",
                "caption": "币种/汇率",
                "idFieldType": 1000040001,
                "width": 100,
                "idAlignType": 1000050001,
                "colIndex": 6,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": false,
                "isMustSelect": false,
                "isSystem": false,
                "isHeader": false,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040001,
                    "name": "字符",
                    "code": "string",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050001,
                    "name": "左对齐",
                    "code": "01",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100007,
                "columnId": 500001,
                "fieldName": "unitName",
                "caption": "计量单位",
                "idFieldType": 1000040001,
                "width": 100,
                "idAlignType": 1000050001,
                "colIndex": 7,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": false,
                "isMustSelect": false,
                "isSystem": false,
                "isHeader": false,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040001,
                    "name": "字符",
                    "code": "string",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050001,
                    "name": "左对齐",
                    "code": "01",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100008,
                "columnId": 500001,
                "fieldName": "quantity",
                "caption": "数量",
                "idFieldType": 1000040002,
                "width": 100,
                "idAlignType": 1000050003,
                "colIndex": 8,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": false,
                "isMustSelect": false,
                "isSystem": false,
                "isHeader": false,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040002,
                    "name": "数值",
                    "code": "decimal",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050003,
                    "name": "右对齐",
                    "code": "03",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100009,
                "columnId": 500001,
                "fieldName": "price",
                "caption": "单价",
                "idFieldType": 1000040002,
                "width": 100,
                "idAlignType": 1000050003,
                "colIndex": 9,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": false,
                "isMustSelect": false,
                "isSystem": false,
                "isHeader": false,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040002,
                    "name": "数值",
                    "code": "decimal",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050003,
                    "name": "右对齐",
                    "code": "03",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100010,
                "columnId": 500001,
                "fieldName": "origAmount",
                "caption": "外币金额",
                "idFieldType": 1000040002,
                "width": 100,
                "idAlignType": 1000050003,
                "colIndex": 10,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": false,
                "isMustSelect": false,
                "isSystem": false,
                "isHeader": false,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040002,
                    "name": "数值",
                    "code": "decimal",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050003,
                    "name": "右对齐",
                    "code": "03",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100011,
                "columnId": 500001,
                "fieldName": "amountDr",
                "caption": "买入",
                "idFieldType": 1000040002,
                "width": 100,
                "idAlignType": 1000050003,
                "colIndex": 11,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": true,
                "isMustSelect": false,
                "isSystem": false,
                "isHeader": false,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040002,
                    "name": "数值",
                    "code": "decimal",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050003,
                    "name": "右对齐",
                    "code": "03",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100012,
                "columnId": 500001,
                "fieldName": "amountCr",
                "caption": "卖出",
                "idFieldType": 1000040002,
                "width": 100,
                "idAlignType": 1000050003,
                "colIndex": 12,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": true,
                "isMustSelect": false,
                "isSystem": false,
                "isHeader": false,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040002,
                    "name": "数值",
                    "code": "decimal",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050003,
                    "name": "右对齐",
                    "code": "03",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100013,
                "columnId": 500001,
                "fieldName": "attachedNum",
                "caption": "附单据数",
                "idFieldType": 1000040002,
                "width": 100,
                "idAlignType": 1000050001,
                "colIndex": 13,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": true,
                "isMustSelect": false,
                "isSystem": false,
                "isHeader": true,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040002,
                    "name": "数值",
                    "code": "decimal",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050001,
                    "name": "左对齐",
                    "code": "01",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100014,
                "columnId": 500001,
                "fieldName": "sourceVoucherCode",
                "caption": "凭证来源",
                "idFieldType": 1000040001,
                "width": 100,
                "idAlignType": 1000050001,
                "colIndex": 14,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": false,
                "isMustSelect": false,
                "isSystem": false,
                "isHeader": true,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040001,
                    "name": "字符",
                    "code": "string",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050001,
                    "name": "左对齐",
                    "code": "01",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100015,
                "columnId": 500001,
                "fieldName": "voucherStateName",
                "caption": "状态",
                "idFieldType": 1000040001,
                "width": 100,
                "idAlignType": 1000050001,
                "colIndex": 15,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": false,
                "isMustSelect": false,
                "isSystem": false,
                "isHeader": true,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040001,
                    "name": "字符",
                    "code": "string",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050001,
                    "name": "左对齐",
                    "code": "01",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100016,
                "columnId": 500001,
                "fieldName": "creator",
                "caption": "制单人",
                "idFieldType": 1000040001,
                "width": 100,
                "idAlignType": 1000050001,
                "colIndex": 16,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": true,
                "isMustSelect": false,
                "isSystem": false,
                "isHeader": true,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040001,
                    "name": "字符",
                    "code": "string",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050001,
                    "name": "左对齐",
                    "code": "01",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }, {
                "id": 50000100017,
                "columnId": 500001,
                "fieldName": "auditor",
                "caption": "审核人",
                "idFieldType": 1000040001,
                "width": 100,
                "idAlignType": 1000050001,
                "colIndex": 17,
                "idOrderMode": 1000060001,
                "isFixed": false,
                "isVisible": true,
                "isMustSelect": false,
                "isSystem": false,
                "isHeader": true,
                "isTotalColumn": false,
                "fieldTypeDTO": {
                    "id": 1000040001,
                    "name": "字符",
                    "code": "string",
                    "enumId": 100004
                },
                "alignTypeDTO": {
                    "id": 1000050001,
                    "name": "左对齐",
                    "code": "01",
                    "enumId": 100005
                },
                "orderModeDTO": {
                    "id": 1000060001,
                    "name": "升序",
                    "code": "01",
                    "enumId": 100006
                }
            }]
        }
    }
}

function query(option) {
    const { accountId, endCode, endPeriod, endYear, simpleCondition, startCode, startPeriod, startYear, summary, voucherState } = option
   
    let tableList = mockData.tableList
    tableList.page.currentPage = option.page.currentPage
    tableList.page.pageSize = option.page.pageSize
    let { accountList, columnDto, displayDate, page, voucherStateList, voucherTypeList, dtoList } = tableList
    let docIdArr = []
    //审核状态voucherState、摘要summary、起止账单号docCode、起止日期period、水果accountId
    if(accountId){
        dtoList.forEach(element => {
            if(accountId == element.accountId){
                docIdArr.push(element.docId)
            }
        });
    }
    let newList = dtoList.filter((item) => {
        if((!accountId || docIdArr.includes(item.docId)) && 
            (!voucherState || voucherState == item.voucherState) && 
            (!summary || summary == item.summary) && 
            (!startCode || (startCode <= item.docCode && item.docCode <= endCode)) && 
            (!startPeriod || (startPeriod <= item.period && item.period <= endPeriod)) &&
            (!simpleCondition || item.docCode.indexOf(simpleCondition) >= 0) ){
            return true
        }else{
            return false
        }
    })
    return {
        page, dtoList: newList
    }
}

function audit(option, state) {
    var dtoList = mockData.tableList.dtoList
    let list = option.map((a)=>{return a.docId})
    dtoList.map( (item) => {
        if(list.includes(item.docId)) {
            if(state){
                item.voucherStateName = '已审核'
                item.auditor = '13333333333'
                item.voucherState = '1000020002'
            }else{
                item.voucherStateName = '未审核'
                item.auditor = ''
                item.voucherState = '1000020001'
            }
        }
    })
}

function deleteDoc(option) {
    var dtoList = mockData.tableList.dtoList
    let list = option.map((a)=>{return a.docId}), item
    for (let i = dtoList.length - 1; i >= 0; i--) {
        item = dtoList[i]
        if (list.includes(item.docId)) {
            dtoList.splice(i, 1);
        }
    }
}

//查询初始列表数据
fetch.mock('/v1/gl/docManage/init', (option) => {
    initTableList()
    return { result: true, value: mockData.tableList }
})

//审核数据
fetch.mock('/v1/gl/doc/auditBatch', (option) => {
    audit(option, true)
    return { result: true, value: '审核成功' }
})

//查询列表数据
fetch.mock('/v1/gl/docManage/query', (option) => {
    return { result: true, value: query(option) }
})

//整理凭证号
fetch.mock('/v1/gl/docManage/reorganizeDocCode', (option) => {
    return { result: true, value: mockData.tableList }
})

//反审核数据
fetch.mock('/v1/gl/doc/unAuditBatch', (option) => {
    audit(option, false)
    return { result: true, value: '反审核成功' }
})

//删除凭证
fetch.mock('/v1/gl/doc/delete', (option) => {
    deleteDoc([option])
    return { result: true, value: {allSuccess: true} }
})

//批量删除凭证
fetch.mock('/v1/gl/doc/deleteBatch', (option) => {
    deleteDoc(option)
    return { result: true, value: {allSuccess: true} }
})

//查询栏目
fetch.mock('/v1/edf/column/findByParam', (option) => {
    return { result: true, value: mockData.tableList.columnDto }
})

//更新栏目
fetch.mock('/v1/edf/column/updateWithDetail', (option) => {
    let columnDetails = mockData.tableList.columnDto.columnDetails
    columnDetails.map((item, index) => {
        item.isVisible = option.columnDetails[index].isVisible
    })
    return { result: true, value: mockData.tableList.columnDto }
})

//初始化时间
fetch.mock('/v1/gl/report/queryDate', (option) => {
    return {result: true,value: {DisplayDate: '2018-03', EnableDate: '2018-03'}}
})

//打印初始化
fetch.mock('v1/gl/docManage/printConfig', (option) => {
    return {result: true, value: { printAuxAccCalc: "1", width: "21.5", type: "0", maxLineNum: "6", height: "12.5"}}
})