import React from 'react'

export default function renderColumns(renderTitle) {
    const accountColumns = [
        {
            title: <span title='科目编码'>科目编码</span>,            
            name: 'accountCode',
            dataIndex: 'accountCode',
            key: 'accountCode'
        }, {
            title: <span title='科目名称'>科目名称</span>,            
            name: 'accountName',
            dataIndex: 'accountName',
            key: 'accountName'
        },
    ]
    const baseColumns = [{       
        title: <span title='期初余额'>期初余额</span>,
        children: [{            
            title: <span title='借方'>借方</span>,
            name: 'periodBeginAmountDr',
            dataIndex: 'periodBeginAmountDr',
            className: 'amountColumnStyle',
            'render': renderTitle,
            key: 'periodBeginAmountDr'
        }, {           
            title: <span title='贷方'>贷方</span>,
            name: 'periodBeginAmountCr',
            dataIndex: 'periodBeginAmountCr',
            className: 'amountColumnStyle',
            'render': renderTitle,
            key: 'periodBeginAmountCr'
        }]
    }, {        
        title: <span title='本期发生额'>本期发生额</span>,
        children: [{            
            title: <span title='借方'>借方</span>,
            name: 'amountDr',
            dataIndex: 'amountDr',
            className: 'amountColumnStyle',
            'render': renderTitle,
            key: 'amountDr'
        }, {           
            title: <span title='贷方'>贷方</span>,
            name: 'amountCr',
            dataIndex: 'amountCr',
            className: 'amountColumnStyle',
            'render': renderTitle,
            key: 'amountCr'
        }]
    }, {        
        title: <span title='本年累计发生额'>本年累计发生额</span>,
        name: 'balance',
        children: [{           
            title: <span title='借方'>借方</span>,
            name: 'yearAmountDr',
            dataIndex: 'yearAmountDr',
            className: 'amountColumnStyle',
            'render': renderTitle,
            key: 'yearAmountDr'
        }, {            
            title: <span title='贷方'>贷方</span>,
            name: 'yearAmountCr',
            dataIndex: 'yearAmountCr',
            className: 'amountColumnStyle',
            'render': renderTitle,
            key: 'yearAmountCr'
        }]
    }, {        
        title: <span title='期末余额'>期末余额</span>,
        name: 'balance',
        children: [{           
            title: <span title='借方'>借方</span>,
            name: 'periodEndAmountDr',
            dataIndex: 'periodEndAmountDr',
            'render': renderTitle,
            className: 'amountColumnStyle',
            key: 'periodEndAmountDr'
        }, {           
            title: <span title='贷方'>贷方</span>,
            name: 'periodEndAmountCr',
            dataIndex: 'periodEndAmountCr',
            className: 'amountColumnStyle',
            'render': renderTitle,
            key: 'periodEndAmountCr'
        }]
    }]
    return [accountColumns, baseColumns]
}



