export function getMeta() {
	return {
		name: 'root',
		component: 'Layout',
		className: 'ttk-table-app-simplerpt',
		children: [{
			name: 'header',
			component: 'Layout',
			className: 'ttk-table-app-simplerpt-header',
			children: [{
				name: 'rptTitle',
				className: 'ttk-table-app-simplerpt-header-title',
				component: "::div",
				children: "部门信息统计表"
			}]
		}, {
			name: 'content',
			className: 'ttk-table-app-simplerpt-content',
			component: 'Layout',
			children: [{
				name: 'report',
				component: 'Table',
				pagination: false,
				//scroll: { x: true, y: true },
				bordered: true,
				width: true,
				dataSource: '{{data.reportDS}}',
				columns: [{
					title: '部门',
					rowSpan: 3,
					children: [{
						colSpan: 0,
						rowSpan: 2,
						dataIndex: 'dept1',
						render: "{{$cellRender('dept1')}}"
					}, {
						title: '2级',
						colSpan: 0,
						rowSpan: 2,
						dataIndex: 'dept2',
						render: "{{$cellRender('dept2')}}"
					}, {
						title: '3级',
						colSpan: 0,
						rowSpan: 2,
						dataIndex: 'dept3',
						render: "{{$cellRender('dept3')}}"
					}]

				}, {
					title: '期初人数',
					dataIndex: 'beginPersonCount',
					render: "{{$cellRender('beginPersonCount')}}"
				}, {
					title: '期末人数',
					dataIndex: 'endPersonCount',
					render: "{{$cellRender('endPersonCount')}}"
				}, {
					title: '平均人数',
					dataIndex: 'averagePersonCount',
					render: "{{$cellRender('averagePersonCount')}}"
				}, {
					title: '入职',
					dataIndex: 'cc1',
					children: [{
						title: '人数',
						dataIndex: 'c1',
						render: "{{$cellRender('c1')}}"
					}, {
						title: '入职率%',
						dataIndex: 'c2',
						render: "{{$cellRender('c2')}}"
					}]

				}, {
					title: '离职',
					dataIndex: 'cc2',
					children: [{
						title: '人数',
						dataIndex: 'c3',
					}, {
						title: '入职率%',
						dataIndex: 'c4',
					}]
				}, {
					title: '学历层次',
					dataIndex: 'cc3',
					children: [{
						title: '研究生',
						children: [{
							title: '人数',
							dataIndex: 'c5',
						}, {
							title: '占比',
							dataIndex: 'c6',
						}]
					}, {
						title: '本科',
						children: [{
							title: '人数',
							dataIndex: 'c7',
						}, {
							title: '占比',
							dataIndex: 'c8',
						}]
					}, {
						title: '专科',
						children: [{
							title: '人数',
							dataIndex: 'c9',
						}, {
							title: '占比',
							dataIndex: 'c10',
						}]
					}]
				}, {
					title: '备注',
					dataIndex: 'c11',
				}]
			}]
		}]
	}
}

export function getInitState() {
	return {
		data: {
			reportDS: []
		}
	}
}