import React from 'react'
import { action as MetaAction, AppLoader } from 'edf-meta-engine'
import config from './config'
import {cashType} from './api'
import { Map, fromJS } from 'immutable'
import { Checkbox, Select } from 'edf-component'
import {FormDecorator} from 'edf-component'
// const Option = Select.Option
class action {
	constructor(option) {
        this.metaAction = option.metaAction
        this.voucherAction = option.voucherAction
        this.config = config.current
        this.webapi = this.config.webapi
    }

	onInit = ({ component, injections }) => {
		this.voucherAction.onInit({component, injections})
		this.component = component
		this.injections = injections
		if (this.component.props.setOkListener)
			this.component.props.setOkListener(this.onOk)

		injections.reduce('init')

		this.load()
	}

	load = async () => {
		const unitList = await this.webapi.queryunit(),
			currencyList = await this.webapi.currency({entity:{isEnable:true}})
		// this.metaAction.sf('data.other.unitList', fromJS(unitList.units))
        // this.metaAction.sf('data.other.currencyList', fromJS(currencyList.currencys))
		let newData = this.metaAction.gf('data').toJS(),
			{data, active} = this.component.props
		newData.other.unitList = unitList.list
		newData.other.currencyList = currencyList.list
		//本界面是由新增凭证打开
		if(active === 'certificate'){
			let value = await this.webapi.quertSubjects({})
			newData.other.subjectList = value.glAccounts
			newData.other.calcDict = {...value.calcDict}
			newData.other.active = active
			newData.other.codeAndName = ''
		}else{
			let oldSubject = await this.webapi.find({id: data.id}),
				isUsed = await this.webapi.used({id: data.id})
			newData.form = {...oldSubject.glAccount}
			newData.other.oldSubject = {...oldSubject.glAccount}
			newData.other.calcDict = {...oldSubject.calcDict}
			let { code, codeAndName, isCalcMulti, isCalcQuantity, cashTypeId, grade, currencyId} = newData.form,
			isDisplayAuxAcc = !(cashTypeId == cashType.CASHTYPE_CASH
				|| cashTypeId == cashType.CASHTYPE_BANKDEPOSIT),//【现金】【银行存款】的不显示辅助核算
			//数量或者外币有选中值时给默认可选列表
			isDisplayBankAccountAux = cashTypeId == cashType.CASHTYPE_BANKDEPOSIT//判断是否是银行相关的，显示

			if(active === 'edit'){
				newData.form.code = code.length > 4 ? code.slice(-2) : code
				newData.other.addonBefore =  code.length > 4 ? code.slice(0,code.length-2) : ''
				newData.other.isUsed = isUsed
				newData.other.active = active
				newData.other.codeAndName = this.component.props.parentSubject.codeAndName
				newData.other.isDisplayBankAccountAux = isDisplayBankAccountAux && grade > 1
				if(!data.isEndNode){
					newData.form.canDisabledMulti = false
					newData.form.canDisabledQuantity = false
				}
			}
			else if(active === 'add'){
				//code初始值
				newData.form.code = this.component.props.newCode
				newData.form.isSystem = false
				newData.form.isEndNode = true
				newData.form.gradeName = ''
				newData.form.name = ''
				newData.other.codeAndName = codeAndName
				newData.other.addonBefore = code
				newData.other.isUsed = isUsed
				newData.other.isDisplayBankAccountAux = isDisplayBankAccountAux
				if(isUsed){
					//如果已使用，新增时辅助核算项、外币、数量全部置灰，不可修改
					newData.form.canDisabledMulti = false
					newData.form.canDisabledQuantity = false
				}
			}

			//外币有选中值时判断当前选择外币是否停用，如选中值停用默认显示第一个
			if(isCalcMulti && currencyId){
				let item = newData.other.currencyList.filter(o => o && o.id == currencyId)
				if(item.length == 0){
					newData.form.currencyName = newData.other.currencyList[0].name
					newData.form.currencyId = newData.other.currencyList[0].id
				}
			}

			let isExist = grade > 1 ? (newData.other.addonBefore != '' ? newData.other.addonBefore.indexOf('2221') : null) : (code ? code.indexOf('2221') : null),
				multiUnit = cashTypeId == cashType.CASHTYPE_CURYEARPROFIT //是否显示外币核算、计量单位

			newData.other.isExist = isExist == 0 && typeof(isExist) == 'number'
			newData.other.multiUnit = !(isExist == 0 && typeof(isExist) == 'number' || multiUnit)
			newData.other.isDisplayAuxAcc = isDisplayAuxAcc && !(isExist == 0 && typeof(isExist) == 'number')
		}
			document.getElementById('subjectName').focus()
			newData.other.loading = false
			this.injections.reduce('load', newData)
	}

	//新增数量、外币核算
	addCalcList = async(name) =>{
		let option = {name: name}
		if(name == 'app-card-currency'){
			option.title = '币种'
		}else{
			option.title = '计量单位'
		}
		const ret = await this.metaAction.modal('show', {
            title: option.title,
            width: 400,
            children: this.metaAction.loadApp(option.name, {
                store: this.component.props.store
            }),
		})
		if(ret){
			let newData = this.metaAction.gf('data').toJS()
			if(name == 'app-card-currency'){
				const currencyList = await this.webapi.currency({entity:{isEnable:true}})
				newData.other.currencyList = currencyList.list.filter((o)=>o.isEnable)
				newData.form.currencyId = ret.id
				let data = [], currencyId = ret.id
				newData.other.currencyList = currencyList.list
				data = currencyList.list.filter((o)=>o.id == currencyId)
				if(data.length == 0){
					newData.form.currencyId = newData.other.currencyList[0].id
				}
			}else{
				const unitList = await this.webapi.queryunit()
				newData.other.unitList = unitList.list
				newData.form.unitId = ret.id
			}
			this.injections.reduce('load', newData)
		}
	}

	//显示辅助核算复选框
	showisCalc = (data) =>{
		//当前配置的辅助核算项
		let isDisplayAuxAcc = this.metaAction.gf('data.other.isDisplayAuxAcc')
		if(!data.isCalc)
			return
		let calcDict = this.metaAction.gf('data.other.calcDict').toJS(),
			list = ['isCalcCustomer','isCalcSupplier','isCalcProject','isCalcDepartment','isCalcPerson','isCalcInventory','isExCalc1','isExCalc2','isExCalc3','isExCalc4','isExCalc5','isExCalc6','isExCalc7','isExCalc8','isExCalc9','isExCalc10'],
			newData = []
		for(let i in list){
			if(calcDict[list[i]]){
				newData.push({name: list[i],title: calcDict[list[i]], check: data[list[i]]})
			}
		}
		return newData.map((item, index)=>{
			if(getBLen(item.title) > 11){
				return <Checkbox disabled={false}
						key={index}
						defaultChecked={item.check}
						disabled={this.disabledState(data.form, item.name)}
						onClick={(v)=>{this.metaAction.sf(`data.form.${item.name}`, v.target.checked)}}
					>
					<span title={item.title}>{item.title}</span>
					</Checkbox>
			}
			return <Checkbox disabled={false}
						key={index}
						defaultChecked={item.check}
						disabled={this.disabledState(data.form, item.name)}
						onClick={(v)=>{this.metaAction.sf(`data.form.${item.name}`, v.target.checked)}}
					>
					{item.title}
					</Checkbox>
		})
	}

	//显示上级
	parentSubjectNode = () =>{
		let other = this.metaAction.gf('data.other').toJS(),
		{subjectList, active, codeAndName} = other
		if(active == 'certificate'){

			let returnOption = subjectList.map((item) => {
				let {code, grade, cashTypeId, codeAndName, id} = item,
					disabled = false
					++grade
				if((code.indexOf('1002') != -1 && grade != 2)
					|| (code.indexOf('1012') != -1 && grade != 2 && grade != 3)
					|| (code == '22210401')
					|| (code.indexOf('1001') != -1  && grade != 1)
					|| (cashTypeId == 5000020033 && grade != 2)
					|| ((cashTypeId == 5000020034 || cashTypeId == 5000020035 || cashTypeId == 5000020036 || cashTypeId == 5000020037) && grade != 2)
					|| (code == '22210109')
					|| (cashTypeId == 5000020005) || grade > 5){
					disabled = true
				}
				return	<Option key={code}  value={id} disabled={disabled}>{codeAndName}</Option>
			})

			return <Select style={{ width: 200 }}
				filterOption={this.filterSubject.bind(this)}
				// onFocus={this.onFocus.bind(this,item.name)}
				onChange={this.changeParentSubject.bind(this)}
				>
				{returnOption}
			</Select>
		}else{
			if(getBLen(codeAndName) > 38){
				return  <span className="parentName" title={codeAndName}>{codeAndName}</span>
			}
			return  <span>{codeAndName}</span>
		}
	}

	//选中上级时筛选匹配
	filterSubject = (inputValue, option) => {
        if (option && option.props && option.props.value&& !option.props.disabled) {
            let accountingSubjects = this.metaAction.gf('data.other.subjectList')
            let itemData = accountingSubjects.find(o => o.get('id') == option.props.value)

            if ((itemData.get('code') && itemData.get('code').indexOf(inputValue) == 0)  //code左匹配
                || (itemData.get('gradeName') && itemData.get('gradeName').indexOf(inputValue) != -1)
                || (itemData.get('codeAndName') && itemData.get('codeAndName').indexOf(inputValue) == 0)
                || (itemData.get('helpCode') && itemData.get('helpCode').indexOf(inputValue.toUpperCase()) != -1)) {

                //将滚动条置顶
                let select = document.getElementsByClassName('ant-select-dropdown-menu')
                if (select.length > 0 && select[0].scrollTop > 0) {
                    select[0].scrollTop = 0
                }

                return true
            }
            else {
                return false
            }
        }

        return true
    }

	//选择上级
	changeParentSubject = async (id)=>{
		const isUsed = await this.webapi.used({id: id})
		let newData = this.metaAction.gf('data').toJS(),
			subjectList = newData.other.subjectList,
			parentSubject = subjectList.filter(subItem => {
				return parseInt(subItem.id) == parseInt(id)
			}),
			name = newData.form.name
		newData.form = {...parentSubject[0]}
		newData.form.name = name
		newData.other.oldSubject = {...parentSubject[0]}
		++newData.form.grade
		let { code, codeAndName, isCalcMulti, isCalcQuantity, cashTypeId, grade, currencyId } = newData.form,
		isDisplayAuxAcc = !(cashTypeId == cashType.CASHTYPE_CASH
			|| cashTypeId == cashType.CASHTYPE_BANKDEPOSIT),//【现金】【银行存款】的不显示辅助核算
			//数量或者外币有选中值时给默认可选列表
			isDisplayBankAccountAux = cashTypeId == cashType.CASHTYPE_BANKDEPOSIT && grade != 1//判断是否是银行相关的，显示

		let value = newData.form.code + generateNewSubCode(newData.form.id, code, subjectList)
		newData.form.code = value
		newData.form.isSystem = false
		newData.form.isEndNode = true
		newData.form.gradeName = ''
		newData.form.parentId = newData.form.id
		newData.other.codeAndName = codeAndName
		newData.other.isUsed = isUsed
		newData.other.isDisplayBankAccountAux = isDisplayBankAccountAux
		let isExist = value ? value.indexOf('2221') : null,
		multiUnit = cashTypeId == cashType.CASHTYPE_CURYEARPROFIT //是否显示外币核算、计量单位
		newData.other.isExist = isExist == 0 && typeof(isExist) == 'number'
		newData.other.multiUnit = !(isExist == 0 && typeof(isExist) == 'number'  || multiUnit)
		newData.other.isDisplayAuxAcc = isDisplayAuxAcc && !(isExist == 0 && typeof(isExist) == 'number')
		newData.form.canDisabledMulti = true
		newData.form.canDisabledQuantity = true
		if(isUsed){
			//如果已使用，新增时辅助核算项、外币、数量全部置灰，不可修改
			newData.form.canDisabledMulti = false
			newData.form.canDisabledQuantity = false
		}

		//外币有选中值时判断当前选择外币是否停用，如选中值停用默认显示第一个
		if(isCalcMulti && currencyId){
			let item = newData.other.currencyList.filter(o => o && o.id == currencyId)
			if(item.length == 0){
				newData.form.currencyName = newData.other.currencyList[0].name
				newData.form.currencyId = newData.other.currencyList[0].id
			}
		}

		this.fieldChange('data.form.code', newData.form.code)
		this.injections.reduce('load', newData)
	}

	//改变外币核算或数量核算
	changeAdjustAccounts = (title, value, list, check) =>{
		let newData = this.metaAction.gf('data').toJS(),
			{form, other} = newData
			newData.form[title] = check

		if(check && other[list].length != 0){
			newData.form[value] = other[list][0].id
		}else{
			newData.form[value] = null
		}
		this.injections.reduce('load', newData)
	}

	disabledState = (subject, title) =>{
		//判断当前节点是否为末级
		if(!subject)
			subject = this.metaAction.gf('data.form').toJS()
		let { isUsed, codeAndName, active, oldSubject } = this.metaAction.gf('data.other').toJS(),
			status = false
		if(active == 'edit'){
			if(!subject.isEndNode){
				// 非末级：数量、外币、辅助核算不可修改；
				let disabled = ['isCalc','isCalcDepartment','isCalcPerson','isCalcCustomer','isCalcSupplier','isCalcInventory','isCalcProject','isCalcBankAccount','isCalcQuantity','unitId','isCalcMulti','currencyId','isEnable','isExCalc1','isExCalc2','isExCalc3','isExCalc4','isExCalc5','isExCalc6','isExCalc7','isExCalc8','isExCalc9','isExCalc10']
				if(disabled.indexOf(title) >= 0){
					status = true
				}

				//非末级-预置
				if(subject.isSystem){
				// 	//6.3【预置】的：【名称】不允许修改；
					if(title == 'name')
					{
						status = true
						if((codeAndName == '1002  银行存款' || codeAndName == '1002 银行存款'))
						{
							status = false
						}
					}
				}
				//末级
			}else if(subject.isEndNode){
				//6.6 所有的末级，都可以修改【停用】标识；
				if(subject.isSystem){//末级-预制
					//6.3【预置】的：【编码、名称、余额方向】不允许修改；
					let disabled = ['code','name','balanceDirection']

					if(title == 'name')
					{
						status = true
						if((codeAndName == '1002  银行存款' || codeAndName == '1002 银行存款'))
						{
							status = false
						}
					}
					//末级-预制-已经使用的
					if(isUsed){
						// 6.2已经使用的：
						// 编码只能修改最后两位，即在同一个上级的情况下，可以修改编码，不能与已有的重复；
						// 名称：允许修改，同一上级的名称不能重复；
						// 【余额方向】不允许修改；
						// 【辅助核算】不允许取消，允许启用新的辅助核算项；
						// 【数量核算】属性不允许修改；允许修改计量单位；（前提是启用了数量核算）
						// 【外币核算】属性不允许修改；允许修改默认币种；（前提是启用了外币核算）

						let disabled = ['isCalc','isCalcDepartment','isCalcPerson','isCalcCustomer','isCalcSupplier','isCalcInventory','isCalcProject','isCalcBankAccount','isCalcQuantity','isCalcMulti','isExCalc1','isExCalc2','isExCalc3','isExCalc4','isExCalc5','isExCalc6','isExCalc7','isExCalc8','isExCalc9','isExCalc10']
						if(disabled.indexOf(title) >= 0){
							status = oldSubject[title]
						}
						//

					}else{//末级-预制-未使用的
						//6.4【预置】并且【未使用】的【末级】：【辅助外币、数量核算、外币核算】允许修改；
					}

				}else{//末级-非预制

					//末级-非预制-已经使用的
					if(isUsed){
						// 6.2已经使用的：
						// 编码只能修改最后两位，即在同一个上级的情况下，可以修改编码，不能与已有的重复；
						// 名称：允许修改，同一上级的名称不能重复；
						// 【余额方向】不允许修改；
						// 【辅助核算】不允许取消，允许启用新的辅助核算项；
						// 【数量核算】属性不允许修改；允许修改计量单位；（前提是启用了数量核算）
						// 【外币核算】属性不允许修改；允许修改默认币种；（前提是启用了外币核算）

						let disabled = ['isCalc','isCalcDepartment','isCalcPerson','isCalcCustomer','isCalcSupplier','isCalcInventory','isCalcProject','isCalcBankAccount',,'isExCalc1','isExCalc2','isExCalc3','isExCalc4','isExCalc5','isExCalc6','isExCalc7','isExCalc8','isExCalc9','isExCalc10']
						if(disabled.indexOf(title) >= 0){
							status = oldSubject[title]
						}

						//末级-非预制-未使用的
					}else{
						//6.5 【非预置】并且【未使用】的【末级】：
						//编码只能修改最后两位，即在同一个上级的情况下，可以修改编码，不能与已有的重复；
						//名称：允许修改，同一上级的名称不能重复；
						//其它数据项可以随意修改；

					}
				}
			}
		}else if(isUsed){
			let disabled = ['isCalc','isCalcDepartment','isCalcPerson','isCalcCustomer','isCalcSupplier','isCalcInventory','isCalcProject','isCalcBankAccount',,'isExCalc1','isExCalc2','isExCalc3','isExCalc4','isExCalc5','isExCalc6','isExCalc7','isExCalc8','isExCalc9','isExCalc10']
			if(disabled.indexOf(title) >= 0){
				status = true
			}
		}
		return status
	}

	//计量单位获取焦点
	measurementUnitFocus = async () => {
		const response = await this.webapi.queryunit()
        this.metaAction.sf('data.other.unitList', fromJS(response.list))
    }

	//默认币种获取焦点
	currencyFocus = async () => {
		const response = await this.webapi.currency({entity:{isEnable:true}})
        this.metaAction.sf('data.other.currencyList', fromJS(response.list))
    }

	//数量管理
	numberAdminClick = () => {
		this.BussClick('unit', '计量单位')
	}

	//外币核算管理
	adjustAdminClick = () => {
		this.BussClick('currency','币种')
	}

	BussClick = async(name, title) => {
		const ret = await this.metaAction.modal('show', {
			title: title,
			width: 840,
			style:{ top: 40},
			bodyStyle: {height: 500, paddingTop: 0},
			footer: '',
            className: 'app-proof-of-charge-modal',
			children: this.metaAction.loadApp(`app-list-${name}?from=subjects`, {
				store: this.component.props.store,
				modelStatus: 1
			}),
		})

		let newData = this.metaAction.gf('data').toJS()
		if(name == 'currency'){
			const currencyList = await this.webapi.currency({entity:{isEnable:true}})
			let currencyId = newData.form.currencyId, data = []
			newData.other.currencyList = currencyList.list
			data = currencyList.list.filter((o)=>o.id == currencyId)
			if(currencyList.list.length == 0){
				newData.form.currencyId = undefined
			}else if(data.length == 0){
				newData.form.currencyId = newData.other.currencyList[0].id
			}
		}else{
			const unitList = await this.webapi.queryunit()
			let unitId = newData.form.unitId, data = []
			newData.other.unitList = unitList.list
			data = unitList.list.filter((o)=>o.id == unitId)
			if(unitList.list.length == 0){
				newData.form.unitId = undefined
			}else if(data.length == 0){
				newData.form.unitId = newData.other.unitList[0].id
			}
		}
		this.injections.reduce('load', newData)


	}

	//新建确认按钮
	onOk = async () => {
		return await this.save()
	}

	save = async () => {
		const other = this.metaAction.gf('data.other').toJS()
		let form = this.metaAction.gf('data.form').toJS(),
			{isCalcQuantity, isCalcMulti, unitId, currencyId, isCalc} = form,
			{unitList, currencyList, oldSubject, isUsed, calcDict, active} = other,
			result = {}

		//数量或者外币有选中值时改变对应name值
		if(isCalcQuantity && unitId){
			let item = unitList.filter(o => o && o.id == unitId)
				form.unitName = item[0].name
		}
		if(isCalcMulti && currencyId){
			let item = currencyList.filter(o => o && o.id == currencyId)
				form.currencyName = item[0].name
		}

		let pathList = [{
			path: 'data.form.name', value: form.name
		},{
			path: 'data.form.code', value: form.code
		}]
		if(other.isDisplayBankAccountAux){
			form.bankCode = form.bankCode.trim()
			form.bankName = form.bankName.trim()
			pathList = pathList.concat([{
				path: 'data.form.bankCode', value: form.bankCode
			},{
				path: 'data.form.bankName', value: form.bankName
			}])
		}

		const ok = await this.voucherAction.check(pathList, this.check)
		let checkCalc = undefined
		let checkStyle = { textAlign: 'left', display: 'inline-block', verticalAlign: 'top' }
		if(form.isCalc){
			let isCalcList = Object.keys(calcDict),
				select = isCalcList.filter((i)=>{
					if(form[i])
						return i
				})
			checkCalc =  await this.checkCalc(select)
		}
		if(!ok && checkCalc == undefined) {
			this.metaAction.toast('warning',
                <div style={checkStyle}>
					<p style={{ marginBottom: '0' }}>请按页面提示信息修改信息后才可提交</p>
                </div>
            )
			return false
		}else if(checkCalc != undefined){
			this.metaAction.toast('warning',
                <div style={checkStyle}>
                    {checkCalc ? <p style={{ marginBottom: '0' }}>{checkCalc}</p> : null}
                </div>
            )
			return false
		}else if(isCalcQuantity && !unitId){
			this.metaAction.toast('warning',
                <div style={checkStyle}>
                    <p style={{ marginBottom: '0' }}>请选择计量单位</p>
                </div>
            )
			return false
		}else if(isCalcMulti && !currencyId){
			this.metaAction.toast('warning',
                <div style={checkStyle}>
                    <p style={{ marginBottom: '0' }}>请选择默认币种</p>
                </div>
            )
			return false
		}
		
		form.name = form.name.trim()
		form.code = form.code.trim()
		if(active === 'certificate' || active === 'add'){
			delete form.ts
			delete form.orgId
			delete form.exchangeRate
			delete form.AuxAccCalcInfo
			delete form.helpCode
			delete form.gradeName
			delete form.id
			delete form.codeAndName
		}

		if(!form.isCalcMulti){
			form.currencyId = null
		}
		if(!form.isCalcQuantity){
			form.unitId = null
		}

		//判断辅助核算是否开启
		if (oldSubject.isCalc != form.isCalc && form.isCalc == false) {
			let isCalcList = Object.keys(calcDict)
			for(let i in isCalcList){
				form[isCalcList[i]] = false
			}
		}
		else if(isUsed){
			if(active === 'edit'){
				let isCalcList = Object.keys(calcDict),
				newCalc = []
				if(!form.isCalc){
					let isCalcList = Object.keys(calcDict)
					for(let i in isCalcList){
						form[isCalcList[i]] = false
					}
				}else{
					for(let i in isCalcList){
						if(oldSubject[isCalcList[i]] != form[isCalcList[i]] && form[isCalcList[i]]){
							newCalc.push(isCalcList[i])
						}
					}
				}

				//已使用新增辅助核算
				if(newCalc.length != 0 && form.isEndNode){
					result.auxAccMap = {}
					const auxAccMap = await this.metaAction.modal('show', {
						title: '档案明细选择',
						width: 400,
						// footer: null,
						bodyStyle:{padding: 16, fontSize: 12},
						style:{ top: 40},
						// closable: false,
						children: this.metaAction.loadApp('ttk-table-app-tab-list-accounting', {
							store: this.component.props.store,
							calcDict: calcDict,
							newCalc: newCalc
						})
					})
					if(auxAccMap){
						result.auxAccMap = auxAccMap
						// this.updateSubject()
					}
					// this.BussClick('currency')
				}
			}

		}
		if(oldSubject.isEndNode && other.active !== 'edit' && isUsed){
			const ret = await this.metaAction.modal('confirm', {
				title: '新增',
				content: '新增下级，历史数据将会结转至新增的下级。此操作不能恢复，是否继续？'
			})
			if(!ret){
				return false
			}
		}
		result.form = form
		if(!form.isCalc){
			let isCalcList = Object.keys(calcDict)
			for(let i in isCalcList){
				form[isCalcList[i]] = false
			}
		}
		if(active === 'edit'){
			// if(!form.isEndNode){
			// 	//传1表示只更新自己的辅助核算，传0表示同时更新所有下级辅助核算
			// 	const isUpdateSelf = await this.metaAction.modal('confirm', {
			// 		title: '',
			// 		content: '是否将所有的下级，全部进行同样的设置？',
			// 		okText: '是',
			// 		cancelText: '否'
			// 	})
			// 	result.isUpdateSelf = isUpdateSelf ? 0 : 1
			// }
			let code = oldSubject.code.length > 4 ?
						oldSubject.code.slice(0,oldSubject.code.length-2) + form.code
						: oldSubject.code
						// ,isUpdateSelf = result.hasOwnProperty('isUpdateSelf') ? result.isUpdateSelf : 1
			form.code = code

			let option = {'glAccountDto': form, "purpose": 1, "isUpdateSelf": 1}
			if(result.hasOwnProperty('auxAccMap') && Object.keys(result.auxAccMap).length != 0){
				option.auxAccMap = result.auxAccMap
			}
			if(result.hasOwnProperty('auxAccMap') && Object.keys(result.auxAccMap).length == 0){
				return false
			}
			const response = await this.webapi.update(option)
			if(response){
				if(!!response.errMsgs && !!response.errMsgs[0]){
					const ret = await this.metaAction.modal('confirm', {
						title: '新增',
						content: getErrMSg(response.errMsgs)
					})
				}
				this.metaAction.toast('success', '更新成功！')
				response.isUpdateSelf = option.isUpdateSelf
				return response
			}
		}else if(active === 'add'){
			let {code, accountTypeId, grade, id, cashTypeId} = oldSubject
            form.code = code + form.code
            form.accountTypeId = accountTypeId
            form.grade = grade + 1
            form.cashTypeId = cashTypeId
            form.parentId = id
            if(!form.isCalcMulti){
                form.currencyId = null
            }
            if(!form.isCalcQuantity){
                form.unitId = null
			}
            const response = await this.webapi.add(form)
            if (response) {
				this.metaAction.toast('success', '新增成功！')
                return response
			}
		}else{
			const response = await this.webapi.add(form)
			if(response){
				this.metaAction.toast('success', '新增成功！')
				return response
			}
		}

		return false
	}

	//必填项校验
	check = async (fieldPathAndValues) => {
		if (!fieldPathAndValues)
			return

		let r = { ...fieldPathAndValues }
		if (fieldPathAndValues.path === 'data.form.name') {
			Object.assign(r, await this.checkName(fieldPathAndValues.value))
		}
		// else if (fieldPathAndValues.path === 'data.form.superiorSubject') {
		// 	Object.assign(r, await this.checkSuperior(fieldPathAndValues.value))
		// }
		else if (fieldPathAndValues.path === 'data.form.code') {
			Object.assign(r, await this.checkCode(fieldPathAndValues.value))
		}
		else if (fieldPathAndValues.path === 'data.form.bankCode') {
			Object.assign(r, await this.checkBankCode(fieldPathAndValues.value))
		}
		else if (fieldPathAndValues.path === 'data.form.bankName') {
			Object.assign(r, await this.checkBankName(fieldPathAndValues.value))
		}

		return r
	}

	checkName = async (name) => {
		let message

		if (!name || !name.trim()){
			message = '请录入名称'
		}else if(name.length > 50){
			message = '名称长度不能超过50'
		}
			
		return { errorPath: 'data.other.error.name', message }
	}

	checkCalc = async (select) => {
		let message

		if (select.length == 0)
			message = '请选择辅助核算'
		return message
	}

	checkBankCode = async (name) => {
		let message

		if (!name || !name.trim()){
			message = '请录入账号'
		}else if(name.length > 50){
			message = '银行账号长度不能超过50'
		}
			
		return { errorPath: 'data.other.error.bankCode', message }
	}

	checkBankName = async (name) => {
		let message

		if (!name || !name.trim()){
			message = '请录入开户银行'
		}else if(name.length > 50){
			message = '银行名称长度不能超过50'
		}
		
		return { errorPath: 'data.other.error.bankName', message }
	}

	checkCode = async (code, active) => {
		let message,
			regex = /^[A-Za-z0-9]+$/
		if (!code || !code.trim()){
			if(this.component.props.active === 'certificate'){
				message = '请选择上级'
			}else{
				message = '请输入编码'
			}
		}
		else if (!regex.test(code))
			message = '请输入字母或数字'
		else if (code.length == 1)
			message = '编码结构错误'
		return { errorPath: 'data.other.error.code', message }
	}

	// //能否变红，需要单独调用弹窗提醒？
	// checkSuperior = async (superior) => {
	// 	var message

	// 	if (!superior)
	// 		message = '请选择上级！'

	// 	return { errorPath: 'data.other.error.superiorSubject', message }
	// }

	fieldChange = (path, value) => {
        this.voucherAction.fieldChange(path, value, this.check)
    }
}

export default function creator(option) {
    const metaAction = new MetaAction(option),
        voucherAction = FormDecorator.actionCreator({...option, metaAction}),
        o = new action({...option, metaAction, voucherAction}),
        ret = {...metaAction, ...voucherAction, ...o}

    metaAction.config({metaHandlers: ret})

    return ret
}

//生成新的编码
function generateNewSubCode(parentId, parentCode, subjectList){
    let newCode,
    newSubjectList = subjectList.filter(subItem => {
        return parseInt(subItem.parentId) == parseInt(parentId)
    })

    if(newSubjectList.length == 0){
        newCode = '01'
    }else {
        let endGradeList = []
        for (var i = 0; i < newSubjectList.length; i++) {
            let code = newSubjectList[i].code
            endGradeList.push(code.substring(code.length - 2))
        }

        endGradeList = endGradeList.sort(sortNumber)

        let maxCode = endGradeList[endGradeList.length - 1]
        if(maxCode == '99' && endGradeList.length < 98){
            maxCode = endGradeList[endGradeList.length - 2]
            if(!isNaN(maxCode)){
                newCode = '00' + (parseInt(maxCode)+1).toString()
                newCode = newCode.substring(newCode.length - 2)
            }else{
                newCode = '00'
            }
        }else if(maxCode != '99' && !isNaN(maxCode)){
            newCode = '00' + (parseInt(maxCode)+1).toString()
            newCode = newCode.substring(newCode.length - 2)
        }else{
            newCode = '00'
        }
    }

    return newCode
}

function sortNumber(a,b)
{
    return a - b
}

//显示提醒信息
function getErrMSg(errMsgs) {
    return <div>
        {
            errMsgs.map(o => {
                return <div style={{lineHeight:'20px',padding:'10px 0 0'}}>{o}</div>
            })
        }
    </div>
}

//获取字符串长度
function getBLen(str) {
	if (str == null) return 0;
	if (typeof str != "string"){
	  str += "";
	}
	return str.replace(/[^\x00-\xff]/g,"01").length;
  }
