import React from 'react'
import { action as MetaAction, AppLoader } from 'edf-meta-engine'
import { List, fromJS } from 'immutable'
import moment from 'moment'
import config from './config'
import { consts } from 'edf-consts'
import { LoadingMask,FormDecorator ,Icon, Input,Select} from 'edf-component'

class action {
    constructor(option) {
        this.metaAction = option.metaAction
        this.voucherAction = option.voucherAction
        this.config = config.current
        this.webapi = this.config.webapi
    }

    onInit = ({ component, injections }) => {
        this.voucherAction.onInit({ component, injections })
        this.component = component
        this.injections = injections
        injections.reduce('init', {
            isPop: this.component.props.isPop
		})  
		if (this.component.props.setOkListener) {
			this.component.props.setOkListener(this.onOk)
		}
        this.load()
    }
    load = async (option) => {
		let subjects = await this.webapi.widthdrawing.getAccountListForSupertaxSet(),
		queryData = await this.webapi.widthdrawing.query(),
		isAccountedMonth = this.component.props.initData.isAccountedMonth,
		initData = {}
		initData.subjects = subjects
		initData.queryData = queryData
		initData.isAccountedMonth = isAccountedMonth
        this.injections.reduce('load', initData)
    }
    mouseEnter = (record) => {
		return {
			className: 'mouseRow'
		}
    }
    filterOption = (inputValue, option) => {
		if (option && option.props && option.props.value) {
			let accountingSubjects = this.metaAction.gf('data.accountingSubjects')
			let itemData = accountingSubjects.find(o => o.get('id') == option.props.value)
	
			if ((itemData.get('code') && itemData.get('code').indexOf(inputValue) == 0)
				|| (itemData.get('gradeName') && itemData.get('gradeName').indexOf(inputValue) != -1)
				|| (itemData.get('codeAndName') && itemData.get('codeAndName').indexOf(inputValue) == 0)
				|| (itemData.get('helpCode') && itemData.get('helpCode').toUpperCase().indexOf(inputValue.toUpperCase()) != -1)
				|| (itemData.get('helpCodeFull') && itemData.get('helpCodeFull').indexOf(inputValue) != -1)) {
	
				//将滚动条置顶
				// let select = document.getElementsByClassName('ant-select-dropdown-menu')
				// if (select.length > 0 && select[0].scrollTop > 0) {
				// 	select[0].scrollTop = 0
				// }
	
				return true
			}
			else {
				return false
			}
		}
	
		return true
	}
    handleSelectChange = async (value, columnName, index, dataSource,record) => {
		let list = this.metaAction.gf('data.list'),
		newList = this.metaAction.gf('data.list').toJS(), 
		arr = {},
		arrList,
		sumProportion = 0
		
		if(columnName == 'accountId'){//科目
			newList.map((item, index) => {
				if(item.accountId == value){
					sumProportion+=Number(item.proportion)
				}
				return sumProportion
			})
			console.log(list.get(index))
			if(list.get(index).get('isEditProportion')==true ){//如果先输入比例
				if(list.get(index).get('proportion') <= 100-sumProportion){
					list = list.update(index, item => item.set(columnName, value))
					// list = list.update(index, item => item.set('proportion', list.get(index).get('proportion')))					
				}else{	
					this.metaAction.toast('warning', '此科目累计比例超过100%')
				}
				list = list.update(index, item => item.set(columnName, value))
			}else{//没有先输入比例
				
				list = list.update(index, item => item.set(columnName, value))
				list = list.update(index, item => item.set('proportion', 100-sumProportion))				
			}
		}
		if(columnName == 'summary'){//摘要
			list = list.update(index, item => item.set(columnName, value))
			
		}
		this.metaAction.sf('data.list', fromJS(list))
    }
    	    //点击确定按钮
	onOk = async () => {
		return await this.save()
	}
	getDisplayErrorMSg = (msg) => {
		return <div style={{display: 'inline-table'}}>{msg.map(item => <div>{item}<br/></div>)}</div>
	}
	save = async () => {
		let list = this.metaAction.gf('data.list').toJS(),
		calcMode = this.metaAction.gf('data.calcMode'),
		data,arr = [],params = {},
		msgList = []//错误数据
		params.dtos = list
		params.calcMode = calcMode
		//保存校验
		list.map((item, index) => {
			if(!item.summary){
				msgList.push(`摘要不能为空`)
			}
			if(!item.accountId){
				msgList.push(`科目不能为空`)
			}
			
			if(item.proportion==undefined){
				msgList.push(`比例不能为空`)
			}
		})
		let newMsgList = []
		for(let i = 0;i < msgList.length;i++){
			if(newMsgList.indexOf(msgList[i]) == -1){
				newMsgList.push(msgList[i])
			}
		}

		if (newMsgList.length > 0) {
			this.metaAction.toast('error', this.getDisplayErrorMSg(newMsgList))
			return false
		}
		console.log(params)
		data = await this.webapi.widthdrawing.update(params)
		
		if(data){		
			this.metaAction.toast('success', '保存成功')
		}else{
			// this.metaAction.toast('warning', data.error.message)
			return false
		}
    }
    addRow = (type, record) => {
		let list = this.metaAction.gf('data.list').toJS(),arr
		
		if( type == 'row' ) {
			arr = list.find((item) => {
				return item.summaryNum==record.summaryNum&&item.summary
			})
			let lastIndex = list.findIndex((item, index) => {
				if( item.summaryNum == record.summaryNum && (!list[index+1] || list[index+1].summaryNum != record.summaryNum) ) {
					return true
				}else{
					return false
				}
			})
			let count = 0
			list.map((o,i) => {
				if(list[i+1]){
					if(o.summaryNum == record.summaryNum &&o.summaryNum == list[i+1].summaryNum){
						count++
					}
				}
				
			})
			list.splice(lastIndex+1, 0, 
				{
					// index: list[lastIndex].summaryNum ,
					summaryNum: arr?arr.summaryNum:list[lastIndex].summaryNum,
					summary: '',
					// debitAccountId: arr?arr.debitAccountId:'',
					// creditAccountIdNum: count+2,
					accountId:'',
					proportion:'100',
					// isEditProportion: false
				}
			)
        }
        else{
			
			// list.push({summaryNum: list[list.length-1].summaryNum+1,summary: '',debitAccountId:'',creditAccountIdNum:1,creditAccountId:'',proportion:'100', isEditProportion: false})
		}
		// list = this.sort(list)
		this.metaAction.sf('data.list', fromJS(list))
    }
    delRow = (type , record, index, disabledDelIcon) => {
		if(disabledDelIcon){
			return
		}
		let list = this.metaAction.gf('data.list').toJS()
		// if(type == 'totalRow'){
			list.splice(index,1)
			
		// }else{			
		// 	let delItem = list.findIndex((item,index) => {
		// 		return item == record
		// 	})
		// 	list.splice(index,1)
		// }
		// let sortList = this.sort(list)
		this.metaAction.sf('data.list', fromJS(list))
    }
    sort = () => {

    }
    // sort = (list) => {//断号排序
		
	// 	const arr = []
	// 	let num = 1
	// 	let childNum = 1
	// 	list.forEach((item, index) => {
	// 		if( index == 0 ) {
	// 			arr.push({
	// 				...item,
	// 				summaryNum: num,
	// 				// creditAccountIdNum: num
	// 			})
	// 			num++
	// 			return 
	// 		}else {
	// 			if( list[index - 1].summaryNum == list[index].summaryNum  ) {
	// 				childNum++
	// 				arr.push({
	// 					...item,
	// 					summaryNum: list[index-1].summaryNum,
	// 					// creditAccountIdNum: childNum
	// 				})
	// 			}else{
	// 				childNum = 1
	// 				arr.push({
	// 					...item,
	// 					summaryNum: num,
	// 					// creditAccountIdNum: childNum
	// 				})
	// 				num++
	// 			}
	// 		}
			
	// 	})
	// 	return arr
		
    // }
    handleBlur = async (value, columnName, index, record) => {
		let list = this.metaAction.gf('data.list'),
		newList = this.metaAction.gf('data.list').toJS(),
		accountId = list.get(index).get('accountId'),
		usedProportion = 0//除此行外相同贷方科目已经使用过的比例数量
		this.customAttribute = Math.random()
		if(accountId){
			// let getProportion = await this.webapi.query.getProportion({creditAccountId: list.get(index).get('accountId'),templateId: templateId})						
			newList.splice(index,1)
			let arr = newList.filter((item ,i)=> {
				return item.accountId == list.get(index).get('accountId')
			})
			arr.map((item,index) => {
				usedProportion += Number(item.proportion)
			})
			if(Number(value) + usedProportion > 100){	
				list = list.update(index, item => item.set(columnName, 0))
				this.metaAction.sf('data.list', fromJS(list))
				this.metaAction.toast('warning', '此科目累计比例超过100%')
				return
			}
		}else{
			if(value>100){
				list = list.update(index, item => item.set(columnName, 0))
				this.metaAction.sf('data.list', fromJS(list))
				this.metaAction.toast('warning', '此科目累计比例超过100%')
				return
			}
		}
		list = list.update(index, item => item.set('isEditProportion', true))			
		list = list.update(index, item => item.set(columnName, value))
		this.metaAction.sf('data.list', fromJS(list))
	}
	setField = async (path, value) => {
		console.log(value)
		this.metaAction.sf(path,value)
	}
    renderCell = (columnName, index, value, record) => {
		let dataSource = this.metaAction.gf('data.subjects') && this.metaAction.gf('data.subjects').toJS(),
		disabledDelIcon = this.metaAction.gf('data.list').size==1?true:false,
		isAccountedMonth = this.metaAction.gf('data.isAccountedMonth')
		console.log(isAccountedMonth)
		if(columnName == 'summaryNum'){
			return (
				<div className="summary">
					<div className="num">{index+1}</div>
					<div className="addAndMinus">
						<Icon fontFamily="edficon" type ="xinzengkemu" className="addIcon" onClick={() => this.addRow('row',record)}/>
						<Icon fontFamily="edficon" type ="xinzengkemu-jian" className="delIcon" onClick={() => this.delRow('row', record,index,disabledDelIcon)} disabled={disabledDelIcon}/>
					</div>
				</div>
			)
        }else if(columnName=='summary'){
            return (
                <Input title = {value} disabled={isAccountedMonth} className ='summaryInput' value = {value} onChange = {(e) => this.handleSelectChange(e.target.value, columnName, index, dataSource)}/>                
            )
        }else if(columnName == 'accountId'){//科目
			return (
				<ExtendEditableSelectCell
				onChange={(value) => this.handleSelectChange(value, columnName, index, dataSource,record)}
				dataSource={dataSource}
				value={value}
				disabled={isAccountedMonth}
				columnName={columnName}
				// handleFocus={this.handleFocus}
				filterOption = {(inputValue,option)=>this.filterOption(inputValue,option)}
				/* handleFoucus={() => this.handlerFoucus(columnName, index)} */
				/>
			)
		}else
		if(columnName == 'proportion'){//bili
			return (
					
				<EditableCell
					value={value}
					disabled={isAccountedMonth}
					// customAttribute = {this.customAttribute}
					onBlur={(value) => this.handleBlur(value, columnName, index, record)}
					onEnter={(e) => this.handleEnter()}
				/>
			)
		}
	}
}

class EditableCell extends React.Component{
	constructor(props) {
		super(props)
		this.state = {
			value: props.value
		}
	}

	handleChange = (value) => {
		if( value > 100 ){
			value = 100
		}
		this.setState({
			value: value
		})
	}

	handleBlur = (e) => {
		const { onBlur} = this.props
		const { value } = this.state
		onBlur(value ? value : 0)
	}
	
	componentWillReceiveProps(nextProps) {
		this.setState({
			value: nextProps.value
		})
	}

	render () {
		const { onBlur, onEnter ,customAttribute, disabled} = this.props
		const value = this.state.value
		return (
			<div className="td_input_antNumber">
				<Input.AntNumber
					onChange= {this.handleChange}
					value={value}
					onBlur={this.handleBlur}
					onPressEnter={(e) => onEnter(e)} 
					style={{'textAlign':'right',fontSize:'12px'}}
					disabled={disabled}
					// customAttribute = {customAttribute}
					// regex='^([0-9]+)(?:\.[0-9]{1,2})?$'
					min={0}
					max={100}
					formatter={value => `${value}%`}
					parser={value => value.replace('%', '')}
				/>
			</div>
		)
	}
}
const ExtendEditableSelectCell = ({ dataSource,filterOption, onChange,value, columnName, onClick, saveNewVlue, handleFocus,disabled}) => {
	let productChildren = [] 
	if (dataSource) {
	  dataSource.forEach((item,index) => {
		productChildren.push(<Option key={item.id} title={item.codeAndName} _data={item} value={item.id}>{item.codeAndName}</Option>)
	  })
	  return (
		<div style={{width: '100%'}}>
		  <Select style={{ width: '100%' }}
			  onSelect={(value) => onChange(value)}
			  value={ value }
			  disabled = {disabled}
			//   filterOptionExpressions="code,name,helpCode,helpCodeFull"
			  dropdownClassName={'widthdrawing-select'}
			  filterOption={filterOption}
			   onFocus={handleFocus}>
			{productChildren}
		  </Select>
		</div>
	  )
	}
	else{
		return (
			<div style={{width: '100%'}}>
			<Select style={{ width: '100%' }}
				onSelect={(value) => onChange(value)}
				value={ '' }
				disabled = {disabled}
				filterOption={(input, option) => filterOption(input, option)}
				// filterOptionExpressions="code,name,helpCode,helpCodeFull"
				dropdownClassName={'cashflowstatementDistributionSelect'}
				// filterOption={(input, option) => option.props.children.toLowerCase().indexOf(input.toLowerCase()) >= 0}
				 onFocus={handleFocus}>
				 <Option value={''}>{''}</Option>
			</Select>
		  </div>
		)
	}
	
  }
export default function creator(option) {
    const metaAction = new MetaAction(option),
        voucherAction = FormDecorator.actionCreator({ ...option, metaAction }),
        o = new action({ ...option, metaAction, voucherAction }),
        ret = { ...metaAction, ...voucherAction, ...o }
    metaAction.config({ metaHandlers: ret })
    return ret
}



