import {consts} from 'edf-consts'
export function getMeta() {
    return {
        name: 'root',
        component: 'Layout',
        className: 'ttk-gl-app-withdrawing',       
        children: [
            {
                name:'mode',
                component:'Form.Item',
                className:'ttk-gl-app-withdrawing-mode',
                label: '计提规则',
                required: true,
                children: [{
                    name: 'setting',
                    component: 'Radio.Group',
                    // options: '{{data.other.setting}}',
                    value: '{{data.calcMode}}',
                    children: [{
                        name: 'borrow',
                        component: 'Radio',
                        value: 1,
                        children: '按月计提'
                    }, {
                        name: 'loan',
                        component: 'Radio',
                        value: 2,
                        children: '按季计提'
                    }],
                    onChange: `{{function(v){$setField('data.calcMode',v.target.value)}}}`,
                }]
            },
            {
                name: 'span',
                component: 'Table',
                pagination: false,
                className: 'ttk-gl-app-withdrawing-body',
                loading: '{{data.other.loading}}',
                allowColResize: false,
                enableSequenceColumn: false,
                bordered: true,
                noDelCheckbox: true,
                scroll:'{{data.list.length > 6 ? data.tableOption : {} }}',
                columns: [{
                    title:'摘要',
                    colSpan: 2,
                    // rowSpan: 0,
                    dataIndex: 'summaryNum',
                    key:'summaryNum',
                    width:'3%',
                    render: "{{function(text, record, index){return $renderCell('summaryNum', index, text, record)} }}"
                },
                {
                    title: '摘要',
                    colSpan: 0,
                    dataIndex: 'summary',
                    width:'28%',
                    key: 'summary',
                    render: "{{function(text, record, index){return $renderCell('summary', index, text, record)} }}"
                },
                {
                    title: '科目',
                    // colSpan: 0,
                    dataIndex: 'accountId',
                    width:'28%',
                    key: 'accountId',
                    render: "{{function(text, record, index){return $renderCell('accountId', index, text, record)} }}"												
                },
                {
                    title: '比例',
                    // colSpan: 0,
                    dataIndex: 'proportion',
                    width:'10%',
                    key: 'proportion',
                    render: "{{function(text, record, index){return $renderCell('proportion', index, text, record)} }}"																
                }
            ],
                // columns: '{{$tableColumns()}}',
                dataSource: '{{data.list}}',
                onRow: '{{function(record){return $mouseEnter(record)}}}'
            }
        ]
    }
}

export function getInitState() {
    return {
        data: {
            calcMode:1,
            list:[{summaryNum:'',summary:'',accountId:'',proportion:''}],
            other:{
                loading: false
            }
        }
    }
}