import moment from 'moment'
export function getMeta() {
	return {
		name: 'root',
		component: 'Layout',
		className: 'app-auxdetailaccount-rpt',
		children: [{
			name: 'accountQuery',
			title: 'accountQuery',
			className: 'app-auxdetailaccount-rpt-accountQuery',
			component: 'SearchCard',
			refName: 'accountQuery',
			searchClick: '{{function(value, option){$searchValueChange(value, option, null)}}}',
			onChange: '{{function(value){$searchValueChange(value, null, null)}}}',
			refreshBtn: {
				name: 'refreshBtn',
				component: 'Icon',
				fontFamily: 'edficon',
				type: 'shuaxin',
				className: 'mk-normalsearch-reload',
				onClick: '{{$refreshBtnClick}}',
				title:'刷新'
			},
			confirmBtn:{
				hidden: false,
				text: '查询'
			},
			cancelBtn: {
				hidden: false,
				text: '取消'
			},
			clearBtn: {
				hidden: true,
				text: ''
			},
			menuBtn:[{
				name: 'newAdd',
				component: 'Checkbox',
				style: '{{$checkBoxisShow("multi")}}',
				checked: '{{data.showOption.currency}}',
				onChange: '{{function(e){$showOptionsChange("currency", e.target.checked)}}}',
				children: '外币'
			},{
				name: '审核',
				component: 'Checkbox',
				children: '数量',
				style: '{{$checkBoxisShow("quantity")}}',
				checked: '{{data.showOption.num}}',
				onChange: '{{function(e){$showOptionsChange("num", e.target.checked)}}}'
			},{
				name: 'common',
				component: 'Dropdown',
				overlay: {
					name: 'menu',
					component: 'Menu',
					onClick: '{{$shareClick}}',
					children: [{
						name: 'weixinShare',
						component: 'Menu.Item',
						key: 'weixinShare',
						children: '微信/QQ'
					}, {
						name: 'mailShare',
						component: 'Menu.Item',
						key: 'mailShare',
						children: '邮件分享'
					}]
				},
				children: {
					name: 'internal',
					component: 'Button',
					type: 'primary',
					children: ['分享', {
						name: 'down',
						component: 'Icon',
						type: 'down'
					}]
				}
			},
			 {
				name: 'save',
				component: 'Icon',
				fontFamily: 'edficon',
				className: 'app-auxdetailaccount-rpt-dayin',
				type: 'dayin',
				onClick: '{{$print}}',
				title: '打印'
			}, {
				name: 'share',
				component: 'Icon',
				fontFamily: 'edficon',
				className: 'app-auxdetailaccount-rpt-daochu',
				type: 'daochu',
				title: '导出',
				onClick: '{{$export}}'
			}],
			normalSearchValue: '{{$getNormalSearchValue()}}',
			normalSearcChildren: [{
				name: 'selectContianer',
				component: '::div',
				className: 'app-auxdetailaccount-rpt-normalSearch',
				children: '{{$renderActiveSearch()}}'
			},{
				name: 'selectContianer',
				component: '::div',
				className: 'app-auxdetailaccount-rpt-normalSearch',
				children: [{
					name: 'leftBtn',
					component: 'Icon',
					fontFamily: 'edficon',
          type: 'zuo',
					className: 'app-auxdetailaccount-rpt-normalSearch-leftBtn',
					onClick: '{{function(){$accountlistBtn("left")}}}'
				},{
					name: 'select',
					component: 'Select',
					className: 'app-auxdetailaccount-rpt-normalSearch-input',
					onChange: '{{function(value){$accountlistChange(value, false)}}}',
					filterOption: '{{$filterAccountOption}}',
					value: '{{data.searchValue.accountCode}}',
					children: {
						name: 'option',
						component: 'Select.Option',
						className: 'app-auxdetailaccount-rpt-account-select-item',
						title: '{{data.other.accountlist && data.other.accountlist[_lastIndex].codeAndName}}',
						value: "{{ data.other.accountlist && data.other.accountlist[_lastIndex].code }}",
						children: '{{data.other.accountlist && data.other.accountlist[_lastIndex].codeAndName }}',
						_power: 'for in data.other.accountlist'
					}
				},{
					name: 'rightBtn',
					component: 'Icon',
					fontFamily: 'edficon',
          type: 'you',
					className: 'app-auxdetailaccount-rpt-normalSearch-rightBtn',
					onClick: '{{function(){$accountlistBtn("right")}}}'
				}]
			}],
			normalSearch:[{
				name: 'date',
				type: 'DateRangeMonthPicker',
				format:"YYYY-MM",
				allowClear: false,
				startEnableDate: '{{data.other.enableddate}}',
				mode: ['month', 'month'],
				onChange: '{{$onPanelChange}}',
				value: '{{$getNormalDateValue()}}'
			}],
			moreSearch: '{{data.searchValue}}',
			moreSearchItem: [{
				name: 'date',
				range: true,
				label: '会计期间',
				centerContent: '到',
				isTime: true,
				pre:{
					name: 'date_start',
					type: 'DatePicker.MonthPicker',
					mode: ['month', 'month'],
					format: "YYYY-MM",
					allowClear: false,
					decoratorDate: '{{function(value, value2){return $disabledDate(value, value2, "pre")}}}'
				},
				next: {
					name: 'date_end',
					type: 'DatePicker.MonthPicker',
					mode: ['month', 'month'],
					format: "YYYY-MM",
					allowClear: false,
					decoratorDate: '{{function(value, value2){return $disabledDate(value, value2, "next")}}}',
				}
			},{
				name: 'assitform',
				type: 'AssistForm',
				assistFormOption: '{{data.assistForm.assistFormOption}}',
				assistFormSelectValue: '{{data.assistForm.assistFormSelectValue}}'
			}],
		}, {
			name: 'voucherItems',
			component: 'Table',
			pagination: false,
			className: 'app-auxdetailaccount-rpt-Body',
			loading: '{{data.loading}}',
			scroll:'{{data.list.length > 0 ? data.tableOption : {}}}',
			allowColResize: false,
			enableSequenceColumn: false,
			bordered: true,
			dataSource: '{{data.list}}',
			noDelCheckbox: true,
			columns: '{{$tableColumns()}}',
			onRow: '{{function(record){if(record.summary=="本月合计"||record.summary=="本年累计"){return {className: "totalRow"}}else{return {className: ""}}}}}'			
		}, {
			name: 'footer',
			className: 'app-auxdetailaccount-rpt-footer',
			component: '::div',
			children: [{
				name: 'pagination',
				component: 'Pagination',
				pageSize: '{{data.pagination.pageSize}}',
				current: '{{data.pagination.currentPage}}',
				total: '{{data.pagination.totalCount}}',
				onChange: '{{$pageChanged}}',
				onShowSizeChange: '{{$pageChanged}}'
			}]
		}]
	}
}

export function childVoucherItems() {
	return {
		name: 'childVoucherItems',
		component: 'Table',
		dataSource: '{{data.dataItems}}',
		className: 'app-auxdetailaccount-rpt-child-Body',
		columns: [{
			title: '摘要1',
			name: 'summary1',
			dataIndex: 'summary1',
			key: 'summary1'
		}, {
			title: '科目1',
			name: 'accountingSubject1',
			dataIndex: 'accountingSubject1',
			key: 'accountingSubject1'
		}, {
			title: '借方金额1',
			name: 'debitAmount1',
			dataIndex: 'debitAmount1',
			key: 'debitAmount1',
			render: "{{data.content}}"
		}, {
			title: '贷方金额1',
			name: 'creditAmount1',
			key: 'creditAmount1',
			dataIndex: 'creditAmount1',
			render: "{{data.content}}"
		}]
	}
}

export function getInitState() {
	return {
		data: {
			tableOption: {
				x: 1090,
				y: null
			},
			sort:{
				userOrderField: null,
				order: null
			},
			showOption: {
				num: false,
				currency: false
			},
			showCheckbox: {
				quantity: false,
				multi: false,
			},
			list: [],
			content: '查询条件：',
			searchValue: {
				accountCode: null,
				date_end: null,
				date_start: null,
			},
			style: '',
			pagination: {
				currentPage: 1,
				totalCount: 0,
				pageSize: 50,
				totalPage: 0
			},
			assistForm: {
				assistFormSelectValue: [],
				initOption: [],
				assistFormOption: [],
				activeValue: ''
			},
			other: {
				accountlist: [],
				currencylist: [],
				enableddate: ''
			},
			loading: true
		}
	}
}
