import moment from 'moment'
export function getMeta() {
    return {
        name: 'root',
        component: 'Layout',
        className: 'app-proof-of-collect-rpt',
        children: [{
            name: 'header',
            component: '::div',
            className: 'app-proof-of-collect-rpt-headerContent',
            children: {
                name: 'header-content',
                component: '::div',
                className: 'app-proof-of-collect-rpt-header',
                children: [{                   
                    name: 'date',
                    component: 'DatePicker.MonthPicker',
                    format: "YYYY-MM",                   
                    allowClear: false,
                    className: "mk-rangePicker",
                    onChange: "{{function(d){$sf('data.period',$momentToString(d,'YYYY-MM'),$onDatePickerChange($momentToString(d,'YYYY-MM')))}}}",
                    value: '{{$stringToMoment(data.period)}}',                  
                    disabledDate: `{{function(current){ var disabledDate = new Date(data.enableDate)
													return current && current.valueOf() < disabledDate
					}}}`                  

                }, {
                    component: 'Icon',
                    fontFamily: 'edficon',
                    type: 'shuaxin',
                    title:'刷新',
                    className: 'app-proof-of-collect-rpt-header-reload',
                    onClick: '{{$refresh}}',
                }, {
                    name: 'lblDocCount',
                    component: 'Layout',
                    className: 'app-proof-of-collect-rpt-header-label',
                    children: ['凭证数: ', {
                        name: 'label',
                        component: '::label',
                        children: '{{data.totalNum ? data.totalNum :0}}'
                    }, ' 张']
                },

                {
                    component: 'Icon',
                    fontFamily: 'edficon',
                    type: 'dayin',
                    className: 'dayin',
                    onClick: '{{$print}}',
                    title: '打印'

                }, {
                    component: 'Icon',
                    fontFamily: 'edficon',
                    className: 'daochu',
                    type: 'daochu',
                    title: '导出',
                    onClick: '{{$export}}'
                }]
            }
        }, {
            name: 'voucherItems',
            component: 'Table',
            pagination: false,
            key: '{{Math.random()}}',
            loading: '{{data.loading}}',
            className: 'app-proof-of-collect-rpt-table-tbody',            
            scroll: '{{data.list.length > 0 ? data.tableOption : {} }}',
            allowColResize: false,
            enableSequenceColumn: false,
            bordered: true,
            dataSource: '{{data.list}}',
            noDelCheckbox: true,
            columns: '{{$tableColumns()}}'
        }]
    }
}

export function childVoucherItems() {
    return {
        name: 'childVoucherItems',
        component: 'Table',
        dataSource: '{{data.dataItems}}',
        className: 'app-proof-of-list-child-Body',
        columns: [{
            title: '摘要1',
            name: 'summary1',
            dataIndex: 'summary1',
            key: 'summary1'
        }, {
            title: '科目1',
            name: 'accountingSubject1',
            dataIndex: 'accountingSubject1',
            key: 'accountingSubject1'
        }, {
            title: '借方金额1',
            name: 'debitAmount1',
            dataIndex: 'debitAmount1',
            key: 'debitAmount1',
            render: '{{data.content}}'
        }, {
            title: '贷方金额1',
            name: 'creditAmount1',
            key: 'creditAmount1',
            dataIndex: 'creditAmount1',
            render: '{{data.content}}'
        }]
    }
}

export function getInitState() {
    return {
        data: {
            tableOption: {
                x: 900,
                y: 700
            },
            period: '',
            list: [],
            changeSipmleDate: false,
            enableDate: null,
            loading: true
        }
    }
}