export function getMeta() {
	return {
		name: 'root',
		component: 'Layout',
		className: 'ttk-omp-app-list-user',
		children: [{
			name: 'root-content',
			component: 'Layout',
			className: 'ttk-omp-app-list-user-backgroundColor',
			children: [{
				name: 'header',
				component: '::div',
				className: 'ttk-omp-app-list-user-header',
				children: [{
					name: 'dataSelect1',
					component: 'DatePicker',
					allowClear: true,
					className: 'ttk-omp-app-list-user-header-left selectDate',
					onChange: '{{$dateSelect}}'
				}, {
					name: 'line',
					component: '::span',
					className: 'ttk-omp-app-list-user-header-left line',
					children: '-'
				}, {
					name: 'dataSelect1',
					component: 'DatePicker',
					allowClear: true,
					className: 'ttk-omp-app-list-user-header-left selectDate marginRight',
					onChange: '{{$dateSelect2}}'
				}, {
					name: 'select',
					component: 'Select',
					className: 'ttk-omp-app-list-user-header-left marginRight selectClear',
					placeholder: '请选择产品',
                    allowClear: true,
					onChange: `{{function(v){!!v ? $sf('data.searchValue.appId',data.appName.filter(function(data){return data.id == v})[0].id) : $sf('data.searchValue.appId','')}}}`,
					children: {
						name: 'option',
						component: 'Select.Option',
						value: "{{data.appName &&data.appName[_rowIndex].id}}",
						children: '{{data.appName && data.appName[_rowIndex].name}}',
						_power: 'for in data.appName'
					}

				}, {
					name: 'companyName',
					component: 'Input',
					className: 'ttk-omp-app-list-user-header-left input companyInput marginRight',
					placeholder: "请输入企业名称",
					value: '{{data.searchValue.orgName}}',
					onChange: `{{function(e){$sf('data.searchValue.orgName',e.target.value)}}}`,
				}, {
					name: 'tel',
					component: 'Input',
					className: 'ttk-omp-app-list-user-header-left input marginRight',
					placeholder: "请输入手机号",
					value: '{{data.searchValue.mobile}}',
					onChange: `{{function(e){$sf('data.searchValue.mobile',e.target.value)}}}`,
				}, {
					name: 'btnGroup',
					component: 'Layout',
					className: 'ttk-omp-app-list-user-header-right',
					children: [{
						name: 'add',
						component: 'Button',
						children: '搜索',
						type: 'primary',
						className: 'btn',
						onClick: '{{$search}}'
					}, {
						name: 'export',
						component: 'Button',
						onClick: '{{$export}}',
						className: 'exportIconBtn',
						children: [{
							name: 'more',
							component: 'Icon',
							fontFamily: 'edficon',
							type: 'daochu',
							title: '导出',
							style: {
								fontSize: '28px'
							},
						}]
					}]
				}]
			},
				{
					name: 'content',
					component: 'Layout',
					className: 'ttk-omp-app-list-user-content',
					children: [{
						name: 'dataGrid',
						component: 'DataGrid',
						ellipsis: true,
						headerHeight: 37,
						rowHeight: 37,
						isColumnResizing: false,
						loading: '{{data.other.loading}}',
						className: '{{$heightCount()}}',
						startSequence: '{{(data.pagination.currentPage-1)*data.pagination.pageSize + 1}}',
						rowsCount: "{{$getListRowsCount()}}",
						columns: [{
						name: 'sequence',
						component: 'DataGrid.Column',
						columnKey: 'sequence',
						width: 70,
						header: {
							name: 'header',
							component: 'DataGrid.Cell',
							children: '序号'
						},
						cell: {
							name: 'cell',
							component: "DataGrid.Cell",
							tip: true,
							value: "{{data.list[_rowIndex].sequence}}",
							_power: '({rowIndex})=>rowIndex',
						}
					}, {
							name: 'appName',
							component: 'DataGrid.Column',
							columnKey: 'appName',
							width: 120,
							flexGrow: 1,
							header: {
								name: 'header',
								component: 'DataGrid.Cell',
								children: '产品'
							},
							cell: {
								name: 'cell',
								component: "DataGrid.Cell",
								tip: true,
								className: 'mk-datagrid-cellContent-left',
								value: "{{data.list[_rowIndex].appName}}",
								_power: '({rowIndex})=>rowIndex',
							}
						}, {
							name: 'userName',
							component: 'DataGrid.Column',
							columnKey: 'userName',
							width: 137,
							flexGrow: 1,
							header: {
								name: 'header',
								component: 'DataGrid.Cell',
								children: '用户名称'
							},
							cell: {
								name: 'cell',
								component: "DataGrid.Cell",
								tip: true,
								className: 'mk-datagrid-cellContent-left',
								value: "{{data.list[_rowIndex].userName}}",
								_power: '({rowIndex})=>rowIndex',
							}
						}, {
							name: 'mobile',
							component: 'DataGrid.Column',
							columnKey: 'mobile',
							width: 120,
							flexGrow: 1,
							header: {
								name: 'header',
								component: 'DataGrid.Cell',
								children: '手机号'
							},
							cell: {
								name: 'cell',
								component: "DataGrid.Cell",
								tip: true,
								className: 'mk-datagrid-cellContent-left',
								value: "{{data.list[_rowIndex].mobile}}",
								_power: '({rowIndex})=>rowIndex',
							}
						}, {
							name: 'orgName',
							component: 'DataGrid.Column',
							columnKey: 'orgName',
							width: 377,
							flexGrow: 1,
							header: {
								name: 'header',
								component: 'DataGrid.Cell',
								children: '所属企业'
							},
							cell: {
								name: 'cell',
								component: "DataGrid.Cell",
								tip: true,
								className: 'mk-datagrid-cellContent-left',
								value: "{{data.list[_rowIndex].orgName}}",
								_power: '({rowIndex})=>rowIndex',
							}
						}, {
							name: 'lastLoginDate',
							component: 'DataGrid.Column',
							columnKey: 'lastLoginDate',
							width: 120,
							flexGrow: 1,
							header: {
								name: 'header',
								component: 'DataGrid.Cell',
								children: '最后登录日期'
							},
							cell: {
								name: 'cell',
								component: "DataGrid.Cell",
								tip: true,
								className: 'mk-datagrid-cellContent-left',
								value: "{{data.list[_rowIndex].lastLoginDate}}",
								_power: '({rowIndex})=>rowIndex',
							}
						}]
					}]
				}]
		}, {
			name: 'footer',
			component: '::div',
			className: 'ttk-omp-app-list-user-footer',
			children: [{
				name: 'pagination',
				component: 'Pagination',
				showSizeChanger: true,
				pageSize: '{{data.pagination.pageSize}}',
				current: '{{data.pagination.current}}',
				total: '{{data.pagination.total}}',
				onChange: '{{$pageChanged}}',
				onShowSizeChange: '{{$pageChanged}}',
			}]
		}]
	}
}

export function getInitState() {
	return {
		data: {
			list: [],
			searchValue: {
				endDate: null, //期间终止
				beginDate: null, //期间起始
				orgName: null, //公司名
				mobile: '', //电话
				appId: null //产品 id
			},
			pagination: {
				current: 1,
				total: 0,
				pageSize: 50
			},
			columns: []
		}
	}
}
