/**
 * webapi.js 封装app所需的所有web请求
 * 供app测试使用，app加入网站后webpai应该由网站通过config,提供给每个app
 */


import { fetch } from 'edf-utils'

let prefix = "/v1/biz/scm/pu/expense"

export default {
    expense: {
        init: (option) => fetch.post('/v1/biz/scm/pu/expense/init', option),
        previous: (code) => fetch.post('/v1/biz/scm/pu/expense/previous', code),
        next: (code) => fetch.post('/v1/biz/scm/pu/expense/next', code),
        getCalcObject: (option) => fetch.post('/v1/biz/scm/pu/expense/getCalcObject', option),
        
        create: (option) => fetch.post('/v1/biz/scm/pu/expense/create', option),
        update: (option) => fetch.post('/v1/biz/scm/pu/expense/update', option),
        del: (option) => fetch.post('/v1/biz/scm/pu/expense/delete', option),
        audit: (option) => fetch.post('/v1/biz/scm/pu/expense/audit', option),
        unaudit: (option) => fetch.post('/v1/biz/scm/pu/expense/unaudit', option),
        updateWithDetail: (option) => fetch.post('v1/edf/voucher/updateWithDetail', option),
        updateEnclosure: (option) => fetch.post('/v1/biz/scm/pu/expense/attachmentUpdate', option),
        // queryByCustomer: (option) => fetch.post('/v1/web/arrival/queryByCustomer', option),
        deleteBatch: (option) => fetch.post('/v1/biz/scm/pu/expense/deleteBatch', option),
        auditBatch: (option) => { throw '请实现批量审核功能' },//fetch.post('v1/arrival/auditBatch', option),
        reInitByUser: (option) => fetch.post('/v1/edf/voucher/reInitByUser', option),
    }
}