import moment from 'moment'
export function getMeta() {
	return {
		name: 'root',
		component: 'Layout',
		className: 'ttk-scm-app-supply-mapping',
		children: [
			{
				name: 'header',
				component: '::div',
				className: 'ttk-scm-app-supply-mapping-header',
				children: [
					{
						name: 'accountQuery',
						title: 'accountQuery',
						className: 'ttk-scm-app-supply-mapping-accountQuery',
						component: 'SearchCard',
						refName: 'accountQuery',
						searchClick: '{{function(value){$searchValueChange(value)}}}',
						cancelClick: '{{function(value){$searchCancelChange(value)}}}',
						clearClick: '{{function(value){$clearValueChange(value)}}}',
						onChange: '{{function(value){$searchValueChange(value)}}}',
						didMount: '{{function(childrenRef){$getSearchCard(childrenRef)}}}',
						refreshBtn: {
							name: 'refreshBtn',
							component: 'Icon',
							fontFamily: 'edficon',
							type: 'shuaxin',
							className: 'mk-normalsearch-reload',
							onClick: '{{$refresh}}'
						},
						className: "ttk-scm-app-supply-mapping-disposal",
						normalSearchValue: `{{$getNormalSearchValue()}}`,
						normalSearchChange: '{{$normalSearchChange}}',
						normalSearch: [
							{
								name: 'simpleCondition',
								type: 'Input.Search',
								className: 'mk-input',
								onChange: '',
								autocomplete: "off",
								placeholder: "请输入编号/名称"
							}
						],
					}]
			},
			{
				name: 'content',
				component: 'Layout',
				className: 'ttk-scm-app-supply-mapping-content',
				children: [{
					name: 'dataGrid',
					component: 'DataGrid',
					headerHeight: 37,
				//	isColumnResizing: false,
					rowHeight: 37,
					ellipsis: true,
				//	onColumnResizeEnd: '{{$onColumnResizeEnd}}',
					loading: '{{data.other.loading}}',
					rowsCount: "{{$getListRowsCount()}}",
					columns: "{{$getColumns()}}",
				}]
			},
			{
				name: 'footer',
				component: '::div',
				className: 'supply-mapping-footer',
				children: [{
					name: 'pagination',
					component: 'Pagination',
					showSizeChanger: true,
					pageSizeOptions: ['50', '100', '150', '200'],
					pageSize: '{{data.page.pageSize}}',
					current: '{{data.page.current}}',
					total: '{{data.page.total}}',
					onChange: '{{$pageChanged}}',
					onShowSizeChange: '{{$pageChanged}}'
				}]
			}
		]
	}
}

export function getInitState() {
	return {
		data: {
			list: [
				{
					code: 1,
					name: '供应商',
					tplusname: '供应商1'
				}
			],
			showTableSetting: false,
			searchValue: {
				state: 0,
				simpleCondition: ""
			},
			filter: {
				page: { pageSize: 50, currentPage: 1 }
			},
			form: {
			},
			other: {
				enabledGuide: false,
				assets: [],
				assetAddType: [],
				assetClassId: [],
				deprMethod: [],
				loading: false, //grid加载状态
				oldSearchValue: {
					state: 0
				},
				columnDto: [
					{ "orgId": 4649498176185344, "id": 40000200001, "columnId": 4683994030379008, "fieldName": "code", "caption": "编号", "idFieldType": 1000040001, "width": 200, "idAlignType": 1000050002, "colIndex": 10, "idOrderMode": 1000060001, "isFixed": false, "isVisible": true, "isMustSelect": true, "isSystem": true, "isHeader": true, "isTotalColumn": false, "isOrderMode": false, "occupyConfig": "6CH", "ts": "2018-06-05 16:18:02.0", "createTime": "2018-06-05 16:18:02", "updateTime": "2018-06-05 16:18:02" },
					{ "orgId": 4649498176185344, "id": 40000200002, "columnId": 4683994030379008, "fieldName": "name", "caption": "供应商名称", "idFieldType": 1000040001, "width": 200, "idAlignType": 1000050002, "colIndex": 20, "idOrderMode": 1000060001, "isFixed": false, "isVisible": true, "isMustSelect": true, "isSystem": true, "isHeader": true, "isTotalColumn": false, "isOrderMode": false, "occupyConfig": "10CH", "ts": "2018-06-05 16:18:02.0", "createTime": "2018-06-05 16:18:02", "updateTime": "2018-06-05 16:18:02" },
					{ "orgId": 4649498176185344, "id": 40000200003, "columnId": 4683994030379008, "fieldName": "tplusname", "caption": "T+供应商", "idFieldType": 1000040003, "width": 200, "idAlignType": 1000050002, "colIndex": 30, "idOrderMode": 1000060001, "isFixed": false, "isVisible": true, "isMustSelect": true, "isSystem": true, "isHeader": true, "isTotalColumn": false, "isOrderMode": false, "occupyConfig": "10CH", "ts": "2018-06-05 16:18:02.0", "createTime": "2018-06-05 16:18:02", "updateTime": "2018-06-05 16:18:02" },
				],
				assetState: [{
					label: '全部',
					value: 0
				}, {
					label: '草稿',
					value: 1
				}, {
					label: '正常',
					value: 2
				}, {
					label: '已处置',
					value: 3
				}],
				isColumnSolution: true,
				isCardEdit: true,
				managementConfirm: true,
				sort: {
					userOrderField: null,
					order: null
				},
			},
			page: {
				current: 1,
				total: 0,
				pageSize: 50
			},
		}
	}
}