import { Map, fromJS } from 'immutable'
import { reducer as MetaReducer } from 'edf-meta-engine'
import config from './config'
import { getInitState } from './data'

class reducer {
    constructor(option) {
        this.metaReducer = option.metaReducer
    }

    init = (state, option) => {
        let initState = getInitState()
        return this.metaReducer.init(state, initState)
    }
    load = (state, option) => {
        if(option.res.achivalRuleDto){
            // customerSet 正常显示的值， otherCustomerSet 多余的记录，需要再传给后端
            let isSet, achivalRuleDto = option.res.achivalRuleDto, otherCustomerSet
            if(option.inventoryType == 'delivery'){
                isSet = achivalRuleDto.customerSet ? true : false
                otherCustomerSet = achivalRuleDto.supplierSet ? true : false
                // state = this.metaReducer.sf(state, 'data.form.customerSet', fromJS(isSet))
                // state = this.metaReducer.sf(state, 'data.form.otherCustomerSet', fromJS(otherCustomerSet))
            }else{
                isSet = achivalRuleDto.supplierSet ? true : false
                otherCustomerSet = achivalRuleDto.customerSet ? true : false
            }
            state = this.metaReducer.sf(state, 'data.form.customerSet', fromJS(isSet))
            state = this.metaReducer.sf(state, 'data.form.otherCustomerSet', fromJS(otherCustomerSet))

            let isInven = achivalRuleDto.inventorySet ? true : false
            state = this.metaReducer.sf(state, 'data.form.inventorySet', fromJS(isInven))
            state = this.metaReducer.sf(state, 'data.form.id', fromJS(achivalRuleDto.id))
            state = this.metaReducer.sf(state, 'data.form.ts', fromJS(achivalRuleDto.ts))
        }
        if(option.res) state = this.metaReducer.sf(state, 'data.form.details', fromJS(option.res.invoiceInventoryList))
        if(option.inventory) state = this.metaReducer.sf(state, 'data.other.inventory', fromJS(option.inventory))
        return state  
    }
    upDate = (state,option) => {
        return state = this.metaReducer.sf(state, option.path, fromJS(option.value))
    }
    // upDates = (state,value) => {
    //     return state = this.metaReducer.sfs(state, {
    //         'data.other.dateHabit': fromJS(value[0]),
    //         'data.form.dateHabitId': fromJS(value[1])
    //     })
    // }
}

export default function creator(option) {
    const metaReducer = new MetaReducer(option),
        o = new reducer({ ...option, metaReducer })

    return { ...metaReducer, ...o }
}