import { Map, fromJS } from 'immutable'
import { reducer as MetaReducer } from 'edf-meta-engine'
import config from './config'
import { getInitState } from './data'

class reducer {
    constructor(option) {
        this.metaReducer = option.metaReducer
    }

    init = (state, option) => {
        let initState = getInitState();
        return this.metaReducer.init(state, initState)
    }

    load = (state, list) => {
        if(list.length) list = this.getQueryList(list)
        state = this.metaReducer.sf(state, 'data.other.tableList', fromJS(list))
        return state  
    }

    setTabs = (state, res) => {
        if(res.length){
            state = this.metaReducer.sf(state, 'data.other.incomeexpensesTabId', res[0].id+'')
        }
     //   state = this.metaReducer.sf(state, 'data.other.incomeexpensesTab', fromJS(res))
        return state  
    }

    incomeexpensesTabChange = (state, path, value, list) => {
        if(list.length) list = this.getQueryList(list)
        state = this.metaReducer.sf(state, 'data.other.tableList', fromJS(list))
        state = this.metaReducer.sf(state, path, value+'')
        return state
    }

    checkedChange = (state, option) => {
        let tableList = this.metaReducer.gf(state, 'data.other.tableList').toJS()
        tableList[option.index].isEnable = option.res.isEnable
        tableList[option.index].id = option.res.id
        tableList[option.index].ts = option.res.ts
        state = this.metaReducer.sf(state, 'data.other.tableList', fromJS(tableList))
        return state
    }

    getQueryList = (list) => {
        list.map((item) => {
            item.accountName = item.accountCode + ' ' + item.accountName
        })
        return list
    }

    update = (state, { path, value }) => {
        return this.metaReducer.sf(state, path, fromJS(value))
    }
}

export default function creator(option) {
    const metaReducer = new MetaReducer(option),
        o = new reducer({ ...option, metaReducer })

    return { ...metaReducer, ...o }
}