
export function getMeta() {
	return {
		name: 'root',
		component: '::div',
		className: 'ttk-taxapply-app-batchchargeback',
		id: 'ttk-taxapply-app-batchchargeback',
		children: [
			{
				name: 'receipt',
				component: '::div',
				className: 'title',
				children: '尊敬的纳税人，',
				_visible: '{{data.other.chargeResult}}'
			}, {
				name: 'receipt',
				component: '::div',
				className: 'title',
				children: '您本次缴款明细如下：',
				_visible: '{{data.other.chargeResult}}'
			}, {
				name: 'content',
				className: '{{data.other.listClassName}}',
				component: 'Table',
				pagination: false,
				allowColResize: false,
				enableSequenceColumn: false,
				bordered: true,
				pureText: '{{data.other.pureText}}',
				dataSource: '{{data.other.pageType == 1 ? data.paymentMethodList : data.list}}',
				rowSelection: '{{data.other.pageType == 0 ? $getRowSelection() : null}}',
				columns: '{{$getColumns(data.other.pageType)}}'
			},{
				name: 'line3',
				component: '::div',
				_visible: '{{!data.other.pageType}}',
				className: 'ttk-taxapply-app-batchchargeback-total',
				children: [{
					name: 'total1',
					component: '::span',
					children: '{{"共选择"+data.total.records+"条欠税记录。实缴金额"}}'
				}, {
					name: 'total2',
					component: '::span',
					className: 'actualFee',
					children: '{{data.total.actualFee}}'
				}, {
					name: 'total3',
					component: '::span',
					children: '元，滞纳金'
				}, {
					name: 'total4',
					component: '::span',
					className: 'lateFee',
					children: '{{data.total.lateFee}}'
				}, {
					name: 'total5',
					component: '::span',
					children: '元， 合计'
				}, {
					name: 'total6',
					component: '::span',
					className: 'totalFee',
					children: '{{data.total.totalFee}}'
				}, {
					name: 'total7',
					component: '::span',
					children: '元。'
				}]
				//children: '{{"共选择"+data.total.records+"条欠税记录。实缴金额"+(data.total.actualFee).toFixed(2)+"元，滞纳金"+(data.total.lateFee).toFixed(2)+"元， 合计"+(data.total.totalFee).toFixed(2)+"元。"}}'
			}, {
				name: 'receipt',
				component: '::div',
				className: 'title',
				children: '缴款结果如下：',
				_visible: '{{data.other.chargeResult}}'
			}, {
				name: 'chargeResult',
				className: 'ttk-taxapply-app-batchchargeback-receipt',
				component: 'Table',
				pagination: false,
				allowColResize: false,
				enableSequenceColumn: false,
				bordered: true,
				pureText: '暂无数据',
				_visible: '{{data.other.chargeResult}}',
				dataSource: '{{data.payInResult}}',
				columns: '{{$getPayInColumns()}}'
			}, {
				name: 'footer',
				component: '::div',
				className: 'ttk-taxapply-app-batchchargeback-footer',
				children: [{
					name: 'cancel',
					component: 'Button',
					_visible: '{{$isDisplayCancelBtn()}}',
					children: '取消',
					className: 'btn',
					onClick: '{{$closeClick}}'
				}, {
					name: 'pre',
					component: 'Button',
					_visible: '{{$isDisplayPreBtn()}}',
					children: '上一步',
					className: 'btn',
					onClick: '{{$getPreClick}}'
				}, {
					name: 'batchchargeback',
					component: 'Button',
					type: 'primary',
					children: '{{$getOKName()}}',
					className: 'btn',
					onClick: '{{$onOk}}'
				}]
			}
		]
	}
}

export function getInitState() {
	return {
		data: {
			form: {
			},
			total: {
				records: 0,
				actualFee: 0,
				lateFee: 0,
				totalFee: 0,
			},
			tableCheckbox: {
					selectedRowKeys: [],
					selectedRows: []
			},
			other: {
					pageType: PAGETYPE_LIST,
					chargeResult: false,
					listClassName: 'ttk-taxapply-app-batchchargeback-content-init',
					pureText: ''
			},
			list: [],
			paymentMethodList: [],
			payInResult: [
				{ yzpzmxxh: 1, dzsphm: '320180621000002010', kkfhxx: '业务处理成功', se: '800.00' }
			]
		}
	}
}

export const PAGETYPE_LIST = 0 // 缴款清单界面
export const PAGETYPE_SFXY = 1 // 三方协议界面
export const PAGETYPE_LJJK = 2 // 立即缴款界面
