import { Map, List, fromJS } from 'immutable'
import * as data from './data'
import { fetch } from 'edf-utils'
//import utils from 'edf-utils'

export function getMeta() {
	return {
		name: 'root',
		component: '::div',
		className: 'ttk-taxapply-app-declare-cancel',
		id: 'ttk-taxapply-app-declare-cancel',
		children: [{
			name: 'title',
			component: '::div',
			className: 'title',
			children: '申报情况'
		}, {
            name: 'content',
            className: '{{data.other.cancelGridStyle}}',
            component: 'Table',
            pagination: false,
            allowColResize: false,
            enableSequenceColumn: false,
            bordered: true,
            dataSource: '{{data.list}}',
            noDelCheckbox: true,
            columns: declareItemColumns
		}, {
			name: 'header',
			component: '::div',
			align: 'center',
			className: 'ttk-taxapply-app-declare-cancel-header',
			children: [{
				name: 'header-top',
				component: '::div',
				align: 'center',
				className: 'ttk-taxapply-app-declare-cancel-header-top',
				children: [{
					name: 'lblCancelReason',
					component: '::span',
					children: '作废原因',
					className: 'ttk-taxapply-app-declare-cancel-header-top-label'
				}, {
					name: 'txtCancelReason',
					component: 'Input.TextArea',
					rows: 3,
					value: '{{data.form.cancelReason}}',
					placeholder: '请输入作废原因',
					onChange: '{{function(e){$changeMaxInput(e)}}}'
				}]
			}]
		}]
	}
}

export const declareItemColumns = [
	{
		title: '序号',
		dataIndex: 'sortNo',
		width: 45,
		key: 'sortNo',
		align: 'center',
	}, {
		title: '征收项目',
		dataIndex: 'zsxmDm',
		key: 'zsxmDm',
		width: 200
	}, {
		title: '征收品目',
		dataIndex: 'zspmDm',
		key: 'zspmDm',
		width: 120
	}, {
		title: '应纳税额',
		dataIndex: 'ynse',
		key: 'ynse',
		align: 'right',
		width: 95
	}, {
		title: '所属期起',
		dataIndex: 'skssqq',
		key: 'skssqq',
		align: 'center',
		width: 95
	}, {
		title: '所属期止',
		dataIndex: 'skssqz',
		key: 'skssqz',
		align: 'center',
		width: 95
	}
]


export function getInitState() {
	return {
		data: {
			form: {
					cancelReason: '',
			},
			total: {
			},
			other: {
				cancelGridStyle: 'ttk-taxapply-app-declare-cancel-content-init',
				loginMode: [
					{id: 1, code: '001', name: '用户名密码登录'},
					{id: 2, code: '002', name: 'CA证书'}],
				province: [
					{id: 1, code: '001', name: '安徽'},
					{id: 2, code: '002', name: '北京'},
					{id: 3, code: '003', name: '天津'}],
				payTaxTime: [
					{id: 1, code: '001', name: '月'},
					{id: 2, code: '002', name: '季'},
					{id: 3, code: '003', name: '半年'},
					{id: 3, code: '003', name: '年'}],
				regulationRule: [
					{id: 1, code: '001', name: '企业会计准则（一般企业）'},
					{id: 2, code: '002', name: '小企业会计准则'},
					{id: 3, code: '003', name: '企业会计制度'}],
				isReClassify: [
					{id: 1, code: '001', name: '重分类'},
					{id: 2, code: '002', name: '不重分类'}]
			},
			list: []
		}
	}
}
