import moment from 'moment'

export function getMeta() {
	return {
		name: 'root',
		component: 'Layout',
		className: 'ttk-taxapply-app-financialtaxrpt-projectadjust',
		children: {
			name: 'mail',
			component: 'Spin',
			tip: '数据处理中...',
			spinning: '{{data.other.loading}}',
			children: [
                {
                    name: 'ttk-taxapply-app-financialtaxrpt-projectadjust-tabs',
                    component: '::div',
                    className: 'ttk-taxapply-app-financialtaxrpt-projectadjust-tabs',
                    children: [
                        {
                            name: 'ButtonList',
                            className:'ttk-taxapply-app-financialtaxrpt-projectadjust-tabs-group',
                            component: 'Radio.Group',
                            value: '{{data.form.activeTab}}',
                            onChange: `{{function(v){$rptTypeChange('data.form.activeTab',v.target.value)}}}`,
                            children: [{
                                name: 'balanceSheetRpt',
                                value: 'balancesheet',
                                component: 'Radio.Button',
                                _visible: '{{data.other.balancesheetStatus}}',
                                width: 88,
                                children: '资产负债表'
                            }, {
                                name: 'profitStatementRpt',
                                value: 'profitstatement',
                                component: 'Radio.Button',
                                _visible: '{{data.other.profitstatementStatus}}',
                                width: 88,
                                children: '利润表'
                            }, {
                                name: 'cashflowStatementRpt',
                                value: 'cashflowstatement',
                                component: 'Radio.Button',
                                _visible: '{{data.other.cashflowstatementStatus}}',
                                width: 88,
                                children: '现金流量表'
                            }]
                        }
                    ]
                },{
                    name:'ttk-taxapply-app-financialtaxrpt-projectadjust-content',
                    component: '::div',
                    className: 'ttk-taxapply-app-financialtaxrpt-projectadjust-content',
                    children: [{
                        name:'top-rpt',
                        component: '::div',
                        className: 'app-transform-top-rpt',
                        children: [{
                            name: 'topTitle',
                            component: '::div',
                            className: 'app-transform-top-title',
                            children: [{
                                name: 'change',
                                component: '::div',
                                children: '列:',
                                style: {'fontSize':'12px'}
                            },
                            {
                                name: 'app-transform-top-body',
                                className: 'app-transform-top-body',
                                component: '::div',
                                children: {
                                    pagination: false,
                                    className: 'app-account-addmultiauxitem-body',
                                    name: 'report',
                                    component: 'Table',
                                    pagination: false,
                                    //scroll: '{{ data.colums <= 1000 ? ( (data.form.activeTab =="balancesheet" ?data.balancesheetColList.length : (data.form.activeTab == "profitstatement"? data.profitstatementColList.length: data.cashflowstatementColList.length)) <= 7 ? {x:0,y:0}:{x:0,y:245}) : ((data.form.activeTab =="balancesheet" ?data.balancesheetColList.length : (data.form.activeTab == "profitstatement"? data.profitstatementColList.length: data.cashflowstatementColList.length)) <= 7 ? {x:(data.colums+50), y:0} : {x:(data.colums+50), y:245})}}',
                                    allowColResize: false,
                                    enableSequenceColumn: true,
                                    bordered: true,
                                    dataSource:'{{ data.form.activeTab =="balancesheet" ?data.balancesheetColList : (data.form.activeTab == "profitstatement"? data.profitstatementColList: data.cashflowstatementColList) }}',
                                    noCalculate: true,
                                    // loading: '{{data.other.isLoading}}',
                                    columns: [{
                                        title: '原表所在列',
                                        dataIndex: 'sourceName',
                                        key: 'sourceName',
                                        width: '400',
                                        render: "{{ function(text, record, index){return $renderCell('sourceName', index, text, 'Col')} }}"
                                    },{
                                        title: '局端报表所在列',
                                        dataIndex: 'targetame',
                                        key: 'targetame',
                                        width: '400',
                                        render: "{{function(text, record, index){return $renderCell('targetame', index, text, 'Col')} }}"
                                    }, {
                                        title: '忽略',
                                        dataIndex: 'ignore',
                                        key: 'ignore',
                                        width: '45px',
                                        render: "{{function(text, record, index){return $renderCell('ignore', index, text, 'Col')} }}"
                                    }]
                                }
                            }]
                        }]
                    },{
                        name:'bottom-rpt',
                        component: '::div',
                        className: 'app-transform-bottom-rpt',
                        children: [{
                            name: 'bottomTitle',
                            component: '::div',
                            className: 'app-transform-bottom-title',
                            children: [{
                                name: 'change',
                                component: '::div',
                                children: '{{$getTableTitle()}}',
                                style: {'fontSize':'12px'}
                            },{
                                name: 'app-transform-bottom-body',
                                className: 'app-transform-bottom-body',
                                component: '::div',
                                children: {
                                    pagination: false,
                                    className: 'app-account-addmultiauxitem-body',
                                    name: 'report',
                                    component: 'Table',
                                    pagination: false,
                                    //scroll: '{{ data.colums <= 1000 ? ((data.form.activeTab =="balancesheet" ?data.balancesheetRowList.length : (data.form.activeTab == "profitstatement"? data.profitstatementRowList.length: data.cashflowstatementRowList.length)) <= 7 ? {x:0,y:0}:{x:0,y:245}) : ((data.form.activeTab =="balancesheet" ?data.balancesheetRowList.length : (data.form.activeTab == "profitstatement"? data.profitstatementRowList.length: data.cashflowstatementRowList.length)) <= 7 ? {x:(data.colums+50), y:0} : {x:(data.colums+50), y:245})}}',
                                    allowColResize: false,
                                    enableSequenceColumn: true,
                                    bordered: true,
                                    dataSource:'{{ data.form.activeTab =="balancesheet" ?data.balancesheetRowList : (data.form.activeTab == "profitstatement"? data.profitstatementRowList: data.cashflowstatementRowList) }}',                        
                                    noCalculate: true,
                                    // loading: '{{data.other.isLoading}}',
                                    columns: [{
                                        title: '原表所在行',
                                        dataIndex: 'sourceName',
                                        key: 'sourceName',
                                        width: '400',
                                        render: "{{ function(text, record, index){return $renderCell('sourceName', index, text, 'Row')} }}"
                                    },{
                                        title: '局端报表所在行',
                                        dataIndex: 'targetame',
                                        key: 'targetame',
                                        width: '400',
                                        render: "{{function(text, record, index){return $renderCell('targetame', index, text, 'Row'  )} }}"
                                    }, {
                                        title: '忽略',
                                        dataIndex: 'ignore',
                                        key: 'ignore',
                                        width: '45px',
                                        render: "{{function(text, record, index){return $renderCell('ignore', index, text, 'Row')} }}"
                                    }]
                                }
                            }]
                        }]
                    }]
                },{
                    name:'ttk-taxapply-app-financialtaxrpt-projectadjust-care',
                    component: '::div',
                    _visible: false,
                    className: 'ttk-taxapply-app-financialtaxrpt-projectadjust-care',
                    children: '{{data.other.care}}'
                }
			]
		}
	}
}

export function getInitState() {
	return {
		data: {
            editState: false,
            balancesheetUpdate: false,//upload
            cashflowstatementUpdate: false,//upload
            profitstatementUpdate: false,//upload
            updateState: false,
            balancesheetColList:EMPTYROWARR,
            balancesheetRowList:EMPTYROWARR,
            profitstatementColList:EMPTYROWARR,
            profitstatementRowList:EMPTYROWARR,
            cashflowstatementColList:EMPTYROWARR,
            cashflowstatementRowList:EMPTYROWARR,
            balancesheetColDataSource: [],
            balancesheetRowDataSource: [],
            cashflowstatementColDataSource: [],
            cashflowstatementRowDataSource: [],
            profitstatementColDataSource: [],
            profitstatementRowDataSource: [],
			form: {
				deprMonth: '',
				quantity: 1,
				activeTab: 'balancesheet',
				buyDate: moment().format('YYYY-MM-DD'),
				changeDate: moment().format('YYYY-MM-DD'),
				isHasInit: false,
				salvageRate: 5,
			},
			systemDate: '',
			other: {
                care: '注：下方列表只显示不一致的项目。',
                balancesheetDisabled: false,//页签是否可选
                cashflowstatementDisabled: false,//true,
                profitstatementDisabled: false,
                balancesheetStatus: true,//upload
                profitstatementStatus: true,//upload
                cashflowstatementStatus: true, //upload
                balancesheetEditStatus: false,//是否已编辑
                profitstatementEditStatus: false,//是否已编辑
                cashflowstatementEditStatus: false,//是否已编辑
				error: {},
				assetProperty: [{
					id: 1,
					name: '资产负债表'
				},{
					id: 2,
					name: '利润表'
				},{
					id: 3,
					name: '现金流量表'
				}],
				ok: true,
				loading: false,
			}
		}
	}
}

const EMPTYROWARR = [{
	empty: true
},{
	empty: true
},{
	empty: true
},{
	empty: true
},{
	empty: true
},{
	empty: true
},{
	empty: true
}]


