import { Map, List, fromJS } from 'immutable'
import { reducer as MetaReducer } from 'edf-meta-engine'
import config from './config'
import moment from 'moment'
import {consts} from 'edf-consts'
import { getInitState } from './data'
import utils from 'edf-utils'

const EMPTYROWARR = [{
	empty: true
},{
	empty: true
},{
	empty: true
},{
	empty: true
},{
	empty: true
},{
	empty: true
},{
	empty: true
}]
class reducer {
    constructor(option) {
        this.metaReducer = option.metaReducer
    }

    init = (state,option) => {
		let initData = getInitState() 
		initData.data.params = option.initData.params
		initData.data.other.balancesheetStatus = option.initData.tabStatus.balancesheetStatus
		initData.data.other.profitstatementStatus = option.initData.tabStatus.profitstatementStatus
		initData.data.other.cashflowstatementStatus = option.initData.tabStatus.cashflowstatementStatus
		initData.data.other.fromPromp = option.initData.fromPromp
		initData.data.form.activeTab = option.initData.reportCode
        return this.metaReducer.init(state, initData)
    }

    load = (state, res, reportCode) => {
		res.map( item => {
			let reportCode = item.reportCode?item.reportCode.toLocaleLowerCase():''
			state = this.setTableData(state, item.needMatchHead ? item.headList:[] , reportCode, 'Col' )
			state = this.setTableData(state, item.needMatchDetail ? item.detailList:[] , reportCode, 'Row' )
			state = this.metaReducer.sf(state, `data.${reportCode}ColState`, item.needMatchHead )
			state = this.metaReducer.sf(state, `data.${reportCode}RowState`, item.needMatchDetail )
			state = this.metaReducer.sf(state, `data.${reportCode}ColDataSource`, fromJS(item.baseHeadList) )
			state = this.metaReducer.sf(state, `data.${reportCode}RowDataSource`, fromJS(item.baseDetailList) )
		})
		state = this.metaReducer.sf(state, `data.form.activeTab`, reportCode )
	    return state
	}

	setTableData(state, listData, rptType, type ) {//将要编辑的行列表数据赋值
		let list = this.getList( listData )
		state = this.metaReducer.sf(state, `data.${rptType}${type}ListLength`, fromJS(list.length))
		if(list.length<EMPTYROWARR.length) {
			list = list.concat(EMPTYROWARR.slice(list.length))
		}
		state = this.metaReducer.sf(state, `data.${rptType}${type}List`, fromJS(list))
		return state
	} 

	getList = (list) => {
		let haveNew = false
		list = list.map( item => {
			if( !item.targetame && !item.ignore ) {
				item.new = true
				haveNew = true
			}
			return item
		})
		if(haveNew) {
			document.querySelector('.tranreport-projectadjust-modal .ant-modal-footer .ant-btn-primary').disabled = false				
		}
		return list
	}
}

export default function creator(option) {
    const metaReducer = new MetaReducer(option),
        o = new reducer({ ...option, metaReducer })

    return { ...metaReducer, ...o }
}