/**
 * mock.js 提供应用截获ajax请求，为脱离后台测试使用
 * 模拟查询更改内存中mockData,并返回数据
 */

import { fetch } from 'edf-utils'

const mockData = fetch.mockData

function initMockData() {
    //摘要
    if(!mockData.summarys){
        mockData.summarys = [{
            id: 1,
            name: '提现模板'
        },{
            id: 2,
            name: '存款模板'
        }]
    }

    //科目
    if(!mockData.accountingSubjects){
        mockData.accountingSubjects = [{
            id: 1,
            code: '1001',
            name: '库存现金'
        },{
            id:2,
            code: '100201',
            name: '银行存款-银行基本户'
        }]
    }

    //凭证
    if(!mockData.proofOfCharges){
        mockData.proofOfCharges = []
        for(let i = 0; i < 117; i++){
            mockData.proofOfCharges.push({
                id: i,
                code: ((i+1) +'').padStart(4,'0'),
                date: '2017-10-24',
                attachment: 0,
                details: [{
                    id: 1,
                    summary: '卖东西',
                    accountingSubject: mockData.accountingSubjects[0],
                    debitAmount: 100.11 + i * 50
                },{
                    id: 2,
                    summary: '买东西',
                    accountingSubject: mockData.accountingSubjects[1],
                    creditAmount: 100.11 + i * 50
                }]
            })
        }
    }
}


// fetch.mock('/v1/gl/doc/init', (option) => {
//     initMockData()
//     return {
//         result: true,
//         value: {
//             certificate: (option.id || option.id == 0) ? mockData.proofOfCharges.find(o => o.id == option.id) : undefined,
//             summarys: mockData.summarys,
//             accountingSubjects: mockData.accountingSubjects
//         }
//     }
// })
//
// fetch.mock('/v1/summary/query', (option) => {
//     initMockData()
//     return {
//         result: true,
//         value: mockData.summarys
//     }
// })
//
// fetch.mock('/v1/accountingSubject/query', (option) => {
//     initMockData()
//     return {
//         result: true,
//         value: mockData.accountingSubjects
//     }
// })
//
//
// fetch.mock('/v1/gl/doc/prev', (option) => {
//     initMockData()
//     if (!mockData.proofOfCharges || mockData.proofOfCharges.length == 0) {
//         return {
//             result: false,
//             error: {
//                 message: '不存在任何单据！'
//             }
//         }
//     }
//
//     if (!(option.id || option.id == 0)) {
//         return { result: true, value: mockData.proofOfCharges[mockData.proofOfCharges.length - 1] }
//     }
//
//     const index = mockData.proofOfCharges.findIndex(o => o.id == option.id)
//
//     if (index == 0) {
//         return {
//             result: false,
//             error: {
//                 message: '已经到第一张单据！'
//             }
//         }
//     }
//
//     return { result: true, value: mockData.proofOfCharges[index - 1] }
// })
//
//
// fetch.mock('/v1/gl/doc/next', (option) => {
//     initMockData()
//
//     if (!mockData.proofOfCharges || mockData.proofOfCharges.length == 0) {
//         return {
//             result: false,
//             error: {
//                 message: '不存在任何存货！'
//             }
//         }
//     }
//
//     if (!(option.id || option.id == 0)) {
//         return { result: true, value: mockData.proofOfCharges[mockData.proofOfCharges.length - 1] }
//     }
//
//     const index = mockData.proofOfCharges.findIndex(o => o.id == option.id)
//
//     if (index == mockData.proofOfCharges.length - 1) {
//         return {
//             result: false,
//             error: {
//                 message: '已经到最后一张单据！'
//             }
//         }
//     }
//
//
//     return { result: true, value: mockData.proofOfCharges[index + 1] }
// })
//
//
// fetch.mock('/v1/gl/doc/update', (option) => {
//     initMockData()
//
//     const index = mockData.proofOfCharges.findIndex(o => o.id == option.id)
//     mockData.proofOfCharges.splice(index, 1, option)
//     return { result: true, value: option }
// })
//
// fetch.mock('/v1/gl/doc/create', (option) => {
//     initMockData()
//
//     var maxId = 0
//
//     mockData.proofOfCharges.forEach(o => {
//         maxId = maxId > o.id ? maxId : o.id
//     })
//
//     const id = maxId + 1
//     option = { ...option, id }
//
//     mockData.proofOfCharges.push(option)
//
//     return { result: true, value: option }
// })
//
// fetch.mock('/v1/gl/doc/audit', (option) => {
//     initMockData()
//
//     const order = mockData.proofOfCharges.find(o => o.id == option.id)
//     order.isAudit = true
//
//     return { result: true, value: order }
// })
//
// fetch.mock('/v1/gl/doc/del', (option) => {
//     initMockData()
//
//     const index = mockData.proofOfCharges.findIndex(o => o.id == option.id)
//     mockData.proofOfCharges.splice(index, 1)
//
//     if (!mockData.proofOfCharges || mockData.proofOfCharges.length == 0) {
//         return {
//             result: true
//         }
//     }
//
//     if (mockData.proofOfCharges.length - 1 >= index) {
//         return {
//             result: true,
//             value: mockData.proofOfCharges[index]
//         }
//     }
//     else {
//         return {
//             result: true,
//             value: mockData.proofOfCharges[mockData.proofOfCharges.length - 1]
//         }
//     }
// })

fetch.mock('/v1/gl/account/query', (option) => {
	return {"result":true,"value":{"calcDict":{"isCalcInventory":"存货","isCalcPerson":"人员","isCalcCustomer":"客户","isCalcDepartment":"部门","isCalcSupplier":"供应商","isCalcProject":"项目"},"glAccounts":[{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"现金","codeAndName":"1001 库存现金","bankId":4,"bankCode":"XJ","bankName":"现金","openingBankName":"","id":99001,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1001","name":"库存现金","gradeName":"库存现金","helpCode":"KCXJ","helpCodeFull":"kucunxianjin","balanceDirection":0,"cashTypeId":5000020001,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"银行存款","codeAndName":"100201 银行存款-基本户","bankId":1,"bankCode":"YHJBH","bankName":"银行基本户","openingBankName":"银行","id":99068,"parentId":99002,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"100201","name":"基本户","gradeName":"银行存款-基本户","helpCode":"YXCK-JBH","helpCodeFull":"yinxingcunkuan-jibenhu","balanceDirection":0,"cashTypeId":5000020003,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"其他货币资金","codeAndName":"1012 其他货币资金","id":99003,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1012","name":"其他货币资金","gradeName":"其他货币资金","helpCode":"QTHBZJ","helpCodeFull":"qitahuobizijin","balanceDirection":0,"cashTypeId":5000020002,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"110101 短期投资-股票","id":99069,"parentId":99004,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"110101","name":"股票","gradeName":"短期投资-股票","helpCode":"DQTZ-GP","helpCodeFull":"duanqitouzi-gupiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"110102 短期投资-债券","id":99070,"parentId":99004,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"110102","name":"债券","gradeName":"短期投资-债券","helpCode":"DQTZ-ZQ","helpCodeFull":"duanqitouzi-zhaiquan","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"110103 短期投资-基金","id":99071,"parentId":99004,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"110103","name":"基金","gradeName":"短期投资-基金","helpCode":"DQTZ-JJ","helpCodeFull":"duanqitouzi-jijin","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1121 应收票据","id":99005,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1121","name":"应收票据","gradeName":"应收票据","helpCode":"YSPJ","helpCodeFull":"yingshoupiaoju","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1122 应收账款","id":99006,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1122","name":"应收账款","gradeName":"应收账款","helpCode":"YSZK","helpCodeFull":"yingshouzhangkuan","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1123 预付账款","id":99007,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1123","name":"预付账款","gradeName":"预付账款","helpCode":"YFZK","helpCodeFull":"yufuzhangkuan","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1131 应收股利","id":99008,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1131","name":"应收股利","gradeName":"应收股利","helpCode":"YSGL","helpCodeFull":"yingshouguli","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1132 应收利息","id":99009,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1132","name":"应收利息","gradeName":"应收利息","helpCode":"YSLX","helpCodeFull":"yingshoulixi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1221 其他应收款","id":99010,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1221","name":"其他应收款","gradeName":"其他应收款","helpCode":"QTYSK","helpCodeFull":"qitayingshoukuan","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1401 材料采购","id":99011,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1401","name":"材料采购","gradeName":"材料采购","helpCode":"CLCG","helpCodeFull":"cailiaocaigou","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1402 在途物资","id":99012,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1402","name":"在途物资","gradeName":"在途物资","helpCode":"ZTWZ","helpCodeFull":"zaituwuzi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1403 原材料","id":99013,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1403","name":"原材料","gradeName":"原材料","helpCode":"YCL","helpCodeFull":"yuancailiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1404 材料成本差异","id":99014,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1404","name":"材料成本差异","gradeName":"材料成本差异","helpCode":"CLCBCY","helpCodeFull":"cailiaochengbenchayi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"库存商品","codeAndName":"1405 库存商品","id":99015,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1405","name":"库存商品","gradeName":"库存商品","helpCode":"KCSP","helpCodeFull":"kucunshangpin","balanceDirection":0,"cashTypeId":5000020006,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"1407 商品进销差价","id":99016,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1407","name":"商品进销差价","gradeName":"商品进销差价","helpCode":"SPJXCJ","helpCodeFull":"shangpinjinxiaochajia","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1408 委托加工物资","id":99017,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1408","name":"委托加工物资","gradeName":"委托加工物资","helpCode":"WTJGWZ","helpCodeFull":"weituojiagongwuzi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1411 周转材料","id":99018,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1411","name":"周转材料","gradeName":"周转材料","helpCode":"ZZCL","helpCodeFull":"zhouzhuancailiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1421 消耗性生物资产","id":99019,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1421","name":"消耗性生物资产","gradeName":"消耗性生物资产","helpCode":"XHXSWZC","helpCodeFull":"xiaohaoxingshengwuzichan","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1501 长期债券投资","id":99020,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1501","name":"长期债券投资","gradeName":"长期债券投资","helpCode":"CQZQTZ","helpCodeFull":"changqizhaiquantouzi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1511 长期股权投资","id":99021,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1511","name":"长期股权投资","gradeName":"长期股权投资","helpCode":"CQGQTZ","helpCodeFull":"changqiguquantouzi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"160101 固定资产-房屋建筑物","id":99072,"parentId":99022,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160101","name":"房屋建筑物","gradeName":"固定资产-房屋建筑物","helpCode":"GDZC-FWJZW","helpCodeFull":"gudingzichan-fangwujianzhuwu","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"160102 固定资产-机器设备","id":99073,"parentId":99022,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160102","name":"机器设备","gradeName":"固定资产-机器设备","helpCode":"GDZC-JQSB","helpCodeFull":"gudingzichan-jiqishebei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"160103 固定资产-工器具及家具","id":99074,"parentId":99022,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160103","name":"工器具及家具","gradeName":"固定资产-工器具及家具","helpCode":"GDZC-GQJJJJ","helpCodeFull":"gudingzichan-gongqijujijiaju","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"160104 固定资产-运输工具","id":99075,"parentId":99022,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160104","name":"运输工具","gradeName":"固定资产-运输工具","helpCode":"GDZC-YSGJ","helpCodeFull":"gudingzichan-yunshugongju","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"160105 固定资产-电子设备","id":99076,"parentId":99022,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160105","name":"电子设备","gradeName":"固定资产-电子设备","helpCode":"GDZC-DZSB","helpCodeFull":"gudingzichan-dianzishebei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"160198 固定资产-持有待售固定资产","id":99077,"parentId":99022,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160198","name":"持有待售固定资产","gradeName":"固定资产-持有待售固定资产","helpCode":"GDZC-CYDSGDZC","helpCodeFull":"gudingzichan-chiyoudaishougudingzichan","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"160201 累计折旧-房屋建筑物","id":99078,"parentId":99023,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160201","name":"房屋建筑物","gradeName":"累计折旧-房屋建筑物","helpCode":"LJZJ-FWJZW","helpCodeFull":"leijizhejiu-fangwujianzhuwu","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"160202 累计折旧-机器设备","id":99079,"parentId":99023,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160202","name":"机器设备","gradeName":"累计折旧-机器设备","helpCode":"LJZJ-JQSB","helpCodeFull":"leijizhejiu-jiqishebei","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"160203 累计折旧-工器具及家具","id":99080,"parentId":99023,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160203","name":"工器具及家具","gradeName":"累计折旧-工器具及家具","helpCode":"LJZJ-GQJJJJ","helpCodeFull":"leijizhejiu-gongqijujijiaju","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"160204 累计折旧-运输工具","id":99081,"parentId":99023,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160204","name":"运输工具","gradeName":"累计折旧-运输工具","helpCode":"LJZJ-YSGJ","helpCodeFull":"leijizhejiu-yunshugongju","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"160205 累计折旧-电子设备","id":99082,"parentId":99023,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160205","name":"电子设备","gradeName":"累计折旧-电子设备","helpCode":"LJZJ-DZSB","helpCodeFull":"leijizhejiu-dianzishebei","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"160401 在建工程-建筑工程","id":99083,"parentId":99024,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160401","name":"建筑工程","gradeName":"在建工程-建筑工程","helpCode":"ZJGC-JZGC","helpCodeFull":"zaijiangongcheng-jianzhugongcheng","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"160402 在建工程-安装工程","id":99084,"parentId":99024,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160402","name":"安装工程","gradeName":"在建工程-安装工程","helpCode":"ZJGC-AZGC","helpCodeFull":"zaijiangongcheng-anzhuanggongcheng","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"160403 在建工程-在安装设备","id":99085,"parentId":99024,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160403","name":"在安装设备","gradeName":"在建工程-在安装设备","helpCode":"ZJGC-ZAZSB","helpCodeFull":"zaijiangongcheng-zaianzhuangshebei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"160404 在建工程-待摊支出","id":99086,"parentId":99024,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160404","name":"待摊支出","gradeName":"在建工程-待摊支出","helpCode":"ZJGC-DTZC","helpCodeFull":"zaijiangongcheng-daitanzhichu","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"160501 工程物资-专用材料","id":99087,"parentId":99025,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160501","name":"专用材料","gradeName":"工程物资-专用材料","helpCode":"GCWZ-ZYCL","helpCodeFull":"gongchengwuzi-zhuanyongcailiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"160502 工程物资-专用设备","id":99088,"parentId":99025,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160502","name":"专用设备","gradeName":"工程物资-专用设备","helpCode":"GCWZ-ZYSB","helpCodeFull":"gongchengwuzi-zhuanyongshebei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"160503 工程物资-预付大型设备款","id":99089,"parentId":99025,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160503","name":"预付大型设备款","gradeName":"工程物资-预付大型设备款","helpCode":"GCWZ-YFDXSBK","helpCodeFull":"gongchengwuzi-yufudaxingshebeikuan","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"160504 工程物资-为生产准备的工具及器具","id":99090,"parentId":99025,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"160504","name":"为生产准备的工具及器具","gradeName":"工程物资-为生产准备的工具及器具","helpCode":"GCWZ-WSCZBDGJJQJ","helpCodeFull":"gongchengwuzi-weishengchanzhunbeidegongjujiqiju","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1606 固定资产清理","id":99026,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1606","name":"固定资产清理","gradeName":"固定资产清理","helpCode":"GDZCQL","helpCodeFull":"gudingzichanqingli","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1621 生产性生物资产","id":99027,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1621","name":"生产性生物资产","gradeName":"生产性生物资产","helpCode":"SCXSWZC","helpCodeFull":"shengchanxingshengwuzichan","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"1622 生产性生物资产累计折旧","id":99028,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1622","name":"生产性生物资产累计折旧","gradeName":"生产性生物资产累计折旧","helpCode":"SCXSWZCLJZJ","helpCodeFull":"shengchanxingshengwuzichanleijizhejiu","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"170101 无形资产-土地使用权","id":99091,"parentId":99029,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"170101","name":"土地使用权","gradeName":"无形资产-土地使用权","helpCode":"WXZC-TDSYQ","helpCodeFull":"wuxingzichan-tudishiyongquan","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"170102 无形资产-专利权","id":99092,"parentId":99029,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"170102","name":"专利权","gradeName":"无形资产-专利权","helpCode":"WXZC-ZLQ","helpCodeFull":"wuxingzichan-zhuanliquan","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"170103 无形资产-商标权","id":99093,"parentId":99029,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"170103","name":"商标权","gradeName":"无形资产-商标权","helpCode":"WXZC-SBQ","helpCodeFull":"wuxingzichan-shangbiaoquan","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"170104 无形资产-著作权","id":99094,"parentId":99029,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"170104","name":"著作权","gradeName":"无形资产-著作权","helpCode":"WXZC-ZZQ","helpCodeFull":"wuxingzichan-zhuzuoquan","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"170105 无形资产-非专利技术","id":99095,"parentId":99029,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"170105","name":"非专利技术","gradeName":"无形资产-非专利技术","helpCode":"WXZC-FZLJS","helpCodeFull":"wuxingzichan-feizhuanlijishu","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"170106 无形资产-特许权使用费","id":99096,"parentId":99029,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"170106","name":"特许权使用费","gradeName":"无形资产-特许权使用费","helpCode":"WXZC-TXQSYF","helpCodeFull":"wuxingzichan-texuquanshiyongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"170199 无形资产-其他","id":99097,"parentId":99029,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"170199","name":"其他","gradeName":"无形资产-其他","helpCode":"WXZC-QT","helpCodeFull":"wuxingzichan-qita","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"170201 累计摊销-土地使用权","id":99098,"parentId":99030,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"170201","name":"土地使用权","gradeName":"累计摊销-土地使用权","helpCode":"LJTX-TDSYQ","helpCodeFull":"leijitanxiao-tudishiyongquan","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"170202 累计摊销-专利权","id":99099,"parentId":99030,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"170202","name":"专利权","gradeName":"累计摊销-专利权","helpCode":"LJTX-ZLQ","helpCodeFull":"leijitanxiao-zhuanliquan","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"170203 累计摊销-商标权","id":99100,"parentId":99030,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"170203","name":"商标权","gradeName":"累计摊销-商标权","helpCode":"LJTX-SBQ","helpCodeFull":"leijitanxiao-shangbiaoquan","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"170204 累计摊销-著作权","id":99101,"parentId":99030,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"170204","name":"著作权","gradeName":"累计摊销-著作权","helpCode":"LJTX-ZZQ","helpCodeFull":"leijitanxiao-zhuzuoquan","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"170205 累计摊销-非专利技术","id":99102,"parentId":99030,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"170205","name":"非专利技术","gradeName":"累计摊销-非专利技术","helpCode":"LJTX-FZLJS","helpCodeFull":"leijitanxiao-feizhuanlijishu","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"170206 累计摊销-特许权使用费","id":99103,"parentId":99030,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"170206","name":"特许权使用费","gradeName":"累计摊销-特许权使用费","helpCode":"LJTX-TXQSYF","helpCodeFull":"leijitanxiao-texuquanshiyongfei","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"170299 累计摊销-其他","id":99104,"parentId":99030,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"170299","name":"其他","gradeName":"累计摊销-其他","helpCode":"LJTX-QT","helpCodeFull":"leijitanxiao-qita","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"1801 长期待摊费用","id":99031,"grade":1,"isEndNode":true,"accountTypeId":5000010001,"code":"1801","name":"长期待摊费用","gradeName":"长期待摊费用","helpCode":"CQDTFY","helpCodeFull":"changqidaitanfeiyong","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"190101 待处理财产损溢-待处理流动资产损溢","id":99105,"parentId":99032,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"190101","name":"待处理流动资产损溢","gradeName":"待处理财产损溢-待处理流动资产损溢","helpCode":"DCLCCSY-DCLLDZCSY","helpCodeFull":"daichulicaichansunyi-daichuliliudongzichansunyi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"资产","balanceDirectionName":"借","cashTypeName":"","codeAndName":"190102 待处理财产损溢-待处理非流动资产损溢","id":99106,"parentId":99032,"grade":2,"isEndNode":true,"accountTypeId":5000010001,"code":"190102","name":"待处理非流动资产损溢","gradeName":"待处理财产损溢-待处理非流动资产损溢","helpCode":"DCLCCSY-DCLFLDZCSY","helpCodeFull":"daichulicaichansunyi-daichulifeiliudongzichansunyi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"2001 短期借款","id":99033,"grade":1,"isEndNode":true,"accountTypeId":5000010002,"code":"2001","name":"短期借款","gradeName":"短期借款","helpCode":"DQJK","helpCodeFull":"duanqijiekuan","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"2201 应付票据","id":99034,"grade":1,"isEndNode":true,"accountTypeId":5000010002,"code":"2201","name":"应付票据","gradeName":"应付票据","helpCode":"YFPJ","helpCodeFull":"yingfupiaoju","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"2202 应付账款","id":99035,"grade":1,"isEndNode":true,"accountTypeId":5000010002,"code":"2202","name":"应付账款","gradeName":"应付账款","helpCode":"YFZK","helpCodeFull":"yingfuzhangkuan","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"2203 预收账款","id":99036,"grade":1,"isEndNode":true,"accountTypeId":5000010002,"code":"2203","name":"预收账款","gradeName":"预收账款","helpCode":"YSZK","helpCodeFull":"yushouzhangkuan","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"221101 应付职工薪酬-职工工资","id":99107,"parentId":99037,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"221101","name":"职工工资","gradeName":"应付职工薪酬-职工工资","helpCode":"YFZGXC-ZGGZ","helpCodeFull":"yingfuzhigongxinchou-zhigonggongzi","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"22110201 应付职工薪酬-基本社会保险费-养老保险费","id":99381,"parentId":99108,"grade":3,"isEndNode":true,"accountTypeId":5000010002,"code":"22110201","name":"养老保险费","gradeName":"应付职工薪酬-基本社会保险费-养老保险费","helpCode":"YFZGXC-JBSHBXF-YLBXF","helpCodeFull":"yingfuzhigongxinchou-jibenshehuibaoxianfei-yanglaobaoxianfei","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"22110202 应付职工薪酬-基本社会保险费-医疗保险费","id":99382,"parentId":99108,"grade":3,"isEndNode":true,"accountTypeId":5000010002,"code":"22110202","name":"医疗保险费","gradeName":"应付职工薪酬-基本社会保险费-医疗保险费","helpCode":"YFZGXC-JBSHBXF-YLBXF","helpCodeFull":"yingfuzhigongxinchou-jibenshehuibaoxianfei-yiliaobaoxianfei","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"22110203 应付职工薪酬-基本社会保险费-失业保险费","id":99383,"parentId":99108,"grade":3,"isEndNode":true,"accountTypeId":5000010002,"code":"22110203","name":"失业保险费","gradeName":"应付职工薪酬-基本社会保险费-失业保险费","helpCode":"YFZGXC-JBSHBXF-SYBXF","helpCodeFull":"yingfuzhigongxinchou-jibenshehuibaoxianfei-shiyebaoxianfei","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"22110204 应付职工薪酬-基本社会保险费-生育保险费","id":99384,"parentId":99108,"grade":3,"isEndNode":true,"accountTypeId":5000010002,"code":"22110204","name":"生育保险费","gradeName":"应付职工薪酬-基本社会保险费-生育保险费","helpCode":"YFZGXC-JBSHBXF-SYBXF","helpCodeFull":"yingfuzhigongxinchou-jibenshehuibaoxianfei-shengyubaoxianfei","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"22110205 应付职工薪酬-基本社会保险费-工伤保险费","id":99385,"parentId":99108,"grade":3,"isEndNode":true,"accountTypeId":5000010002,"code":"22110205","name":"工伤保险费","gradeName":"应付职工薪酬-基本社会保险费-工伤保险费","helpCode":"YFZGXC-JBSHBXF-GSBXF","helpCodeFull":"yingfuzhigongxinchou-jibenshehuibaoxianfei-gongshangbaoxianfei","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"221103 应付职工薪酬-补充养老保险","id":99109,"parentId":99037,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"221103","name":"补充养老保险","gradeName":"应付职工薪酬-补充养老保险","helpCode":"YFZGXC-BCYLBX","helpCodeFull":"yingfuzhigongxinchou-buchongyanglaobaoxian","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"221104 应付职工薪酬-补充医疗保险","id":99110,"parentId":99037,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"221104","name":"补充医疗保险","gradeName":"应付职工薪酬-补充医疗保险","helpCode":"YFZGXC-BCYLBX","helpCodeFull":"yingfuzhigongxinchou-buchongyiliaobaoxian","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"221105 应付职工薪酬-住房公积金","id":99111,"parentId":99037,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"221105","name":"住房公积金","gradeName":"应付职工薪酬-住房公积金","helpCode":"YFZGXC-ZFGJJ","helpCodeFull":"yingfuzhigongxinchou-zhufanggongjijin","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"221106 应付职工薪酬-应付奖金、津贴和补贴","id":99112,"parentId":99037,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"221106","name":"应付奖金、津贴和补贴","gradeName":"应付职工薪酬-应付奖金、津贴和补贴","helpCode":"YFZGXC-YFJJ、JTHBT","helpCodeFull":"yingfuzhigongxinchou-yingfujiangjin、jintiehebutie","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"221107 应付职工薪酬-应付福利费","id":99113,"parentId":99037,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"221107","name":"应付福利费","gradeName":"应付职工薪酬-应付福利费","helpCode":"YFZGXC-YFFLF","helpCodeFull":"yingfuzhigongxinchou-yingfufulifei","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"221108 应付职工薪酬-非货币性福利","id":99114,"parentId":99037,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"221108","name":"非货币性福利","gradeName":"应付职工薪酬-非货币性福利","helpCode":"YFZGXC-FHBXFL","helpCodeFull":"yingfuzhigongxinchou-feihuobixingfuli","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"221109 应付职工薪酬-工会经费","id":99115,"parentId":99037,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"221109","name":"工会经费","gradeName":"应付职工薪酬-工会经费","helpCode":"YFZGXC-GHJF","helpCodeFull":"yingfuzhigongxinchou-gonghuijingfei","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"221110 应付职工薪酬-职工教育经费","id":99116,"parentId":99037,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"221110","name":"职工教育经费","gradeName":"应付职工薪酬-职工教育经费","helpCode":"YFZGXC-ZGJYJF","helpCodeFull":"yingfuzhigongxinchou-zhigongjiaoyujingfei","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"221111 应付职工薪酬-辞退福利","id":99117,"parentId":99037,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"221111","name":"辞退福利","gradeName":"应付职工薪酬-辞退福利","helpCode":"YFZGXC-CTFL","helpCodeFull":"yingfuzhigongxinchou-cituifuli","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"221199 应付职工薪酬-其他","id":99118,"parentId":99037,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"221199","name":"其他","gradeName":"应付职工薪酬-其他","helpCode":"YFZGXC-QT","helpCodeFull":"yingfuzhigongxinchou-qita","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"借","cashTypeName":"进项税额","codeAndName":"22210101 应交税费-应交增值税-进项税额","id":99386,"parentId":99119,"grade":3,"isEndNode":true,"accountTypeId":5000010002,"code":"22210101","name":"进项税额","gradeName":"应交税费-应交增值税-进项税额","helpCode":"YJSF-YJZZS-JXSE","helpCodeFull":"yingjiaoshuifei-yingjiaozengzhishui-jinxiangshuie","balanceDirection":0,"cashTypeId":5000020038,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"借","cashTypeName":"","codeAndName":"22210102 应交税费-应交增值税-销项税额抵减","id":99387,"parentId":99119,"grade":3,"isEndNode":true,"accountTypeId":5000010002,"code":"22210102","name":"销项税额抵减","gradeName":"应交税费-应交增值税-销项税额抵减","helpCode":"YJSF-YJZZS-XXSEDJ","helpCodeFull":"yingjiaoshuifei-yingjiaozengzhishui-xiaoxiangshuiedijian","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"借","cashTypeName":"","codeAndName":"22210103 应交税费-应交增值税-已交税金","id":99388,"parentId":99119,"grade":3,"isEndNode":true,"accountTypeId":5000010002,"code":"22210103","name":"已交税金","gradeName":"应交税费-应交增值税-已交税金","helpCode":"YJSF-YJZZS-YJSJ","helpCodeFull":"yingjiaoshuifei-yingjiaozengzhishui-yijiaoshuijin","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"借","cashTypeName":"转出未交增值税","codeAndName":"22210104 应交税费-应交增值税-转出未交增值税","id":99389,"parentId":99119,"grade":3,"isEndNode":true,"accountTypeId":5000010002,"code":"22210104","name":"转出未交增值税","gradeName":"应交税费-应交增值税-转出未交增值税","helpCode":"YJSF-YJZZS-ZCWJZZS","helpCodeFull":"yingjiaoshuifei-yingjiaozengzhishui-zhuanchuweijiaozengzhishui","balanceDirection":0,"cashTypeId":5000020020,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"借","cashTypeName":"减免税款","codeAndName":"22210105 应交税费-应交增值税-减免税款","id":99390,"parentId":99119,"grade":3,"isEndNode":true,"accountTypeId":5000010002,"code":"22210105","name":"减免税款","gradeName":"应交税费-应交增值税-减免税款","helpCode":"YJSF-YJZZS-JMSK","helpCodeFull":"yingjiaoshuifei-yingjiaozengzhishui-jianmianshuikuan","balanceDirection":0,"cashTypeId":5000020019,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"借","cashTypeName":"","codeAndName":"22210106 应交税费-应交增值税-出口抵减内销产品应纳税额","id":99391,"parentId":99119,"grade":3,"isEndNode":true,"accountTypeId":5000010002,"code":"22210106","name":"出口抵减内销产品应纳税额","gradeName":"应交税费-应交增值税-出口抵减内销产品应纳税额","helpCode":"YJSF-YJZZS-CKDJNXCPYNSE","helpCodeFull":"yingjiaoshuifei-yingjiaozengzhishui-chukoudijiannaxiaochanpinyingnashuie","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"22210107 应交税费-应交增值税-销项税额","id":99392,"parentId":99119,"grade":3,"isEndNode":true,"accountTypeId":5000010002,"code":"22210107","name":"销项税额","gradeName":"应交税费-应交增值税-销项税额","helpCode":"YJSF-YJZZS-XXSE","helpCodeFull":"yingjiaoshuifei-yingjiaozengzhishui-xiaoxiangshuie","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"22210108 应交税费-应交增值税-出口退税","id":99393,"parentId":99119,"grade":3,"isEndNode":true,"accountTypeId":5000010002,"code":"22210108","name":"出口退税","gradeName":"应交税费-应交增值税-出口退税","helpCode":"YJSF-YJZZS-CKTS","helpCodeFull":"yingjiaoshuifei-yingjiaozengzhishui-chukoutuishui","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"进项转出","codeAndName":"22210109 应交税费-应交增值税-进项税额转出","id":99394,"parentId":99119,"grade":3,"isEndNode":true,"accountTypeId":5000010002,"code":"22210109","name":"进项税额转出","gradeName":"应交税费-应交增值税-进项税额转出","helpCode":"YJSF-YJZZS-JXSEZC","helpCodeFull":"yingjiaoshuifei-yingjiaozengzhishui-jinxiangshuiezhuanchu","balanceDirection":1,"cashTypeId":5000020040,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"转出多交增值税","codeAndName":"22210110 应交税费-应交增值税-转出多交增值税","id":99395,"parentId":99119,"grade":3,"isEndNode":true,"accountTypeId":5000010002,"code":"22210110","name":"转出多交增值税","gradeName":"应交税费-应交增值税-转出多交增值税","helpCode":"YJSF-YJZZS-ZCDJZZS","helpCodeFull":"yingjiaoshuifei-yingjiaozengzhishui-zhuanchuduojiaozengzhishui","balanceDirection":1,"cashTypeId":5000020021,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"未交增值税","codeAndName":"222102 应交税费-未交增值税","id":99120,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222102","name":"未交增值税","gradeName":"应交税费-未交增值税","helpCode":"YJSF-WJZZS","helpCodeFull":"yingjiaoshuifei-weijiaozengzhishui","balanceDirection":1,"cashTypeId":5000020022,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"预交增值税","codeAndName":"222103 应交税费-预交增值税","id":99121,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222103","name":"预交增值税","gradeName":"应交税费-预交增值税","helpCode":"YJSF-YJZZS","helpCodeFull":"yingjiaoshuifei-yujiaozengzhishui","balanceDirection":1,"cashTypeId":5000020031,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"待抵扣进项","codeAndName":"222104 应交税费-待抵扣进项税额","id":99122,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222104","name":"待抵扣进项税额","gradeName":"应交税费-待抵扣进项税额","helpCode":"YJSF-DDKJXSE","helpCodeFull":"yingjiaoshuifei-daidikoujinxiangshuie","balanceDirection":1,"cashTypeId":5000020018,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222105 应交税费-待认证进项税额","id":99123,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222105","name":"待认证进项税额","gradeName":"应交税费-待认证进项税额","helpCode":"YJSF-DRZJXSE","helpCodeFull":"yingjiaoshuifei-dairenzhengjinxiangshuie","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222106 应交税费-待转销项税额","id":99124,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222106","name":"待转销项税额","gradeName":"应交税费-待转销项税额","helpCode":"YJSF-DZXXSE","helpCodeFull":"yingjiaoshuifei-daizhuanxiaoxiangshuie","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222107 应交税费-增值税留抵税额","id":99125,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222107","name":"增值税留抵税额","gradeName":"应交税费-增值税留抵税额","helpCode":"YJSF-ZZSLDSE","helpCodeFull":"yingjiaoshuifei-zengzhishuiliudishuie","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"简易计税","codeAndName":"222108 应交税费-简易计税","id":99126,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222108","name":"简易计税","gradeName":"应交税费-简易计税","helpCode":"YJSF-JYJS","helpCodeFull":"yingjiaoshuifei-jianyijishui","balanceDirection":1,"cashTypeId":5000020023,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222109 应交税费-转让金融商品应交增值税","id":99127,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222109","name":"转让金融商品应交增值税","gradeName":"应交税费-转让金融商品应交增值税","helpCode":"YJSF-ZRJRSPYJZZS","helpCodeFull":"yingjiaoshuifei-zhuanrangjinrongshangpinyingjiaozengzhishui","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222110 应交税费-代扣代交增值税","id":99128,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222110","name":"代扣代交增值税","gradeName":"应交税费-代扣代交增值税","helpCode":"YJSF-DKDJZZS","helpCodeFull":"yingjiaoshuifei-daikoudaijiaozengzhishui","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222111 应交税费-增值税检查调整","id":99129,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222111","name":"增值税检查调整","gradeName":"应交税费-增值税检查调整","helpCode":"YJSF-ZZSJCDZ","helpCodeFull":"yingjiaoshuifei-zengzhishuijianchadiaozheng","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222112 应交税费-应交营业税","id":99130,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222112","name":"应交营业税","gradeName":"应交税费-应交营业税","helpCode":"YJSF-YJYYS","helpCodeFull":"yingjiaoshuifei-yingjiaoyingyeshui","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222113 应交税费-应交消费税","id":99131,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222113","name":"应交消费税","gradeName":"应交税费-应交消费税","helpCode":"YJSF-YJXFS","helpCodeFull":"yingjiaoshuifei-yingjiaoxiaofeishui","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222114 应交税费-应交资源税","id":99132,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222114","name":"应交资源税","gradeName":"应交税费-应交资源税","helpCode":"YJSF-YJZYS","helpCodeFull":"yingjiaoshuifei-yingjiaoziyuanshui","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"应交所得税","codeAndName":"222115 应交税费-应交所得税","id":99133,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222115","name":"应交所得税","gradeName":"应交税费-应交所得税","helpCode":"YJSF-YJSDS","helpCodeFull":"yingjiaoshuifei-yingjiaosuodeshui","balanceDirection":1,"cashTypeId":5000020042,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222116 应交税费-应交土地增值税","id":99134,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222116","name":"应交土地增值税","gradeName":"应交税费-应交土地增值税","helpCode":"YJSF-YJTDZZS","helpCodeFull":"yingjiaoshuifei-yingjiaotudizengzhishui","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"城市维护建设税","codeAndName":"222117 应交税费-应交城市维护建设税","id":99135,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222117","name":"应交城市维护建设税","gradeName":"应交税费-应交城市维护建设税","helpCode":"YJSF-YJCSWHJSS","helpCodeFull":"yingjiaoshuifei-yingjiaochengshiweihujiansheshui","balanceDirection":1,"cashTypeId":5000020027,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222118 应交税费-应交房产税","id":99136,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222118","name":"应交房产税","gradeName":"应交税费-应交房产税","helpCode":"YJSF-YJFCS","helpCodeFull":"yingjiaoshuifei-yingjiaofangchanshui","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222119 应交税费-应交城镇土地使用税","id":99137,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222119","name":"应交城镇土地使用税","gradeName":"应交税费-应交城镇土地使用税","helpCode":"YJSF-YJCZTDSYS","helpCodeFull":"yingjiaoshuifei-yingjiaochengzhentudishiyongshui","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222120 应交税费-应交车船使用税","id":99138,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222120","name":"应交车船使用税","gradeName":"应交税费-应交车船使用税","helpCode":"YJSF-YJCCSYS","helpCodeFull":"yingjiaoshuifei-yingjiaochechuanshiyongshui","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222121 应交税费-应交个人所得税","id":99139,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222121","name":"应交个人所得税","gradeName":"应交税费-应交个人所得税","helpCode":"YJSF-YJGRSDS","helpCodeFull":"yingjiaoshuifei-yingjiaogerensuodeshui","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"教育费附加","codeAndName":"222122 应交税费-教育费附加","id":99140,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222122","name":"教育费附加","gradeName":"应交税费-教育费附加","helpCode":"YJSF-JYFFJ","helpCodeFull":"yingjiaoshuifei-jiaoyufeifujia","balanceDirection":1,"cashTypeId":5000020028,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222123 应交税费-矿产资源补偿费","id":99141,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222123","name":"矿产资源补偿费","gradeName":"应交税费-矿产资源补偿费","helpCode":"YJSF-KCZYBCF","helpCodeFull":"yingjiaoshuifei-kuangchanziyuanbuchangfei","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222124 应交税费-排污费","id":99142,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222124","name":"排污费","gradeName":"应交税费-排污费","helpCode":"YJSF-PWF","helpCodeFull":"yingjiaoshuifei-paiwufei","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222125 应交税费-应交印花税","id":99143,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222125","name":"应交印花税","gradeName":"应交税费-应交印花税","helpCode":"YJSF-YJYHS","helpCodeFull":"yingjiaoshuifei-yingjiaoyinhuashui","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"地方教育费附加","codeAndName":"222126 应交税费-地方教育费附加","id":99144,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222126","name":"地方教育费附加","gradeName":"应交税费-地方教育费附加","helpCode":"YJSF-DFJYFFJ","helpCodeFull":"yingjiaoshuifei-difangjiaoyufeifujia","balanceDirection":1,"cashTypeId":5000020029,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"222127 应交税费-文化事业建设费","id":99145,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222127","name":"文化事业建设费","gradeName":"应交税费-文化事业建设费","helpCode":"YJSF-WHSYJSF","helpCodeFull":"yingjiaoshuifei-wenhuashiyejianshefei","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"水利建设基金","codeAndName":"222128 应交税费-应交水利建设基金","id":99146,"parentId":99038,"grade":2,"isEndNode":true,"accountTypeId":5000010002,"code":"222128","name":"应交水利建设基金","gradeName":"应交税费-应交水利建设基金","helpCode":"YJSF-YJSLJSJJ","helpCodeFull":"yingjiaoshuifei-yingjiaoshuilijianshejijin","balanceDirection":1,"cashTypeId":5000020039,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"2231 应付利息","id":99039,"grade":1,"isEndNode":true,"accountTypeId":5000010002,"code":"2231","name":"应付利息","gradeName":"应付利息","helpCode":"YFLX","helpCodeFull":"yingfulixi","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"2232 应付利润","id":99040,"grade":1,"isEndNode":true,"accountTypeId":5000010002,"code":"2232","name":"应付利润","gradeName":"应付利润","helpCode":"YFLR","helpCodeFull":"yingfulirun","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"2241 其他应付款","id":99041,"grade":1,"isEndNode":true,"accountTypeId":5000010002,"code":"2241","name":"其他应付款","gradeName":"其他应付款","helpCode":"QTYFK","helpCodeFull":"qitayingfukuan","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"2401 递延收益","id":99042,"grade":1,"isEndNode":true,"accountTypeId":5000010002,"code":"2401","name":"递延收益","gradeName":"递延收益","helpCode":"DYSY","helpCodeFull":"diyanshouyi","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"2501 长期借款","id":99043,"grade":1,"isEndNode":true,"accountTypeId":5000010002,"code":"2501","name":"长期借款","gradeName":"长期借款","helpCode":"CQJK","helpCodeFull":"changqijiekuan","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"负债","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"2701 长期应付款","id":99044,"grade":1,"isEndNode":true,"accountTypeId":5000010002,"code":"2701","name":"长期应付款","gradeName":"长期应付款","helpCode":"CQYFK","helpCodeFull":"changqiyingfukuan","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"权益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"3001 实收资本","id":99045,"grade":1,"isEndNode":true,"accountTypeId":5000010004,"code":"3001","name":"实收资本","gradeName":"实收资本","helpCode":"SSZB","helpCodeFull":"shishouziben","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"权益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"3002 资本公积","id":99046,"grade":1,"isEndNode":true,"accountTypeId":5000010004,"code":"3002","name":"资本公积","gradeName":"资本公积","helpCode":"ZBGJ","helpCodeFull":"zibengongji","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"权益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"310101 盈余公积-法定盈余公积","id":99147,"parentId":99047,"grade":2,"isEndNode":true,"accountTypeId":5000010004,"code":"310101","name":"法定盈余公积","gradeName":"盈余公积-法定盈余公积","helpCode":"YYGJ-FDYYGJ","helpCodeFull":"yingyugongji-fadingyingyugongji","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"权益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"310102 盈余公积-任意盈余公积","id":99148,"parentId":99047,"grade":2,"isEndNode":true,"accountTypeId":5000010004,"code":"310102","name":"任意盈余公积","gradeName":"盈余公积-任意盈余公积","helpCode":"YYGJ-RYYYGJ","helpCodeFull":"yingyugongji-renyiyingyugongji","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"权益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"310103 盈余公积-储备基金","id":99149,"parentId":99047,"grade":2,"isEndNode":true,"accountTypeId":5000010004,"code":"310103","name":"储备基金","gradeName":"盈余公积-储备基金","helpCode":"YYGJ-CBJJ","helpCodeFull":"yingyugongji-chubeijijin","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"权益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"310104 盈余公积-企业发展基金","id":99150,"parentId":99047,"grade":2,"isEndNode":true,"accountTypeId":5000010004,"code":"310104","name":"企业发展基金","gradeName":"盈余公积-企业发展基金","helpCode":"YYGJ-QYFZJJ","helpCodeFull":"yingyugongji-qiyefazhanjijin","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"权益","balanceDirectionName":"贷","cashTypeName":"本年利润","codeAndName":"3103 本年利润","id":99048,"grade":1,"isEndNode":true,"accountTypeId":5000010004,"code":"3103","name":"本年利润","gradeName":"本年利润","helpCode":"BNLR","helpCodeFull":"bennianlirun","balanceDirection":1,"cashTypeId":5000020005,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"权益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"310401 利润分配-其他转入","id":99151,"parentId":99049,"grade":2,"isEndNode":true,"accountTypeId":5000010004,"code":"310401","name":"其他转入","gradeName":"利润分配-其他转入","helpCode":"LRFP-QTZR","helpCodeFull":"lirunfenpei-qitazhuanru","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"权益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"310402 利润分配-提取法定盈余公积","id":99152,"parentId":99049,"grade":2,"isEndNode":true,"accountTypeId":5000010004,"code":"310402","name":"提取法定盈余公积","gradeName":"利润分配-提取法定盈余公积","helpCode":"LRFP-TQFDYYGJ","helpCodeFull":"lirunfenpei-tiqufadingyingyugongji","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"权益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"310403 利润分配-提取职工奖励及福利基金","id":99153,"parentId":99049,"grade":2,"isEndNode":true,"accountTypeId":5000010004,"code":"310403","name":"提取职工奖励及福利基金","gradeName":"利润分配-提取职工奖励及福利基金","helpCode":"LRFP-TQZGJLJFLJJ","helpCodeFull":"lirunfenpei-tiquzhigongjianglijifulijijin","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"权益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"310404 利润分配-提取任意盈余公积","id":99154,"parentId":99049,"grade":2,"isEndNode":true,"accountTypeId":5000010004,"code":"310404","name":"提取任意盈余公积","gradeName":"利润分配-提取任意盈余公积","helpCode":"LRFP-TQRYYYGJ","helpCodeFull":"lirunfenpei-tiqurenyiyingyugongji","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"权益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"310405 利润分配-应付股利或利润","id":99155,"parentId":99049,"grade":2,"isEndNode":true,"accountTypeId":5000010004,"code":"310405","name":"应付股利或利润","gradeName":"利润分配-应付股利或利润","helpCode":"LRFP-YFGLHLR","helpCodeFull":"lirunfenpei-yingfugulihuolirun","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"权益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"310406 利润分配-提取储备基金","id":99156,"parentId":99049,"grade":2,"isEndNode":true,"accountTypeId":5000010004,"code":"310406","name":"提取储备基金","gradeName":"利润分配-提取储备基金","helpCode":"LRFP-TQCBJJ","helpCodeFull":"lirunfenpei-tiquchubeijijin","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"权益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"310407 利润分配-提取企业发展基金","id":99157,"parentId":99049,"grade":2,"isEndNode":true,"accountTypeId":5000010004,"code":"310407","name":"提取企业发展基金","gradeName":"利润分配-提取企业发展基金","helpCode":"LRFP-TQQYFZJJ","helpCodeFull":"lirunfenpei-tiquqiyefazhanjijin","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"权益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"310408 利润分配-未分配利润","id":99158,"parentId":99049,"grade":2,"isEndNode":true,"accountTypeId":5000010004,"code":"310408","name":"未分配利润","gradeName":"利润分配-未分配利润","helpCode":"LRFP-WFPLR","helpCodeFull":"lirunfenpei-weifenpeilirun","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400101 生产成本-直接材料","id":99159,"parentId":99050,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400101","name":"直接材料","gradeName":"生产成本-直接材料","helpCode":"SCCB-ZJCL","helpCodeFull":"shengchanchengben-zhijiecailiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400102 生产成本-职工工资","id":99160,"parentId":99050,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400102","name":"职工工资","gradeName":"生产成本-职工工资","helpCode":"SCCB-ZGGZ","helpCodeFull":"shengchanchengben-zhigonggongzi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400103 生产成本-基本社会保险费","id":99161,"parentId":99050,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400103","name":"基本社会保险费","gradeName":"生产成本-基本社会保险费","helpCode":"SCCB-JBSHBXF","helpCodeFull":"shengchanchengben-jibenshehuibaoxianfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400104 生产成本-补充养老保险","id":99162,"parentId":99050,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400104","name":"补充养老保险","gradeName":"生产成本-补充养老保险","helpCode":"SCCB-BCYLBX","helpCodeFull":"shengchanchengben-buchongyanglaobaoxian","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400105 生产成本-补充医疗保险","id":99163,"parentId":99050,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400105","name":"补充医疗保险","gradeName":"生产成本-补充医疗保险","helpCode":"SCCB-BCYLBX","helpCodeFull":"shengchanchengben-buchongyiliaobaoxian","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400106 生产成本-住房公积金","id":99164,"parentId":99050,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400106","name":"住房公积金","gradeName":"生产成本-住房公积金","helpCode":"SCCB-ZFGJJ","helpCodeFull":"shengchanchengben-zhufanggongjijin","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400107 生产成本-福利费","id":99165,"parentId":99050,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400107","name":"福利费","gradeName":"生产成本-福利费","helpCode":"SCCB-FLF","helpCodeFull":"shengchanchengben-fulifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400108 生产成本-工会经费","id":99166,"parentId":99050,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400108","name":"工会经费","gradeName":"生产成本-工会经费","helpCode":"SCCB-GHJF","helpCodeFull":"shengchanchengben-gonghuijingfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400109 生产成本-职工教育经费","id":99167,"parentId":99050,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400109","name":"职工教育经费","gradeName":"生产成本-职工教育经费","helpCode":"SCCB-ZGJYJF","helpCodeFull":"shengchanchengben-zhigongjiaoyujingfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400110 生产成本-制造费用","id":99168,"parentId":99050,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400110","name":"制造费用","gradeName":"生产成本-制造费用","helpCode":"SCCB-ZZFY","helpCodeFull":"shengchanchengben-zhizaofeiyong","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400199 生产成本-其他","id":99169,"parentId":99050,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400199","name":"其他","gradeName":"生产成本-其他","helpCode":"SCCB-QT","helpCodeFull":"shengchanchengben-qita","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400201 劳务成本-直接材料","id":99170,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400201","name":"直接材料","gradeName":"劳务成本-直接材料","helpCode":"LWCB-ZJCL","helpCodeFull":"laowuchengben-zhijiecailiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400202 劳务成本-职工工资","id":99171,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400202","name":"职工工资","gradeName":"劳务成本-职工工资","helpCode":"LWCB-ZGGZ","helpCodeFull":"laowuchengben-zhigonggongzi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400203 劳务成本-基本社会保险费","id":99172,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400203","name":"基本社会保险费","gradeName":"劳务成本-基本社会保险费","helpCode":"LWCB-JBSHBXF","helpCodeFull":"laowuchengben-jibenshehuibaoxianfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400204 劳务成本-补充养老保险","id":99173,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400204","name":"补充养老保险","gradeName":"劳务成本-补充养老保险","helpCode":"LWCB-BCYLBX","helpCodeFull":"laowuchengben-buchongyanglaobaoxian","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400205 劳务成本-补充医疗保险","id":99174,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400205","name":"补充医疗保险","gradeName":"劳务成本-补充医疗保险","helpCode":"LWCB-BCYLBX","helpCodeFull":"laowuchengben-buchongyiliaobaoxian","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400206 劳务成本-住房公积金","id":99175,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400206","name":"住房公积金","gradeName":"劳务成本-住房公积金","helpCode":"LWCB-ZFGJJ","helpCodeFull":"laowuchengben-zhufanggongjijin","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400207 劳务成本-福利费","id":99176,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400207","name":"福利费","gradeName":"劳务成本-福利费","helpCode":"LWCB-FLF","helpCodeFull":"laowuchengben-fulifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400208 劳务成本-工会经费","id":99177,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400208","name":"工会经费","gradeName":"劳务成本-工会经费","helpCode":"LWCB-GHJF","helpCodeFull":"laowuchengben-gonghuijingfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400209 劳务成本-职工教育经费","id":99178,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400209","name":"职工教育经费","gradeName":"劳务成本-职工教育经费","helpCode":"LWCB-ZGJYJF","helpCodeFull":"laowuchengben-zhigongjiaoyujingfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400210 劳务成本-办公用品及办公费","id":99179,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400210","name":"办公用品及办公费","gradeName":"劳务成本-办公用品及办公费","helpCode":"LWCB-BGYPJBGF","helpCodeFull":"laowuchengben-bangongyongpinjibangongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400211 劳务成本-租赁费","id":99180,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400211","name":"租赁费","gradeName":"劳务成本-租赁费","helpCode":"LWCB-ZLF","helpCodeFull":"laowuchengben-zulinfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400212 劳务成本-物业管理费","id":99181,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400212","name":"物业管理费","gradeName":"劳务成本-物业管理费","helpCode":"LWCB-WYGLF","helpCodeFull":"laowuchengben-wuyeguanlifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400213 劳务成本-水电费","id":99182,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400213","name":"水电费","gradeName":"劳务成本-水电费","helpCode":"LWCB-SDF","helpCodeFull":"laowuchengben-shuidianfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400214 劳务成本-交通费","id":99183,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400214","name":"交通费","gradeName":"劳务成本-交通费","helpCode":"LWCB-JTF","helpCodeFull":"laowuchengben-jiaotongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400215 劳务成本-差旅费","id":99184,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400215","name":"差旅费","gradeName":"劳务成本-差旅费","helpCode":"LWCB-CLF","helpCodeFull":"laowuchengben-chalvfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400216 劳务成本-通讯费","id":99185,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400216","name":"通讯费","gradeName":"劳务成本-通讯费","helpCode":"LWCB-TXF","helpCodeFull":"laowuchengben-tongxunfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400217 劳务成本-会议费","id":99186,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400217","name":"会议费","gradeName":"劳务成本-会议费","helpCode":"LWCB-HYF","helpCodeFull":"laowuchengben-huiyifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400218 劳务成本-网络使用费","id":99187,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400218","name":"网络使用费","gradeName":"劳务成本-网络使用费","helpCode":"LWCB-WLSYF","helpCodeFull":"laowuchengben-wangluoshiyongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400219 劳务成本-车辆使用费","id":99188,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400219","name":"车辆使用费","gradeName":"劳务成本-车辆使用费","helpCode":"LWCB-CLSYF","helpCodeFull":"laowuchengben-cheliangshiyongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400220 劳务成本-折旧费","id":99189,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400220","name":"折旧费","gradeName":"劳务成本-折旧费","helpCode":"LWCB-ZJF","helpCodeFull":"laowuchengben-zhejiufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400221 劳务成本-无形资产摊销费","id":99190,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400221","name":"无形资产摊销费","gradeName":"劳务成本-无形资产摊销费","helpCode":"LWCB-WXZCTXF","helpCodeFull":"laowuchengben-wuxingzichantanxiaofei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400222 劳务成本-长期待摊费用摊销","id":99191,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400222","name":"长期待摊费用摊销","gradeName":"劳务成本-长期待摊费用摊销","helpCode":"LWCB-CQDTFYTX","helpCodeFull":"laowuchengben-changqidaitanfeiyongtanxiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400223 劳务成本-周转材料摊销","id":99192,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400223","name":"周转材料摊销","gradeName":"劳务成本-周转材料摊销","helpCode":"LWCB-ZZCLTX","helpCodeFull":"laowuchengben-zhouzhuancailiaotanxiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400224 劳务成本-旅游费","id":99193,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400224","name":"旅游费","gradeName":"劳务成本-旅游费","helpCode":"LWCB-LYF","helpCodeFull":"laowuchengben-lvyoufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400225 劳务成本-劳保费","id":99194,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400225","name":"劳保费","gradeName":"劳务成本-劳保费","helpCode":"LWCB-LBF","helpCodeFull":"laowuchengben-laobaofei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400226 劳务成本-修理费","id":99195,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400226","name":"修理费","gradeName":"劳务成本-修理费","helpCode":"LWCB-XLF","helpCodeFull":"laowuchengben-xiulifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400227 劳务成本-快递物流费","id":99196,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400227","name":"快递物流费","gradeName":"劳务成本-快递物流费","helpCode":"LWCB-KDWLF","helpCodeFull":"laowuchengben-kuaidiwuliufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400228 劳务成本-培训费","id":99197,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400228","name":"培训费","gradeName":"劳务成本-培训费","helpCode":"LWCB-PXF","helpCodeFull":"laowuchengben-peixunfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400229 劳务成本-劳务费","id":99198,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400229","name":"劳务费","gradeName":"劳务成本-劳务费","helpCode":"LWCB-LWF","helpCodeFull":"laowuchengben-laowufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400230 劳务成本-仓储费","id":99199,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400230","name":"仓储费","gradeName":"劳务成本-仓储费","helpCode":"LWCB-CCF","helpCodeFull":"laowuchengben-cangchufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"400299 劳务成本-其他","id":99200,"parentId":99051,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"400299","name":"其他","gradeName":"劳务成本-其他","helpCode":"LWCB-QT","helpCodeFull":"laowuchengben-qita","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410101 制造费用-办公用品及办公费","id":99201,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410101","name":"办公用品及办公费","gradeName":"制造费用-办公用品及办公费","helpCode":"ZZFY-BGYPJBGF","helpCodeFull":"zhizaofeiyong-bangongyongpinjibangongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410102 制造费用-租赁费","id":99202,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410102","name":"租赁费","gradeName":"制造费用-租赁费","helpCode":"ZZFY-ZLF","helpCodeFull":"zhizaofeiyong-zulinfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410103 制造费用-物业管理费","id":99203,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410103","name":"物业管理费","gradeName":"制造费用-物业管理费","helpCode":"ZZFY-WYGLF","helpCodeFull":"zhizaofeiyong-wuyeguanlifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410104 制造费用-水电费","id":99204,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410104","name":"水电费","gradeName":"制造费用-水电费","helpCode":"ZZFY-SDF","helpCodeFull":"zhizaofeiyong-shuidianfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410105 制造费用-职工工资","id":99205,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410105","name":"职工工资","gradeName":"制造费用-职工工资","helpCode":"ZZFY-ZGGZ","helpCodeFull":"zhizaofeiyong-zhigonggongzi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410106 制造费用-基本社会保险费","id":99206,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410106","name":"基本社会保险费","gradeName":"制造费用-基本社会保险费","helpCode":"ZZFY-JBSHBXF","helpCodeFull":"zhizaofeiyong-jibenshehuibaoxianfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410107 制造费用-补充养老保险","id":99207,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410107","name":"补充养老保险","gradeName":"制造费用-补充养老保险","helpCode":"ZZFY-BCYLBX","helpCodeFull":"zhizaofeiyong-buchongyanglaobaoxian","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410108 制造费用-补充医疗保险","id":99208,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410108","name":"补充医疗保险","gradeName":"制造费用-补充医疗保险","helpCode":"ZZFY-BCYLBX","helpCodeFull":"zhizaofeiyong-buchongyiliaobaoxian","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410109 制造费用-住房公积金","id":99209,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410109","name":"住房公积金","gradeName":"制造费用-住房公积金","helpCode":"ZZFY-ZFGJJ","helpCodeFull":"zhizaofeiyong-zhufanggongjijin","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410110 制造费用-福利费","id":99210,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410110","name":"福利费","gradeName":"制造费用-福利费","helpCode":"ZZFY-FLF","helpCodeFull":"zhizaofeiyong-fulifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410111 制造费用-工会经费","id":99211,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410111","name":"工会经费","gradeName":"制造费用-工会经费","helpCode":"ZZFY-GHJF","helpCodeFull":"zhizaofeiyong-gonghuijingfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410112 制造费用-职工教育经费","id":99212,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410112","name":"职工教育经费","gradeName":"制造费用-职工教育经费","helpCode":"ZZFY-ZGJYJF","helpCodeFull":"zhizaofeiyong-zhigongjiaoyujingfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410113 制造费用-折旧费","id":99213,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410113","name":"折旧费","gradeName":"制造费用-折旧费","helpCode":"ZZFY-ZJF","helpCodeFull":"zhizaofeiyong-zhejiufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410114 制造费用-无形资产摊销","id":99214,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410114","name":"无形资产摊销","gradeName":"制造费用-无形资产摊销","helpCode":"ZZFY-WXZCTX","helpCodeFull":"zhizaofeiyong-wuxingzichantanxiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410115 制造费用-长期待摊费用摊销","id":99215,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410115","name":"长期待摊费用摊销","gradeName":"制造费用-长期待摊费用摊销","helpCode":"ZZFY-CQDTFYTX","helpCodeFull":"zhizaofeiyong-changqidaitanfeiyongtanxiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410116 制造费用-周转材料摊销","id":99216,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410116","name":"周转材料摊销","gradeName":"制造费用-周转材料摊销","helpCode":"ZZFY-ZZCLTX","helpCodeFull":"zhizaofeiyong-zhouzhuancailiaotanxiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410117 制造费用-劳保费","id":99217,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410117","name":"劳保费","gradeName":"制造费用-劳保费","helpCode":"ZZFY-LBF","helpCodeFull":"zhizaofeiyong-laobaofei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410118 制造费用-修理费","id":99218,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410118","name":"修理费","gradeName":"制造费用-修理费","helpCode":"ZZFY-XLF","helpCodeFull":"zhizaofeiyong-xiulifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410119 制造费用-劳务费","id":99219,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410119","name":"劳务费","gradeName":"制造费用-劳务费","helpCode":"ZZFY-LWF","helpCodeFull":"zhizaofeiyong-laowufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410120 制造费用-仓储费","id":99220,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410120","name":"仓储费","gradeName":"制造费用-仓储费","helpCode":"ZZFY-CCF","helpCodeFull":"zhizaofeiyong-cangchufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410121 制造费用-交通费","id":99221,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410121","name":"交通费","gradeName":"制造费用-交通费","helpCode":"ZZFY-JTF","helpCodeFull":"zhizaofeiyong-jiaotongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410122 制造费用-差旅费","id":99222,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410122","name":"差旅费","gradeName":"制造费用-差旅费","helpCode":"ZZFY-CLF","helpCodeFull":"zhizaofeiyong-chalvfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410123 制造费用-通讯费","id":99223,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410123","name":"通讯费","gradeName":"制造费用-通讯费","helpCode":"ZZFY-TXF","helpCodeFull":"zhizaofeiyong-tongxunfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410124 制造费用-会议费","id":99224,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410124","name":"会议费","gradeName":"制造费用-会议费","helpCode":"ZZFY-HYF","helpCodeFull":"zhizaofeiyong-huiyifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410125 制造费用-网络使用费","id":99225,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410125","name":"网络使用费","gradeName":"制造费用-网络使用费","helpCode":"ZZFY-WLSYF","helpCodeFull":"zhizaofeiyong-wangluoshiyongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410126 制造费用-车辆使用费","id":99226,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410126","name":"车辆使用费","gradeName":"制造费用-车辆使用费","helpCode":"ZZFY-CLSYF","helpCodeFull":"zhizaofeiyong-cheliangshiyongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410127 制造费用-旅游费","id":99227,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410127","name":"旅游费","gradeName":"制造费用-旅游费","helpCode":"ZZFY-LYF","helpCodeFull":"zhizaofeiyong-lvyoufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410128 制造费用-快递物流费","id":99228,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410128","name":"快递物流费","gradeName":"制造费用-快递物流费","helpCode":"ZZFY-KDWLF","helpCodeFull":"zhizaofeiyong-kuaidiwuliufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410129 制造费用-培训费","id":99229,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410129","name":"培训费","gradeName":"制造费用-培训费","helpCode":"ZZFY-PXF","helpCodeFull":"zhizaofeiyong-peixunfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"410199 制造费用-其他","id":99230,"parentId":99052,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"410199","name":"其他","gradeName":"制造费用-其他","helpCode":"ZZFY-QT","helpCodeFull":"zhizaofeiyong-qita","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010101 研发支出-费用化支出-职工工资","id":99396,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010101","name":"职工工资","gradeName":"研发支出-费用化支出-职工工资","helpCode":"YFZC-FYHZC-ZGGZ","helpCodeFull":"yanfazhichu-feiyonghuazhichu-zhigonggongzi","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010102 研发支出-费用化支出-基本社会保险费","id":99397,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010102","name":"基本社会保险费","gradeName":"研发支出-费用化支出-基本社会保险费","helpCode":"YFZC-FYHZC-JBSHBXF","helpCodeFull":"yanfazhichu-feiyonghuazhichu-jibenshehuibaoxianfei","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010103 研发支出-费用化支出-补充养老保险","id":99398,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010103","name":"补充养老保险","gradeName":"研发支出-费用化支出-补充养老保险","helpCode":"YFZC-FYHZC-BCYLBX","helpCodeFull":"yanfazhichu-feiyonghuazhichu-buchongyanglaobaoxian","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010104 研发支出-费用化支出-补充医疗保险","id":99399,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010104","name":"补充医疗保险","gradeName":"研发支出-费用化支出-补充医疗保险","helpCode":"YFZC-FYHZC-BCYLBX","helpCodeFull":"yanfazhichu-feiyonghuazhichu-buchongyiliaobaoxian","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010105 研发支出-费用化支出-住房公积金","id":99400,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010105","name":"住房公积金","gradeName":"研发支出-费用化支出-住房公积金","helpCode":"YFZC-FYHZC-ZFGJJ","helpCodeFull":"yanfazhichu-feiyonghuazhichu-zhufanggongjijin","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010106 研发支出-费用化支出-福利费","id":99401,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010106","name":"福利费","gradeName":"研发支出-费用化支出-福利费","helpCode":"YFZC-FYHZC-FLF","helpCodeFull":"yanfazhichu-feiyonghuazhichu-fulifei","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010107 研发支出-费用化支出-工会经费","id":99402,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010107","name":"工会经费","gradeName":"研发支出-费用化支出-工会经费","helpCode":"YFZC-FYHZC-GHJF","helpCodeFull":"yanfazhichu-feiyonghuazhichu-gonghuijingfei","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010108 研发支出-费用化支出-职工教育经费","id":99403,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010108","name":"职工教育经费","gradeName":"研发支出-费用化支出-职工教育经费","helpCode":"YFZC-FYHZC-ZGJYJF","helpCodeFull":"yanfazhichu-feiyonghuazhichu-zhigongjiaoyujingfei","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010109 研发支出-费用化支出-外聘研发人员劳务费","id":99404,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010109","name":"外聘研发人员劳务费","gradeName":"研发支出-费用化支出-外聘研发人员劳务费","helpCode":"YFZC-FYHZC-WPYFRYLWF","helpCodeFull":"yanfazhichu-feiyonghuazhichu-waipinyanfarenyuanlaowufei","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010110 研发支出-费用化支出-材料费","id":99405,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010110","name":"材料费","gradeName":"研发支出-费用化支出-材料费","helpCode":"YFZC-FYHZC-CLF","helpCodeFull":"yanfazhichu-feiyonghuazhichu-cailiaofei","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010111 研发支出-费用化支出-燃料费","id":99406,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010111","name":"燃料费","gradeName":"研发支出-费用化支出-燃料费","helpCode":"YFZC-FYHZC-RLF","helpCodeFull":"yanfazhichu-feiyonghuazhichu-ranliaofei","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010112 研发支出-费用化支出-动力费用","id":99407,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010112","name":"动力费用","gradeName":"研发支出-费用化支出-动力费用","helpCode":"YFZC-FYHZC-DLFY","helpCodeFull":"yanfazhichu-feiyonghuazhichu-donglifeiyong","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010113 研发支出-费用化支出-模具及工艺装备开发制造费","id":99408,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010113","name":"模具及工艺装备开发制造费","gradeName":"研发支出-费用化支出-模具及工艺装备开发制造费","helpCode":"YFZC-FYHZC-MJJGYZBKFZZF","helpCodeFull":"yanfazhichu-feiyonghuazhichu-mojujigongyizhuangbeikaifazhizaofei","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010114 研发支出-费用化支出-样品样机及测试手段购置费","id":99409,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010114","name":"样品样机及测试手段购置费","gradeName":"研发支出-费用化支出-样品样机及测试手段购置费","helpCode":"YFZC-FYHZC-YPYJJCSSDGZF","helpCodeFull":"yanfazhichu-feiyonghuazhichu-yangpinyangjijiceshishouduangouzhifei","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010115 研发支出-费用化支出-检验费","id":99410,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010115","name":"检验费","gradeName":"研发支出-费用化支出-检验费","helpCode":"YFZC-FYHZC-JYF","helpCodeFull":"yanfazhichu-feiyonghuazhichu-jianyanfei","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010116 研发支出-费用化支出-仪器设备维护费","id":99411,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010116","name":"仪器设备维护费","gradeName":"研发支出-费用化支出-仪器设备维护费","helpCode":"YFZC-FYHZC-YQSBWHF","helpCodeFull":"yanfazhichu-feiyonghuazhichu-yiqishebeiweihufei","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010117 研发支出-费用化支出-仪器设备租赁费","id":99412,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010117","name":"仪器设备租赁费","gradeName":"研发支出-费用化支出-仪器设备租赁费","helpCode":"YFZC-FYHZC-YQSBZLF","helpCodeFull":"yanfazhichu-feiyonghuazhichu-yiqishebeizulinfei","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010118 研发支出-费用化支出-折旧费用","id":99413,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010118","name":"折旧费用","gradeName":"研发支出-费用化支出-折旧费用","helpCode":"YFZC-FYHZC-ZJFY","helpCodeFull":"yanfazhichu-feiyonghuazhichu-zhejiufeiyong","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010119 研发支出-费用化支出-无形资产摊销","id":99414,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010119","name":"无形资产摊销","gradeName":"研发支出-费用化支出-无形资产摊销","helpCode":"YFZC-FYHZC-WXZCTX","helpCodeFull":"yanfazhichu-feiyonghuazhichu-wuxingzichantanxiao","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010120 研发支出-费用化支出-长期待摊费用摊销","id":99415,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010120","name":"长期待摊费用摊销","gradeName":"研发支出-费用化支出-长期待摊费用摊销","helpCode":"YFZC-FYHZC-CQDTFYTX","helpCodeFull":"yanfazhichu-feiyonghuazhichu-changqidaitanfeiyongtanxiao","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010121 研发支出-费用化支出-新产品设计费","id":99416,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010121","name":"新产品设计费","gradeName":"研发支出-费用化支出-新产品设计费","helpCode":"YFZC-FYHZC-XCPSJF","helpCodeFull":"yanfazhichu-feiyonghuazhichu-xinchanpinshejifei","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010122 研发支出-费用化支出-委托研发投入","id":99417,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010122","name":"委托研发投入","gradeName":"研发支出-费用化支出-委托研发投入","helpCode":"YFZC-FYHZC-WTYFTR","helpCodeFull":"yanfazhichu-feiyonghuazhichu-weituoyanfatouru","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"费用化支出","codeAndName":"43010199 研发支出-费用化支出-其他费用","id":99418,"parentId":99231,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010199","name":"其他费用","gradeName":"研发支出-费用化支出-其他费用","helpCode":"YFZC-FYHZC-QTFY","helpCodeFull":"yanfazhichu-feiyonghuazhichu-qitafeiyong","balanceDirection":0,"cashTypeId":5000020011,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010201 研发支出-资本化支出-职工工资","id":99419,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010201","name":"职工工资","gradeName":"研发支出-资本化支出-职工工资","helpCode":"YFZC-ZBHZC-ZGGZ","helpCodeFull":"yanfazhichu-zibenhuazhichu-zhigonggongzi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010202 研发支出-资本化支出-基本社会保险费","id":99420,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010202","name":"基本社会保险费","gradeName":"研发支出-资本化支出-基本社会保险费","helpCode":"YFZC-ZBHZC-JBSHBXF","helpCodeFull":"yanfazhichu-zibenhuazhichu-jibenshehuibaoxianfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010203 研发支出-资本化支出-补充养老保险","id":99421,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010203","name":"补充养老保险","gradeName":"研发支出-资本化支出-补充养老保险","helpCode":"YFZC-ZBHZC-BCYLBX","helpCodeFull":"yanfazhichu-zibenhuazhichu-buchongyanglaobaoxian","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010204 研发支出-资本化支出-补充医疗保险","id":99422,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010204","name":"补充医疗保险","gradeName":"研发支出-资本化支出-补充医疗保险","helpCode":"YFZC-ZBHZC-BCYLBX","helpCodeFull":"yanfazhichu-zibenhuazhichu-buchongyiliaobaoxian","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010205 研发支出-资本化支出-住房公积金","id":99423,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010205","name":"住房公积金","gradeName":"研发支出-资本化支出-住房公积金","helpCode":"YFZC-ZBHZC-ZFGJJ","helpCodeFull":"yanfazhichu-zibenhuazhichu-zhufanggongjijin","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010206 研发支出-资本化支出-福利费","id":99424,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010206","name":"福利费","gradeName":"研发支出-资本化支出-福利费","helpCode":"YFZC-ZBHZC-FLF","helpCodeFull":"yanfazhichu-zibenhuazhichu-fulifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010207 研发支出-资本化支出-工会经费","id":99425,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010207","name":"工会经费","gradeName":"研发支出-资本化支出-工会经费","helpCode":"YFZC-ZBHZC-GHJF","helpCodeFull":"yanfazhichu-zibenhuazhichu-gonghuijingfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010208 研发支出-资本化支出-职工教育经费","id":99426,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010208","name":"职工教育经费","gradeName":"研发支出-资本化支出-职工教育经费","helpCode":"YFZC-ZBHZC-ZGJYJF","helpCodeFull":"yanfazhichu-zibenhuazhichu-zhigongjiaoyujingfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010209 研发支出-资本化支出-外聘研发人员劳务费","id":99427,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010209","name":"外聘研发人员劳务费","gradeName":"研发支出-资本化支出-外聘研发人员劳务费","helpCode":"YFZC-ZBHZC-WPYFRYLWF","helpCodeFull":"yanfazhichu-zibenhuazhichu-waipinyanfarenyuanlaowufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010210 研发支出-资本化支出-材料费","id":99428,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010210","name":"材料费","gradeName":"研发支出-资本化支出-材料费","helpCode":"YFZC-ZBHZC-CLF","helpCodeFull":"yanfazhichu-zibenhuazhichu-cailiaofei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010211 研发支出-资本化支出-燃料费","id":99429,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010211","name":"燃料费","gradeName":"研发支出-资本化支出-燃料费","helpCode":"YFZC-ZBHZC-RLF","helpCodeFull":"yanfazhichu-zibenhuazhichu-ranliaofei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010212 研发支出-资本化支出-动力费用","id":99430,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010212","name":"动力费用","gradeName":"研发支出-资本化支出-动力费用","helpCode":"YFZC-ZBHZC-DLFY","helpCodeFull":"yanfazhichu-zibenhuazhichu-donglifeiyong","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010213 研发支出-资本化支出-模具及工艺装备开发制造费","id":99431,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010213","name":"模具及工艺装备开发制造费","gradeName":"研发支出-资本化支出-模具及工艺装备开发制造费","helpCode":"YFZC-ZBHZC-MJJGYZBKFZZF","helpCodeFull":"yanfazhichu-zibenhuazhichu-mojujigongyizhuangbeikaifazhizaofei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010214 研发支出-资本化支出-样品样机及测试手段购置费","id":99432,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010214","name":"样品样机及测试手段购置费","gradeName":"研发支出-资本化支出-样品样机及测试手段购置费","helpCode":"YFZC-ZBHZC-YPYJJCSSDGZF","helpCodeFull":"yanfazhichu-zibenhuazhichu-yangpinyangjijiceshishouduangouzhifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010215 研发支出-资本化支出-检验费","id":99433,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010215","name":"检验费","gradeName":"研发支出-资本化支出-检验费","helpCode":"YFZC-ZBHZC-JYF","helpCodeFull":"yanfazhichu-zibenhuazhichu-jianyanfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010216 研发支出-资本化支出-仪器设备维护费","id":99434,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010216","name":"仪器设备维护费","gradeName":"研发支出-资本化支出-仪器设备维护费","helpCode":"YFZC-ZBHZC-YQSBWHF","helpCodeFull":"yanfazhichu-zibenhuazhichu-yiqishebeiweihufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010217 研发支出-资本化支出-仪器设备租赁费","id":99435,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010217","name":"仪器设备租赁费","gradeName":"研发支出-资本化支出-仪器设备租赁费","helpCode":"YFZC-ZBHZC-YQSBZLF","helpCodeFull":"yanfazhichu-zibenhuazhichu-yiqishebeizulinfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010218 研发支出-资本化支出-折旧费用","id":99436,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010218","name":"折旧费用","gradeName":"研发支出-资本化支出-折旧费用","helpCode":"YFZC-ZBHZC-ZJFY","helpCodeFull":"yanfazhichu-zibenhuazhichu-zhejiufeiyong","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010219 研发支出-资本化支出-无形资产摊销","id":99437,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010219","name":"无形资产摊销","gradeName":"研发支出-资本化支出-无形资产摊销","helpCode":"YFZC-ZBHZC-WXZCTX","helpCodeFull":"yanfazhichu-zibenhuazhichu-wuxingzichantanxiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010220 研发支出-资本化支出-长期待摊费用摊销","id":99438,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010220","name":"长期待摊费用摊销","gradeName":"研发支出-资本化支出-长期待摊费用摊销","helpCode":"YFZC-ZBHZC-CQDTFYTX","helpCodeFull":"yanfazhichu-zibenhuazhichu-changqidaitanfeiyongtanxiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010221 研发支出-资本化支出-新产品设计费","id":99439,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010221","name":"新产品设计费","gradeName":"研发支出-资本化支出-新产品设计费","helpCode":"YFZC-ZBHZC-XCPSJF","helpCodeFull":"yanfazhichu-zibenhuazhichu-xinchanpinshejifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010222 研发支出-资本化支出-委托研发投入","id":99440,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010222","name":"委托研发投入","gradeName":"研发支出-资本化支出-委托研发投入","helpCode":"YFZC-ZBHZC-WTYFTR","helpCodeFull":"yanfazhichu-zibenhuazhichu-weituoyanfatouru","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"43010299 研发支出-资本化支出-其他费用","id":99441,"parentId":99232,"grade":3,"isEndNode":true,"accountTypeId":5000010005,"code":"43010299","name":"其他费用","gradeName":"研发支出-资本化支出-其他费用","helpCode":"YFZC-ZBHZC-QTFY","helpCodeFull":"yanfazhichu-zibenhuazhichu-qitafeiyong","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"440101 工程施工-合同成本","id":99233,"parentId":99054,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"440101","name":"合同成本","gradeName":"工程施工-合同成本","helpCode":"GCSG-HTCB","helpCodeFull":"gongchengshigong-hetongchengben","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"440102 工程施工-合同毛利","id":99234,"parentId":99054,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"440102","name":"合同毛利","gradeName":"工程施工-合同毛利","helpCode":"GCSG-HTML","helpCodeFull":"gongchengshigong-hetongmaoli","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"440103 工程施工-间接费用","id":99235,"parentId":99054,"grade":2,"isEndNode":true,"accountTypeId":5000010005,"code":"440103","name":"间接费用","gradeName":"工程施工-间接费用","helpCode":"GCSG-JJFY","helpCodeFull":"gongchengshigong-jianjiefeiyong","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"成本","balanceDirectionName":"借","cashTypeName":"","codeAndName":"4403 机械作业","id":99055,"grade":1,"isEndNode":true,"accountTypeId":5000010005,"code":"4403","name":"机械作业","gradeName":"机械作业","helpCode":"JXZY","helpCodeFull":"jixiezuoye","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"货物销售","codeAndName":"5001 主营业务收入","id":99056,"grade":1,"isEndNode":true,"accountTypeId":5000010006,"code":"5001","name":"主营业务收入","gradeName":"主营业务收入","helpCode":"ZYYWSR","helpCodeFull":"zhuyingyewushouru","balanceDirection":1,"cashTypeId":5000020007,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"505101 其他业务收入-销售材料收入","id":99236,"parentId":99057,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"505101","name":"销售材料收入","gradeName":"其他业务收入-销售材料收入","helpCode":"QTYWSR-XSCLSR","helpCodeFull":"qitayewushouru-xiaoshoucailiaoshouru","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"505102 其他业务收入-出租固定资产收入","id":99237,"parentId":99057,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"505102","name":"出租固定资产收入","gradeName":"其他业务收入-出租固定资产收入","helpCode":"QTYWSR-CZGDZCSR","helpCodeFull":"qitayewushouru-chuzugudingzichanshouru","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"505103 其他业务收入-出租无形资产收入","id":99238,"parentId":99057,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"505103","name":"出租无形资产收入","gradeName":"其他业务收入-出租无形资产收入","helpCode":"QTYWSR-CZWXZCSR","helpCodeFull":"qitayewushouru-chuzuwuxingzichanshouru","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"505104 其他业务收入-出租包装物和商品收入","id":99239,"parentId":99057,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"505104","name":"出租包装物和商品收入","gradeName":"其他业务收入-出租包装物和商品收入","helpCode":"QTYWSR-CZBZWHSPSR","helpCodeFull":"qitayewushouru-chuzubaozhuangwuheshangpinshouru","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"505199 其他业务收入-其他","id":99240,"parentId":99057,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"505199","name":"其他","gradeName":"其他业务收入-其他","helpCode":"QTYWSR-QT","helpCodeFull":"qitayewushouru-qita","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"5111 投资收益","id":99058,"grade":1,"isEndNode":true,"accountTypeId":5000010006,"code":"5111","name":"投资收益","gradeName":"投资收益","helpCode":"TZSY","helpCodeFull":"touzishouyi","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"530101 营业外收入-非流动资产处置净收益","id":99241,"parentId":99059,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"530101","name":"非流动资产处置净收益","gradeName":"营业外收入-非流动资产处置净收益","helpCode":"YYWSR-FLDZCCZJSY","helpCodeFull":"yingyewaishouru-feiliudongzichanchuzhijingshouyi","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"530102 营业外收入-政府补助","id":99242,"parentId":99059,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"530102","name":"政府补助","gradeName":"营业外收入-政府补助","helpCode":"YYWSR-ZFBZ","helpCodeFull":"yingyewaishouru-zhengfubuzhu","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"530103 营业外收入-税费返还","id":99243,"parentId":99059,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"530103","name":"税费返还","gradeName":"营业外收入-税费返还","helpCode":"YYWSR-SFFH","helpCodeFull":"yingyewaishouru-shuifeifanhuan","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"530104 营业外收入-捐赠收益","id":99244,"parentId":99059,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"530104","name":"捐赠收益","gradeName":"营业外收入-捐赠收益","helpCode":"YYWSR-JZSY","helpCodeFull":"yingyewaishouru-juanzengshouyi","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"530105 营业外收入-盘盈收益","id":99245,"parentId":99059,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"530105","name":"盘盈收益","gradeName":"营业外收入-盘盈收益","helpCode":"YYWSR-PYSY","helpCodeFull":"yingyewaishouru-panyingshouyi","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"530106 营业外收入-确实无法偿付的应付账款","id":99246,"parentId":99059,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"530106","name":"确实无法偿付的应付账款","gradeName":"营业外收入-确实无法偿付的应付账款","helpCode":"YYWSR-QSWFCFDYFZK","helpCodeFull":"yingyewaishouru-queshiwufachangfudeyingfuzhangkuan","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"530107 营业外收入-已作坏账损失处理后又收回的应收账款","id":99247,"parentId":99059,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"530107","name":"已作坏账损失处理后又收回的应收账款","gradeName":"营业外收入-已作坏账损失处理后又收回的应收账款","helpCode":"YYWSR-YZHZSSCLHYSHDYSZK","helpCodeFull":"yingyewaishouru-yizuohuaizhangsunshichulihouyoushouhuideyingshouzhangkuan","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"530108 营业外收入-出租包装物和商品的租金收入","id":99248,"parentId":99059,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"530108","name":"出租包装物和商品的租金收入","gradeName":"营业外收入-出租包装物和商品的租金收入","helpCode":"YYWSR-CZBZWHSPDZJSR","helpCodeFull":"yingyewaishouru-chuzubaozhuangwuheshangpindezujinshouru","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"530109 营业外收入-逾期未退包装物押金收益","id":99249,"parentId":99059,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"530109","name":"逾期未退包装物押金收益","gradeName":"营业外收入-逾期未退包装物押金收益","helpCode":"YYWSR-YQWTBZWYJSY","helpCodeFull":"yingyewaishouru-yuqiweituibaozhuangwuyajinshouyi","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"530110 营业外收入-汇兑收益","id":99250,"parentId":99059,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"530110","name":"汇兑收益","gradeName":"营业外收入-汇兑收益","helpCode":"YYWSR-HDSY","helpCodeFull":"yingyewaishouru-huiduishouyi","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"530111 营业外收入-罚没及违约金收益","id":99251,"parentId":99059,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"530111","name":"罚没及违约金收益","gradeName":"营业外收入-罚没及违约金收益","helpCode":"YYWSR-FMJWYJSY","helpCodeFull":"yingyewaishouru-fameijiweiyuejinshouyi","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"530112 营业外收入-非货币性资产交换利得","id":99252,"parentId":99059,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"530112","name":"非货币性资产交换利得","gradeName":"营业外收入-非货币性资产交换利得","helpCode":"YYWSR-FHBXZCJHLD","helpCodeFull":"yingyewaishouru-feihuobixingzichanjiaohuanlide","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"530113 营业外收入-债务重组利得","id":99253,"parentId":99059,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"530113","name":"债务重组利得","gradeName":"营业外收入-债务重组利得","helpCode":"YYWSR-ZWZZLD","helpCodeFull":"yingyewaishouru-zhaiwuzhongzulide","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"贷","cashTypeName":"","codeAndName":"530199 营业外收入-其他","id":99254,"parentId":99059,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"530199","name":"其他","gradeName":"营业外收入-其他","helpCode":"YYWSR-QT","helpCodeFull":"yingyewaishouru-qita","balanceDirection":1,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"货物销售成本","codeAndName":"5401 主营业务成本","id":99060,"grade":1,"isEndNode":true,"accountTypeId":5000010006,"code":"5401","name":"主营业务成本","gradeName":"主营业务成本","helpCode":"ZYYWCB","helpCodeFull":"zhuyingyewuchengben","balanceDirection":0,"cashTypeId":5000020008,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540201 其他业务成本-销售材料","id":99255,"parentId":99061,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540201","name":"销售材料","gradeName":"其他业务成本-销售材料","helpCode":"QTYWCB-XSCL","helpCodeFull":"qitayewuchengben-xiaoshoucailiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540202 其他业务成本-非货币性资产交换","id":99256,"parentId":99061,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540202","name":"非货币性资产交换","gradeName":"其他业务成本-非货币性资产交换","helpCode":"QTYWCB-FHBXZCJH","helpCodeFull":"qitayewuchengben-feihuobixingzichanjiaohuan","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540203 其他业务成本-出租固定资产","id":99257,"parentId":99061,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540203","name":"出租固定资产","gradeName":"其他业务成本-出租固定资产","helpCode":"QTYWCB-CZGDZC","helpCodeFull":"qitayewuchengben-chuzugudingzichan","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540204 其他业务成本-出租无形资产","id":99258,"parentId":99061,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540204","name":"出租无形资产","gradeName":"其他业务成本-出租无形资产","helpCode":"QTYWCB-CZWXZC","helpCodeFull":"qitayewuchengben-chuzuwuxingzichan","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540205 其他业务成本-出租包装物","id":99259,"parentId":99061,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540205","name":"出租包装物","gradeName":"其他业务成本-出租包装物","helpCode":"QTYWCB-CZBZW","helpCodeFull":"qitayewuchengben-chuzubaozhuangwu","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540299 其他业务成本-其他","id":99260,"parentId":99061,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540299","name":"其他","gradeName":"其他业务成本-其他","helpCode":"QTYWCB-QT","helpCodeFull":"qitayewuchengben-qita","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540301 营业税金及附加-消费税","id":99261,"parentId":99062,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540301","name":"消费税","gradeName":"营业税金及附加-消费税","helpCode":"YYSJJFJ-XFS","helpCodeFull":"yingyeshuijinjifujia-xiaofeishui","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540302 营业税金及附加-营业税","id":99262,"parentId":99062,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540302","name":"营业税","gradeName":"营业税金及附加-营业税","helpCode":"YYSJJFJ-YYS","helpCodeFull":"yingyeshuijinjifujia-yingyeshui","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540303 营业税金及附加-城市维护建设税","id":99263,"parentId":99062,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540303","name":"城市维护建设税","gradeName":"营业税金及附加-城市维护建设税","helpCode":"YYSJJFJ-CSWHJSS","helpCodeFull":"yingyeshuijinjifujia-chengshiweihujiansheshui","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540304 营业税金及附加-资源税","id":99264,"parentId":99062,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540304","name":"资源税","gradeName":"营业税金及附加-资源税","helpCode":"YYSJJFJ-ZYS","helpCodeFull":"yingyeshuijinjifujia-ziyuanshui","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540305 营业税金及附加-土地增值税","id":99265,"parentId":99062,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540305","name":"土地增值税","gradeName":"营业税金及附加-土地增值税","helpCode":"YYSJJFJ-TDZZS","helpCodeFull":"yingyeshuijinjifujia-tudizengzhishui","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540306 营业税金及附加-城镇土地使用税","id":99266,"parentId":99062,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540306","name":"城镇土地使用税","gradeName":"营业税金及附加-城镇土地使用税","helpCode":"YYSJJFJ-CZTDSYS","helpCodeFull":"yingyeshuijinjifujia-chengzhentudishiyongshui","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540307 营业税金及附加-房产税","id":99267,"parentId":99062,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540307","name":"房产税","gradeName":"营业税金及附加-房产税","helpCode":"YYSJJFJ-FCS","helpCodeFull":"yingyeshuijinjifujia-fangchanshui","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540308 营业税金及附加-车船税","id":99268,"parentId":99062,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540308","name":"车船税","gradeName":"营业税金及附加-车船税","helpCode":"YYSJJFJ-CCS","helpCodeFull":"yingyeshuijinjifujia-chechuanshui","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540309 营业税金及附加-印花税","id":99269,"parentId":99062,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540309","name":"印花税","gradeName":"营业税金及附加-印花税","helpCode":"YYSJJFJ-YHS","helpCodeFull":"yingyeshuijinjifujia-yinhuashui","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540310 营业税金及附加-教育费附加","id":99270,"parentId":99062,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540310","name":"教育费附加","gradeName":"营业税金及附加-教育费附加","helpCode":"YYSJJFJ-JYFFJ","helpCodeFull":"yingyeshuijinjifujia-jiaoyufeifujia","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540311 营业税金及附加-矿产资源补偿费","id":99271,"parentId":99062,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540311","name":"矿产资源补偿费","gradeName":"营业税金及附加-矿产资源补偿费","helpCode":"YYSJJFJ-KCZYBCF","helpCodeFull":"yingyeshuijinjifujia-kuangchanziyuanbuchangfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540312 营业税金及附加-排污费","id":99272,"parentId":99062,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540312","name":"排污费","gradeName":"营业税金及附加-排污费","helpCode":"YYSJJFJ-PWF","helpCodeFull":"yingyeshuijinjifujia-paiwufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540313 营业税金及附加-文化事业建设费","id":99273,"parentId":99062,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540313","name":"文化事业建设费","gradeName":"营业税金及附加-文化事业建设费","helpCode":"YYSJJFJ-WHSYJSF","helpCodeFull":"yingyeshuijinjifujia-wenhuashiyejianshefei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"540314 营业税金及附加-水利建设基金","id":99274,"parentId":99062,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"540314","name":"水利建设基金","gradeName":"营业税金及附加-水利建设基金","helpCode":"YYSJJFJ-SLJSJJ","helpCodeFull":"yingyeshuijinjifujia-shuilijianshejijin","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560101 销售费用-职工工资","id":99275,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560101","name":"职工工资","gradeName":"销售费用-职工工资","helpCode":"XSFY-ZGGZ","helpCodeFull":"xiaoshoufeiyong-zhigonggongzi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560102 销售费用-基本社会保险费","id":99276,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560102","name":"基本社会保险费","gradeName":"销售费用-基本社会保险费","helpCode":"XSFY-JBSHBXF","helpCodeFull":"xiaoshoufeiyong-jibenshehuibaoxianfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560103 销售费用-补充养老保险","id":99277,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560103","name":"补充养老保险","gradeName":"销售费用-补充养老保险","helpCode":"XSFY-BCYLBX","helpCodeFull":"xiaoshoufeiyong-buchongyanglaobaoxian","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560104 销售费用-补充医疗保险","id":99278,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560104","name":"补充医疗保险","gradeName":"销售费用-补充医疗保险","helpCode":"XSFY-BCYLBX","helpCodeFull":"xiaoshoufeiyong-buchongyiliaobaoxian","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560105 销售费用-住房公积金","id":99279,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560105","name":"住房公积金","gradeName":"销售费用-住房公积金","helpCode":"XSFY-ZFGJJ","helpCodeFull":"xiaoshoufeiyong-zhufanggongjijin","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560106 销售费用-福利费","id":99280,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560106","name":"福利费","gradeName":"销售费用-福利费","helpCode":"XSFY-FLF","helpCodeFull":"xiaoshoufeiyong-fulifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560107 销售费用-工会经费","id":99281,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560107","name":"工会经费","gradeName":"销售费用-工会经费","helpCode":"XSFY-GHJF","helpCodeFull":"xiaoshoufeiyong-gonghuijingfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560108 销售费用-职工教育经费","id":99282,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560108","name":"职工教育经费","gradeName":"销售费用-职工教育经费","helpCode":"XSFY-ZGJYJF","helpCodeFull":"xiaoshoufeiyong-zhigongjiaoyujingfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560109 销售费用-办公费","id":99283,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560109","name":"办公费","gradeName":"销售费用-办公费","helpCode":"XSFY-BGF","helpCodeFull":"xiaoshoufeiyong-bangongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560110 销售费用-业务招待费","id":99284,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560110","name":"业务招待费","gradeName":"销售费用-业务招待费","helpCode":"XSFY-YWZDF","helpCodeFull":"xiaoshoufeiyong-yewuzhaodaifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560111 销售费用-广告宣传费","id":99285,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560111","name":"广告宣传费","gradeName":"销售费用-广告宣传费","helpCode":"XSFY-GGXCF","helpCodeFull":"xiaoshoufeiyong-guanggaoxuanchuanfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560112 销售费用-差旅费","id":99286,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560112","name":"差旅费","gradeName":"销售费用-差旅费","helpCode":"XSFY-CLF","helpCodeFull":"xiaoshoufeiyong-chalvfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560113 销售费用-交通费","id":99287,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560113","name":"交通费","gradeName":"销售费用-交通费","helpCode":"XSFY-JTF","helpCodeFull":"xiaoshoufeiyong-jiaotongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560114 销售费用-快递物流费","id":99288,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560114","name":"快递物流费","gradeName":"销售费用-快递物流费","helpCode":"XSFY-KDWLF","helpCodeFull":"xiaoshoufeiyong-kuaidiwuliufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560115 销售费用-通讯费","id":99289,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560115","name":"通讯费","gradeName":"销售费用-通讯费","helpCode":"XSFY-TXF","helpCodeFull":"xiaoshoufeiyong-tongxunfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560116 销售费用-会议费","id":99290,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560116","name":"会议费","gradeName":"销售费用-会议费","helpCode":"XSFY-HYF","helpCodeFull":"xiaoshoufeiyong-huiyifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560117 销售费用-折旧费","id":99291,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560117","name":"折旧费","gradeName":"销售费用-折旧费","helpCode":"XSFY-ZJF","helpCodeFull":"xiaoshoufeiyong-zhejiufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560118 销售费用-无形资产摊销","id":99292,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560118","name":"无形资产摊销","gradeName":"销售费用-无形资产摊销","helpCode":"XSFY-WXZCTX","helpCodeFull":"xiaoshoufeiyong-wuxingzichantanxiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560119 销售费用-长期待摊费用摊销","id":99293,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560119","name":"长期待摊费用摊销","gradeName":"销售费用-长期待摊费用摊销","helpCode":"XSFY-CQDTFYTX","helpCodeFull":"xiaoshoufeiyong-changqidaitanfeiyongtanxiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560120 销售费用-周转材料摊销","id":99294,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560120","name":"周转材料摊销","gradeName":"销售费用-周转材料摊销","helpCode":"XSFY-ZZCLTX","helpCodeFull":"xiaoshoufeiyong-zhouzhuancailiaotanxiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560121 销售费用-租赁费","id":99295,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560121","name":"租赁费","gradeName":"销售费用-租赁费","helpCode":"XSFY-ZLF","helpCodeFull":"xiaoshoufeiyong-zulinfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560122 销售费用-保险费","id":99296,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560122","name":"保险费","gradeName":"销售费用-保险费","helpCode":"XSFY-BXF","helpCodeFull":"xiaoshoufeiyong-baoxianfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560123 销售费用-修理费","id":99297,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560123","name":"修理费","gradeName":"销售费用-修理费","helpCode":"XSFY-XLF","helpCodeFull":"xiaoshoufeiyong-xiulifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560124 销售费用-劳务费","id":99298,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560124","name":"劳务费","gradeName":"销售费用-劳务费","helpCode":"XSFY-LWF","helpCodeFull":"xiaoshoufeiyong-laowufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560125 销售费用-佣金","id":99299,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560125","name":"佣金","gradeName":"销售费用-佣金","helpCode":"XSFY-YJ","helpCodeFull":"xiaoshoufeiyong-yongjin","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560126 销售费用-仓储费","id":99300,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560126","name":"仓储费","gradeName":"销售费用-仓储费","helpCode":"XSFY-CCF","helpCodeFull":"xiaoshoufeiyong-cangchufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560127 销售费用-包装费","id":99301,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560127","name":"包装费","gradeName":"销售费用-包装费","helpCode":"XSFY-BZF","helpCodeFull":"xiaoshoufeiyong-baozhuangfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560128 销售费用-运输费","id":99302,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560128","name":"运输费","gradeName":"销售费用-运输费","helpCode":"XSFY-YSF","helpCodeFull":"xiaoshoufeiyong-yunshufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560129 销售费用-装卸费","id":99303,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560129","name":"装卸费","gradeName":"销售费用-装卸费","helpCode":"XSFY-ZXF","helpCodeFull":"xiaoshoufeiyong-zhuangxiefei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560130 销售费用-运输合理损耗","id":99304,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560130","name":"运输合理损耗","gradeName":"销售费用-运输合理损耗","helpCode":"XSFY-YSHLSH","helpCodeFull":"xiaoshoufeiyong-yunshuhelisunhao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560131 销售费用-入库前挑选整理费","id":99305,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560131","name":"入库前挑选整理费","gradeName":"销售费用-入库前挑选整理费","helpCode":"XSFY-RKQTXZLF","helpCodeFull":"xiaoshoufeiyong-rukuqiantiaoxuanzhenglifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560132 销售费用-物业管理费","id":99306,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560132","name":"物业管理费","gradeName":"销售费用-物业管理费","helpCode":"XSFY-WYGLF","helpCodeFull":"xiaoshoufeiyong-wuyeguanlifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560133 销售费用-水电费","id":99307,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560133","name":"水电费","gradeName":"销售费用-水电费","helpCode":"XSFY-SDF","helpCodeFull":"xiaoshoufeiyong-shuidianfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560134 销售费用-网络使用费","id":99308,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560134","name":"网络使用费","gradeName":"销售费用-网络使用费","helpCode":"XSFY-WLSYF","helpCodeFull":"xiaoshoufeiyong-wangluoshiyongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560135 销售费用-展览费","id":99309,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560135","name":"展览费","gradeName":"销售费用-展览费","helpCode":"XSFY-ZLF","helpCodeFull":"xiaoshoufeiyong-zhanlanfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560136 销售费用-商品维修费","id":99310,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560136","name":"商品维修费","gradeName":"销售费用-商品维修费","helpCode":"XSFY-SPWXF","helpCodeFull":"xiaoshoufeiyong-shangpinweixiufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560137 销售费用-预计产品质量保证损失","id":99311,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560137","name":"预计产品质量保证损失","gradeName":"销售费用-预计产品质量保证损失","helpCode":"XSFY-YJCPZLBZSS","helpCodeFull":"xiaoshoufeiyong-yujichanpinzhiliangbaozhengsunshi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560138 销售费用-车辆使用费","id":99312,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560138","name":"车辆使用费","gradeName":"销售费用-车辆使用费","helpCode":"XSFY-CLSYF","helpCodeFull":"xiaoshoufeiyong-cheliangshiyongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560139 销售费用-劳保费","id":99313,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560139","name":"劳保费","gradeName":"销售费用-劳保费","helpCode":"XSFY-LBF","helpCodeFull":"xiaoshoufeiyong-laobaofei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560140 销售费用-旅游费","id":99314,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560140","name":"旅游费","gradeName":"销售费用-旅游费","helpCode":"XSFY-LYF","helpCodeFull":"xiaoshoufeiyong-lvyoufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560141 销售费用-培训费","id":99315,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560141","name":"培训费","gradeName":"销售费用-培训费","helpCode":"XSFY-PXF","helpCodeFull":"xiaoshoufeiyong-peixunfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560199 销售费用-其他","id":99316,"parentId":99063,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560199","name":"其他","gradeName":"销售费用-其他","helpCode":"XSFY-QT","helpCodeFull":"xiaoshoufeiyong-qita","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560201 管理费用-职工工资","id":99317,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560201","name":"职工工资","gradeName":"管理费用-职工工资","helpCode":"GLFY-ZGGZ","helpCodeFull":"guanlifeiyong-zhigonggongzi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560202 管理费用-基本社会保险费","id":99318,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560202","name":"基本社会保险费","gradeName":"管理费用-基本社会保险费","helpCode":"GLFY-JBSHBXF","helpCodeFull":"guanlifeiyong-jibenshehuibaoxianfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560203 管理费用-补充养老保险","id":99319,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560203","name":"补充养老保险","gradeName":"管理费用-补充养老保险","helpCode":"GLFY-BCYLBX","helpCodeFull":"guanlifeiyong-buchongyanglaobaoxian","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560204 管理费用-补充医疗保险","id":99320,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560204","name":"补充医疗保险","gradeName":"管理费用-补充医疗保险","helpCode":"GLFY-BCYLBX","helpCodeFull":"guanlifeiyong-buchongyiliaobaoxian","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560205 管理费用-住房公积金","id":99321,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560205","name":"住房公积金","gradeName":"管理费用-住房公积金","helpCode":"GLFY-ZFGJJ","helpCodeFull":"guanlifeiyong-zhufanggongjijin","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560206 管理费用-福利费","id":99322,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560206","name":"福利费","gradeName":"管理费用-福利费","helpCode":"GLFY-FLF","helpCodeFull":"guanlifeiyong-fulifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560207 管理费用-工会经费","id":99323,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560207","name":"工会经费","gradeName":"管理费用-工会经费","helpCode":"GLFY-GHJF","helpCodeFull":"guanlifeiyong-gonghuijingfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560208 管理费用-职工教育经费","id":99324,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560208","name":"职工教育经费","gradeName":"管理费用-职工教育经费","helpCode":"GLFY-ZGJYJF","helpCodeFull":"guanlifeiyong-zhigongjiaoyujingfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560209 管理费用-办公费","id":99325,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560209","name":"办公费","gradeName":"管理费用-办公费","helpCode":"GLFY-BGF","helpCodeFull":"guanlifeiyong-bangongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560210 管理费用-业务招待费","id":99326,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560210","name":"业务招待费","gradeName":"管理费用-业务招待费","helpCode":"GLFY-YWZDF","helpCodeFull":"guanlifeiyong-yewuzhaodaifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560211 管理费用-广告宣传费","id":99327,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560211","name":"广告宣传费","gradeName":"管理费用-广告宣传费","helpCode":"GLFY-GGXCF","helpCodeFull":"guanlifeiyong-guanggaoxuanchuanfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560212 管理费用-差旅费","id":99328,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560212","name":"差旅费","gradeName":"管理费用-差旅费","helpCode":"GLFY-CLF","helpCodeFull":"guanlifeiyong-chalvfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560213 管理费用-交通费","id":99329,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560213","name":"交通费","gradeName":"管理费用-交通费","helpCode":"GLFY-JTF","helpCodeFull":"guanlifeiyong-jiaotongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560214 管理费用-快递物流费","id":99330,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560214","name":"快递物流费","gradeName":"管理费用-快递物流费","helpCode":"GLFY-KDWLF","helpCodeFull":"guanlifeiyong-kuaidiwuliufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560215 管理费用-通讯费","id":99331,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560215","name":"通讯费","gradeName":"管理费用-通讯费","helpCode":"GLFY-TXF","helpCodeFull":"guanlifeiyong-tongxunfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560216 管理费用-会议费","id":99332,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560216","name":"会议费","gradeName":"管理费用-会议费","helpCode":"GLFY-HYF","helpCodeFull":"guanlifeiyong-huiyifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560217 管理费用-开办费","id":99333,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560217","name":"开办费","gradeName":"管理费用-开办费","helpCode":"GLFY-KBF","helpCodeFull":"guanlifeiyong-kaibanfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560218 管理费用-折旧费","id":99334,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560218","name":"折旧费","gradeName":"管理费用-折旧费","helpCode":"GLFY-ZJF","helpCodeFull":"guanlifeiyong-zhejiufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560219 管理费用-无形资产摊销","id":99335,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560219","name":"无形资产摊销","gradeName":"管理费用-无形资产摊销","helpCode":"GLFY-WXZCTX","helpCodeFull":"guanlifeiyong-wuxingzichantanxiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560220 管理费用-长期待摊费用摊销","id":99336,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560220","name":"长期待摊费用摊销","gradeName":"管理费用-长期待摊费用摊销","helpCode":"GLFY-CQDTFYTX","helpCodeFull":"guanlifeiyong-changqidaitanfeiyongtanxiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560221 管理费用-周转材料摊销","id":99337,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560221","name":"周转材料摊销","gradeName":"管理费用-周转材料摊销","helpCode":"GLFY-ZZCLTX","helpCodeFull":"guanlifeiyong-zhouzhuancailiaotanxiao","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560222 管理费用-租赁费","id":99338,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560222","name":"租赁费","gradeName":"管理费用-租赁费","helpCode":"GLFY-ZLF","helpCodeFull":"guanlifeiyong-zulinfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560223 管理费用-物业管理费","id":99339,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560223","name":"物业管理费","gradeName":"管理费用-物业管理费","helpCode":"GLFY-WYGLF","helpCodeFull":"guanlifeiyong-wuyeguanlifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560224 管理费用-水电费","id":99340,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560224","name":"水电费","gradeName":"管理费用-水电费","helpCode":"GLFY-SDF","helpCodeFull":"guanlifeiyong-shuidianfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560225 管理费用-咨询费","id":99341,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560225","name":"咨询费","gradeName":"管理费用-咨询费","helpCode":"GLFY-ZXF","helpCodeFull":"guanlifeiyong-zixunfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560226 管理费用-诉讼费","id":99342,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560226","name":"诉讼费","gradeName":"管理费用-诉讼费","helpCode":"GLFY-SSF","helpCodeFull":"guanlifeiyong-susongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560227 管理费用-保险费","id":99343,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560227","name":"保险费","gradeName":"管理费用-保险费","helpCode":"GLFY-BXF","helpCodeFull":"guanlifeiyong-baoxianfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560228 管理费用-存货盘亏或盘盈","id":99344,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560228","name":"存货盘亏或盘盈","gradeName":"管理费用-存货盘亏或盘盈","helpCode":"GLFY-CHPKHPY","helpCodeFull":"guanlifeiyong-cunhuopankuihuopanying","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560229 管理费用-劳保费","id":99345,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560229","name":"劳保费","gradeName":"管理费用-劳保费","helpCode":"GLFY-LBF","helpCodeFull":"guanlifeiyong-laobaofei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560230 管理费用-修理费","id":99346,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560230","name":"修理费","gradeName":"管理费用-修理费","helpCode":"GLFY-XLF","helpCodeFull":"guanlifeiyong-xiulifei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560231 管理费用-劳务费","id":99347,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560231","name":"劳务费","gradeName":"管理费用-劳务费","helpCode":"GLFY-LWF","helpCodeFull":"guanlifeiyong-laowufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560232 管理费用-仓储费","id":99348,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560232","name":"仓储费","gradeName":"管理费用-仓储费","helpCode":"GLFY-CCF","helpCodeFull":"guanlifeiyong-cangchufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"研究费","codeAndName":"560233 管理费用-研究费用","id":99349,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560233","name":"研究费用","gradeName":"管理费用-研究费用","helpCode":"GLFY-YJFY","helpCodeFull":"guanlifeiyong-yanjiufeiyong","balanceDirection":0,"cashTypeId":5000020012,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560234 管理费用-辞退福利","id":99350,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560234","name":"辞退福利","gradeName":"管理费用-辞退福利","helpCode":"GLFY-CTFL","helpCodeFull":"guanlifeiyong-cituifuli","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560235 管理费用-聘请中介机构费","id":99351,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560235","name":"聘请中介机构费","gradeName":"管理费用-聘请中介机构费","helpCode":"GLFY-PQZJJGF","helpCodeFull":"guanlifeiyong-pinqingzhongjiejigoufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560236 管理费用-网络使用费","id":99352,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560236","name":"网络使用费","gradeName":"管理费用-网络使用费","helpCode":"GLFY-WLSYF","helpCodeFull":"guanlifeiyong-wangluoshiyongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560237 管理费用-车辆使用费","id":99353,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560237","name":"车辆使用费","gradeName":"管理费用-车辆使用费","helpCode":"GLFY-CLSYF","helpCodeFull":"guanlifeiyong-cheliangshiyongfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560238 管理费用-保修费","id":99354,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560238","name":"保修费","gradeName":"管理费用-保修费","helpCode":"GLFY-BXF","helpCodeFull":"guanlifeiyong-baoxiufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560239 管理费用-保险金","id":99355,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560239","name":"保险金","gradeName":"管理费用-保险金","helpCode":"GLFY-BXJ","helpCodeFull":"guanlifeiyong-baoxianjin","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560240 管理费用-展览费","id":99356,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560240","name":"展览费","gradeName":"管理费用-展览费","helpCode":"GLFY-ZLF","helpCodeFull":"guanlifeiyong-zhanlanfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560241 管理费用-旅游费","id":99357,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560241","name":"旅游费","gradeName":"管理费用-旅游费","helpCode":"GLFY-LYF","helpCodeFull":"guanlifeiyong-lvyoufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560242 管理费用-培训费","id":99358,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560242","name":"培训费","gradeName":"管理费用-培训费","helpCode":"GLFY-PXF","helpCodeFull":"guanlifeiyong-peixunfei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560243 管理费用-残保金","id":99359,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560243","name":"残保金","gradeName":"管理费用-残保金","helpCode":"GLFY-CBJ","helpCodeFull":"guanlifeiyong-canbaojin","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560299 管理费用-其他","id":99360,"parentId":99064,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560299","name":"其他","gradeName":"管理费用-其他","helpCode":"GLFY-QT","helpCodeFull":"guanlifeiyong-qita","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560301 财务费用-利息收入","id":99361,"parentId":99065,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560301","name":"利息收入","gradeName":"财务费用-利息收入","helpCode":"CWFY-LXSR","helpCodeFull":"caiwufeiyong-lixishouru","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560302 财务费用-利息支出","id":99362,"parentId":99065,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560302","name":"利息支出","gradeName":"财务费用-利息支出","helpCode":"CWFY-LXZC","helpCodeFull":"caiwufeiyong-lixizhichu","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560303 财务费用-汇兑损失","id":99363,"parentId":99065,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560303","name":"汇兑损失","gradeName":"财务费用-汇兑损失","helpCode":"CWFY-HDSS","helpCodeFull":"caiwufeiyong-huiduisunshi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560304 财务费用-手续费","id":99364,"parentId":99065,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560304","name":"手续费","gradeName":"财务费用-手续费","helpCode":"CWFY-SXF","helpCodeFull":"caiwufeiyong-shouxufei","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560305 财务费用-现金折扣","id":99365,"parentId":99065,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560305","name":"现金折扣","gradeName":"财务费用-现金折扣","helpCode":"CWFY-XJZK","helpCodeFull":"caiwufeiyong-xianjinzhekou","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"560399 财务费用-其他","id":99366,"parentId":99065,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"560399","name":"其他","gradeName":"财务费用-其他","helpCode":"CWFY-QT","helpCodeFull":"caiwufeiyong-qita","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"571101 营业外支出-非流动资产处置净损失","id":99367,"parentId":99066,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"571101","name":"非流动资产处置净损失","gradeName":"营业外支出-非流动资产处置净损失","helpCode":"YYWZC-FLDZCCZJSS","helpCodeFull":"yingyewaizhichu-feiliudongzichanchuzhijingsunshi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"571102 营业外支出-赞助支出","id":99368,"parentId":99066,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"571102","name":"赞助支出","gradeName":"营业外支出-赞助支出","helpCode":"YYWZC-ZZZC","helpCodeFull":"yingyewaizhichu-zanzhuzhichu","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"571103 营业外支出-捐赠支出","id":99369,"parentId":99066,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"571103","name":"捐赠支出","gradeName":"营业外支出-捐赠支出","helpCode":"YYWZC-JZZC","helpCodeFull":"yingyewaizhichu-juanzengzhichu","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"571104 营业外支出-盘亏损失","id":99370,"parentId":99066,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"571104","name":"盘亏损失","gradeName":"营业外支出-盘亏损失","helpCode":"YYWZC-PKSS","helpCodeFull":"yingyewaizhichu-pankuisunshi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"571105 营业外支出-坏账损失","id":99371,"parentId":99066,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"571105","name":"坏账损失","gradeName":"营业外支出-坏账损失","helpCode":"YYWZC-HZSS","helpCodeFull":"yingyewaizhichu-huaizhangsunshi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"571106 营业外支出-存货毁损报废损失","id":99372,"parentId":99066,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"571106","name":"存货毁损报废损失","gradeName":"营业外支出-存货毁损报废损失","helpCode":"YYWZC-CHHSBFSS","helpCodeFull":"yingyewaizhichu-cunhuohuisunbaofeisunshi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"571107 营业外支出-无法收回的长期债券投资损失","id":99373,"parentId":99066,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"571107","name":"无法收回的长期债券投资损失","gradeName":"营业外支出-无法收回的长期债券投资损失","helpCode":"YYWZC-WFSHDCQZQTZSS","helpCodeFull":"yingyewaizhichu-wufashouhuidechangqizhaiquantouzisunshi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"571108 营业外支出-无法收回的长期股权投资损失","id":99374,"parentId":99066,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"571108","name":"无法收回的长期股权投资损失","gradeName":"营业外支出-无法收回的长期股权投资损失","helpCode":"YYWZC-WFSHDCQGQTZSS","helpCodeFull":"yingyewaizhichu-wufashouhuidechangqiguquantouzisunshi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"571109 营业外支出-自然灾害等不可抗力因素造成的损失","id":99375,"parentId":99066,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"571109","name":"自然灾害等不可抗力因素造成的损失","gradeName":"营业外支出-自然灾害等不可抗力因素造成的损失","helpCode":"YYWZC-ZRZHDBKKLYSZCDSS","helpCodeFull":"yingyewaizhichu-ziranzaihaidengbukekangliyinsuzaochengdesunshi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"571110 营业外支出-税收滞纳金","id":99376,"parentId":99066,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"571110","name":"税收滞纳金","gradeName":"营业外支出-税收滞纳金","helpCode":"YYWZC-SSZNJ","helpCodeFull":"yingyewaizhichu-shuishouzhinajin","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"571111 营业外支出-罚没损失","id":99377,"parentId":99066,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"571111","name":"罚没损失","gradeName":"营业外支出-罚没损失","helpCode":"YYWZC-FMSS","helpCodeFull":"yingyewaizhichu-fameisunshi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"571112 营业外支出-非货币性资产交换损失","id":99378,"parentId":99066,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"571112","name":"非货币性资产交换损失","gradeName":"营业外支出-非货币性资产交换损失","helpCode":"YYWZC-FHBXZCJHSS","helpCodeFull":"yingyewaizhichu-feihuobixingzichanjiaohuansunshi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"571113 营业外支出-债务重组损失","id":99379,"parentId":99066,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"571113","name":"债务重组损失","gradeName":"营业外支出-债务重组损失","helpCode":"YYWZC-ZWZZSS","helpCodeFull":"yingyewaizhichu-zhaiwuzhongzusunshi","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"","codeAndName":"571199 营业外支出-其他","id":99380,"parentId":99066,"grade":2,"isEndNode":true,"accountTypeId":5000010006,"code":"571199","name":"其他","gradeName":"营业外支出-其他","helpCode":"YYWZC-QT","helpCodeFull":"yingyewaizhichu-qita","balanceDirection":0,"cashTypeId":5000020004,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"},{"accountTypeName":"损益","balanceDirectionName":"借","cashTypeName":"所得税费用","codeAndName":"5801 所得税费用","id":99067,"grade":1,"isEndNode":true,"accountTypeId":5000010006,"code":"5801","name":"所得税费用","gradeName":"所得税费用","helpCode":"SDSFY","helpCodeFull":"suodeshuifeiyong","balanceDirection":0,"cashTypeId":5000020041,"isCalc":false,"isCalcDepartment":false,"isCalcPerson":false,"isCalcCustomer":false,"isCalcSupplier":false,"isCalcInventory":false,"isCalcProject":false,"isCalcBankAccount":false,"isCalcQuantity":false,"isCalcMulti":false,"isExCalc1":false,"isExCalc2":false,"isExCalc3":false,"isExCalc4":false,"isExCalc5":false,"isExCalc6":false,"isExCalc7":false,"isExCalc8":false,"isExCalc9":false,"isExCalc10":false,"isEnable":true,"isSystem":true,"isIncidentalAcc":false,"ts":"2018-03-26 16:04:17.0"}]}}
})

fetch.mock('/v1/ba/currency/queryList', (option) => {
	return {"result":true,"value":{"list":[{"exchangeRate":1,"isBaseCurrency":true,"id":1,"code":"RMB","name":"人民币","helpCode":"RMB","isEnable":true,"ts":"2018-03-26 16:04:17.0"},{"exchangeRate":6.7705,"isBaseCurrency":false,"id":2,"code":"USD","name":"美元","helpCode":"MY","isEnable":true,"ts":"2018-03-26 16:04:17.0"},{"exchangeRate":7.3707,"isBaseCurrency":false,"id":3,"code":"EUR","name":"欧元","helpCode":"OY","isEnable":true,"ts":"2018-03-26 16:04:17.0"},{"exchangeRate":0.065026,"isBaseCurrency":false,"id":4,"code":"JPY","name":"日元","helpCode":"RY","isEnable":true,"ts":"2018-03-26 16:04:17.0"},{"exchangeRate":8.2472,"isBaseCurrency":false,"id":5,"code":"GBP","name":"英镑","helpCode":"YB","isEnable":true,"ts":"2018-03-26 16:04:17.0"},{"exchangeRate":3.8089,"isBaseCurrency":false,"id":6,"code":"DEM","name":"德国马克","helpCode":"DGMK","isEnable":true,"ts":"2018-03-26 16:04:17.0"},{"exchangeRate":5.1803,"isBaseCurrency":false,"id":7,"code":"AUD","name":"澳大利亚元","helpCode":"ADLYY","isEnable":true,"ts":"2018-03-26 16:04:17.0"},{"exchangeRate":0.8729,"isBaseCurrency":false,"id":8,"code":"HKD","name":"港币","helpCode":"GY","isEnable":true,"ts":"2018-03-26 16:04:17.0"}]}}
})

fetch.mock('/v1/gl/doc/init', (option) => {
	return {"result":true,"value":{"docCode":"0001","voucherDate":"2018-03-27","containAccont":false,"accountDtoList":[]}}
})

fetch.mock('/v1/ba/summary/queryList', (option) => {
	return {"result":true,"value":{"summarys":[]}}
})

fetch.mock('/v1/gl/commonDoc/query', (option) => {
	return {"result":true,"value":[{"docTemplateId":10001,"docTemplateCode":"YZ-001","docTemplateName":"提现","isSaveAmount":false,"docType":"记","entrys":[{"accountCode":"1001","accountName":"库存现金","rowNo":1,"direction":0,"directionName":"借"},{"accountCode":"100201","accountName":"基本户","rowNo":2,"direction":0,"directionName":"贷"}],"enclosures":[],"srcVoucherInfos":[]},{"docTemplateId":10002,"docTemplateCode":"YZ-002","docTemplateName":"存款","isSaveAmount":false,"docType":"记","entrys":[{"accountCode":"100201","accountName":"基本户","rowNo":1,"direction":0,"directionName":"借"},{"accountCode":"1001","accountName":"库存现金","rowNo":2,"direction":0,"directionName":"贷"}],"enclosures":[],"srcVoucherInfos":[]},{"docTemplateId":10003,"docTemplateCode":"YZ-003","docTemplateName":"缴纳增值税","isSaveAmount":false,"docType":"记","entrys":[{"accountCode":"222102","accountName":"未交增值税","direction":0,"directionName":"借"},{"accountCode":"100201","accountName":"基本户","direction":0,"directionName":"贷"}],"enclosures":[],"srcVoucherInfos":[]}]}
})

fetch.mock('/v1/gl/commonDoc/findById', (option) => {
	if(option.docTemplateName == '提现'){
		return {"result":true,"value":{"docTemplateId":10001,"docTemplateCode":"YZ-001","docTemplateName":"提现","isSaveAmount":false,"docType":"记","entrys":[{"summary":"提现","accountId":99001,"accountCode":"1001","accountName":"库存现金","amountDr":0,"rowNo":1,"direction":0,"directionName":"借"},{"summary":"提现","accountId":99068,"accountCode":"100201","accountName":"基本户","amountCr":0,"rowNo":2,"direction":0,"directionName":"贷"}],"enclosures":[],"srcVoucherInfos":[]}}
	} else if(option.docTemplateName == '存款'){
		return {"result":true,"value":{"docTemplateId":10002,"docTemplateCode":"YZ-002","docTemplateName":"存款","isSaveAmount":false,"docType":"记","entrys":[{"summary":"存款","accountId":99068,"accountCode":"100201","accountName":"基本户","amountDr":0,"rowNo":1,"direction":0,"directionName":"借"},{"summary":"存款","accountId":99001,"accountCode":"1001","accountName":"库存现金","amountCr":0,"rowNo":2,"direction":0,"directionName":"贷"}],"enclosures":[],"srcVoucherInfos":[]}}
	} else if(option.docTemplateName == "缴纳增值税"){
		return {"result":true,"value":{"docTemplateId":10003,"docTemplateCode":"YZ-003","docTemplateName":"缴纳增值税","isSaveAmount":false,"docType":"记","entrys":[{"summary":"缴纳增值税","accountId":99120,"accountCode":"222102","accountName":"未交增值税","amountDr":0,"price":1,"direction":0,"directionName":"借"},{"summary":"缴纳增值税","accountId":99068,"accountCode":"100201","accountName":"基本户","amountCr":0,"price":2,"direction":0,"directionName":"贷"}],"enclosures":[],"srcVoucherInfos":[]}}
	}
})

fetch.mock('/v1/gl/doc/getAccountsBalance', (option) => {
	[{accountId: 99001}, {accountId: 99068}]
	if(option[0].accountId == 99001 && option[1].accountId == 99068){
		return {"result":true,"value":[{"accountId":99001,"pageType":0,"isCalcQuantity":false,"isCalcMulti":false,"isCreate":false,"isDetailData":0,"balance":0},{"accountId":99068,"pageType":0,"isCalcQuantity":false,"isCalcMulti":false,"isCreate":false,"isDetailData":0,"balance":0}]}
	} else if(option[0].accountId == 99068 && option[1].accountId == 99001){
		return {"result":true,"value":[{"accountId":99068,"pageType":0,"isCalcQuantity":false,"isCalcMulti":false,"isCreate":false,"isDetailData":0,"balance":0},{"accountId":99001,"pageType":0,"isCalcQuantity":false,"isCalcMulti":false,"isCreate":false,"isDetailData":0,"balance":0}]}
	} else if(option[0].accountId == 99120 && option[1].accountId == 99068){
		return {"result":true,"value":[{"accountId":99120,"pageType":0,"isCalcQuantity":false,"isCalcMulti":false,"isCreate":false,"isDetailData":0,"balance":0},{"accountId":99068,"pageType":0,"isCalcQuantity":false,"isCalcMulti":false,"isCreate":false,"isDetailData":0,"balance":0}]}
	}
})

fetch.mock('/v1/gl/doc/nextDoc', (option) => {
	return {"result":false,"error":{"message":"已经是最后一张凭证！","code":"70081","type":{"name":"warning"},"stack":"com.ttk.edf.base.BusinessException: 已经是最后一张凭证！\n    at com.ttk.gl.impl.GlDocServiceImpl.findPreviousOrNextDocByCode (GlDocServiceImpl.java:421)\n    at com.ttk.gl.impl.GlDocServiceImpl.findNextDocByCode (GlDocServiceImpl.java:160)\n    at com.alibaba.dubbo.common.bytecode.Wrapper34.invokeMethod (Wrapper34.java:-1)\n    at com.alibaba.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke (JavassistProxyFactory.java:46)\n    at com.alibaba.dubbo.rpc.proxy.AbstractProxyInvoker.invoke (AbstractProxyInvoker.java:72)\n    at com.alibaba.dubbo.rpc.protocol.InvokerWrapper.invoke (InvokerWrapper.java:53)\n    at com.ttk.edf.shardingDB.dubbo.filter.ProvidingFilter.invoke (ProvidingFilter.java:26)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.filter.ExceptionFilter.invoke (ExceptionFilter.java:64)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.monitor.support.MonitorFilter.invoke (MonitorFilter.java:75)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.filter.TimeoutFilter.invoke (TimeoutFilter.java:42)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.ttk.edf.trace.dubbo.filter.BraveProviderFilter.invoke (BraveProviderFilter.java:49)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke (TraceFilter.java:78)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.filter.ContextFilter.invoke (ContextFilter.java:70)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.filter.GenericFilter.invoke (GenericFilter.java:132)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.filter.ClassLoaderFilter.invoke (ClassLoaderFilter.java:38)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.filter.EchoFilter.invoke (EchoFilter.java:38)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply (DubboProtocol.java:113)\n    at com.alibaba.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest (HeaderExchangeHandler.java:84)\n    at com.alibaba.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received (HeaderExchangeHandler.java:170)\n    at com.alibaba.dubbo.remoting.transport.DecodeHandler.received (DecodeHandler.java:52)\n    at com.alibaba.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run (ChannelEventRunnable.java:82)\n    at java.util.concurrent.ThreadPoolExecutor.runWorker (ThreadPoolExecutor.java:1149)\n    at java.util.concurrent.ThreadPoolExecutor$Worker.run (ThreadPoolExecutor.java:624)\n    at java.lang.Thread.run (Thread.java:748)"}}
})

fetch.mock('/v1/gl/doc/previousDoc', (option) => {
	return {"result":false,"error":{"message":"已经是第一张凭证！","code":"70080","type":{"name":"warning"},"stack":"com.ttk.edf.base.BusinessException: 已经是第一张凭证！\n    at com.ttk.gl.impl.GlDocServiceImpl.findPreviousOrNextDocByCode (GlDocServiceImpl.java:418)\n    at com.ttk.gl.impl.GlDocServiceImpl.findPreviousDocByCode (GlDocServiceImpl.java:154)\n    at com.alibaba.dubbo.common.bytecode.Wrapper34.invokeMethod (Wrapper34.java:-1)\n    at com.alibaba.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke (JavassistProxyFactory.java:46)\n    at com.alibaba.dubbo.rpc.proxy.AbstractProxyInvoker.invoke (AbstractProxyInvoker.java:72)\n    at com.alibaba.dubbo.rpc.protocol.InvokerWrapper.invoke (InvokerWrapper.java:53)\n    at com.ttk.edf.shardingDB.dubbo.filter.ProvidingFilter.invoke (ProvidingFilter.java:26)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.filter.ExceptionFilter.invoke (ExceptionFilter.java:64)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.monitor.support.MonitorFilter.invoke (MonitorFilter.java:75)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.filter.TimeoutFilter.invoke (TimeoutFilter.java:42)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.ttk.edf.trace.dubbo.filter.BraveProviderFilter.invoke (BraveProviderFilter.java:49)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke (TraceFilter.java:78)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.filter.ContextFilter.invoke (ContextFilter.java:70)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.filter.GenericFilter.invoke (GenericFilter.java:132)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.filter.ClassLoaderFilter.invoke (ClassLoaderFilter.java:38)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.filter.EchoFilter.invoke (EchoFilter.java:38)\n    at com.alibaba.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke (ProtocolFilterWrapper.java:91)\n    at com.alibaba.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply (DubboProtocol.java:113)\n    at com.alibaba.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest (HeaderExchangeHandler.java:84)\n    at com.alibaba.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received (HeaderExchangeHandler.java:170)\n    at com.alibaba.dubbo.remoting.transport.DecodeHandler.received (DecodeHandler.java:52)\n    at com.alibaba.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run (ChannelEventRunnable.java:82)\n    at java.util.concurrent.ThreadPoolExecutor.runWorker (ThreadPoolExecutor.java:1149)\n    at java.util.concurrent.ThreadPoolExecutor$Worker.run (ThreadPoolExecutor.java:624)\n    at java.lang.Thread.run (Thread.java:748)"}}
})

fetch.mock('/v1/gl/commonDoc/update', (option) => {
	return {"result":true,"value":null}
})

fetch.mock('/v1/gl/commonDoc/delete', (option) => {
	return {"result":true,"value":null}
})

fetch.mock('/v1/gl/doc/create', (option) => {
	return {"result":true,"value":{"docId":4288498810737664,"docType":"记","docCode":"0003","year":2018,"period":3,"voucherDate":"2018-03-27","origAmountDrSum":1,"origAmountCrSum":1,"amountDrSum":1,"amountCrSum":1,"creatorId":4281915936466944,"creator":"18088668832","businessTypeId":5000040001,"attachedNum":0,"voucherState":1000020001,"voucherStateName":"未审核","isModifiedDocCode":false,"ts":"2018-03-27 19:58:24.0","createTime":"2018-03-27 19:58:24","entrys":[{"id":4288498810803200,"summary":"提现","accountId":99001,"accountCode":"1001","accountName":"库存现金","accountGradeName":"库存现金","origAmountDr":1,"amountDr":1,"currencyId":1,"currencyCode":"RMB","currencyName":"人民币","exchangeRate":1,"rowNo":1,"ts":"2018-03-27 19:58:24.0","direction":0},{"id":4288498811524096,"summary":"提现","accountId":99068,"accountCode":"100201","accountName":"基本户","accountGradeName":"银行存款-基本户","origAmountCr":1,"amountCr":1,"currencyId":1,"currencyCode":"RMB","currencyName":"人民币","exchangeRate":1,"rowNo":2,"ts":"2018-03-27 19:58:24.0","direction":0}],"enclosures":[],"srcVoucherInfos":[]}}
})

fetch.mock('/v1/gl/doc/getAccountBalance', (option) => {
	return {"result":true,"value":1}
})
